
$thisScriptName = $0;

#print("thisScriptName = ", $0, "\n");

&DoInitialization;

&ReadInputParameters;

&ReadInputLines;

printf("Building %s\n", $toBuild);

&GenerateOutputFiles;


##############################################################################
#
# These are support functions
#
##############################################################################



#
#  Read in the input file lines (describing the ISAs)
# and fill our the "this" record.
#
sub ReadInputLines {
    local(@fields, $lineNumber);

    if ($inputFileName ne "") {
	#printf( "Trying to open file %s\n", $inputFileName);
	open(INFILE, "<".$inputFileName) || die "Can't open input file $inputFileName";
    }
    else {
	printf( "You must not specify an empty input file name!\n");
	exit(-1);
    }

    $lineNumber = 0;

    while (<INFILE>) {
	@fields = split(/\s+/, $_);
	if (/^[ \t]*$/) {
	    #*** empty line ***#
	}
	elsif (/^[ \t]*#/) {
	    #*** comment line ***#
	}
	elsif (/^[ \t]*ppc_name[ \t]/i) {
	    $this_ppc_name = $fields[1];
	}
	elsif (/^[ \t]*ppc32_name[ \t]/i) {
	    $this_ppc32_name = $fields[1];
	}
	elsif (/^[ \t]*ppc40x_name[ \t]/i) {
	    $this_ppc40x_name = $fields[1];
	}
	elsif (/^[ \t]*ppc601_name[ \t]/i) {
	    $this_ppc601_name = $fields[1];
	}
	elsif (/^[ \t]*power_name[ \t]/i) {
	    $this_power_name = $fields[1];
	}
	elsif (/^[ \t]*power2_name[ \t]/i) {
	    $this_power2_name = $fields[1];
	}
	elsif (/^[ \t]*amazon_name[ \t]/i) {
	    $this_amazon_name = $fields[1];
	}
	elsif (/^[ \t]*format[ \t]/i) {
	    $this_format = $fields[1];
	}
	elsif (/^[ \t]*full_format[ \t]/i) {
	    $this_full_format = $fields[1];
	}
	elsif (/^[ \t]*opcode[ \t]/i) {
	    $this_opcode = $fields[1];
	}
	elsif (/^[ \t]*extended_op[ \t]/i) {
	    $this_extended_op = $fields[1];
	}
	elsif (/^[ \t]*RA[ \t]/i) {
	    $this_RA = $fields[1];
	}
	elsif (/^[ \t]*VA[ \t]/i) {
	    $this_VA = $fields[1];
	}
	elsif (/^[ \t]*RB[ \t]/i) {
	    $this_RB = $fields[1];
	}
	elsif (/^[ \t]*VB[ \t]/i) {
	    $this_VB = $fields[1];
	}
	elsif (/^[ \t]*RT[ \t]/i) {
	    $this_RT = $fields[1];
	}
	elsif (/^[ \t]*VT[ \t]/i) {
	    $this_VT = $fields[1];
	}
	elsif (/^[ \t]*RS[ \t]/i) {
	    $this_RS = $fields[1];
	}
	elsif (/^[ \t]*VS[ \t]/i) {
	    $this_VS = $fields[1];
	}
	elsif (/^[ \t]*FRA[ \t]/i) {
	    $this_FRA = $fields[1];
	}
	elsif (/^[ \t]*FRB[ \t]/i) {
	    $this_FRB = $fields[1];
	}
	elsif (/^[ \t]*FRC[ \t]/i) {
	    $this_FRC = $fields[1];
	}
	elsif (/^[ \t]*FRT[ \t]/i) {
	    $this_FRT = $fields[1];
	}
	elsif (/^[ \t]*FRS[ \t]/i) {
	    $this_FRS = $fields[1];
	}
	elsif (/^[ \t]*BFA[ \t]/i) {
	    $this_BFA = $fields[1];
	}
	elsif (/^[ \t]*BA[ \t]/i) {
	    $this_BA = $fields[1];
	}
	elsif (/^[ \t]*BB[ \t]/i) {
	    $this_BB = $fields[1];
	}
	elsif (/^[ \t]*BT[ \t]/i) {
	    $this_BT = $fields[1];
	}
	elsif (/^[ \t]*BF[ \t]/i) {
	    $this_BF = $fields[1];
	}
	elsif (/^[ \t]*AA[ \t]/i) {
	    $this_AA = $fields[1];
	}
	elsif (/^[ \t]*LK[ \t]/i) {
	    $this_LK = $fields[1];
	}
	elsif (/^[ \t]*Rc[ \t]/i) {
	    $this_Rc = $fields[1];
	}
	elsif (/^[ \t]*OE[ \t]/i) {
	    $this_OE = $fields[1];
	}
	elsif (/^[ \t]*L[ \t]/i) {
	    $this_L = $fields[1];
	}
	elsif (/^[ \t]*XO2[ \t]/i) {
	    $this_XO2 = $fields[1];
	}
	elsif (/^[ \t]*SI[ \t]/i) {
	    $this_SI = $fields[1];
	}
	elsif (/^[ \t]*UI[ \t]/i) {
	    $this_UI = $fields[1];
	}
	elsif (/^[ \t]*DQ[ \t]/i) {
	    $this_DQ = $fields[1];
	}
	elsif (/^[ \t]*PT[ \t]/i) {
	    $this_PT = $fields[1];
	}
	elsif (/^[ \t]*DS[ \t]/i) {
	    $this_DS = $fields[1];
	}
	elsif (/^[ \t]*D[ \t]/i) {
	    $this_D = $fields[1];
	}
	elsif (/^[ \t]*SH[ \t]/i) {
	    $this_SH = $fields[1];
	}
	elsif (/^[ \t]*NB[ \t]/i) {
	    $this_NB = $fields[1];
	}
	elsif (/^[ \t]*LI[ \t]/i) {
	    $this_LI = $fields[1];
	}
	elsif (/^[ \t]*XB[ \t]/i) {
	    $this_XB = $fields[1];
	}
	elsif (/^[ \t]*uses[ \t]/i) {
	    $this_uses = $fields[1];
	    for ($i = 2; $i <= $#fields; $i++) {
		$this_uses = $this_uses . ":" . $fields[$i];
	    }
	}
	elsif (/^[ \t]*sets[ \t]/i) {
	    $this_sets = $fields[1];
	    for ($i = 2; $i <= $#fields; $i++) {
		$this_sets = $this_sets . ":" . $fields[$i];
	    }
	}
	elsif (/^[ \t]*dlength[ \t]/i) {
	    $this_dlength = $fields[1];
	}
	elsif (/^[ \t]*load[ \t]*/i) {
	    $this_load = "1";
	}
	elsif (/^[ \t]*cache[ \t]*/i) {
	    $this_cache = "1";
	}
	elsif (/^[ \t]*string[ \t]*/i) {
	    $this_string = "1";
	}
	elsif (/^[ \t]*store[ \t]*/i) {
	    $this_store = "1";
	}
	elsif (/^[ \t]*RAas0[ \t]*/i) {
	    $this_RAas0 = "1";
	}
	elsif (/^[ \t]*float[ \t]*/i) {
	    $this_float = "1";
	}
	elsif (/^[ \t]*branch[ \t]*/i) {
	    $this_branch = "1";
	}
	elsif (/^[ \t]*alters_flow[ \t]*/i) {
	    $this_alters_flow = "1";
	}
	elsif (/^[ \t]*update[ \t]*/i) {
	    $this_update = "1";
	}
	elsif (/^[ \t]*multiple[ \t]*/i) {
	    $this_multiple = "1";
	}
	elsif (/^[ \t]*multaccess[ \t]*/i) {
	    $this_multaccess = "1";
	}
	elsif (/^[ \t]*imultiply[ \t]*/i) {
	    $this_imultiply = "1";
	}
	elsif (/^[ \t]*idivide[ \t]*/i) {
	    $this_idivide = "1";
	}
	elsif (/^[ \t]*privileged[ \t]*/i) {
	    $this_privileged = "1";
	}
	elsif (/^[ \t]*VMX[ \t]*/i) {
	    $this_VMX = "1";
	}
	elsif (/^[ \t]*\@end[ \t]*/i) {
	    &CopyThisToDo;    
	    if ($showRecordsAsRead) {
		&PrintThisDoRecord;
	    }
	    &AddInstructionsForThis;
	}
	elsif (/^[ \t]*[A-Za-z_][A-Za-z_0-9]*[ \t]*$/) {
	    if( $G_processing_record ne "" ) {
		printf(STDERR "line %d: %s\n", $lineNumber, $_);
		printf(STDERR "   already processing record %s\n", $G_processing_record);
		exit( 0 );
	    }
	    &ClearThis($fields[0]);
	    $G_processing_record = $1;
	}
	else {
	    printf(STDERR "I don't understand line %d: \"%s\"\n", $lineNumber, $_);
	    exit(-1);
	}
	$lineNumber++;
    }
    close(INFILE);


    ##################################################
    # Now read in any simulation-file information 
    # (which contains sim code for instructions)
    #
    if ($simulationFileName ne "") {
	#printf( "Trying to open file %s\n", $simulationFileName);
	open(SIMFILE, "<".$simulationFileName) || die "Can't open input file $simulationFileName";
	$lineNumber = 0;
	while (<SIMFILE>) {
	    @fields = split(/\s+/, $_);
	    if (/^[ \t]*$/) {
		#*** empty line ***#
	    }
	    elsif (/^[ \t]*#/) {
		#*** commment line ***#
	    }
	    elsif (/^[ \t]*simppc[ \t]*$/) {
		$this_simppc = 1;
		$G_sim_type = "PowerPC";
		$G_sim_first = 1;
		#print "  processing the simppc code\n";
	    }

	    elsif (/^[ \t]*simpower[ \t]*$/) {
		$this_simpower = 1;
		$G_sim_type = "POWER";
		$G_sim_first = 1;
		#print "  processing the simpower code\n";
	    }

	    elsif (/^[ \t]*simpower2[ \t]*$/) {
		$this_simpower2 = 1;
		$G_sim_type = "POWER2";
		$G_sim_first = 1;
		#print "  processing the simpower2 code\n";
	    }

	    elsif (/^[ \t]*simppc64on32[ \t]*$/) {
		$this_simppc64on32 = 1;
		$G_sim_type = "PPC64on32";
		$G_sim_first = 1;
		#print "  processing the simppc_64_on_32 code\n";
	    }

	    elsif (/^[ \t]*OPC_ASM_[A-Z0-9]+.*[ \t]*$/) {
		#printf "    %s\n", $_;
		if ($G_sim_type eq "POWER") {
		    if ($G_sim_first == 1) {
			$G_sim_first = 0;
		    }
		    else {
			$this_simpower_code = $this_simpower_code . ":";
		    }
		    for ($i = 0; $i <= $#fields; $i++) {
			$this_simpower_code = $this_simpower_code . $fields[$i] . " ";
		    }
		}
		elsif ($G_sim_type eq "POWER2") {
		    if ($G_sim_first == 1) {
			$G_sim_first = 0;
		    }
		    else {
			$this_simpower2_code = $this_simpower2_code . ":";
		    }
		    for ($i = 0; $i <= $#fields; $i++) {
			$this_simpower2_code = $this_simpower2_code . $fields[$i] . " ";
		    }
		}
		elsif ($G_sim_type eq "PowerPC") {
		    if ($G_sim_first == 1) {
			$G_sim_first = 0;
		    }
		    else {
			$this_simppc_code = $this_simppc_code . ":";
		    }
		    for ($i = 0; $i <= $#fields; $i++) {
			$this_simppc_code = $this_simppc_code . $fields[$i] . " ";
		    }
		}
		elsif ($G_sim_type eq "PPC64on32") {
		    if ($G_sim_first == 1) {
			$G_sim_first = 0;
		    }
		    else {
			$this_simppc64on32_code = $this_simppc64on32_code . ":";
		    }
		    for ($i = 0; $i <= $#fields; $i++) {
			$this_simppc64on32_code = $this_simppc64on32_code . $fields[$i] . " ";
		    }
		}
	    }

	    elsif (/^[ \t]*\@end[ \t]*$/) {
		$G_simpower{$G_preproc_instr}     = $this_simpower;
		$G_simpower2{$G_preproc_instr}    = $this_simpower2;
		$G_simppc{$G_preproc_instr}       = $this_simppc;
		$G_simppc64on32{$G_preproc_instr} = $this_simppc64on32;
		
		$G_simpower_code{$G_preproc_instr}     = $this_simpower_code;
		$G_simpower2_code{$G_preproc_instr}    = $this_simpower2_code;
		$G_simppc_code{$G_preproc_instr}       = $this_simppc_code;
		$G_simppc64on32_code{$G_preproc_instr} = $this_simppc64on32_code;
		
		#if ($G_simppc64on32{$G_preproc_instr}) {
		#    printf("Simulation code for %s :\n", $G_preproc_instr);
		#    if ($G_simppc64on32{$G_preproc_instr}) {
		#	@fields = split(":", $G_simppc64on32_code{$G_preproc_instr});
		#	printf("  simppc64on32 = %s\n", $fields[0]);
		#	for ($i = 1; $i <= $#fields; $i++) {
		#	    printf("              %s\n", $fields[$i]);
		#	}
		#    }
		#}
		#print "   ... done\n";
		#if (($G_simppc{$G_preproc_instr}) || ($G_simpower{$G_preproc_instr}) || ($G_simpower2{$G_preproc_instr})) {
		#    printf("Simulation code for %s :\n", $G_preproc_instr);
		#    if ($G_simppc{$G_preproc_instr}) {
		#	@fields = split(":", $G_simppc_code{$G_preproc_instr});
		#	printf("  simppc    = %s\n", $fields[0]);
		#	for ($i = 1; $i <= $#fields; $i++) {
		#	    printf("              %s\n", $fields[$i])
		#	    }
		#    }
		#    if ($G_simpower{$G_preproc_instr}) {
		#	@fields = split(":", $G_simpower_code{$G_preproc_instr});
		#	printf("  simpower  = %s\n", $fields[0]);
		#	for ($i = 1; $i <= $#fields; $i++) {
		#	    printf("              %s\n", $fields[$i])
		#	    }
		#    }
		#    if ($G_simpower2{$G_preproc_instr}) {
		#	@fields = split(":", $G_simpower2_code{$G_preproc_instr});
		#	printf("  simpower2 = %s\n", $fields[0]);
		#	for ($i = 1; $i <= $#fields; $i++) {
		#	    printf("              %s\n", $fields[$i])
		#	    }
		#    }
		#}
		$G_processing_record = "";
	    }

	    elsif (/^[ \t]*\@endsims[ \t]*$/) {
		#print " Done with the simulation code preprocessing...\n";
	    }
	    
	    elsif (/^[ \t]*[A-Za-z_][A-Za-z_0-9]*[ \t]*$/) {
		$G_preproc_instr = $fields[$0];
		if ( ($G_simpower{$G_preproc_instr}) || ($G_simpower2{$G_preproc_instr}) || ($G_simppc{$G_preproc_instr}) ) {
		    printf(STDERR "line %d: %s\n", $lineNumber, $_);
		    printf(STDERR "    already processed simulation code for %s\n", $G_preproc_instr);
		    exit( 0 );
		}
		else {
		    #printf(" Preprocessing %s now...\n", $G_preproc_instr);
		    $G_simpower_code{$G_preproc_instr} = 0;
		    $G_simpower2{$G_preproc_instr}     = 0;
		    $G_simppc{$G_preproc_instr}        = 0;
		    $G_simppc64on32{$G_preproc_instr}  = 0;
		    &ClearThisSimulationCode;
		}
	    }

	    else {
		printf(STDERR "I don't understand line %d: \"%s\"\n", $lineNumber, $_);
		exit( 0 );
	    }
	    $lineNumber++;
	}
	close(SIMFILE);
    }
}


sub ClearThisSimulationCode {
    $this_simppc = "";
    $this_simpower = "";
    $this_simpower2 = "";
    $this_simppc64on32 = "";
    $this_simppc_code = "";
    $this_simpower_code = "";
    $this_simpower2_code = "";
    $this_simppc64on32_code = "";
}


sub ClearThis {
    $G_num = $G_num + 1;
    $this_num = $G_num;
    $this_id = $_[0];

    $this_ppc_name = "";
    $this_ppc32_name = "";
    $this_ppc40x_name = "";
    $this_ppc601_name = "";
    $this_amazon_name = "";
    $this_power_name = "";
    $this_power2_name = "";

    $this_format = "";
    $this_full_format = "";
    $this_opcode = "";
    $this_extended_op = "";

    $this_RA = "";
    $this_RB = "";
    $this_RT = "";
    $this_RS = "";

    $this_FRA = "";
    $this_FRB = "";
    $this_FRC = "";
    $this_FRT = "";
    $this_FRS = "";

    $this_BFA = "";
    $this_BF  = "";
    $this_BA  = "";
    $this_BB  = "";
    $this_BT  = "";

    $this_VA = "";
    $this_VB = "";
    $this_VC = "";
    $this_VT = "";
    $this_VS = "";

    $this_Rc = "";
    $this_OE = "";
    $this_AA = "";
    $this_LK = "";

    $this_XO2 = "";

    $this_MB = "";
    $this_ME = "";

    $this_BO = "";
    $this_BI = "";
    $this_BD = "";

    $this_L  = "";
    $this_LI = "";

    $this_SH = "";
    $this_NB = "";

    $this_SI = "";
    $this_UI = "";
    $this_DQ = "";
    $this_DS = "";
    $this_PT = "";
    $this_D  = "";
    $this_XB  = "";
    $this_XO2 = "";

    $this_load = "";
    $this_store = "";
    $this_cache = "";
    $this_dlength = "";
    $this_string = "";
    $this_update = "";
    $this_multiple = "";
    $this_multaccess = "";
    $this_RAas0 = "";

    $this_float = "";
    $this_branch = "";
    $this_alters_flow = "";
    $this_imultiply = "";
    $this_idivide = "";
    $this_privileged = "";

    $this_uses = "";
    $this_sets = "";
}


sub AddInstructionsForThis {
    &AddThisInstructionToList;

    if(($this_format eq "D_form") ||
       ($this_format eq "DS_form") ||
       ($this_format eq "DQ_form") ||
       ($this_format eq "XFX_form") ||
       ($this_format eq "VA_form") ||
       ($this_format eq "VX_form") 
       ) {
    }
    elsif(($this_format eq "X_form") ||
	  ($this_format eq "XFL_form") ||
	  ($this_format eq "XS_form") ||
	  ($this_format eq "XFL_form") ||
	  ($this_format eq "A_form") ||
	  ($this_format eq "M_form") ||
	  ($this_format eq "MD_form") ||
	  ($this_format eq "MDS_form") ||
	  ($this_format eq "TX_form") ||
	  ($this_format eq "VXR_form")
	  ) {
	if($this_Rc eq "") {
	    &CopyThisToDo;
	    $G_num  = $G_num + 1;
	    $do_num = $G_num;
	    $do_id  = $do_id . "_";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "." }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "." }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "." }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "." }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "." }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "." }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "." }
	    $do_Rc = "1";
	    &AddSetsCR;
	    &AddUsesCR;
	    &AddThisInstructionToList;
	}
    }
    elsif( $this_format eq "XO_form" ) {
	if( $this_OE eq "" ) {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "O";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "o" }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "o" }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "o" }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "o" }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "o" }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "o" }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "o" }
	    $do_OE = "1";
	    &AddSetsOE;
	    &AddThisInstructionToList;
	}
	if( $this_Rc eq "" ) {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "_";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "." }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "." }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "." }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "." }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "." }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "." }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "." }
	    $do_Rc = "1";
	    &AddSetsCR;
	    &AddUsesCR;
	    &AddThisInstructionToList;
	}
	if( $this_Rc eq "" && $this_OE eq "") {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "O_";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "o." }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "o." }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "o." }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "o." }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "o." }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "o." }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "o." }
	    $do_OE = "1";
	    $do_Rc = "1";
	    &AddSetsOE;
	    &AddSetsCR;
	    &AddUsesCR;
	    &AddThisInstructionToList;
	}
    }
    elsif( ($this_format eq "I_form") ||
	  ($this_format eq "B_form") ) {
	if( $this_AA eq "" ) {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "A";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "a" }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "a" }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "a" }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "a" }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "a" }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "a" }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "a" }
	    $do_AA = "1";
	    &AddThisInstructionToList;
	}
	if( $this_LK eq "" ) {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "L";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "l" }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "l" }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "l" }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "l" }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "l" }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "l" }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "l" }
	    $do_LK = "1";
	    &AddSetsLR;
	    &AddThisInstructionToList;
	}
	if( $this_LK eq "" && $this_AA eq "") {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "LA";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "la" }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "la" }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "la" }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "la" }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "la" }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "la" }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "la" }
	    $do_AA = "1";
	    $do_LK = "1";
	    &AddSetsLR;
	    &AddThisInstructionToList;
	}
    }
    elsif( ($this_format eq "SC_form") ||
	  ($this_format eq "XL_form") ) {
	if( $this_LK eq "" ) {
	    &CopyThisToDo;
	    $G_num = $G_num + 1;
	    $do_num = $G_num;
	    $do_id = $do_id . "L";
	    if( $do_ppc_name ) { $do_ppc_name = $do_ppc_name . "l" }
	    if( $do_ppc32_name ) { $do_ppc32_name = $do_ppc32_name . "l" }
	    if( $do_ppc40x_name ) { $do_ppc40x_name = $do_ppc40x_name . "l" }
	    if( $do_ppc601_name ) { $do_ppc601_name = $do_ppc601_name . "l" }
	    if( $do_amazon_name ) { $do_amazon_name = $do_amazon_name . "l" }
	    if( $do_power_name ) { $do_power_name = $do_power_name . "l" }
	    if( $do_power2_name ) { $do_power2_name = $do_power2_name . "l" }
	    $do_LK = "1";
	    &AddSetsLR;
	    &AddThisInstructionToList;
	}
    }
    else {
	printf(STDERR  "%s: unknown format %s\n", $do_id, $do_format);
    }
}

sub AddSetsLR {
    if ($do_sets ne "") {
	$do_sets = $do_sets . ":LR";
    }
    else {
	$do_sets = "LR";
    }
}

sub AddSetsOE {
    if ($do_sets ne "") {
	$do_sets = $do_sets . ":OV:SO";
    }
    else {
	$do_sets = "OV:SO";
    }
}

sub AddSetsCR {
    if( $do_float ) {
	if ($do_sets ne "") {
	    $do_sets = $do_sets . ":CR1";
	}
	else {
	    $do_sets = "CR1";
	}
    }
    else {
	if ($do_sets ne "") {
	    $do_sets = $do_sets . ":CR0";
	}
	else {
	    $do_sets = "CR0";
	}
    }
}

sub AddUsesCR {
    if( $do_float ) {
	#if ($do_uses ne "") {
	#    $do_uses = $do_uses . ":FPSCR_ENR";
	#}
	#else {
	#    $do_uses = "FPSCR_ENR";
	#}
    }
    else {
	if ($do_uses ne "") {
	    $do_uses = $do_uses . ":SO";
	}
	else {
	    $do_uses = "SO";
	}
    }
}



sub AddThisInstructionToList {
    local(@valid);
    local($error, $extended_op, $code);

    $error = 1;
    $extended_op = 0;

    #* Check that the instruction is attributed to at least one ISA 
    if(($do_ppc_name eq "")    && ($do_ppc32_name eq "") && 
       ($do_ppc40x_name eq "") &&
       ($do_ppc601_name eq "") && ($do_power_name eq "") && 
       ($do_power2_name eq "") && ($do_amazon_name eq "") ) {
	printf( STDERR "%s: must specify at least one of ppc_name, power_name, amazon_name, and power2_name\n", $do_id);
	exit(-1);
    } 
    
    undef %valid;

    if (($do_format eq "I_form") && ($do_full_format eq "I_1")) {
	$valid{"LI"} = "1";
	$valid{"AA"} = "1";
	$valid{"LK"} = "1";
	$error = 0;
	$extended_op = $do_extended_op + $do_AA * 2 + $do_LK;
    }
    if (($do_format eq "B_form") && ($do_full_format eq "B_1")) {
	$valid{"BO"} = "1";
	$valid{"BI"} = "1";
	$valid{"BD"} = "1";
	$valid{"AA"} = "1";
	$valid{"LK"} = "1";
	$error = 0;
	$extended_op = $do_extended_op + $do_AA * 2 + $do_LK;
    }
    elsif ($do_format eq "SC_form") {
	if ($do_full_format eq "SC_1") {
	    $valid{"LK"} = "1";
	    $do_LK = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "SC_2") {
	    $valid{"LEV"} = "1";
	    $valid{"LK"} = "1";
	    $extended_op = $do_extended_op * 2 + $do_LK;
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_LK;
    }
    elsif ($do_format eq "D_form") { 
	if ($do_full_format eq "D_1") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"D"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_2") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SI"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_3") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"D"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_4") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SI"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_5") {
	    $valid{"BF"} = "1";
	    $valid{"L"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SI"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_6") {
	    $valid{"BF"} = "1";
	    $valid{"L"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"UI"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_7") {
	    $valid{"TO"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SI"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_8") {
	    $valid{"FRT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"D"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "D_9") {
	    $valid{"FRS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"D"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op;
    } 
    elsif ($do_format eq "DS_form") { 
	if ($do_full_format eq "DS_1") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"DS"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "DS_2") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"DS"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op;
    } 
    if (($do_format eq "DQ_form") && ($do_full_format eq "DQ_1")) {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"DQ"} = "1";
	$valid{"PT"} = "1";
	$error = 0;
	$extended_op = $do_extended_op;
    }
    elsif ($do_format eq "X_form") { 
	if ($do_full_format eq "X_1") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_2") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"NB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_3") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_4") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"NB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_5") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SH"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_6") {
	    $valid{"RS"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_7") {
	    $valid{"BF"} = "1";
	    $valid{"L"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_8") {
	    $valid{"BF"} = "1";
	    $valid{"FRA"} = "1";
	    $valid{"FRB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_9") {
	    $valid{"BF"} = "1";
	    $valid{"BFA"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_10") {
	    $valid{"BF"} = "1";
	    $valid{"U"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_11") {
	    $valid{"TO"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_12") {
	    $valid{"FRT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_13") {
	    $valid{"FRT"} = "1";
	    $valid{"FRB"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_14") {
	    $valid{"FRS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_15") {
	    $valid{"BT"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_16") {
	    $valid{"RS"} = "1";
	    $valid{"SR"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_17") {
	    $valid{"RT"} = "1";
	    $valid{"SR"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_18") {
	    $valid{"T"} = "1";
	    $valid{"STRM"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_19") {
	    $valid{"VS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "X_20") {
	    $valid{"VT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"Rc"} = "1";
	    $this_Rc = "0"; $do_Rc = "0";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    elsif ($do_format eq "XL_form") { 
	if ($do_full_format eq "XL_1") {
	    $valid{"BT"} = "1";
	    $valid{"BA"} = "1";
	    $valid{"BB"} = "1";
	    $valid{"LK"} = "1";
	    $this_LK = "0"; $do_LK = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "XL_2") {
	    $valid{"BO"} = "1";
	    $valid{"BI"} = "1";
	    $valid{"LK"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XL_3") {
	    $valid{"BF"} = "1";
	    $valid{"BFA"} = "1";
	    $valid{"LK"} = "1";
	    $this_LK = "0"; $do_LK = "0";
	    $error = 0;
	}
	elsif ($do_full_format eq "XL_4") {
	    $valid{"LK"} = "1";
	    $this_LK = "0"; $do_LK = "0";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_LK;
    } 
    elsif ($do_format eq "XFX_form") { 
	if ($do_full_format eq "XFX_1") {
	    $valid{"RT"} = "1";
	    $valid{"SPR"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XFX_2") {
	    $valid{"RT"} = "1";
	    $valid{"TBR"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XFX_3") {
	    $valid{"RS"} = "1";
	    $valid{"FXM"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XFX_4") {
	    $valid{"RS"} = "1";
	    $valid{"SPR"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XFX_5") {
	    $valid{"XO2"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + 0;
    } 
    if (($do_format eq "XFL_form") && ($do_full_format eq "XFL_1")) {
	$valid{"FLM"} = "1";
	$valid{"FRB"} = "1";
	$valid{"Rc"} = "1";
	$error = 0;
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    if (($do_format eq "XS_form") && ($do_full_format eq "XS_1")) {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"Rc"} = "1";
	$error = 0;
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    elsif ($do_format eq "XO_form") { 
	if ($do_full_format eq "XO_1") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"OE"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "XO_2") {
	    $valid{"RT"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"OE"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	$extended_op = $do_OE * 1024 + $do_extended_op * 2 + $do_Rc;
    } 
    if (($do_format eq "A_form") && ($do_full_format eq "A_1")) {
	$valid{"FRT"} = "1";
	$valid{"FRA"} = "1";
	$valid{"FRB"} = "1";
	$valid{"FRC"} = "1";
	$valid{"Rc"} = "1";
	$error = 0;
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    elsif ($do_format eq "M_form") { 
	if ($do_full_format eq "M_1") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"MB"} = "1";
	    $valid{"ME"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "M_2") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SH"} = "1";
	    $valid{"MB"} = "1";
	    $valid{"ME"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    elsif ($do_format eq "MD_form") { 
	if ($do_full_format eq "MD_1") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SH"} = "1";
	    $valid{"MB"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MD_2") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"SH"} = "1";
	    $valid{"ME"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    elsif ($do_format eq "MDS_form") { 
	if ($do_full_format eq "MDS_1") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"MB"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_2") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"ME"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_3") {
	    $valid{"IS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"IB"} = "1";
	    $valid{"XBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_3n") {
	    $valid{"IS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"IB"} = "1";
	    $valid{"CBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_4") {
	    $valid{"IS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"XBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_4n") {
	    $valid{"IS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"CBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_5") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"IB"} = "1";
	    $valid{"XBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_5n") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"IB"} = "1";
	    $valid{"CBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_6") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"XBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "MDS_6n") {
	    $valid{"RS"} = "1";
	    $valid{"RA"} = "1";
	    $valid{"RB"} = "1";
	    $valid{"CBI"} = "1";
	    $valid{"Rc"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op * 2 + $do_Rc;
    } 
    if (($do_format eq "TX_form") && ($do_full_format eq "TX_1")) {
	$valid{"TO"} = "1";
	$valid{"UI"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
	$error = 0;
	$extended_op = $do_extended_op * 2 + $do_Rc;
    }

    if ($do_format eq "VA_form") {
	if ($do_full_format eq "VA_1") {
	    $valid{"VT"} = "1";
	    $valid{"VA"} = "1";
	    $valid{"VB"} = "1";
	    $valid{"VC"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "VA_2") {
	    $valid{"VT"} = "1";
	    $valid{"VA"} = "1";
	    $valid{"VB"} = "1";
	    $valid{"VSH"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op;
    }
    if ($do_format eq "VX_form") {
	if ($do_full_format eq "VX_1") {
	    $valid{"VT"} = "1";
	    $valid{"VA"} = "1";
	    $valid{"VB"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "VX_2") {
	    $valid{"VT"} = "1";
	    $valid{"VUI"} = "1";
	    $valid{"VB"} = "1";
	    $error = 0;
	}
	elsif ($do_full_format eq "VX_3") {
	    $valid{"VT"} = "1";
	    $valid{"VSI"} = "1";
	    $valid{"VB"} = "1";
	    $error = 0;
	}
	$extended_op = $do_extended_op;
    }
    if (($do_format eq "VXR_form") && ($do_full_format eq "VXR_1")) {
	$valid{"VT"} = "1";
	$valid{"VA"} = "1";
	$valid{"VB"} = "1";
	$valid{"Rc"} = "1";
	$error = 0;
	$extended_op = $do_Rc * 1024 + $do_extended_op;
    }
    
    if ($error == 1) {
	printf(STDERR "%s : unknown format %s full_format %s pair\n", $do_id, $do_format, $do_full_format);
	exit(-1);
    }

    if( $do_RT ne "" && ($valid{"RT"} ne "1") )  {
	printf(STDERR "%s : RT field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_RS ne "" && ($valid{"RS"} ne "1") )  {
	printf(STDERR "%s : RS field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_RA ne "" && ($valid{"RA"} ne "1") )  {
	printf(STDERR "%s : RA field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_RB ne "" && ($valid{"RB"} ne "1") )  {
	printf(STDERR "%s : RB field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_L  ne "" && ($valid{"L"} ne "1") )  {
	printf(STDERR "%s : L field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_Rc ne "" && ($valid{"Rc"} ne "1") )  {
	printf(STDERR "%s : Rc field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_BO ne "" && ($valid{"BO"} ne "1") )  {
	printf(STDERR "%s : BO field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_BI ne "" && ($valid{"BI"} ne "1") )  {
	printf(STDERR "%s : BI field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_BD ne "" && ($valid{"BD"} ne "1") )  {
	printf(STDERR "%s : BD field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_AA ne "" && ($valid{"AA"} ne "1") )  {
	printf(STDERR "%s : AA field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_LK ne "" && ($valid{"LK"} ne "1") )  {
	printf(STDERR "%s : LK field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_OE ne "" && ($valid{"OE"} ne "1") )  {
	printf(STDERR "%s : OE field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_MB ne "" && ($valid{"MB"} ne "1") )  {
	printf(STDERR "%s : MB field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_ME ne "" && ($valid{"ME"} ne "1") )  {
	printf(STDERR "%s : ME field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_SH ne "" && ($valid{"SH"} ne "1") )  {
	printf(STDERR "%s : SH field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_VSH ne "" && ($valid{"VSH"} ne "1") )  {
	printf(STDERR "%s : VSH field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_D ne "" && ($valid{"D"} ne "1") )  {
	printf(STDERR "%s : D field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_DS ne "" && ($valid{"DS"} ne "1") )  {
	printf(STDERR "%s : DS field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_DQ ne "" && ($valid{"DQ"} ne "1") )  {
	printf(STDERR "%s : DQ field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_UI ne "" && ($valid{"UI"} ne "1") )  {
	printf(STDERR "%s : UI field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_VUI ne "" && ($valid{"VUI"} ne "1") )  {
	printf(STDERR "%s : VUI field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_SI ne "" && ($valid{"SI"} ne "1") )  {
	printf(STDERR "%s : SI field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }
    if( $do_VSI ne "" && ($valid{"VSI"} ne "1") )  {
	printf(STDERR "%s : VSI field invalid for format %s subform %s\n", $do_id, $do_format, $do_full_format );
    }

    if( ($valid{"Rc"} eq "1")  && ($do_Rc eq "") )  { $do_Rc  = "0" }
    if( ($valid{"OE"} eq "1")  && ($do_OE eq "") )  { $do_OE  = "0" }
    if( ($valid{"AA"} eq "1")  && ($do_AA eq "") )  { $do_AA  = "0" }
    if( ($valid{"LK"} eq "1")  && ($do_LK eq "") )  { $do_LK  = "0" }
    if( ($valid{"RA"} eq "1")  && ($do_RA eq "") )  { $do_RA  = "GPR" }
    if( ($valid{"RB"} eq "1")  && ($do_RB eq "") )  { $do_RB  = "GPR" }
    if( ($valid{"RT"} eq "1")  && ($do_RT eq "") )  { $do_RT  = "GPR" }
    if( ($valid{"RS"} eq "1")  && ($do_RS eq "") )  { $do_RS  = "GPR" }
    if( ($valid{"FRA"} eq "1") && ($do_FRA eq "") ) { $do_FRA = "FPR" }
    if( ($valid{"FRB"} eq "1") && ($do_FRB eq "") ) { $do_FRB = "FPR" }
    if( ($valid{"FRC"} eq "1") && ($do_FRC eq "") ) { $do_FRC = "FPR" }
    if( ($valid{"FRT"} eq "1") && ($do_FRT eq "") ) { $do_FRT = "FPR" }
    if( ($valid{"FRS"} eq "1") && ($do_FRS eq "") ) { $do_FRS = "FPR" }
    if( ($valid{"BFA"} eq "1") && ($do_BFA eq "") ) { $do_BFA = "CRF" }
    if( ($valid{"BF"} eq "1")  && ($do_BF eq "") )  { $do_BF  = "CRF" }
    if( ($valid{"BA"} eq "1")  && ($do_BA eq "") )  { $do_BA  = "CRB" }
    if( ($valid{"BB"} eq "1")  && ($do_BB eq "") )  { $do_BB  = "CRB" }
    if( ($valid{"BT"} eq "1")  && ($do_BT eq "") )  { $do_BT  = "CRB" }
    if( ($valid{"BI"} eq "1")  && ($do_BI eq "") )  { $do_BI  = "CRB" }
    if( ($valid{"VA"} eq "1")  && ($do_VA eq "") )  { $do_VA  = "VECR" }
    if( ($valid{"VB"} eq "1")  && ($do_VB eq "") )  { $do_VB  = "VECR" }
    if( ($valid{"VC"} eq "1")  && ($do_VC eq "") )  { $do_VC  = "VECR" }
    if( ($valid{"VT"} eq "1")  && ($do_VT eq "") )  { $do_VT  = "VECR" }
    if( ($valid{"VS"} eq "1")  && ($do_VS eq "") )  { $do_VS  = "VECR" }
    
    $code = $do_opcode . " " . $extended_op;

    #** Set up the ISA-specific index and opcode information 
    if( $do_ppc_name ne "" ) {
	if( $G_ppc_name_names{$do_ppc_name} ne "" ) {
	    printf(STDERR "%s: ppc_name name %s already specified for %s\n", $do_id, $do_ppc_name, $G_ppc_name_names{$do_ppc_name}  );
	}
	$G_ppc_name_names{$do_ppc_name} = $do_id;
	
	if( $G_ppc_id_names{$do_id} ne "" ) {
	    printf(STDERR  "PPC: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_ppc_id_names{$do_id}  );
	}
	$G_ppc_id_names{$do_id} = $do_id;
	
	if( $G_ppc_codes{$code} ne "" ) {
	    printf(STDERR  "PPC: %s: code %s already specified for %s\n", $do_id, $code, $G_ppc_codes{$code}  );
	}
	$G_ppc_codes{$code} = $do_id;
    }
    
    if( $do_ppc32_name ne "" ) {
	if( $G_ppc32_name_names{$do_ppc32_name} ne "" ) {
	    printf(STDERR "%s: ppc32_name name %s already specified for %s\n", $do_id, $do_ppc32_name, $G_ppc32_name_names{$do_ppc32_name}  );
	}
	$G_ppc_name_names{$do_ppc_name} = $do_id;

	if( $G_ppc32_id_names{$do_id} ne "" ) {
	    printf(STDERR  "PPC-32: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_ppc32_id_names{$do_id}  );
	}
	$G_ppc32_id_names{$do_id} = $do_id;

	if( $G_ppc32_codes{$code} ne "" ) {
	    printf(STDERR  "PPC-32: %s: code %s already specified for %s\n", $do_id, $code, $G_ppc32_codes{$code}  );
	}
	$G_ppc32_codes{$code} = $do_id;
    }

    if( $do_ppc40x_name ne "" ) {
	if( $G_ppc40x_name_names{$do_ppc40x_name} ne "" ) {
	    printf(STDERR "%s: ppc40x_name name %s already specified for %s\n", $do_id, $do_ppc40x_name, $G_ppc40x_name_names{$do_ppc40x_name}  );
	}
	$G_ppc_name_names{$do_ppc_name} = $do_id;

	if( $G_ppc40x_id_names{$do_id} ne "" ) {
	    printf(STDERR  "PPC-40X: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_ppc40x_id_names{$do_id}  );
	}
	$G_ppc40x_id_names{$do_id} = $do_id;

	if( $G_ppc40x_codes{$code} ne "" ) {
	    printf(STDERR  "PPC-40X: %s: code %s already specified for %s\n", $do_id, $code, $G_ppc40x_codes{$code}  );
	}
	$G_ppc40x_codes{$code} = $do_id;
    }

    if( $do_ppc601_name ne "" ) {
	if( $G_ppc601_name_names{$do_ppc601_name} ne "" ) {
	    printf(STDERR "%s: ppc601_name name %s already specified for %s\n", $do_id, $do_ppc601_name, $G_ppc601_name_names{$do_ppc601_name}  );
	}
	$G_ppc601_name_names{$do_ppc601_name} = $do_id;

	if( $G_ppc601_id_names{$do_id} ne "" ) {
	    printf(STDERR  "PPC-601: %s: id name %s already specified for " , $do_id, $do_id, $G_ppc601_id_names{$do_id}  );
	}
	$G_ppc601_id_names{$do_id} = $do_id;

	if( $G_ppc601_codes{$code} ne "" ) {
	    printf(STDERR  "PPC-601: %s: code %s already specified for %s\n", $do_id, $code, $G_ppc601_codes{$code}  );
	}
	$G_ppc601_codes{$code} = $do_id;
    }

    if( $do_amazon_name ne "" ) {
	if( $G_amazon_name_names{$do_amazon_name} ne "" ) {
	    printf(STDERR "%s: amazon_name name %s already specified for %s\n", $do_id, $do_amazon_name, $G_amazon_name_names{$do_amazon_name}  );
	}
	$G_amazon_name_names{$do_amazon_name} = $do_id;

	if( $G_amazon_id_names{$do_id} ne "" ) {
	    printf(STDERR  "AMAZON: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_amazon_id_names{$do_id}  );
	}
	$G_amazon_id_names{$do_id} = $do_id;

	if( $G_amazon_codes{$code} ne "" ) {
	    printf(STDERR  "AMAZON: %s: code %s already specified for %s\n", $do_id, $code, $G_amazon_codes{$code}  );
	}
	$G_amazon_codes{$code} = $do_id;
    }

    if( $do_power_name ne "" ) {
	if( $G_power_name_names{$do_power_name} ne "" ) {
	    printf(STDERR "%s: power_name name %s already specified for %s\n", $do_id, $do_power_name, $G_power_name_names{$do_power_name}  );
	}
	$G_power_name_names{$do_power_name} = $do_id;

	if( $G_power_id_names{$do_id} ne "" ) {
	    printf(STDERR  "POWER: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_power_id_names{$do_id}  );
	}
	$G_power_id_names{$do_id} = $do_id;

	if( $G_power_codes{$code} ne "" ) {
	    printf(STDERR  "POWER: %s: code %s already specified for %s\n", $do_id, $code, $G_power_codes{$code}  );
	}
	$G_power_codes{$code} = $do_id;
    }

    if( $do_power2_name ne "" ) {
	if( $G_power2_name_names{$do_power2_name} ne "" ) {
	    printf(STDERR "%s: power2_name name %s already specified for %s\n", $do_id, $do_power2_name, $G_power2_name_names{$do_power2_name}  );
	}
	$G_power2_name_names{$do_power2_name} = $do_id;

	if( $G_power2_id_names{$do_id} ne "" ) {
	    printf(STDERR  "POWER2: %s: id name %s already specified for %s\n", $do_id, $do_id, $G_power2_id_names{$do_id}  );
	}
	$G_power2_id_names{$do_id} = $do_id;

	if( $G_power2_codes{$code} ne "" ) {
	    printf(STDERR  "POWER: %s: code %s already specified for %s\n", $do_id, $code, $G_power2_codes{$code}  );
	}
	$G_power2_codes{$code} = $do_id;
    }

    $G_ids_by_index[$do_num] = $do_id;
    $G_instructions_by_index[$do_num] = join("#",
					     $do_num, 
					     $do_id,
					     $do_ppc_name, 
					     $do_ppc32_name, 
					     $do_ppc40x_name, 
					     $do_ppc601_name,
					     $do_power_name, 
					     $do_power2_name, 
					     $do_amazon_name,
					     $do_format, 
					     $do_full_format, 
					     $do_opcode, 
					     $do_extended_op,
					     $do_RA, 
					     $do_RB, 
					     $do_RT,
					     $do_RS,
					     $do_FRA, 
					     $do_FRB, 
					     $do_FRC, 
					     $do_FRT, 
					     $do_FRS,
					     $do_BFA, 
					     $do_BF, 
					     $do_BA, 
					     $do_BB, 
					     $do_BT,
					     $do_VA, 
					     $do_VB, 
					     $do_VC, 
					     $do_VT, 
					     $do_VS,
					     $do_Rc, 
					     $do_OE, 
					     $do_AA, 
					     $do_LK,
					     $do_MB, 
					     $do_ME,
					     $do_BO,
					     $do_BI,
					     $do_BD,
					     $do_L, 
					     $do_LI,
					     $do_SH,
					     $do_VSH,
					     $do_NB,
					     $do_SI,
					     $do_VSI,
					     $do_UI,
					     $do_VUI,
					     $do_DQ,
					     $do_PT,
					     $do_DS,
					     $do_D, 
					     $do_XB,
					     $do_XO2,
					     $do_load,
					     $do_store,
					     $do_cache,
					     $do_dlength,
					     $do_string,
					     $do_update,
					     $do_multiple,
					     $do_multaccess,
					     $do_RAas0,
					     $do_float,
					     $do_branch,
					     $do_alters_flow,
					     $do_imultiply,
					     $do_idivide,
					     $do_privileged,
					     $do_VMX,
					     $do_uses,
					     $do_sets
					     );
    #if ($do_id eq "LWAX") {
    #printf "Opcode.pl:: %4d : %s : l='%s' s='%s' vs \n\t%s\n", $do_num, $do_id, $do_load, $do_store, $G_instructions_by_index[$do_num];
    #}
}

sub CopyThisToDo {
    $do_num = $this_num;
    $do_id = $this_id;

    $do_ppc_name    = $this_ppc_name;
    $do_ppc32_name  = $this_ppc32_name;
    $do_ppc40x_name  = $this_ppc40x_name;
    $do_ppc601_name = $this_ppc601_name;
    $do_power_name  = $this_power_name;
    $do_power2_name = $this_power2_name;
    $do_amazon_name = $this_amazon_name;

    $do_format = $this_format;
    $do_full_format = $this_full_format;
    $do_opcode = $this_opcode;
    $do_extended_op = $this_extended_op;

    $do_RA = $this_RA;
    $do_RB = $this_RB;
    $do_RT = $this_RT;
    $do_RS = $this_RS;

    $do_FRA = $this_FRA;
    $do_FRB = $this_FRB;
    $do_FRC = $this_FRC;
    $do_FRT = $this_FRT;
    $do_FRS = $this_FRS;

    $do_BFA = $this_BFA;
    $do_BF  = $this_BF;
    $do_BA  = $this_BA;
    $do_BB  = $this_BB;
    $do_BT  = $this_BT;

    $do_VA = $this_VA;
    $do_VB = $this_VB;
    $do_VC = $this_VC;
    $do_VT = $this_VT;
    $do_VS = $this_VS;

    $do_Rc = $this_Rc;
    $do_OE = $this_OE;
    $do_AA = $this_AA;
    $do_LK = $this_LK;

    $do_MB = $this_MB;
    $do_ME = $this_ME;

    $do_BO = $this_BO;
    $do_BI = $this_BI;
    $do_BD = $this_BD;

    $do_L  = $this_L;
    $do_LI = $this_LI;

    $do_SH = $this_SH;
    $do_VSH = $this_VSH;
    $do_NB = $this_NB;
    
    $do_SI  = $this_SI;
    $do_VSI = $this_VSI;
    $do_UI  = $this_UI;
    $do_VUI = $this_VUI;

    $do_DQ = $this_DQ;
    $do_PT = $this_DQ;
    $do_DS = $this_DS;
    $do_D  = $this_D;

    $do_XB  = $this_XB;
    $do_XO2 = $this_XO2;
	
    $do_load = $this_load;
    $do_store = $this_store;
    $do_cache = $this_cache;
    $do_dlength = $this_dlength;
    $do_string = $this_string;
    $do_update = $this_update;
    $do_multiple = $this_multiple;
    $do_multaccess = $this_multaccess;
    $do_RAas0 = $this_RAas0;

    $do_float = $this_float;
    $do_branch = $this_branch;
    $do_alters_flow = $this_alters_flow;
    $do_imultiply = $this_imultiply;
    $do_idivide = $this_idivide;
    $do_privileged = $this_privileged;

    $do_VMX = $this_VMX;

    $do_uses = $this_uses;
    $do_sets = $this_sets;
}



sub PrintThisDoRecord {
    print( STDERR "\nThe do record is:\n" );
    if( $do_id ne "" ) { print(STDERR  $do_id, "\n"); }
    if( $do_ppc_name ne "" ) { print(STDERR  "ppc_name\t", $do_ppc_name, "\n"); }
    if( $do_ppc32_name ne "" ) { print(STDERR  "ppc32_name\t", $do_ppc32_name, "\n"); }
    if( $do_ppc40x_name ne "" ) { print(STDERR  "ppc40x_name\t", $do_ppc40x_name, "\n"); }
    if( $do_ppc601_name ne "" ) { print(STDERR  "ppc601_name\t", $do_ppc601_name, "\n"); }
    if( $do_amazon_name ne "" ) { print(STDERR  "amazon_name\t", $do_amazon_name, "\n"); }
    if( $do_power_name ne "" ) { print(STDERR  "power_name\t", $do_power_name, "\n"); }
    if( $do_power2_name ne "" ) { print(STDERR  "power2_name\t", $do_power2_name, "\n"); }
    if( $do_format ne "" ) { print(STDERR  "format\t\t", $do_format, "\n"); }
    if( $do_full_format ne "" ) { print(STDERR  "full_format\t", $do_full_format, "\n"); }
    if( $do_opcode ne "" ) { print(STDERR  "opcode\t\t", $do_opcode, "\n"); }
    if( $do_extended_op ne "" ) { print(STDERR  "extended_op\t", $do_extended_op, "\n"); }
    if( $do_RA ne "" ) { print(STDERR  "RA\t\t", $do_RA, "\n"); }
    if( $do_RB ne "" ) { print(STDERR  "RB\t\t", $do_RB, "\n"); }
    if( $do_RT ne "" ) { print(STDERR  "RT\t\t", $do_RT, "\n"); }
    if( $do_RS ne "" ) { print(STDERR  "RS\t\t", $do_RS, "\n"); }
    if( $do_FRA ne "" ) { print(STDERR  "FRA\t\t", $do_FRA, "\n"); }
    if( $do_FRB ne "" ) { print(STDERR  "FRB\t\t", $do_FRB, "\n"); }
    if( $do_FRC ne "" ) { print(STDERR  "FRC\t\t", $do_FRC, "\n"); }
    if( $do_FRT ne "" ) { print(STDERR  "FRT\t\t", $do_FRT, "\n"); }
    if( $do_FRS ne "" ) { print(STDERR  "FRS\t\t", $do_FRS, "\n"); }
    if( $do_VA ne "" ) { print(STDERR  "VA\t\t", $do_VA, "\n"); }
    if( $do_VB ne "" ) { print(STDERR  "VB\t\t", $do_VB, "\n"); }
    if( $do_VC ne "" ) { print(STDERR  "VC\t\t", $do_VC, "\n"); }
    if( $do_VT ne "" ) { print(STDERR  "VT\t\t", $do_VT, "\n"); }
    if( $do_VS ne "" ) { print(STDERR  "VS\t\t", $do_VS, "\n"); }
    if( $do_BFA ne "" ) { print(STDERR  "BFA\t\t", $do_BFA, "\n"); }
    if( $do_XO2 ne "" ) { print(STDERR  "XO2\t\t", $do_XO2, "\n"); }
    if( $do_L  ne "" ) { print(STDERR  "L \t\t", $do_L, "\n");  }
    if( $do_Rc ne "" ) { print(STDERR  "Rc\t\t", $do_Rc, "\n"); }
    if( $do_OE ne "" ) { print(STDERR  "OE\t\t", $do_OE, "\n"); }
    if( $do_load ne "" ) { print(STDERR  "load", "\n");  }
    if( $do_cache ne "" ) { print(STDERR  "cache", "\n");  }
    if( $do_string ne "" ) { print(STDERR  "string", "\n"); }
    if( $do_store ne "" ) { print(STDERR  "store", "\n"); }
    if( $do_float ne "" ) { print(STDERR  "float", "\n"); }
    if( $do_branch ne "" ) { print(STDERR  "branch", "\n"); }
    if( $do_alters_flow ne "" ) { print(STDERR  "alters_flow", "\n"); }
    if( $do_update ne "" ) { print(STDERR  "update", "\n"); }
    if( $do_multiple ne "" ) { print(STDERR  "multiple", "\n"); }
    if( $do_multaccess ne "" ) { print(STDERR  "multaccess", "\n"); }
    if( $do_privileged ne "" ) { print(STDERR  "privileged", "\n"); }
    if( $do_imultiply ne "" ) { print(STDERR  "imultiply", "\n"); }
    if( $do_idivide ne "" ) { print(STDERR  "idivide", "\n"); }
    if( $do_dlength ne "" ) { print(STDERR  "dlength\t\t", $do_dlength, "\n"); }
    print(STDERR  "\@end\n\n") ;
}




#
# &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#


##############################################################################
#
# These are support functions
#
##############################################################################

# Initialize the global varaibles used

sub DoInitialization {
    undef %G_simpower;
    undef %G_simpower2;
    undef %G_simppc;
    undef %G_simpower_code;
    undef %G_simpower2_code;
    undef %G_simppc_code;
		
    $inputFileName = "-";
    $simulationFileName = "";

    $toBuild = "";

    $showRecordsAsRead = 0;
    $G_num = 0;
    $G_processing_record = "";

    $extopFileName     = "include/opc_extended_op.gen";
    $memopFileName     = "include/opc_memop.gen";
    $ff32catFileName   = "include/opc_ff32cat.gen";
    $imulFileName      = "include/opc_imul.gen";
    $idivFileName      = "include/opc_idiv.gen";
    $formatFileName    = "include/opc_iformats.gen";
    $fullformFileName  = "include/opc_fullformats.gen";
    $floatsFileName    = "include/opc_ifloats.gen";
    $vmxFileName       = "include/opc_iVMX.gen";
    $dlenghtFileName   = "include/opc_dlength.gen";
    $updateFileName    = "include/opc_iupdates.gen";
    $recordFileName    = "include/opc_irecords.gen";
    $declFileName      = "include/opc_decl.gen";
    $itypeFileName     = "include/opc_itypes.gen";
    $inISAFileName     = "include/opc_is_in_ISA.gen";
    $inameFileName     = "include/opc_names.gen";
    $legalFileName     = "include/opc_legal.gen";
    $tbsizeFileName    = "include/opc_tblsizes.gen";
    $tbsetupFileName   = "include/opc_tblsetup.gen";
    $formIwordFileName = "include/opc_integrate_operands_to_iword.gen";

    $disFileName      = "include/opc_dis.gen";
    $disasFileName    = "include/opc_disas.gen";

    $asmFileName      = "include/opc_asm.gen";
    $asFileName      = "include/opc_as.gen";
    
    $instusesFileName   = "include/opc_uses.gen";
    $instsetsFileName   = "include/opc_sets.gen";
    $vecusesFileName    = "include/opc_usevecs.gen";
    $vecsetsFileName    = "include/opc_setvecs.gen";
    $vecusesetFileName  = "include/opc_usesetvecs.gen";

    $setdadlFileName   = "include/opc_idx_set_daddr_dlen_code.gen";
    #$setdlenFileName  = "include/opc_idx_set_dlen_code.gen";
    $fulldtrceFileName = "include/opc_idx_dtrb_code.gen";
    $fullxlFileName    = "include/opc_idx_full_xlate_code.gen";
    $fullcmxlFileName  = "include/opc_idx_canned_multiple_code.gen";
    $isimplFileName    = "include/opc_is_implemented_table.gen";

    $setdadlFileName64   = "include/opc_idx_set_daddr_dlen_code_64.gen";
    #$setdlenFileName64  = "include/opc_idx_set_dlen_code_64.gen";
    $fulldtrceFileName64 = "include/opc_idx_dtrb_code_64.gen";
    $fullxlFileName64    = "include/opc_idx_full_xlate_code_64.gen";
    $fullcmxlFileName64  = "include/opc_idx_canned_multiple_code_64.gen";

    $depprepFileName  = "include/opc_dep.gen";

    $execFileName       = "include/opc_exec.gen";
    $emulFileName       = "include/opc_emul.gen";
    $emul4xxFileName    = "include/opc_emul4xx.gen";

    $execxcoffFileName  = "include/opc_exec_xcoff.gen";

    $simConvertFileName  = "include/opc_form_simulation_code.gen";
    $simRegDefFileName   = "include/opc_reg_ident_defines.gen";
}



# Read the input parameters and modify globals to show them

sub ReadInputParameters {
    #printf "There are %d input parameters\n", ($#ARGV + 1);
    
    $i = 0; 
    while ($i <= $#ARGV) {
	if ($ARGV[$i] eq "-extop") {
	    $toBuild .=  "extended_ops:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$extopFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-memop") {
	    $toBuild .=  "memops:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$memopFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-ffcat") {
	    $toBuild .= "ffcat:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$ff32catFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-imul") {
	    $toBuild .= "imultiply:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$imulFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-idiv") {
	    $toBuild .= "idivide:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$idivFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-format") {
	    $toBuild .= "iformat:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$formatFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-full_format") {
	    $toBuild .= "ifullform:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fullformFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-isfloat") {
	    $toBuild .= "ifloats:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$floatsFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-isVMX") {
	    $toBuild .= "iVMX:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$vmxFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-dlength") {
	    $toBuild .= "dlength:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$dlengthFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-updates") {
	    $toBuild .= "iupdates:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$updateFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-records") {
	    $toBuild .= "irecords:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$recordFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-decl") {
	    $toBuild .= "declare:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		printf("Setting declFileName to \"%s\"\n", $ARGV[$i]);
		$declFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-itype") {
	    $toBuild .= "itypes:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$itypeFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-inISA") {
	    $toBuild .= "isinisa:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$inISAFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-names") {
	    $toBuild .= "inames:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$inameFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-legal") {
	    $toBuild .= "ilegal:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$legalFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-sizes") {
	    $toBuild .= "tblsize:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$tbsizeFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-setup") {
	    $toBuild .= "tblsetup:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$tbsetupFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-formIword") {
	    $toBuild .= "formIword:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$formIwordFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-lib") {
	    $toBuild .= "extended_ops:";
	    $toBuild .= "memops:";
	    $toBuild .= "ffcat:";
	    $toBuild .= "imultiply:";
	    $toBuild .= "idivide:";
	    $toBuild .= "iformat:";
	    $toBuild .= "ifullform:";
	    $toBuild .= "ifloats:";
	    $toBuild .= "iVMX:";
	    $toBuild .= "dlength:";
	    $toBuild .= "iupdates:";
	    $toBuild .= "irecords:";
	    $toBuild .= "declare:";
	    $toBuild .= "itypes:";
	    $toBuild .= "isinisa:";
	    $toBuild .= "inames:";
	    $toBuild .= "ilegal:";
	    $toBuild .= "tblsize:";
	    $toBuild .= "tblsetup:";
	    $toBuild .= "formIword:";
	}

	# General (.h file) stuff/utilities (part of libopc.a package)
	elsif ($ARGV[$i] eq "-asm") {
	    $toBuild .= "asmmacros:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$asmFileName = $ARGV[$i];
	    }
	}

	# General (.h file) stuff/utilities (part of libopc.a package)
	elsif ($ARGV[$i] eq "-dis") {
	    $toBuild .= "opc_dis:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$disFileName = $ARGV[$i];
	    }
	}

	elsif ($ARGV[$i] eq "-disas") {
	    $toBuild .= "disassembly:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$disasFileName = $ARGV[$i];
	    }
	}

	elsif ($ARGV[$i] eq "-all_dis") {
	    $toBuild .= "opc_dis:disassembly:";
	}

	elsif ($ARGV[$i] eq "-as" ) {
	  $toBuild .= "assembly:";
	  if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
	      $i++;
	      $asFileName = $ARGV[$i];
	  }
	}


	# The instruction use/def (and vector use/def) information
	elsif ($ARGV[$i] eq "-uses") {
	    $toBuild .= "instruses:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$instusesFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-sets") {
	    $toBuild .= "instrsets:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$instsetsFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-usevecs") {
	    $toBuild .= "vecuses:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$vecusesFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-setvecs") {
	    $toBuild .= "vecsets:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$vecsetsFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-usesetvecs") {
	    $toBuild .= "vecusesets:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$vecusesetsFileName = $ARGV[$i];
	    }
	}

	elsif ($ARGV[$i] eq "-usedef") {
	    $toBuild .= "instruses:";
	    $toBuild .= "instrsets:";
	    $toBuild .= "vecuses:";
	    $toBuild .= "vecsets:";
	    $toBuild .= "vecusesets:";
	}

	# Aria translation gen files 
	elsif ($ARGV[$i] eq "-daddr_dlen_code") {
	    $toBuild .= "daddr_dlen:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$setdadlFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-dyn_tr_code") {
	    $toBuild .= "dyn_trace:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fulldtrceFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-full_xl") {
	    $toBuild .= "full_xl:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fullxlFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-full_cmxl") {
	    $toBuild .= "full_cmxl:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fullcmxlFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-implemented") {
	    $toBuild .= "implemented:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$isimplFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-aria") {
	    $toBuild .= "daddr_dlen:";
	    $toBuild .= "dyn_trace:";
	    $toBuild .= "full_xl:";
	    $toBuild .= "full_cmxl:";
	    $toBuild .= "implemented:";
	}

        # Aria64 translation gen files 
        elsif ($ARGV[$i] eq "-daddr_dlen_code64") {
            $toBuild .= "daddr_dlen64:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$setdadlFileName64 = $ARGV[$i];
	    }
	    print "Generating $setdadlFileName64 ...\n";
	}
	elsif ($ARGV[$i] eq "-dyn_tr_code64") {
	    $toBuild .= "dyn_trace64:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fulldtrceFileName64 = $ARGV[$i];
	    }
	    print "Generating $fulldtrceFileName64 ...\n";
	}
	elsif ($ARGV[$i] eq "-full_xl64") {
	    $toBuild .= "full_xl64:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fullxlFileName64 = $ARGV[$i];
	    }
	    print "Generating $fullxlFileName64 ...\n";
	}
	elsif ($ARGV[$i] eq "-full_cmxl64") {
	    $toBuild .= "full_cmxl64:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$fullcmxlFileName64 = $ARGV[$i];
	    }
	    print "Generating $fullcmxlFileName64 ...\n";
	}
	elsif ($ARGV[$i] eq "-aria64") {
	    $toBuild .= "daddr_dlen64:";
	    $toBuild .= "dyn_trace64:";
	    $toBuild .= "full_xl64:";
	    $toBuild .= "full_cmxl64:";
	}
 
	# Other specific code users (turandot dep_prep)
	elsif ($ARGV[$i] eq "-dep") {
	    $toBuild .= "dep_prep:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$depprepFileName = $ARGV[$i];
	    }
	}

	# Execution-mode (for symphony)
	elsif ($ARGV[$i] eq "-exec") {
	    $toBuild .= "exec:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$execFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-emul") {
	    $toBuild .= "emul:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$emulFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-emul4xx") {
	    $toBuild .= "emul4xx:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$emul4xxFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-exec_xcoff") {
	    $toBuild .= "exec_xcoff:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$execxcoffFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-all_exec") {
	    $toBuild .= "exec_code:";
	    $toBuild .= "exec_xcoff:";
	}


	elsif ($ARGV[$i] eq "-sim") {
	    $toBuild .= "simfile:";
	    if (($i < $#ARGV) && (($ARGV[$i+1] eq "-") || (substr($ARGV[$i+1], 0, 1) ne "-")) ) {
		$i++;
		$simConvertFileName = $ARGV[$i];
	    }
	}

	# All .gen file creation with one flag...
	elsif ($ARGV[$i] eq "-all_gen") {
	    $toBuild .= "extended_ops:";
	    $toBuild .= "memops:";
	    $toBuild .= "ffcat:";
	    $toBuild .= "imultiply:";
	    $toBuild .= "idivide:";
	    $toBuild .= "iformat:";
	    $toBuild .= "ifullform:";
	    $toBuild .= "ifloats:";
	    $toBuild .= "iVMX:";
	    $toBuild .= "dlength:";
	    $toBuild .= "iupdates:";
	    $toBuild .= "irecords:";
	    $toBuild .= "declare:";
	    $toBuild .= "itypes:";
	    $toBuild .= "isinisa:";
	    $toBuild .= "inames:";
	    $toBuild .= "ilegal:";
	    $toBuild .= "tblsize:";
	    $toBuild .= "tblsetup:";
	    $toBuild .= "formIword:";

	    $toBuild .= "asmmacros:";

	    $toBuild .= "opc_dis:";
	    $toBuild .= "disassembly:";

	    $toBuild .= "instruses:";
	    $toBuild .= "instrsets:";
	    $toBuild .= "vecuses:";
	    $toBuild .= "vecsets:";
	    $toBuild .= "vecusesets:";

	    $toBuild .= "daddr_dlen:";
	    $toBuild .= "dyn_trace:";
	    $toBuild .= "full_xl:";
	    $toBuild .= "full_cmxl:";
	    $toBuild .= "implemented:";

	    $toBuild .= "daddr_dlen64:";
	    $toBuild .= "dyn_trace64:";
	    $toBuild .= "full_xl64:";
	    $toBuild .= "full_cmxl64:";

	    $toBuild .= "dep_prep:";

	    $toBuild .= "emul:";
	    $toBuild .= "emul4xx:";
	    $toBuild .= "exec_code:";
	    $toBuild .= "exec_xcoff:";

	    $toBuild .= "simfile:";
	}


	# Other flags, e.g. debugging, input files, etc. 
	elsif ($ARGV[$i] eq "-debug") {
	    $showRecordsAsRead = 1;
	}
	elsif ($ARGV[$i] eq "-f") {
	    if ($i < $#ARGV) {
		$i++;
		#printf "input file name is at %d and is %s\n", $i, $ARGV[$i];
		$inputFileName = $ARGV[$i];
	    }
	}
	elsif ($ARGV[$i] eq "-s") {
	    if ($i < $#ARGV) {
		$i++;
		$simulationFileName = $ARGV[$i];
	    }
	}

	else {
	    printf "I don't understand argument %d (it's \"%s\")\n", $i, $ARGV[$i];
	    exit(-1);
	}

	$i++;
    }
}



sub GenerateOutputFiles {
    local($i);

    # The libopc.a package .gen files
    if ($toBuild =~ m/extended_ops/) {
	open(EXTOP,     ">" . $extopFileName)    || die "Can't open $extopFileName";    # The extended opcodes file
        &DoInitialExtendedOps(EXTOP);
    }
    if ($toBuild =~ m/memops/) {
	open(MEMOP,     ">" . $memopFileName)    || die "Can't open $memopFileName";    # The memory operations file
        &DoInitialMemOps(MEMOP);
    }
    if ($toBuild =~ m/ffcat/) {
	open(FFCAT,     ">" . $ff32catFileName)  || die "Can't open $ff32catFileName";  # The fF32 itype file
	&DoInitialFFCat(FFCAT);
    }
    if ($toBuild =~ m/imultiply/) {
	open(IMULTIPLY, ">" . $imulFileName)     || die "Can't open $imulFileName";     # The integer multiply instructions file
	&DoInitialIMult(IMULTIPLY);
    }
    if ($toBuild =~ m/idivide/) {
	open(IDIVIDE,   ">" . $idivFileName)     || die "Can't open $idivFileName";     # The integer divide instructions file
	&DoInitialIDiv(IDIVIDE);
    }
    if ($toBuild =~ m/iformat/) {
	open(FORMATS,   ">" . $formatFileName)   || die "Can't open $formatFileName";   # The instruction formats
	&DoInitialFormat(FORMATS);
    }
    if ($toBuild =~ m/ifullform/) {
	open(FULLFORM,  ">" . $fullformFileName) || die "Can't open $fullformFileName"; # The instruction full_formats
	&DoInitialFullFormat(FULFORM);
    }
    if ($toBuild =~ m/ifloats/) {
	open(FLOATS,    ">" . $floatsFileName)   || die "Can't open $floatsFileName";   # The floating-point instructions
	&DoInitialFloats(FLOATS);
    }
    if ($toBuild =~ m/iVMX/) {
	open(VMX,    ">" . $vmxFileName)   || die "Can't open $vmxFileName";            # The VMX instructions
	&DoInitialVMX(VMX);
    }
    if ($toBuild =~ m/dlength/) {
	open(DLENGTH,   ">" . $dlenghtFileName)  || die "Can't open $dlenghtFileName";  # The data access length
	&DoInitialDLength(DLENGTH);
    }
    if ($toBuild =~ m/iupdates/) {
	open(UPDATES,   ">" . $updateFileName)   || die "Can't open $updateFileName";   # The "does_an_update"
	&DoInitialUpdates(UPDATES);
    }
    if ($toBuild =~ m/irecords/) {
	open(RECORDS,   ">" . $recordFileName)   || die "Can't open $recordFileName";   # The "does_an_record"
	&DoInitialRecords(RECORDS);
    }
    if ($toBuild =~ m/declare/) {
	open(DECL,      ">" . $declFileName)     || die "Can't open $declFileName";     # The index symbolic name declarations
	&DoInitialDecls(DECL);
    }
    if ($toBuild =~ m/itypes/) {
	open(ITYPE,     ">" . $itypeFileName)   || die "Can't open $itypeFileName";     # The instruction kind (type) file
	&DoInitialIType(ITYPE);
    }
    if ($toBuild =~ m/isinisa/) {
	open(ISINISA, ">" . $inISAFileName) || die "Can't open $inISAFileName"; 
	&DoInitialIsInISA(ISINISA);
    }
    if ($toBuild =~ m/inames/) {
	open(INAMES, ">" . $inameFileName) || die "Can't open $inameFileName";
	&DoInitialIName(INAMES);
    }
    if ($toBuild =~ m/ilegal/) {
	open(LEGAL, ">" . $legalFileName) || die "Can't open $legalFileName";
	&DoInitialLegal(LEGAL);
    }
    if ($toBuild =~ m/tblsize/) {
	open(TBLSIZE, ">".$tbsizeFileName) || die "Can't open file $tbsizeFileName";
	&DoInitialTableSize(TBLSIZE);
    }
    if ($toBuild =~ m/tblsetup/) {
	open(TBLSETUP, ">".$tbsetupFileName) || die "Can't open file $tbsetupFileName";
	&DoInitialTableSetup(TBLSETUP);
    }
    if ($toBuild =~ m/formIword/) {
	open(FORMIWORD, ">".$formIwordFileName) || die "Can't open file $formIwordFileName";
	&DoInitialGenerateSimIword(FORMIWORD);
    }

    &InitializeDisInfo;
    if ($toBuild =~ m/opc_dis/) {
	open(DISFILE, ">".$disFileName) || die "Can't open file $disFileName";
	&DoInitialGenerateDis(DISFILE);
    }

    if ($toBuild =~ m/disassembly/) {
	open(DISASFILE, ">".$disasFileName) || die "Can't open file $disasFileName";
	&DoInitialGenerateDisassembly(DISASFILE);
    }

    if ($toBuild =~ m/assembly/) {
	open(ASFILE, ">".$asFileName) || die "Can't open file $asFileName";
	&DoInitialGenerateAssembly(ASFILE);
    }


    # General (.h file) stuff/utilities (part of libopc.a package)
    if ($toBuild =~ m/asmmacros/) {
	open(ASMFILE, ">".$asmFileName) || die "Can't open file $asmFileName\n";
	&DoInitialGenerateAsmMacros(ASMFILE);
    }


    # The instruction use/def (and vector use/def) information
    &InitializeUseDefInfo;
    if ($toBuild =~ m/instruses/) {
	open(INSTUSES, ">".$instusesFileName) || die "Can't open file $instusesFileName\n";
	&DoInitialGenerateInstrUses(INSTUSES);
    }
    if ($toBuild =~ m/instrsets/) {
	open(INSTSETS, ">".$instsetsFileName) || die "Can't open file $instsetsFileName\n";
	&DoInitialGenerateInstrSets(INSTSETS);
    }
    if ($toBuild =~ m/vecuses/) {
	open(UVECFILE, ">".$vecusesFileName) || die "Can't open file $vecusesFileName\n";
	&DoInitialGenerateInstrVecUses(UVECFILE);
    }
    if ($toBuild =~ m/vecsets/) {
	open(SVECFILE, ">".$vecsetsFileName) || die "Can't open file $vecsetsFileName\n";
	&DoInitialGenerateInstrVecSets(SVECFILE);
    }
    if ($toBuild =~ m/vecusesets/) {
	open(USVECFILE, ">".$vecusesetFileName) || die "Can't open file $vecusesetFileName\n";
	&DoInitialGenerateInstrVecUseSets(USVECFILE);
    }
   
    # Aria specific stuff
    &InitializeAriaInfo;
    if ($toBuild =~ m/daddr_dlen/) {
	open(SETDADL, ">".$setdadlFileName) || die "Can't open file $setdadlFileName";
	&DoInitialSetDaddrAndDlen(SETDADL);
    }
    if ($toBuild =~ m/dyn_trace/) {
	open(FULLDTRCE, ">".$fulldtrceFileName) || die "Can't open file $fulldtrceFileName";
	&DoInitialFullDynamicTraceCode(FULLDTRCE);
    }
    if ($toBuild =~ m/full_xl/) {
	open(FULLXL, ">".$fullxlFileName) || die "Can't open file $fullxlFileName";
	$processingType = "simulation";
	&DoInitialFullTranslationCode(FULLXL);
    }
    if ($toBuild =~ m/full_cmxl/) {
	open(FULLCMXL, ">".$fullcmxlFileName) || die "Can't open file $fullcmxlFileName";
	$processingType = "canned_multiple";
	&DoInitialCannedMultipleTranslationCode(FULLCMXL);
    }
    if ($toBuild =~ m/implemented/) {
	open(IMPLEMENTED, ">".$isimplFileName) || die "Can't open file $isimplFileName";
	&DoInitialIsImplementedInstrForISA(IMPLEMENTED);
    }
    
    # Aria 64-bit specific stuff
    &InitializeAriaInfo64;
    if ($toBuild =~ m/daddr_dlen64/) {
	open(SETDADL64, ">".$setdadlFileName64) || die "Can't open file $setdadlFileName64";
	&DoInitialSetDaddrAndDlen64(SETDADL64);
    }
    if ($toBuild =~ m/dyn_trace64/) {
	open(FULLDTRCE64, ">".$fulldtrceFileName64) || die "Can't open file $fulldtrceFileName64";
	&DoInitialFullDynamicTraceCode64(FULLDTRCE64);
    }
    if ($toBuild =~ m/full_xl64/) {
	open(FULLXL64, ">".$fullxlFileName64) || die "Can't open file $fullxlFileName64";
	$processingType = "simulation";
	&DoInitialFullTranslationCode64(FULLXL64);
    }
    if ($toBuild =~ m/full_cmxl64/) {
	open(FULLCMXL64, ">".$fullcmxlFileName64) || die "Can't open file $fullcmxlFileName64";
	$processingType = "canned_multiple";
	&DoInitialCannedMultipleTranslationCode64(FULLCMXL64);
    }
    
    # Other specific code users (turandot dep_prep)
    if ($toBuild =~ m/dep_prep/) {
	open(DEPPREPFILE, ">".$depprepFileName) || die "Can't open file $depprepFileName\n";
	&DoInitialGenerateDepPrepCode(DEPPREPFILE);
    }


    &InitializeExecInfo;
    &InitializeEmulInfo;
    &InitializeEmul4xxInfo;
    if ($toBuild =~ m/exec_code/) {
	open(EXECCODE, ">".$execFileName) || die "Can't open file $execFileName";
	&DoInitialExecCode(EXECCODE);
    }
    if ($toBuild =~ m/emul/) {
	open(EMULCODE, ">".$emulFileName) || die "Can't open file $emulFileName";
	&DoInitialExecCode(EMULCODE);
    }
    if ($toBuild =~ m/emul4xx/) {
	open(EMUL4XXCODE, ">".$emul4xxFileName) || die "Can't open file $emul4xxFileName";
	&DoInitialExecCode(EMUL4XXCODE);
    }
    if ($toBuild =~ m/exec_xcoff/) {
	open(EXECXCOFF, ">".$execxcoffFileName) || die "Can't open file $execxcoffFileName";
	&DoInitialExecXcoffCode(EXECXCOFF);
    }

    if ($toBuild =~ m/simfile/) {
	open(SIMCONVERT, ">".$simConvertFileName) || die "Can't open file $simConvertFileName";
	open(REGDEF, ">".$simRegDefFileName ) || die "Can't open file .$simRegDefFileName";
	&DoInitialSimConvertCode(SIMCONVERT, REGDEF);
    }

    for ($i = 1; $i <= $G_num; $i++) {
        # Split out the record information 	
	($do_num, 
	 $do_id,
	 $do_ppc_name, 
	 $do_ppc32_name, 
	 $do_ppc40x_name, 
	 $do_ppc601_name,
	 $do_power_name, 
	 $do_power2_name, 
	 $do_amazon_name,
	 $do_format, 
	 $do_full_format, 
	 $do_opcode, 
	 $do_extended_op,
	 $do_RA, 
	 $do_RB, 
	 $do_RT,
	 $do_RS,
	 $do_FRA, 
	 $do_FRB, 
	 $do_FRC, 
	 $do_FRT, 
	 $do_FRS,
	 $do_BFA, 
	 $do_BF, 
	 $do_BA, 
	 $do_BB, 
	 $do_BT,
	 $do_VA, 
	 $do_VB, 
	 $do_VC, 
	 $do_VT, 
	 $do_VS,
	 $do_Rc, 
	 $do_OE, 
	 $do_AA, 
	 $do_LK,
	 $do_MB, 
	 $do_ME,
	 $do_BO,
	 $do_BI,
	 $do_BD,
	 $do_L, 
	 $do_LI,
	 $do_SH,
	 $do_VSH,
	 $do_NB,
	 $do_SI,
	 $do_VSI,
	 $do_UI,
	 $do_VUI,
	 $do_DQ,
	 $do_PT,
	 $do_DS,
	 $do_D, 
	 $do_XB,
	 $do_XO2,
	 $do_load,
	 $do_store,
	 $do_cache,
	 $do_dlength,
	 $do_string,
	 $do_update,
	 $do_multiple,
	 $do_multaccess,
	 $do_RAas0,
	 $do_float,
	 $do_branch,
	 $do_alters_flow,
	 $do_imultiply,
	 $do_idivide,
	 $do_privileged,
	 $do_VMX,
	 $do_uses,
	 $do_sets
	 ) = split("#", $G_instructions_by_index[$i]);


	if ($toBuild =~ m/extended_op/) {
	    &DoExtendedOpsForThisInstruction(EXTOP);
	}
	if ($toBuild =~ m/memops/) {
	    &DoMemOpsForThisInstruction(MEMOP);
	}
	if ($toBuild =~ m/ffcat/) {
	    &DoFFCatForThisInstruction(FFCAT);
	}
	if ($toBuild =~ m/imultiply/) {
	    &DoIMultForThisInstruction(IMULTIPLY);
	}
	if ($toBuild =~ m/idivide/) {
	    &DoIDivForThisInstruction(IDIVIDE);
	}
	if ($toBuild =~ m/iformat/) {
	    &DoFormatForThisInstruction(FORMATS);
	}
	if ($toBuild =~ m/ifullform/) {
	    &DoFullFormatForThisInstruction(FULLFORM);
	}
	if ($toBuild =~ m/ifloats/) {
	    &DoFloatsForThisInstruction(FLOATS);
	}
	if ($toBuild =~ m/iVMX/) {
	    &DoVMXForThisInstruction(VMX);
	}
	if ($toBuild =~ m/dlength/) {
	    &DoDLengthForThisInstruction(DLENGTH);
	}
	if ($toBuild =~ m/iupdates/) {
	    &DoUpdatesForThisInstruction(UPDATES);
	}
	if ($toBuild =~ m/irecords/) {
	    &DoRecordsForThisInstruction(RECORDS);
	}
	if ($toBuild =~ m/declare/) {
	    &DoDeclsForThisInstruction(DECL);
	}
	if ($toBuild =~ m/itypes/) {
	    &DoITypeForThisInstruction(ITYPE);
	}
	if ($toBuild =~ m/isinisa/) {
	    &DoIsInISAForThisInstruction(ISINISA);
	}
	if ($toBuild =~ m/inames/) {
	    &DoINameForThisInstruction(INAMES);
	}
	if ($toBuild =~ m/ilegal/) {
	    &DoLegalForThisInstruction(LEGAL);
	}
	if ($toBuild =~ m/tblsize/) {
	    &DoTableSizeForThisInstruction(TBLSIZE);
	}
	if ($toBuild =~ m/tblsetup/) {
	    &DoTableSetupForThisInstruction(TBLSETUP);
	}
	if ($toBuild =~ m/formIword/) {
	    &DoGenerateSimIwordForThisInstruction(FORMIWORD);
	}

	if ($toBuild =~ m/opc_dis/) {
	    &DoGenerateDisForThisInstruction(DISFILE);
	}

	if ($toBuild =~ m/disassembly/) {
	    &DoGenerateDisassemblyForThisInstruction(DISASFILE);
	}

	if ($toBuild =~ m/assembly/) {
	    &DoGenerateAssemblyForThisInstruction(ASFILE);
	}

	# General (.h file) stuff/utilities (part of libopc.a package)
	if ($toBuild =~ m/asmmacros/) {
	    &DoGenerateAsmMacrosForThisInstruction(ASMFILE);
	}


	# The instruction use/def (and vector use/def) information
	if ($toBuild =~ m/instruses/) {
	    &DoGenerateInstrUsesForThisInstruction(INSTUSES);
	}
	if ($toBuild =~ m/instrsets/) {
	    &DoGenerateInstrSetsForThisInstruction(INSTSETS);
	}
	if ($toBuild =~ m/vecuses/) {
	    &DoGenerateInstrVecUsesForThisInstruction(UVECFILE);
	}
	if ($toBuild =~ m/vecsets/) {
	    &DoGenerateInstrVecSetsForThisInstruction(SVECFILE);
	}
	if ($toBuild =~ m/vecusesets/) {
	    &DoGenerateInstrVecUseSetsForThisInstruction(USVECFILE);
	}

	# Other specific code users (turandot dep_prep)
	if ($toBuild =~ m/dep_prep/) {
	    &DoGenerateDepPrepCodeForThisInstruction(DEPPREPFILE);
	}

	if ($toBuild =~ m/exec_code/) {
	    &DoExecCodeForThisInstruction(EXECCODE);
	}
	if ($toBuild =~ m/emul/) {
	    &DoEmulCodeForThisInstruction(EMULCODE);
	}
	if ($toBuild =~ m/emul4xx/) {
	    &DoEmul4xxCodeForThisInstruction(EMUL4XXCODE);
	}
	if ($toBuild =~ m/exec_xcoff/) {
	    &DoExecXcoffCodeForThisInstruction(EXECXCOFF);
	}

	if ($toBuild =~ m/simfile/) {
	    &DoSimConvertCodeForThisInstruction(SIMCONVERT);
	}

	# Create a new indexing scheme by full format and simulation code existence
	if ( ($G_simppc{$do_id}) || ($G_simpower{$do_id}) || ($G_simpower2{$do_id}) || ($G_simppc64on32{$do_id}) ) {
	    $G_instructions_by_full_format[$do_num] = join("#",
							   $do_full_format, 
							   "1",  # a sim-code-exists flag
							   $do_num, 
							   $do_id
							   );
	}
	else {
	    $G_instructions_by_full_format[$do_num] = join("#",
							   $do_full_format, 
							   "0",  # a sim-code-does-not-exist flag
							   $do_num, 
							   $do_id
							   );
	}
	#print "$G_instructions_by_full_format[$do_num]\n";
    }

    # sort the instrs by same full-format and no-sim before any sim code
    #@G_sorted = sort by_full_format_and_simflag @G_instructions_by_full_format;
    @G_sorted = sort @G_instructions_by_full_format;
    #for ($i = 1; $i <= $G_num; $i++) {
	#print "$G_instructions_by_full_format[$i] vs. $G_sorted[$i]\n";
    #}

    # now generate the Aria codes grouping the same full_formats together.
    for ($i = 1; $i <= $G_num; $i++) {
        # Split out the record information 	
	($temp_full_format, 
	 $temp_sim_flag,
	 $temp_instr_num, 
	 $temp_instr_id
	 ) = split("#", $G_sorted[$i]);

	($do_num, 
	 $do_id,
	 $do_ppc_name, 
	 $do_ppc32_name, 
	 $do_ppc40x_name, 
	 $do_ppc601_name,
	 $do_power_name, 
	 $do_power2_name, 
	 $do_amazon_name,
	 $do_format, 
	 $do_full_format, 
	 $do_opcode, 
	 $do_extended_op,
	 $do_RA, 
	 $do_RB, 
	 $do_RT,
	 $do_RS,
	 $do_FRA, 
	 $do_FRB, 
	 $do_FRC, 
	 $do_FRT, 
	 $do_FRS,
	 $do_BFA, 
	 $do_BF, 
	 $do_BA, 
	 $do_BB, 
	 $do_BT,
	 $do_VA, 
	 $do_VB, 
	 $do_VC, 
	 $do_VT, 
	 $do_VS,
	 $do_Rc, 
	 $do_OE, 
	 $do_AA, 
	 $do_LK,
	 $do_MB, 
	 $do_ME,
	 $do_BO,
	 $do_BI,
	 $do_BD,
	 $do_L, 
	 $do_LI,
	 $do_SH,
	 $do_VSH,
	 $do_NB,
	 $do_SI,
	 $do_VSI,
	 $do_UI,
	 $do_VUI,
	 $do_DQ,
	 $do_PT,
	 $do_DS,
	 $do_D, 
	 $do_XB,
	 $do_XO2,
	 $do_load,
	 $do_store,
	 $do_cache,
	 $do_dlength,
	 $do_string,
	 $do_update,
	 $do_multiple,
	 $do_multaccess,
	 $do_RAas0,
	 $do_float,
	 $do_branch,
	 $do_alters_flow,
	 $do_imultiply,
	 $do_idivide,
	 $do_privileged,
	 $do_VMX,
	 $do_uses,
	 $do_sets
	 ) = split("#", $G_instructions_by_index[$temp_instr_num]);

	# Aria specific stuff 
	if ($toBuild =~ m/daddr_dlen/) {
	    &DoSetDaddrAndDlenForThisInstruction(SETDADL);
	}
	if ($toBuild =~ m/dyn_trace/) {
	    &DoFullDynamicTraceCodeForThisInstruction(FULLDTRCE);
	}
	if ($toBuild =~ m/full_xl/) {
	    $processingType = "simulation";
	    &DoFullTranslationCodeForThisInstruction(FULLXL);
	}
	if ($toBuild =~ m/full_cmxl/) {
	    $processingType = "canned_multiple";
	    &DoCannedMultipleTranslationCodeForThisInstruction(FULLCMXL);
	}
	if ($toBuild =~ m/isinisa/) {
	    &DoIsImplementedInstrForISAForThisInstruction(IMPLEMENTED);
	}

	# Aria 64-bit specific stuff 
	if ($toBuild =~ m/daddr_dlen/) {
	    &DoSetDaddrAndDlenForThisInstruction64(SETDADL64);
	}
	if ($toBuild =~ m/dyn_trace/) {
	    &DoFullDynamicTraceCodeForThisInstruction64(FULLDTRCE64);
	}
	if ($toBuild =~ m/full_xl/) {
	    $processingType = "simulation";
	    &DoFullTranslationCodeForThisInstruction64(FULLXL64);
	}
	if ($toBuild =~ m/full_cmxl/) {
	    $processingType = "canned_multiple";
	    &DoCannedMultipleTranslationCodeForThisInstruction64(FULLCMXL64);
	}
    }

    if ($toBuild =~ m/extended_op/) {
        &DoFinalExtendedOps(EXTOP);
	close(EXTOP);
    }
    if ($toBuild =~ m/memops/) {
        &DoFinalMemOps(MEMOP);
	close(MEMOP);
    }
    if ($toBuild =~ m/ffcat/) {
	&DoFinalFFCat(FFCAT);
	close(FFCAT);
    }
    if ($toBuild =~ m/imultiply/) {
	&DoFinalIMult(IMULTIPLY);
	close(IMULTIPLY);
    }
    if ($toBuild =~ m/idivide/) {
	&DoFinalIDiv(IDIVIDE);
	close(IDIVIDE);
    }
    if ($toBuild =~ m/iformat/) {
	&DoFinalFormat(FORMATS);
	close(FORMATS);
    }
    if ($toBuild =~ m/ifullform/) {
	&DoFinalFullFormat(FULFORM);
	close(FULFORM);
    }
    if ($toBuild =~ m/ifloats/) {
	&DoFinalFloats(FLOATS);
	close(FLOATS);
    }
    if ($toBuild =~ m/iVMX/) {
	&DoFinalVMX(VMX);
	close(VMX);
    }
    if ($toBuild =~ m/dlength/) {
	&DoFinalDLength(DLENGTH);
	close(DLENGTH);
    }
    if ($toBuild =~ m/iupdates/) {
	&DoFinalUpdates(UPDATES);
	close(UPDATES);
    }
    if ($toBuild =~ m/irecords/) {
	&DoFinalRecords(RECORDS);
	close(RECORDS);
    }
    if ($toBuild =~ m/declare/) {
	&DoFinalDecls(DECL);
	close(DECL);
    }
    if ($toBuild =~ m/itypes/) {
	&DoFinalIType(ITYPE);
	close(ITYPE);
    }
    if ($toBuild =~ m/isinisa/) {
	&DoFinalIsInISA(ISINISA);
	close(ISINISA);
    }
    if ($toBuild =~ m/inames/) {
	&DoFinalIName(INAMES);
	close(INAMES);
    }
    if ($toBuild =~ m/ilegal/) {
	&DoFinalLegal(LEGAL);
	close(LEGAL);
    }
    if ($toBuild =~ m/tblsize/) {
	&DoFinalTableSize(TBLSIZE);
	close(TBLSIZE);
    }
    if ($toBuild =~ m/tblsetup/) {
	&DoFinalTableSetup(TBLSETUP);
	close(TBLSETUP);
    }
    if ($toBuild =~ m/formIword/) {
	&DoFinalGenerateSimIword(FORMIWORD);
	close(FORMIWORD);
    }

    if ($toBuild =~ m/dis/) {
	&DoFinalGenerateDis(DISFILE);
	close(DISFILE);
    }

    if ($toBuild =~ m/disassembly/) {
	&DoFinalGenerateDisassembly(DISASFILE);
	close(DISASFILE);
    }

    if ($toBuild =~ m/assembly/) {
	&DoFinalGenerateAssembly(ASFILE);
	close(ASFILE);
    }

    # General (.h file) stuff/utilities (part of libopc.a package)
    if ($toBuild =~ m/asmmacros/) {
	&DoFinalGenerateAsmMacros(ASMFILE);
	close(ASMFILE);
    }


    # The instruction use/def (and vector use/def) information
    if ($toBuild =~ m/instruses/) {
	&DoFinalGenerateInstrUses(INSTUSES);
	close(INSTUSES);
    }
    if ($toBuild =~ m/instrsets/) {
	&DoFinalGenerateInstrUses(INSTSETS);
	close(INSTSETS);
    }
    if ($toBuild =~ m/vecuses/) {
	&DoFinalGenerateInstrUses(UVECFILE);
	close(UVECFILE);
    }
    if ($toBuild =~ m/vecsets/) {
	&DoFinalGenerateInstrUses(SVECFILE);
	close(SVECFILE);
    }
    if ($toBuild =~ m/vecusesets/) {
	&DoFinalGenerateInstrUses(USVECFILE);
	close(USVECFILE);
    }

    # Aria specific stuff
    if ($toBuild =~ m/daddr_dlen/) {
	&DoFinalSetDaddrAndDlen(SETDADL);
	close(SETDADL);
    }
    if ($toBuild =~ m/dyn_trace/) {
	&DoFinalFullDynamicTraceCode(FULLDTRCE);
	close(FULLDTRCE);
    }
    if ($toBuild =~ m/full_xl/) {
	$processingType = "simulation";
	&DoFinalFullTranslationCode(FULLXL);
	close(FULLXL);
    }
    if ($toBuild =~ m/full_cmxl/) {
	$processingType = "canned_multiple";
	&DoFinalCannedMultipleTranslationCode(FULLCMXL);
	close(FULLCMXL);
    }
    if ($toBuild =~ m/isinisa/) {
	&DoFinalIsImplementedInstrForISA(IMPLEMENTED);
	close(IMPLEMENTED);
    }

    # Aria 64-bit specific stuff 
    if ($toBuild =~ m/daddr_dlen64/) {
	&DoFinalSetDaddrAndDlen64(SETDADL64);
	close(SETDADL64);
    }
    if ($toBuild =~ m/dyn_trace64/) {
	&DoFinalFullDynamicTraceCode64(FULLDTRCE64);
	close(FULLDTRCE64);
    }
    if ($toBuild =~ m/full_xl64/) {
	$processingType = "simulation";
	&DoFinalFullTranslationCode64(FULLXL64);
	close(FULLXL64);
    }
    if ($toBuild =~ m/full_cmxl64/) {
	$processingType = "canned_multiple";
	&DoFinalCannedMultipleTranslationCode64(FULLCMXL64);
	close(FULLCMXL64);
    }

    # Other specific code users (turandot dep_prep)
    if ($toBuild =~ m/dep_prep/) {
	&DoFinalGenerateDepPrepCode(DEPPREPFILE);
	close(DEPPREPFILE);
    }
    
    if ($toBuild =~ m/exec_code/) {
	&DoFinalExecCode(EXECCODE);
	close(EXECCODE);
    }
    if ($toBuild =~ m/emul/) {
	&DoFinalEmulCode(EMULCODE);
	close(EMULCODE);
    }
    if ($toBuild =~ m/emul4xx/) {
	&DoFinalEmul4xxCode(EMUL4XXCODE);
	close(EMUL4XXCODE);
    }
    if ($toBuild =~ m/exec_xcoff/) {
	&DoFinalExecXcoffCode(EXECXCOFF);
	close(EXECXCOFF);
    }
    if ($toBuild =~ m/simfile/) {
	&DoFinalSimConvertCode(SIMCONVERT);
    }


}

sub by_full_format_and_simflag {
    ($a_full_format, 
     $a_instr_num, 
     $a_id
     ) = split("#", $a);
    
    ($b_full_format, 
     $b_instr_num, 
     $b_id
     ) = split("#", $b);
    
    $ff_cmp = ($a_full_format cmp $b_full_format);
    if ($ff_cmp == 0) {
	if ( ($G_simppc{$a_id}) || ($G_simpower{$a_id}) || ($G_simpower2{$a_id}) || ($G_simppc64on32{$a_id}) ) {
	    if ( ($G_simppc{$b_id}) || ($G_simpower{$b_id}) || ($G_simpower2{$b_id}) || ($G_simppc64on32{$b_id}) ) {
		($a_instr_num <=> $b_instr_num);
	    }
	    else {
		("z" cmp "a");
	    }
	}
	else {
	    if ( ($G_simppc{$b_id}) || ($G_simpower{$b_id}) || ($G_simpower2{$b_id}) || ($G_simppc64on32{$b_id}) ) {
		("a" cmp "z");
	    }
	    else {
		($a_instr_num <=> $b_instr_num);
	    }
	}
    }
    else {
	$ff_cmp;
    }
}
