
sub InitializeAriaInfo64 {
    undef %last_printed;
}


########################################################################
#
# Set the data address accessed and the data access length (only)
#
sub DoInitialSetDaddrAndDlen64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  if (OPC_IS_A_MEMORY_ACCESS_OP(iword_ikind)) {\n");
    printf(TOFILE "    switch (iword_index) {\n");
}

sub DoSetDaddrAndDlenForThisInstruction64 {
    local(*TOFILE) = $_[0];

    if (($do_full_format eq "I_1")   || 
	($do_full_format eq "B_1")   ||
	($do_full_format eq "D_2")   ||
	($do_full_format eq "D_4")   ||
	($do_full_format eq "D_5")   ||
	($do_full_format eq "D_6")   ||
	($do_full_format eq "D_7")   ||
	($do_full_format eq "SC_1")  ||
	($do_full_format eq "SC_2")  ||
	($do_full_format eq "X_5")   ||
	($do_full_format eq "X_6")   ||
	($do_full_format eq "X_7")   ||
	($do_full_format eq "X_8")   ||
	($do_full_format eq "X_9")   ||
	($do_full_format eq "X_10")  ||
	($do_full_format eq "X_11")  ||
	($do_full_format eq "X_13")  ||
	($do_full_format eq "X_15")  ||
	($do_full_format eq "X_16")  ||
	($do_full_format eq "X_17")  ||
	($do_full_format eq "X_18")  ||
	($do_full_format eq "XL_1")  ||
	($do_full_format eq "XL_2")  ||
	($do_full_format eq "XL_3")  ||
	($do_full_format eq "XL_4")  ||
	($do_full_format eq "XFX_1") ||
	($do_full_format eq "XFX_2") ||
	($do_full_format eq "XFX_3") ||
	($do_full_format eq "XFX_4") ||
	($do_full_format eq "XFX_5") ||
	($do_full_format eq "XFL_1") ||
	($do_full_format eq "XS_1")  ||
	($do_full_format eq "XO_1")  ||
	($do_full_format eq "XO_2")  ||
	($do_full_format eq "A_1")   ||
	($do_full_format eq "M_1")   ||
	($do_full_format eq "M_2")   ||
	($do_full_format eq "MD_1")  ||
	($do_full_format eq "MD_2")  ||
	($do_full_format eq "MDS_1") ||
	($do_full_format eq "MDS_2") ||
	($do_full_format eq "MDS_3") ||
	($do_full_format eq "MDS_4") ||
	($do_full_format eq "MDS_5") ||
	($do_full_format eq "MDS_6") ||
	($do_full_format eq "MDS_3n") ||
	($do_full_format eq "MDS_4n") ||
	($do_full_format eq "MDS_5n") ||
	($do_full_format eq "MDS_6n") ||
	($do_full_format eq "TX_1")   ||
	($do_full_format eq "VA_1")   ||
	($do_full_format eq "VA_2")   ||
	($do_full_format eq "VX_1")   ||
	($do_full_format eq "VX_2")   ||
	($do_full_format eq "VX_3")   ||
	($do_full_format eq "VXR_1") 
	) {
	# Do nothing
    }
    else {
	if ($do_full_format eq "D_1") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RT = OPC_DEC_RT(iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? D : proc_state_GPR(saved_proc_state_ptr, RA) + D;\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      iword_dlen  = (32-RT) << 2;\n");
	    }
	    else {
		printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "D_3") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RS = OPC_DEC_RS(iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? D : proc_state_GPR(saved_proc_state_ptr, RA) + D;\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      iword_dlen  = (32-RS) << 2;\n");
	    }
	    else {
		printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "D_8") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? D : proc_state_GPR(saved_proc_state_ptr, RA) + D;\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "D_9") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA  = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned D   = OPC_DEC_D(iword);\n");
	    printf(TOFILE "      iword_daddr  = (RA == 0) ? D : proc_state_GPR(saved_proc_state_ptr, RA) + D;\n");
	    printf(TOFILE "      iword_dlen   = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "DS_1") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned DS = OPC_DEC_DS(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? (DS<<2) : proc_state_GPR(saved_proc_state_ptr, RA) + (DS<<2);\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "DS_2") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned DS = OPC_DEC_DS(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? (DS<<2) : proc_state_GPR(saved_proc_state_ptr, RA) + (DS<<2);\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "DQ_1") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned DQ = OPC_DEC_DQ(iword);\n");
	    printf(TOFILE "      unsigned PT = OPC_DEC_PT(iword);\n");
	    printf(TOFILE "      iword_daddr = (RA == 0) ? (DQ<<4) : proc_state_GPR(saved_proc_state_ptr, RA) + (DQ<<4);\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	}
	elsif (($do_full_format eq "X_1")  ||
	       ($do_full_format eq "X_3")  ||
	       ($do_full_format eq "X_19") ||
	       ($do_full_format eq "X_20")) {
	    if( ($do_load) || ($do_store) ) {
		printf(TOFILE "    case OPC_%s : {\n", $do_id);
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(iword);\n");
		printf(TOFILE "      iword_daddr = (RA != 0) ?\n");
		printf(TOFILE "             (proc_state_GPR(saved_proc_state_ptr, RA) + proc_state_GPR(saved_proc_state_ptr, RB)) :\n");
		printf(TOFILE "             proc_state_GPR(saved_proc_state_ptr, RB);\n");
		if ( $do_string ){
		    printf(TOFILE "      iword_dlen = proc_state_XER(saved_proc_state_ptr) & 0x0000003f;\n");
		}
		elsif( $do_multaccess ) {
		    printf(STDERR "ERROR: Unknown instruction: X-format Multiple??\n");
		    printf(STDERR "         for instr with index OPC_%s\n", $do_id);
		}
		else {
		    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
		}
		printf(TOFILE "      }\n");
		printf(TOFILE "      break;\n");
	    }
	}
	elsif (($do_full_format eq "X_2") ||
	       ($do_full_format eq "X_4") ) {
	    if( ($do_load) || ($do_store) ) {
		if ( $do_string ) {
		    printf(TOFILE "    case OPC_%s : {\n", $do_id);
		    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
		    printf(TOFILE "      unsigned NB = OPC_DEC_NB(iword);\n");
		    printf(TOFILE "      iword_daddr = (RA != 0) ? proc_state_GPR(saved_proc_state_ptr, RA) : 0;\n");
		    printf(TOFILE "      iword_dlen  = (NB != 0) ? NB : 32;\n");
		    printf(TOFILE "      }\n");
		    printf(TOFILE "      break;\n");
		}
		else {
		    printf(STDERR "ERROR: don't know what to do with OPC_%s in daddr_dlen\n", $do_id);
		}
	    }
	}
	elsif ($do_full_format eq "X_12") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned RB = OPC_DEC_RB(iword);\n");
	    printf(TOFILE "      if (RA != 0) {\n");
	    printf(TOFILE "        iword_daddr = proc_state_GPR(saved_proc_state_ptr, RA) + proc_state_GPR(saved_proc_state_ptr, RB);\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        iword_daddr = proc_state_GPR(saved_proc_state_ptr, RB);\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	elsif ($do_full_format eq "X_14") {
	    printf(TOFILE "    case OPC_%s : {\n", $do_id);
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(iword);\n");
	    printf(TOFILE "      unsigned RB = OPC_DEC_RB(iword);\n");
	    printf(TOFILE "      if (RA != 0) {\n");
	    printf(TOFILE "        iword_daddr = proc_state_GPR(saved_proc_state_ptr, RA) + proc_state_GPR(saved_proc_state_ptr, RB);\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        iword_daddr = proc_state_GPR(saved_proc_state_ptr, RB);\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      iword_dlen  = %u;\n", $do_dlength);
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      break;\n");
	}
	else {
	    printf(TOFILE "Don't have a case for %s\n", $do_id);
	}
    }
}


sub DoFinalSetDaddrAndDlen64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE "    default:\n");
    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
    printf(TOFILE "  }\n");
}




########################################################################
#
# Set the data address accessed and the data access length (only)
#
sub DoInitialFullDynamicTraceCode64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE "if (OPC_IS_A_MEMORY_ACCESS_OP(instr_xlate_info[instr_num].ikind)) {\n");
    printf(TOFILE "switch ( instr_xlate_info[instr_num].index ) {\n");
}

sub DoFullDynamicTraceCodeForThisInstruction64 {
    local(*TOFILE) = $_[0];

    if (($do_full_format eq "I_1")   || 
	($do_full_format eq "B_1")   ||
	($do_full_format eq "SC_1")  ||
	($do_full_format eq "SC_2")  ||
	($di_full_format eq "D_2")   ||
	($do_full_format eq "D_4")   ||
	($do_full_format eq "D_5")   ||
	($do_full_format eq "D_6")   ||
	($do_full_format eq "D_7")   ||
	($do_full_format eq "X_5")   ||
	($do_full_format eq "X_6")   ||
	($do_full_format eq "X_7")   ||
	($do_full_format eq "X_8")   ||
	($do_full_format eq "X_9")   ||
	($do_full_format eq "X_10")  ||
	($do_full_format eq "X_11")  ||
	($do_full_format eq "X_13")  ||
	($do_full_format eq "X_15")  ||
	($do_full_format eq "X_16")  ||
	($do_full_format eq "X_17")  ||
	($do_full_format eq "X_18")  ||
	($do_full_format eq "XL_1")  ||
	($do_full_format eq "XL_2")  ||
	($do_full_format eq "XL_3")  ||
	($do_full_format eq "XL_4")  ||
	($do_full_format eq "XFX_1") ||
	($do_full_format eq "XFX_2") ||
	($do_full_format eq "XFX_3") ||
	($do_full_format eq "XFX_4") ||
	($do_full_format eq "XFX_5") ||
	($do_full_format eq "XFL_1") ||
	($do_full_format eq "XS_1")  ||
	($do_full_format eq "XO_1")  ||
	($do_full_format eq "XO_2")  ||
	($do_full_format eq "A_1")   ||
	($do_full_format eq "M_1")   ||
	($do_full_format eq "M_2")   ||
	($do_full_format eq "MD_1")  ||
	($do_full_format eq "MD_2")  ||
	($do_full_format eq "MDS_1") ||
	($do_full_format eq "MDS_2") ||
	($do_full_format eq "MDS_3") ||
	($do_full_format eq "MDS_4") ||
	($do_full_format eq "MDS_5") ||
	($do_full_format eq "MDS_6") ||
	($do_full_format eq "MDS_3n") ||
	($do_full_format eq "MDS_4n") ||
	($do_full_format eq "MDS_5n") ||
	($do_full_format eq "MDS_6n") ||
	($do_full_format eq "TX_1")   ||
	($do_full_format eq "VA_1")   ||
	($do_full_format eq "VA_2")   ||
	($do_full_format eq "VX_1")   ||
	($do_full_format eq "VX_2")   ||
	($do_full_format eq "VX_3")   ||
	($do_full_format eq "VXR_1")  || 
	(!$do_store && !$do_load) ) {
	#printf(TOFILE "    case OPC_%s : \n", $do_id);
    }
    else {
	printf(TOFILE "    case OPC_%s : {\n", $do_id);
	
	if ($do_full_format eq "D_1") {
	    printf(TOFILE "      unsigned RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "    /* Set the data access length value */\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = (32-RT) << 2;\n");
	    }
	    else {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (RA == 0) {\n");
	    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "        }\n");
	    printf(TOFILE "      }\n");
	}
	elsif ($do_full_format eq "D_3") {
	    printf(TOFILE "      unsigned RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "    /* Set the data access length value */\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = (32-RS) << 2;\n");
	    }
	    else {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (RA == 0) {\n");
	    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "        }\n");
	    printf(TOFILE "      }\n");
	}
	elsif (($do_full_format eq "D_8") || 
	       ($do_full_format eq "D_9") ) {
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (RA == 0) {\n");
	    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "        }\n");
	    printf(TOFILE "      }\n");
	}
	elsif (($do_full_format eq "DS_1") ||
	       ($do_full_format eq "DS_2") ) {
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned DS = OPC_DEC_DSb(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (DS != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DS);                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (RA == 0) {\n");
	    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DS);                  next_xlate_address++;\n");
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "        }\n");
	    printf(TOFILE "      }\n");
	}
	elsif ($do_full_format eq "DQ_1") {
	    printf(TOFILE "      unsigned RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned DQ4 = OPC_DEC_DQb(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (DQ4 != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DQ4);                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (RA == 0) {\n");
	    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DQ4);                 next_xlate_address++;\n");
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "        }\n");
	    printf(TOFILE "      }\n");
	}
	elsif (($do_full_format eq "X_1")  || 
	       ($do_full_format eq "X_3")  ||
	       ($do_full_format eq "X_19") ||
	       ($do_full_format eq "X_20")
	       ) { 
	    if( ($do_load) || ($do_store) ) {
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      if (RA != 0) {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD  (scratch_reg, RA, RB);                   next_xlate_address++;\n");      
		printf(TOFILE "        *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		printf(TOFILE "      } else {\n");
		printf(TOFILE "        *next_xlate_address = STORE_REG (RB, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		printf(TOFILE "      }\n");
		if ( $do_string ){
		    if ($do_dlength != "0") {
			printf(STDERR "ERROR: illegal dlength value in load or store string indexed\n");
			printf(STDERR "         for instr with index OPC_%s\n", $do_id);
			exit (-2);
		    }
		    printf(TOFILE "      /* dlength dynamically determined in code below */\n");
		    printf(TOFILE "      *next_xlate_address = OPC_ASM_MFSPR(scratch_reg, 1);                     next_xlate_address++;\n");
		    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI (scratch_reg, scratch_reg, 0x7f);            next_xlate_address++;\n");
		    printf(TOFILE "      *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DLENGTH_OFFSET, trbf_base_reg); next_xlate_address++;\n");
		}
		elsif( $do_multaccess ) {
		    printf(STDERR "ERROR: Unknown instruction: X-format Multiple??\n");
		    printf(STDERR "         for instr with index OPC_%s\n", $do_id);
		    exit (-2);
		}
		else {
		    printf(TOFILE "      /* Set the data access length value */\n");
		    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
		}
	    }
	}
	elsif (($do_full_format eq "X_2") ||
	       ($do_full_format eq "X_4") ) {
	    if( ($do_load) || ($do_store) ) {
		if ( $do_string ) {
		    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		    printf(TOFILE "      unsigned NB = OPC_DEC_NB(instr_xlate_info[instr_num].iword);\n");
		    printf(TOFILE "      unsigned len = (NB != 0) ? NB : 32;\n");
		    printf(TOFILE "      if (RA != 0) {\n");
		    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		    printf(TOFILE "      } else {\n");
		    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, 0, 0);      next_xlate_address++;\n");
		    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		    printf(TOFILE "      }\n");
		    printf(TOFILE "      /* Set the data access length value */\n");
		    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = len;\n");
		}
		else {
		    printf(STDERR "ERROR: don't know what to do with OPC_%s in daddr_dlen\n", $do_id);
		}
	    }
	}
	elsif (($do_full_format eq "X_12") || 
	       ($do_full_format eq "X_14") ) {
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      if (RA != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD  (scratch_reg, RA, RB);                   next_xlate_address++;\n");      
	    printf(TOFILE "        *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RB, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	}
	else {
	    printf(TOFILE "Don't have a case for %s\n", $do_id);
	}

	printf(TOFILE "     }\n");
	printf(TOFILE "     break;\n\n");
    }
}

sub DoFinalFullDynamicTraceCode64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  default:\n");
    printf(TOFILE "    /* No dynamic trace (memory-access) data for this instruction */\n");
    printf(TOFILE "  break;\n");
    printf(TOFILE "}\n");
    printf(TOFILE "}\n");
}







###########################################################################
#
# Generate the full translation code (for the "canned_multiple" mode)
#
sub DoInitialCannedMultipleTranslationCode64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE   "switch ( instr_xlate_info[instr_num].index ) {\n");
    $last_printed{$processingType} = 0;
}

sub DoCannedMultipleTranslationCodeForThisInstruction64 {
    local(*TOFILE) = $_[0];

    if ( ($processingType eq "canned_multiple") && (!$do_multaccess) ) {
	$last_printed{$processingType} = 1;
	printf(TOFILE "    case OPC_%s :\n", $do_id);
	return;
    }
    
    if ($last_printed{$processingType} == 1) {
	printf(TOFILE "      fprintf(stderr, \"ERROR: The case %%d not supported for %s\\n\", instr_xlate_info[instr_num].index);\n",
	       $processingType);
	printf(TOFILE "      break;\n\n");
	$last_printed{$processingType} = 0;
    }
    
    &generate_the_translation_code64(TOFILE, $do_num, "no");
}

sub DoFinalCannedMultipleTranslationCode64 {
    local(*TOFILE) = $_[0];
    &generate_final_translation_code64(TOFILE);
}


###########################################################################
#
# Generate the full translation code (for either the "simulation-enabled" 
#   or "native-only" mode)
#
sub DoInitialFullTranslationCode64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE   "switch ( instr_xlate_info[instr_num].index ) {\n");
    $last_full_instr_num64 = -1;
    $last_full_instr_id64 = "";
    $last_full_format64 = "";
}

sub DoFullTranslationCodeForThisInstruction64 {
    local(*TOFILE) = $_[0];
    local($mem_access);
    local($local_format);

    $mem_access = "no";
    if (($do_load) || ($do_store)) {
	$mem_access = "yes";
    }

    $local_format = join("#", $do_full_format, $mem_access, $do_string, $do_multiple, $do_dlength);

    if ($last_full_format64 ne "") {
  	if ($local_format eq $last_full_format64) {
  	    if ( ($G_simppc{$do_id}) || ($G_simpower{$do_id}) || ($G_simpower2{$do_id}) || ($G_simppc64on32{$do_id}) ) {
  		if ($last_full_instr_num64 >= 0) {
  		    &generate_the_translation_code64(TOFILE, $last_full_instr_num64, "yes");
  		}
  		&generate_the_translation_code64(TOFILE, $do_num, "yes");
  		$last_full_instr_id64 = "";
  		$last_full_format64 = "";
  		$last_full_instr_num64 = -1;
  	    }
  	    else {
  		if ($last_full_instr_id64 ne "") {
  		    printf(TOFILE "    case OPC_%s :\n", $last_full_instr_id64);
  		}
  		$last_full_instr_id64 = $do_id;
  		$last_full_format64 = $local_format;
  		$last_full_instr_num64 = $do_num;
  	    }
  	}
  	else {
  	    if ($last_full_instr_num64 >= 0) {
  		&generate_the_translation_code64(TOFILE, $last_full_instr_num64, "yes");
  	    }
  	    #&generate_the_translation_code(TOFILE, $do_num, "yes");
  	    $last_full_instr_id64 = $do_id;
  	    $last_full_format64 = $local_format;
  	    $last_full_instr_num64 = $do_num;
  	}
    }
    else {
  	if ( ($G_simppc{$do_id}) || ($G_simpower{$do_id}) || ($G_simpower2{$do_id}) || ($G_simppc64on32{$do_id}) ) {
  	    &generate_the_translation_code64(TOFILE, $do_num, "yes");
  	    $last_full_instr_id64 = "";
  	    $last_full_format64 = "";
  	    $last_full_instr_num64 = -1;
  	}
  	else {
  	    $last_full_instr_id64 = $do_id;
  	    $last_full_format64 = $local_format;
  	    $last_full_instr_num64 = $do_num;
  	}
    }
}

sub DoFinalFullTranslationCode64 {
    local(*TOFILE) = $_[0];
    if ($last_full_format64 ne "") {
  	&generate_the_translation_code64(TOFILE, $last_full_instr_num64, "yes");
    }
    &generate_final_translation_code64(TOFILE);
}




##########################################################################
#
# This is the routine that generates the translation code for either mode
#
sub generate_the_translation_code64 {
    local(*TOFILE) = $_[0];
    local($xlate_array_num) = $_[1];
    local($include_dynamic) = $_[2];
    local($add_cr_code);
    local($do_num, 
	  $do_id,
	  $do_ppc_name, 
	  $do_ppc32_name, 
	  $do_ppc40x_name, 
	  $do_ppc601_name,
	  $do_power_name, 
	  $do_power2_name, 
	  $do_amazon_name,
	  $do_format, 
	  $do_full_format, 
	  $do_opcode, 
	  $do_extended_op,
	  $do_RA, 
	  $do_RB, 
	  $do_RT,
	  $do_RS,
	  $do_FRA, 
	  $do_FRB, 
	  $do_FRC, 
	  $do_FRT, 
	  $do_FRS,
	  $do_BFA, 
	  $do_BF, 
	  $do_BA, 
	  $do_BB, 
	  $do_BT,
	  $do_VA, 
	  $do_VB, 
	  $do_VC, 
	  $do_VT, 
	  $do_VS,
	  $do_Rc, 
	  $do_OE, 
	  $do_AA, 
	  $do_LK,
	  $do_MB, 
	  $do_ME,
	  $do_BO,
	  $do_BI,
	  $do_BD,
	  $do_L, 
	  $do_LI,
	  $do_SH,
	  $do_VSH,
	  $do_NB,
	  $do_SI,
	  $do_VSI,
	  $do_UI,
	  $do_VUI,
	  $do_DQ,
	  $do_PT,
	  $do_DS,
	  $do_D, 
	  $do_XB,
	  $do_XO2,
	  $do_load,
	  $do_store,
	  $do_cache,
	  $do_dlength,
	  $do_string,
	  $do_update,
	  $do_multiple,
	  $do_multaccess,
	  $do_RAas0,
	  $do_float,
	  $do_branch,
	  $do_alters_flow,
	  $do_imultiply,
	  $do_idivide,
	  $do_privileged,
	  $do_VMX,
	  $do_uses,
	  $do_sets
	  ) = split("#", $G_instructions_by_index[$xlate_array_num]);

    #if ($do_id eq "LWAX") {
    #printf "Opcode_aria64.pl:: %4d : %s : l='%s' s='%s' vs \n\t%s\n", $do_num, $do_id, $do_load, $do_store, $G_instructions_by_index[$xlate_array_num];
    #}

    printf(TOFILE "    case OPC_%s : {\n", $do_id);

    &InsertInstructionDisassembly64;

    if ($include_dynamic eq "yes") {
	if (($do_full_format eq "I_1")   || 
	    ($do_full_format eq "B_1")   ||
	    ($do_full_format eq "SC_1")  ||
	    ($do_full_format eq "SC_2")  ||
	    ($do_full_format eq "D_2")   ||
	    ($do_full_format eq "D_4")   ||
	    ($do_full_format eq "D_5")   ||
	    ($do_full_format eq "D_6")   ||
	    ($do_full_format eq "D_7")   ||
	    ($do_full_format eq "X_13")  ||
	    ($do_full_format eq "X_15")  ||
	    ($do_full_format eq "X_16")  ||
	    ($do_full_format eq "X_17")  ||
	    ($do_full_format eq "X_18")  ||
	    ($do_full_format eq "XL_1")  ||
	    ($do_full_format eq "XL_2")  ||
	    ($do_full_format eq "XL_3")  ||
	    ($do_full_format eq "XL_4")  ||
	    ($do_full_format eq "XFX_1") ||
	    ($do_full_format eq "XFX_2") ||
	    ($do_full_format eq "XFX_3") ||
	    ($do_full_format eq "XFX_4") ||
	    ($do_full_format eq "XFX_5") ||
	    ($do_full_format eq "XFL_1") ||
	    ($do_full_format eq "XS_1")  ||
	    ($do_full_format eq "XO_1")  ||
	    ($do_full_format eq "XO_2")  ||
	    ($do_full_format eq "A_1")   ||
	    ($do_full_format eq "M_1")   ||
	    ($do_full_format eq "M_2")   ||
	    ($do_full_format eq "MD_1")  ||
	    ($do_full_format eq "MD_2")  ||
	    ($do_full_format eq "MDS_1") ||
	    ($do_full_format eq "MDS_2") ||
	    ($do_full_format eq "MDS_3") ||
	    ($do_full_format eq "MDS_4") ||
	    ($do_full_format eq "MDS_5") ||
	    ($do_full_format eq "MDS_6") ||
	    ($do_full_format eq "MDS_3n") ||
	    ($do_full_format eq "MDS_4n") ||
	    ($do_full_format eq "MDS_5n") ||
	    ($do_full_format eq "MDS_6n") ||
	    ($do_full_format eq "TX_1")   ||
	    ($do_full_format eq "VA_1")   ||
	    ($do_full_format eq "VA_2")   ||
	    ($do_full_format eq "VX_1")   ||
	    ($do_full_format eq "VX_2")   ||
	    ($do_full_format eq "VX_3")   ||
	    ($do_full_format eq "VXR_1") 
	    ) {
	    printf(TOFILE "      /* No dlength needed */\n");
	    printf(TOFILE "      /* no dynamic trace information for this instr */\n");
	}
	elsif ($do_full_format eq "D_1") {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = (32-RT) << 2;\n");
	    }
	    else {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "    }\n");
	}
	elsif ($do_full_format eq "D_3") {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    if( ($do_multaccess) ) {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = (32-RS) << 2;\n");
	    }
	    else {
		printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    }
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "    }\n");
	}
	elsif (($do_full_format eq "D_8") || 
	       ($do_full_format eq "D_9") ) {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (D != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);                   next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "    }\n");
	}
	elsif (($do_full_format eq "DS_1") ||
	       ($do_full_format eq "DS_2") ) {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned DS = OPC_DEC_DSb(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (DS != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DS);                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "    }\n");
	}
	elsif ($do_full_format eq "DQ_1") {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned DQ4 = OPC_DEC_DQ(instr_xlate_info[instr_num].iword) << 4;\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "      /* insert the dynamic trace code for this instr */\n");
	    printf(TOFILE "      if (DQ4 != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DQ4);                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "    }\n");
	}
	elsif (($do_full_format eq "X_1")  || 
	       ($do_full_format eq "X_3")  || 
	       ($do_full_format eq "X_19") ||
	       ($do_full_format eq "X_20") ) {
	    if( ($do_load) || ($do_store) ) {
		printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      if (RA != 0) {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD  (scratch_reg, RA, RB);                   next_xlate_address++;\n");      
		printf(TOFILE "        *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		printf(TOFILE "      } else {\n");
		printf(TOFILE "        *next_xlate_address = STORE_REG (RB, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		printf(TOFILE "      }\n");
		if ( $do_string ){
		    if ($do_dlength != "0") {
			printf(STDERR "ERROR: illegal dlength value in load or store string indexed\n");
			printf(STDERR "         for instr with index OPC_%s\n", $do_id);
			exit (-2);
		    }
		    printf(TOFILE "      /* dlength dynamically determined in code below */\n");
		    printf(TOFILE "      *next_xlate_address = OPC_ASM_MFSPR(scratch_reg, 1);                     next_xlate_address++;\n");
		    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI (scratch_reg, scratch_reg, 0x7f);            next_xlate_address++;\n");
		    printf(TOFILE "      *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DLENGTH_OFFSET, trbf_base_reg); next_xlate_address++;\n");
		}
		elsif( $do_multaccess ) {
		    printf(STDERR "ERROR: Unknown instruction: X-format Multiple??\n");
		    printf(STDERR "         for instr with index OPC_%s\n", $do_id);
		    exit (-2);
		}
		else {
		    printf(TOFILE "      /* Set the data access length value */\n");
		    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
		}
		printf(TOFILE "    }\n");
	    }
	}
	elsif (($do_full_format eq "X_2") ||
	       ($do_full_format eq "X_4") ) {
	    if( ($do_load) || ($do_store) ) {
		if ( $do_string ) {
		    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
		    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		    printf(TOFILE "      unsigned NB = OPC_DEC_NB(instr_xlate_info[instr_num].iword);\n");
		    printf(TOFILE "      unsigned len = (NB != 0) ? NB:32;\n");
		    printf(TOFILE "      if (RA != 0) {\n");
		    printf(TOFILE "        *next_xlate_address = STORE_REG (RA, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		    printf(TOFILE "      } else {\n");
		    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, 0, 0);      next_xlate_address++;\n");
		    printf(TOFILE "        *next_xlate_address = STORE_REG (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
		    printf(TOFILE "      }\n");
		    printf(TOFILE "      /* Set the data access length value */\n");
		    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = len;\n");
		    printf(TOFILE "    }\n");
		}
		else {
		    printf(STDERR "ERROR: don't know what to do with OPC_%s in daddr_dlen\n", $do_id);
		}
	    }
	}
	elsif (($do_full_format eq "X_5")  ||
	       ($do_full_format eq "X_6")  ||
	       ($do_full_format eq "X_7")  ||
	       ($do_full_format eq "X_8")  ||
	       ($do_full_format eq "X_9")  ||
	       ($do_full_format eq "X_10") ||
	       ($do_full_format eq "X_11") ) {
	}
	elsif (($do_full_format eq "X_12") || 
	       ($do_full_format eq "X_14") ) {
	    printf(TOFILE "    if (do_dynamic_trace_generation == 1) {\n");
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      if (RA != 0) {\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD  (scratch_reg, RA, RB);                   next_xlate_address++;\n");      
	    printf(TOFILE "        *next_xlate_address = STORE_REG  (scratch_reg, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG (RB, ARIA_TB_PER_INSTR_SIZE*4*instr_num+ARIA_TB_DADDR_OFFSET, trbf_base_reg);   next_xlate_address++;\n");
	    printf(TOFILE "      }\n");
	    printf(TOFILE "      /* Set the data access length value */\n");
	    printf(TOFILE "      aria_Trace_Dlen(microtrace_buffer_address, instr_num) = %u;\n", $do_dlength);
	    printf(TOFILE "    }\n");
	}
	else {
	    printf(TOFILE "Don't have a case for %s\n", $do_id);
	}
    }

    # The taken-path translation code 
    printf(TOFILE "    if (translation_type == TAKEN_XLATE) {\n");
    printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
    printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
    printf(TOFILE "        DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
    printf(TOFILE "        temp_ptr = next_xlate_address;\n");
    printf(TOFILE "      }      \n");
    printf(TOFILE "      #endif\n");

    # printf(TOFILE "      *next_xlate_address = instr_xlate_info[instr_num].iword;   next_xlate_address++;\n");
    &InsertInstructionWordOrSimCode64(TOFILE);

    printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
    printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
    printf(TOFILE "        DUMP_XLATE_DESCRIPTION(temp_ptr, next_xlate_address, (unsigned *)instr_xlate_info[instr_num].iaddr);\n");
    printf(TOFILE "        temp_ptr = next_xlate_address;\n");
    printf(TOFILE "      }      \n");
    printf(TOFILE "      #endif\n");
    printf(TOFILE "    } else {\n");

    $add_cr_code = 0;
    if(( $do_full_format == "D_5" ) || 
       ( $do_full_format == "D_6" ) || 
       ( $do_full_format == "X_7" ) || 
       ( $do_full_format == "X_8" ) || 
       ( $do_full_format == "X_9" ) || 
       ( $do_full_format == "X_10" ) || 
       ( $do_full_format == "XL_3" ) ) {
	$add_cr_code = 1;
    }
    elsif ( ( $do_uses =~ m/CR[0-7]/i ) || ($do_sets =~ m/CR[0-7]/i ) ) {
	$add_cr_code = 1;
    }

    $doNonMemInstrHandling = 0;

    # The not-taken-path translation code
    if (($do_full_format eq "I_1")   || 
	($do_full_format eq "B_1")   ||
	($do_full_format eq "SC_1")  ||
	($do_full_format eq "SC_2")  ||
	($do_full_format eq "D_2")   ||
	($do_full_format eq "D_4")   ||
	($do_full_format eq "D_5")   ||
	($do_full_format eq "D_6")   ||
	($do_full_format eq "D_7")   ||
	($do_full_format eq "X_5")   ||
	($do_full_format eq "X_6")   ||
	($do_full_format eq "X_7")   || 
	($do_full_format eq "X_8")   ||
	($do_full_format eq "X_9")   ||
	($do_full_format eq "X_10")  ||
	($do_full_format eq "X_11")  ||
	($do_full_format eq "X_13")  ||
	($do_full_format eq "X_15")  ||
	($do_full_format eq "X_16")  ||
	($do_full_format eq "X_17")  ||
	($do_full_format eq "X_18")  ||
	($do_full_format eq "XL_1")  ||
	($do_full_format eq "XL_2")  ||
	($do_full_format eq "XL_3")  ||
	($do_full_format eq "XL_4")  ||
	($do_full_format eq "XFX_1") ||
	($do_full_format eq "XFX_2") ||
	($do_full_format eq "XFX_3") ||
	($do_full_format eq "XFX_4") ||
	($do_full_format eq "XFX_5") ||
	($do_full_format eq "XFL_1") ||
	($do_full_format eq "XS_1")  ||
	($do_full_format eq "XO_1")  ||
	($do_full_format eq "XO_2")  ||
	($do_full_format eq "A_1")   ||
	($do_full_format eq "M_1")   ||
	($do_full_format eq "M_2")   ||
	($do_full_format eq "MD_1")  ||
	($do_full_format eq "MD_2")  ||
	($do_full_format eq "MDS_1") ||
	($do_full_format eq "MDS_2") ||
	($do_full_format eq "MDS_3") ||
	($do_full_format eq "MDS_4") ||
	($do_full_format eq "MDS_5") ||
	($do_full_format eq "MDS_6") ||
	($do_full_format eq "MDS_3n") ||
	($do_full_format eq "MDS_4n") ||
	($do_full_format eq "MDS_5n") ||
	($do_full_format eq "MDS_6n") ||
	($do_full_format eq "TX_1")   ||
	($do_full_format eq "VA_1")   ||
	($do_full_format eq "VA_2")   ||
	($do_full_format eq "VX_1")   ||
	($do_full_format eq "VX_2")   ||
	($do_full_format eq "VX_3")   ||
	($do_full_format eq "VXR_1") 
	) {
	$doNonMemInstrHandling = 1;
    }

    elsif (($do_full_format eq "D_1") || 
	   ($do_full_format eq "D_8") ) {
	printf(TOFILE "    {\n");
	if( ($do_multaccess) ) {
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
	    printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
	    printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	    printf(TOFILE "        CR_must_be_saved = 0;\n");
	    printf(TOFILE "      }\n");	
	    printf(TOFILE "\n      /* Determine the segment we are speculatively addressing */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);    next_xlate_address++;\n");      
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_BC(0xc, 2, 8);     next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Check whether the LAST register load will be in a valid segment*/\n"); 
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);    next_xlate_address++;\n");      
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, 0, 4*(32 - D));   next_xlate_address++;\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
	    printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
	    printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "        *br_posn = OPC_ASM_BC(0xc, 2, 0); /* Insert a temp place-holding branch */\n");	
	    printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	    printf(TOFILE "        #endif\n");
	    printf(TOFILE "        temp_ptr = next_xlate_address;\n");
	    printf(TOFILE "      }      \n");
	    printf(TOFILE "\n      /* Do the original instruction word (a load multiple) */\n");
	    &InsertInstructionWordOrSimCode64(TOFILE);
	    printf(TOFILE "      *br_posn = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn)); /* Insert the branch-over branch */\n");	
	    if ( $add_cr_code == 1 ) {
		printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 1;\n");
		printf(TOFILE "      }\n");  
	    }
	}
	else {
	    printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
	    printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
	    printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	    printf(TOFILE "        CR_must_be_saved = 0;\n");
	    printf(TOFILE "      }\n");	
	    printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, D);    next_xlate_address++;\n");      
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
	    printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
	    printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
	    printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "        *br_posn = OPC_ASM_BC(0xc, 2, 0); /* Insert a temp place-holding branch */\n");	
	    printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	    printf(TOFILE "        #endif\n");	    
	    printf(TOFILE "      }      \n");
	    printf(TOFILE "\n      /* Do the original instruction word (normal load with FORMAT DS_1) */\n");
	    &InsertInstructionWordOrSimCode64(TOFILE);
	    printf(TOFILE "      br_posn_2 = next_xlate_address; /* Avoid the update calculation (done in instr) */;\n");
	    printf(TOFILE "      *br_posn = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn)); /* Insert the branch-over branch */\n");	
	    if ( $do_update ) {
		printf(TOFILE "\n      /* This was a load with update (and invalid access) so do the update part */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_B(2);       next_xlate_address++;\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(RA, RA, D);    next_xlate_address++;\n");      
	    }
	    printf(TOFILE "      *br_posn_2 = OPC_ASM_B(next_xlate_address - br_posn_2); /* Insert the branch-over branch */\n");	
	    if ( $add_cr_code == 1 ) {
		printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 1;\n");
		printf(TOFILE "      }\n");  
	    }
	}
	printf(TOFILE "    }\n");
    }
    
    elsif (($do_full_format eq "D_3") || 
	   ($do_full_format eq "D_9") ||
	   ($do_full_format eq "DS_2") ) {
	if ( $do_update ) {
	    printf(TOFILE "    {\n");
	    printf(TOFILE "      unsigned RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      unsigned D   = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(RA, RA, D);    next_xlate_address++;\n");      
	    printf(TOFILE "    }\n");
	}
    }
    
    elsif ($do_full_format eq "DS_1") {
	printf(TOFILE "    {\n");
	printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "      unsigned DS = OPC_DEC_DSb(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
	printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
	printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
	printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
	printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	printf(TOFILE "        CR_must_be_saved = 0;\n");
	printf(TOFILE "      }\n");	
	printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DS);    next_xlate_address++;\n");      
	printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
	printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
	printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
	printf(TOFILE "        *br_posn = OPC_ASM_BC(0xc, 2, 0); /* Insert a temp place-holding branch */\n");	
	printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	printf(TOFILE "        #endif\n");	    
	printf(TOFILE "        temp_ptr = next_xlate_address;\n");
	printf(TOFILE "      }      \n");
	printf(TOFILE "\n      /* Do the original instruction word (normal load with FORMAT DS_1) */\n");
	&InsertInstructionWordOrSimCode64(TOFILE);
	printf(TOFILE "      br_posn_2 = next_xlate_address; /* Avoid the update calculation (done in instr) */;\n");
	printf(TOFILE "      *br_posn = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn)); /* Insert the branch-over branch */\n");
	if ( $do_update ) {
	    printf(TOFILE "\n      /* This was a load with update (and invalid access) so do the update part */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_B(2);       next_xlate_address++;\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(RA, RA, DS);    next_xlate_address++;\n");      
	}
	printf(TOFILE "      *br_posn_2 = OPC_ASM_B(next_xlate_address - br_posn_2); /* Insert the branch-over branch */\n");
	if ( $add_cr_code == 1 ) {
	    printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
	    printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
	    printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
	    printf(TOFILE "        CR_must_be_saved = 1;\n");
	    printf(TOFILE "      }\n");  
	}
	printf(TOFILE "    }\n");
    }

    elsif ($do_full_format eq "DQ_1") {
	printf(TOFILE "    {\n");
	printf(TOFILE "      unsigned RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "      unsigned DQ4 = OPC_DEC_DQ(instr_xlate_info[instr_num].iword) << 4;\n");
	printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
	printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
	printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
	printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
	printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	printf(TOFILE "        CR_must_be_saved = 0;\n");
	printf(TOFILE "      }\n");	
	printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, DQ4);    next_xlate_address++;\n");      
	printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
	printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
	printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
	printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
	printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
	printf(TOFILE "        *br_posn = OPC_ASM_BC(0xc, 2, 0); /* Insert a temp place-holding branch */\n");	
	printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	printf(TOFILE "        #endif\n");	    
	printf(TOFILE "        temp_ptr = next_xlate_address;\n");
	printf(TOFILE "      }      \n");
	printf(TOFILE "\n      /* Do the original instruction word (normal load with FORMAT DS_1) */\n");
	&InsertInstructionWordOrSimCode64(TOFILE);
	printf(TOFILE "      br_posn_2 = next_xlate_address; /* Avoid the update calculation (done in instr) */;\n");
	printf(TOFILE "      *br_posn = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn)); /* Insert the branch-over branch */\n");
	if ( $do_update ) {
	    printf(TOFILE "\n      /* This was a load with update (and invalid access) so do the update part */\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_B(2);       next_xlate_address++;\n");
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(RA, RA, DQ4);    next_xlate_address++;\n");      
	}
	else {
	    printf(TOFILE "      *next_xlate_address = OPC_ASM_OR(0, 0, 0);       next_xlate_address++;\n");
	}
	printf(TOFILE "      *br_posn_2 = OPC_ASM_B(next_xlate_address - br_posn_2); /* Insert the branch-over branch */\n");
	if ( $add_cr_code == 1 ) {
	    printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
	    printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
	    printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
	    printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
	    printf(TOFILE "        CR_must_be_saved = 1;\n");
	    printf(TOFILE "      }\n");  
	}
	printf(TOFILE "    }\n");
    }
    
    elsif (($do_full_format eq "X_1")  ||  
	   ($do_full_format eq "X_13") ||
	   ($do_full_format eq "X_20") ) {
	if ( $do_load ) {
	    if ( $do_string ){
		printf(TOFILE "      /* This is an indexed-mode (i.e. an lswx) instruction:*/\n");
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
		printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
		printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 0;\n");
		printf(TOFILE "      }\n");	
		printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
		printf(TOFILE "      if (RA != 0) {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD(scratch_reg, RA, RB);    next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RB, 0);    next_xlate_address++;\n");
		printf(TOFILE "      }\n");

		printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");

		printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
		printf(TOFILE "\n      /** Check whether the LAST register load will be in a valid segment **/\n"); 
		printf(TOFILE "      /*  determine number of bytes from XER(25:31) and add to the effective address */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_MFSPR(scratch_reg, 1);                 next_xlate_address++;\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ANDI_(scratch_reg, scratch_reg, 0x7f);    next_xlate_address++;\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ADD(scratch_reg, scratch_reg, RA);        next_xlate_address++;\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
		printf(TOFILE "      /* Load the validity flag for that segment from the set of segment flags */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
		printf(TOFILE "      /* If the segment is invalid (could seg-fault) */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);               next_xlate_address++;\n");
		printf(TOFILE "      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");

		printf(TOFILE "      br_posn_2 = next_xlate_address;  next_xlate_address++; /* Save a spot for second branch */\n");

		printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "        *br_posn   = OPC_ASM_BC(0xc, 2, 0); /* Insert temp branch-over branch instr */\n");	
		printf(TOFILE "        *br_posn_2 = OPC_ASM_BC(0xc, 2, 0); /* Insert temp branch-over branch instr */\n");	
		printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "        #endif\n");	    
		printf(TOFILE "        temp_ptr = next_xlate_address;\n");
		printf(TOFILE "      }      \n");
		printf(TOFILE "\n      /** Do the instruction execution (a load string indexed) **/\n");
		&InsertInstructionWordOrSimCode64(TOFILE);
		printf(TOFILE "      *br_posn   = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn  )); /* Insert the branch-over branch */\n");	
		printf(TOFILE "      *br_posn_2 = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn_2)); /* Insert the branch-over branch */\n");	
		if ( $add_cr_code == 1 ) {
		    printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		    printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		    printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		    printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		    printf(TOFILE "        CR_must_be_saved = 1;\n");
		    printf(TOFILE "      }\n");  
		}
	    }
	    else{	    
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
		printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
		printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 0;\n");
		printf(TOFILE "      }\n");	
		printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
		printf(TOFILE "      if (RA != 0) {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADD(scratch_reg, RA, RB);    next_xlate_address++;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RB, 0);    next_xlate_address++;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);   next_xlate_address++;\n");
		printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
		printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
		printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "        *br_posn   = OPC_ASM_BC(0xc, 2, 0); /* Insert temp branch-over branch instr */\n");	
		printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "        #endif\n");	    
		printf(TOFILE "        temp_ptr = next_xlate_address;\n");
		printf(TOFILE "      }      \n");
		printf(TOFILE "\n      /* Do the original instruction word (a load multiple) */\n");
		&InsertInstructionWordOrSimCode64(TOFILE);
		printf(TOFILE "      br_posn_2 = next_xlate_address; /* Avoid the update calculation (done in instr) */;\n");
		printf(TOFILE "      *br_posn = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn)); /* Insert the branch-over branch */\n");
		if ( $do_update ) {
		    printf(TOFILE "\n      /* This was a load with update (and invalid access) so do the update part */\n");
		    printf(TOFILE "        if (RA != 0) {\n");
		    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADD(RA, RA, RB);    next_xlate_address++;\n");
		    printf(TOFILE "        }\n");
		    printf(TOFILE "        else {\n");
		    printf(TOFILE "          *next_xlate_address = OPC_ASM_ADDI(RA, RB, 0);    next_xlate_address++;\n");
		    printf(TOFILE "        }\n");
		}
		printf(TOFILE "      *br_posn_2 = OPC_ASM_B(next_xlate_address - br_posn_2); /* Insert the branch-over branch */\n");	
		if ( $add_cr_code == 1 ) {
		    printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		    printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		    printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		    printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		    printf(TOFILE "        CR_must_be_saved = 1;\n");
		    printf(TOFILE "      }\n");  
		}
	    }
	} 
	elsif ( do_cache ) {
	    if ( $do_update ) {
		printf(TOFILE "    {\n");
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ADD (RA, RA, RB);            next_xlate_address++;\n");
		printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "       if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "         temp_ptr = next_xlate_address;\n");
		printf(TOFILE "       }      \n");
		printf(TOFILE "      #endif\n");	    
		printf(TOFILE "    }\n");  
	    }
	}
	else {
	    $doNonMemInstrHandling = 1;
	}
    }
    elsif (($do_full_format eq "X_3") ||  
	   ($do_full_format eq "X_14") ||
	   ($do_full_format eq "X_19") ) {
	if( $do_store || $do_cache ) {
	    if ( $do_update ) {
		printf(TOFILE "    {\n");
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "       if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "         temp_ptr = next_xlate_address;\n");
		printf(TOFILE "       }      \n");
		printf(TOFILE "      #endif\n");	    
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ADD (RA, RA, RB);           next_xlate_address++;\n");
		printf(TOFILE "    }\n");
	    }
	}
	else {
	    $doNonMemInstrHandling = 1;
	}
    }

    elsif ($do_full_format eq "X_2") {
	if( $do_load ) {
	    if ( $do_string ) {
		printf(TOFILE "      /* This is an immediate-mode (i.e. an lswi) instruction:*/\n");
		printf(TOFILE "      unsigned RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "      unsigned NB = OPC_DEC_NB(instr_xlate_info[instr_num].iword);\n");
		printf(TOFILE "\n      /* Determine the segement we are speculatively addressing */\n");
		printf(TOFILE "\n      /* Save off the current CR register value so we can use it */\n");
		printf(TOFILE "      if (CR_must_be_saved == 1) {\n");
		printf(TOFILE "        /* Save the current user CR register value so we can use the CR */\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MFCR(scratch_reg);                                  next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = STORE_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 0;\n");
		printf(TOFILE "      }\n");	
		printf(TOFILE "      *next_xlate_address = OPC_ASM_OR (scratch_reg, RA, RA);    next_xlate_address++;\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
		printf(TOFILE "      br_posn = next_xlate_address;   next_xlate_address++; /* Save a spot for the branch-over */\n");
		printf(TOFILE "\n      /* Check whether the LAST register load will be in a valid segment*/\n"); 
		printf(TOFILE "\n      /*  determine number of bytes from XER(25:31) and add to teh effective address */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_ADDI(scratch_reg, RA, NB);            next_xlate_address++;\n");      
		printf(TOFILE "      *next_xlate_address = OPC_ASM_RLWINM(scratch_reg, scratch_reg, 8, 24, 31);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Load the validity flag for that segment from the set of segment flags */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_LBZX(scratch_reg, base_register, scratch_reg);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* If the segment is invalid (could seg-fault) */\n");
		printf(TOFILE "      *next_xlate_address = OPC_ASM_CMPI(0, 0, scratch_reg, 0);    next_xlate_address++;\n");
		printf(TOFILE "\n      /* Skip the load of that segment (NOTE: not quite proper behavior) */\n");
		printf(TOFILE "      br_posn_2 = next_xlate_address;  next_xlate_address++; /* Save a spot for second branch */\n");
		printf(TOFILE "\n      /* Do the original instruction word (a load string immediate) */\n");
		printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "        *br_posn   = OPC_ASM_BC(0xc, 2, 0); /* Insert temp branch-over branch instr */\n");	
		printf(TOFILE "        *br_posn_2 = OPC_ASM_BC(0xc, 2, 0); /* Insert temp branch-over branch instr */\n");	
		printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "        #endif\n");	    
		printf(TOFILE "        temp_ptr = next_xlate_address;\n");
		printf(TOFILE "      }      \n");
		&InsertInstructionWordOrSimCode64(TOFILE);
		printf(TOFILE "      *br_posn   = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn  )); /* Insert the branch-over branch */\n");	
		printf(TOFILE "      *br_posn_2 = OPC_ASM_BC(0xc, 2, (next_xlate_address - br_posn_2)); /* Insert the branch-over branch */\n");	
		if ( $add_cr_code == 1 ) {
		    printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		    printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		    printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		    printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		    printf(TOFILE "        CR_must_be_saved = 1;\n");
		    printf(TOFILE "      }\n");  
		}
	    }
	    else {
		printf(STDERR "ERROR: don't know what to do with OPC_%s in daddr_dlen\n", $do_id);
	    }
	}
    }
    elsif ($do_full_format eq "X_4") {
	if( $do_store || $do_cache ) {
	    if ( $do_update ) {
		printf(TOFILE "    #ifndef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "    {\n");
		printf(TOFILE "      if (do_no_output_during_runs == 0) {\n");
		printf(TOFILE "        DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
		printf(TOFILE "        temp_ptr = next_xlate_address;\n");
		printf(TOFILE "      }      \n");
		printf(TOFILE "    }\n");
		printf(TOFILE "    #endif\n");
	    }
	}
	else {
	    $doNonMemInstrHandling = 1;
	}
    }

    
    if ($doNonMemInstrHandling) {
	if ( do_alters_flow ) {
	    printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "       if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	    printf(TOFILE "         temp_ptr = next_xlate_address;\n");
	    printf(TOFILE "       }\n");
	    printf(TOFILE "      #endif\n");	    
	}
	else {
	    if ( $add_cr_code == 1 ) {
		printf(TOFILE "      if ( CR_must_be_saved == 0 ) {\n");  
		printf(TOFILE "        /* Restore the unmodified (user) CR register value so we can use it */\n");
		printf(TOFILE "        *next_xlate_address = LOAD_REG(scratch_reg, CR_SAVE_OFFSET, base_register);    next_xlate_address++;\n");
		printf(TOFILE "        *next_xlate_address = OPC_ASM_MTCRF (0xff, scratch_reg);                next_xlate_address++;\n");
		printf(TOFILE "        CR_must_be_saved = 1;\n");
		printf(TOFILE "      }\n");	
	    }
	    printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "       if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "         DUMP_FAKE_DESCRIPTION(temp_ptr, next_xlate_address);\n");
	    printf(TOFILE "         temp_ptr = next_xlate_address;\n");
	    printf(TOFILE "       }\n");
	    printf(TOFILE "      #endif\n");	    

	    &InsertInstructionWordOrSimCode64(TOFILE);
	}
    }
    
    printf(TOFILE "      #ifndef DO_ARIA_AIX_43_COMPILE\n");
    printf(TOFILE "       if (do_no_output_during_runs == 0) {\n");
    printf(TOFILE "         DUMP_XLATE_DESCRIPTION(temp_ptr, next_xlate_address, (unsigned *)instr_xlate_info[instr_num].iaddr);\n");
    printf(TOFILE "         temp_ptr = next_xlate_address;\n");
    printf(TOFILE "       }      \n");
    printf(TOFILE "      #endif\n");	    
    printf(TOFILE "    }\n");
    
    printf(TOFILE "  }\n");
    printf(TOFILE "break;\n");
}


sub generate_final_translation_code64 {
    local(*TOFILE) = $_[0];

    if ($last_printed{$processingType} == 1) {
	printf(TOFILE "      fprintf(stderr, \"ERROR: The case %%d not supported for %s\\n\", instr_xlate_info[instr_num].index);\n", $processingType);
	printf(TOFILE "      break;\n\n");
    }
    
    printf(TOFILE "  default:\n");
    printf(TOFILE "    if (translation_type == NOT_TAKEN_XLATE) {\n");
    printf(TOFILE "      if (global_return_nop_in_trace_for_illegal_speculatives) {\n");
    printf(TOFILE "        aria_Trace_Iword(microtrace_buffer_address, instr_num) = global_spec_nop_iword;\n");
    printf(TOFILE "        aria_Trace_Ikind(microtrace_buffer_address, instr_num) = global_spec_nop_itype;\n");
    printf(TOFILE "        aria_Trace_Iword(microtrace_buffer_address, instr_num) = 0x0;\n");
    printf(TOFILE "        aria_Trace_Ikind(microtrace_buffer_address, instr_num) = 0x0;\n");
    printf(TOFILE "      }\n");
    printf(TOFILE "      *next_xlate_address = global_spec_nop_iword;   next_xlate_address++;\n");
    printf(TOFILE "    } else {\n");
    printf(TOFILE "      warn(\"ARIA: ERROR:  opcode switch on index bad for %s\\n\",\n", "0x%08x => %u");
    printf(TOFILE "           instr_xlate_info[instr_num].iword, instr_xlate_info[instr_num].index);\n");
    printf(TOFILE "    }\n");
    printf(TOFILE "  break;\n");
    printf(TOFILE "}\n");
}




sub InsertInstructionWordOrSimCode64 {
    local(*TOFILE) = $_[0];
    local(@code_lines);
    local($sim_instr);

    if ($processingType eq "simulation") {
	if ( ($G_simppc{$do_id}) || ($G_simpower{$do_id}) || ($G_simpower2{$do_id}) || ($G_simppc64on32{$do_id}) ) {
	    printf(TOFILE "      if ( (global_do_aria_simulation == 0) ) { \n");
	    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
	    printf(TOFILE "        #endif\n");
	    printf(TOFILE "        *next_xlate_address = instr_xlate_info[instr_num].iword;   next_xlate_address++;\n");
	    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
	    printf(TOFILE "        #endif\n");
	    printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "           DUMP_XLATE_DESCRIPTION(temp_ptr, next_xlate_address, (unsigned *)instr_xlate_info[instr_num].iaddr);\n");
	    printf(TOFILE "           temp_ptr = next_xlate_address;\n");
	    printf(TOFILE "         }      \n");
	    printf(TOFILE "        #endif\n");
	    printf(TOFILE "      } else {\n");
	    printf(TOFILE "        if (the_machine_isa_type == OPC_PPC_ISA) {\n");
	    if ($G_simppc{$do_id}) {
		#printf(STDOUT " Adding PowerPC simulation code for :: %s\n", $do_id);
		@code_lines = split(":", $G_simppc_code{$do_id});
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
		for( $sim_instr = 0; $sim_instr <= $#code_lines; $sim_instr++) {
		    printf(TOFILE "          *next_xlate_address = %s;   next_xlate_address++;\n", $code_lines[$sim_instr]);
		}
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
	    }
	    else {
		printf(TOFILE "          WARN(fprintf(mystderr, \"WARNING: No explicit PowerPC simulation for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword));\n");
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
		printf(TOFILE "          *next_xlate_address = instr_xlate_info[instr_num].iword;  next_xlate_address++;\n");
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
	    }
	    if ($G_simpower2{$do_id}) {
		printf(TOFILE "        } else if (the_machine_isa_type == OPC_POWER_ISA) {\n");
		if ($G_simpower{$do_id}) {
		    #printf(STDOUT " Adding  POWER  simulation code for :: %s\n", $do_id);
		    @code_lines = split(":", $G_simpower_code{$do_id});
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		    for( $sim_instr = 0; $sim_instr <= $#code_lines; $sim_instr++) {
			printf(TOFILE "          *next_xlate_address = %s;   next_xlate_address++;\n", $code_lines[$sim_instr]);
		    }
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		}
		else {
		    printf(TOFILE "          WARN(fprintf(mystderr, \"WARNING: No explicit POWER simulation for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword));\n");
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		    printf(TOFILE "          *next_xlate_address = instr_xlate_info[instr_num].iword;  next_xlate_address++;\n");
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		}
		printf(TOFILE "        } else if (the_machine_isa_type == OPC_POWER2_ISA) {\n");
		#printf(STDOUT " Adding  POWER2 simulation code for :: %s\n", $do_id);
		@code_lines = split(":", $G_simpower2_code{$do_id});
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
		for( $sim_instr = 1; $sim_instr <= $#code_lines; $sim_instr++) {
		    printf(TOFILE "          *next_xlate_address = %s;   next_xlate_address++;\n", $code_lines[$sim_instr]);
		}
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
	    }
	    else {
		printf(TOFILE "        } else if ( (the_machine_isa_type == OPC_POWER_ISA) || (the_machine_isa_type == OPC_POWER2_ISA) ) {\n");
		if ($G_simpower{$do_id}) {
		    #printf(STDOUT " Adding  POWER  simulation code for :: %s\n", $do_id);
		    #printf(STDOUT " Adding  POWER2 simulation code for :: %s\n", $do_id);
		    @code_lines = split(":", $G_simpower_code{$do_id});
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		    for( $sim_instr = 0; $sim_instr <= $#code_lines; $sim_instr++) {
			printf(TOFILE "          *next_xlate_address = %s;   next_xlate_address++;\n", $code_lines[$sim_instr]);
		    }
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		}
		else {
		    printf(TOFILE "          WARN(fprintf(mystderr, \"WARNING: No explicit POWER/POWER2 simulation for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword));\n");
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		    printf(TOFILE "          *next_xlate_address = instr_xlate_info[instr_num].iword;  next_xlate_address++;\n");
		    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		    printf(TOFILE "        #endif\n");
		}
	    }
	    printf(TOFILE "        } else if (the_machine_isa_type == OPC_PPC64on32_ISA) {\n");
	    if ($G_simppc64on32{$do_id}) {
		#printf(STDOUT " Adding PPC64on32 simulation code for :: %s\n", $do_id);
		@code_lines = split(":", $G_simppc64on32_code{$do_id});
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
		for( $sim_instr = 0; $sim_instr <= $#code_lines; $sim_instr++) {
		    printf(TOFILE "          *next_xlate_address = %s;   next_xlate_address++;\n", $code_lines[$sim_instr]);
		}
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
	    }
	    else {
		printf(TOFILE "          WARN(fprintf(mystderr, \"WARNING: No explicit PPC64on32 simulation for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword));\n");
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
		printf(TOFILE "          *next_xlate_address = instr_xlate_info[instr_num].iword;  next_xlate_address++;\n");
		printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
		printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
		printf(TOFILE "        #endif\n");
	    }
	    printf(TOFILE "        } else {\n");
	    printf(TOFILE "          fprintf(mystderr, \"ERROR: No simulation code for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword);\n");
	    printf(TOFILE "          exit(-1);\n");
	    printf(TOFILE "        }\n");      
	    printf(TOFILE "        #ifndef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         if (do_no_output_during_runs == 0) {\n");
	    printf(TOFILE "           DUMP_SIMULATION_DESCRIPTION(temp_ptr, next_xlate_address, (unsigned *)instr_xlate_info[instr_num].iaddr);\n");
	    printf(TOFILE "           temp_ptr = next_xlate_address;\n");
	    printf(TOFILE "         }\n");
	    printf(TOFILE "        #endif\n");	    
	    printf(TOFILE "      }\n");
	}
	else {
	    printf(TOFILE "      WARN(fprintf(mystderr, \"Warning: No simulation code for instruction 0x%%08x\\n\", instr_xlate_info[instr_num].iword));\n");
	    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr = (BASE_TYPE)next_xlate_address;\n");
	    printf(TOFILE "        #endif\n");
	    printf(TOFILE "      *next_xlate_address = instr_xlate_info[instr_num].iword;      next_xlate_address++;\n");
	    printf(TOFILE "        #ifdef DO_ARIA_AIX_43_COMPILE\n");
	    printf(TOFILE "         instr_xlate_info[instr_num].xl_addr_end = (BASE_TYPE)next_xlate_address;\n");
	    printf(TOFILE "        #endif\n");
	}
    }
    elsif ( ($processingType eq "native") || ($processingType = "canned_multiple") ) {
	printf(TOFILE "      *next_xlate_address = instr_xlate_info[instr_num].iword;      next_xlate_address++;\n");
    }
    else {
	printf(STDERR "ERROR: I don't understand processing type %s in full translation code\n", $processingType);
    }
}






sub InsertInstructionDisassembly64 {
    local(*TOFILE) = $_[0];

    if ($do_full_format eq "I_1") {
	printf(TOFILE "    int LI = OPC_DEC_LI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int AA = OPC_DEC_AA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "B_1") {
	printf(TOFILE "    int BO = OPC_DEC_BO(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BI = OPC_DEC_BI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BD = OPC_DEC_BD(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int AA = OPC_DEC_AA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "SC_1") {
	printf(TOFILE "    int LK = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "SC_2") {
	printf(TOFILE "    int LEV = OPC_DEC_LEV(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK  = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_1") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_2") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SI = OPC_DEC_SI(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_3") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_4") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SI = OPC_DEC_SI(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_5") {
	printf(TOFILE "    int BF = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int L  = OPC_DEC_L(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SI = OPC_DEC_SI(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_6") {
	printf(TOFILE "    int BF = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int L  = OPC_DEC_L(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int UI = OPC_DEC_UI(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_7") {
	printf(TOFILE "    int TO = OPC_DEC_TO(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SI = OPC_DEC_SI(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_8") {
	printf(TOFILE "    int FRT = OPC_DEC_FRT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D   = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "D_9") {
	printf(TOFILE "    int FRS = OPC_DEC_FRS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D   = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "DS_1") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "DS_2") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int D  = OPC_DEC_D(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "DQ_1") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int DQ = OPC_DEC_DQ(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int PT = OPC_DEC_PT(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_1") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_2") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int NB = OPC_DEC_NB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_3") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_4") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int NB = OPC_DEC_NB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_5") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SH(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_6") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_7") {
	printf(TOFILE "    int BF = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int L  = OPC_DEC_L(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_8") {
	printf(TOFILE "    int BF  = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRA = OPC_DEC_FRA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRB = OPC_DEC_FRB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_9") {
	printf(TOFILE "    int BF  = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BFA = OPC_DEC_BFA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_10") {
	printf(TOFILE "    int BF = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int U  = OPC_DEC_U(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_11") {
	printf(TOFILE "    int TO = OPC_DEC_TO(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_12") {
	printf(TOFILE "    int FRT = OPC_DEC_FRT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_13") {
	printf(TOFILE "    int FRT = OPC_DEC_FRT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_14") {
	printf(TOFILE "    int FRS = OPC_DEC_FRS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_15") {
	printf(TOFILE "    int BT = OPC_DEC_BT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_16") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SR = OPC_DEC_SR(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "X_17") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SR = OPC_DEC_SR(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "X_18") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "X_19") {
	printf(TOFILE "    int VS = OPC_DEC_VS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "X_20") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XL_1") {
	printf(TOFILE "    int BT = OPC_DEC_BT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BA = OPC_DEC_BA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BB = OPC_DEC_BB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XL_2") {
	printf(TOFILE "    int BO = OPC_DEC_BO(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BI = OPC_DEC_BI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XL_3") {
	printf(TOFILE "    int BF  = OPC_DEC_BF(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int BFA = OPC_DEC_BFA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int LK  = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XL_4") {
	printf(TOFILE "    int LK  = OPC_DEC_LK(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "XFX_1") {
	printf(TOFILE "    int RT  = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SPR = OPC_DEC_SPR(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XFX_2") {
	printf(TOFILE "    int RT  = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int TBR = OPC_DEC_TBR(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XFX_3") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FXM = OPC_DEC_FXM(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XFX_4") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SPR = OPC_DEC_SPR(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XFX_5") {
	printf(TOFILE "    int XO2 = OPC_DEC_XO2(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XFL_1") {
	printf(TOFILE "    int FLM = OPC_DEC_FLM(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRB = OPC_DEC_FRB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XS_1") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SH(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "XO_1") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int OE = OPC_DEC_OE(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "XO_2") {
	printf(TOFILE "    int RT = OPC_DEC_RT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int OE = OPC_DEC_OE(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "A_1") {
	printf(TOFILE "    int FRT = OPC_DEC_FRT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRA = OPC_DEC_FRA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRB = OPC_DEC_FRB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int FRC = OPC_DEC_FRC(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "M_1") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int MB = OPC_DEC_MB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int ME = OPC_DEC_ME(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "M_2") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SH(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int MB = OPC_DEC_MB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int ME = OPC_DEC_ME(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MD_1") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SH(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int MB = OPC_DEC_MBW(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MD_2") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SH(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int ME = OPC_DEC_MEW(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_1") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int MB = OPC_DEC_MBW(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_2") {
	printf(TOFILE "    int RS = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int ME = OPC_DEC_MEW(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_3") {
	printf(TOFILE "    int IS  = OPC_DEC_IS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int IB  = OPC_DEC_IB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int XBI = OPC_DEC_XBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_3n") {
	printf(TOFILE "    int IS  = OPC_DEC_IS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int IB  = OPC_DEC_IB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int CBI = OPC_DEC_CBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_4") {
	printf(TOFILE "    int IS  = OPC_DEC_IS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int XBI = OPC_DEC_XBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_4n") {
	printf(TOFILE "    int IS  = OPC_DEC_IS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int CBI = OPC_DEC_CBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_5") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int IB  = OPC_DEC_IB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int XBI = OPC_DEC_XBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_5n") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int IB  = OPC_DEC_IB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int CBI = OPC_DEC_CBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "MDS_6") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int XBI = OPC_DEC_XBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "MDS_6n") {
	printf(TOFILE "    int RS  = OPC_DEC_RS(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RA  = OPC_DEC_RA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int RB  = OPC_DEC_RB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int CBI = OPC_DEC_CBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    } 
    elsif ($do_full_format eq "TX_1") {
	printf(TOFILE "    int TO  = OPC_DEC_TO(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int UI  = OPC_DEC_UI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int XBI = OPC_DEC_XBI(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc  = OPC_DEC_Rc(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VA_1") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VC = OPC_DEC_VC(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VA_2") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int SH = OPC_DEC_SHB(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VX_1") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VX_2") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VX_3") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
    }
    elsif ($do_full_format eq "VXR_1") {
	printf(TOFILE "    int VT = OPC_DEC_VT(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VA = OPC_DEC_VA(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int VB = OPC_DEC_VB(instr_xlate_info[instr_num].iword);\n");
	printf(TOFILE "    int Rc = OPC_DEC_VRc(instr_xlate_info[instr_num].iword);\n");
    }
    else {
	printf(STDERR "Opcode_aria64.pl: instr %s Illegal full_format %s for format %s\n", $do_id, $do_full_format, $do_format);
    }
}






#* Note: If you alter the generation of this, make sure to update the */
#*  definition of the machine ISA types in opc_is_implemented_types.h */
sub DoInitialIsImplementedInstrForISA64 {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  0x00, /* %-10s */\n", "ILLEGAL");
}


sub DoIsImplementedInstrForISAForThisInstruction64 {
    local(*TOFILE) = $_[0];
    local ($value);
    
    $value = 0;
    if ($do_power_name ne "") {
	$value = $value + 1;
    }
    if ($do_power2_name ne "") {
	$value = $value + 2;
    }
    if ($do_ppc601_name ne "") {
	$value = $value + 4;
    }
    if ($do_ppc32_name ne "") {
	$value = $value + 8;
    }
    if ($do_ppc40x_name ne "") {
	$value = $value + 16;
    }
    if ($do_ppc_name ne "") {
	$value = $value + 32;
    }
    if ($do_amazon_name ne "") {
	$value = $value + 64;
    }
    printf(TOFILE "  0x%02x, /* %-10s */\n", $value, $do_id);
}


sub DoFinalIsImplementedInstrForISA64 {
    local(*TOFILE) = $_[0];
}
