

#************************************************************************#
#*  The process_dep routine is used for some specific code for the      *#
#*    MET turandot dep_prep tool.                                       *#
#************************************************************************#
sub DoInitialGenerateDepPrepCode {
    local(*TOFILE) = $_[0];
}

sub DoFinalGenerateDepPrepCode {
    local(*TOFILE) = $_[0];
}

sub DoGenerateDepPrepCodeForThisInstruction {
    local(*TOFILE) = $_[0];
    local($regidx, @others, $idx, $reg, $special_memop);

    $special_memop = 0;

    printf(TOFILE "  case OPC_%s: {\n", $do_id);

    if( $do_id eq "MTSR" || $do_id eq "MTSRIN" ||
       $do_id eq "MFSR" || $do_id eq "MFSRIN" ||
       $do_id eq "EIEIO" ||
       $do_id eq "SYNC" ||
       $do_id eq "TLBSYNC" || $do_id eq "TLBIA" || $do_id eq "TLBIE" ) {

	$special_memop = 1;
	printf(TOFILE "      is_memop = 1;\n");
	printf(TOFILE "      is_notaddr = 1;\n");
	printf(TOFILE "      is_athead = 1;\n");
    }
    
    if( $do_id eq "MTSR" ) {
	printf(TOFILE "      is_mtsr = 1;\n");
    }
    
    if( $do_id eq "ISYNC" ) {
	printf(TOFILE "      is_sync = 1;\n");
    }
    
    if( $do_full_format eq "I_1" ) {
	if( $do_LK eq "1" ) {
	    printf(TOFILE "      is_brlk = 1;\n");
	}
    }	
    
    elsif( $do_full_format eq "B_1" ) {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x14) != 0x14) {\n  ");
	&gen_uses(TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
	printf(TOFILE "      is_brcond = 1;\n");
	if( $do_LK eq "1" ) {
	    printf(TOFILE "      is_brlk = 1; \n");
	}
    }
    
    elsif ($do_full_format eq "SC_1") {
	#* None *#
    }
    elsif ($do_full_format eq "SC_2") {
	#* None *#
    }
    
    elsif ($do_full_format eq "D_1") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	if( $do_load ) {
	    if ($do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "A");
	    }
	}
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_2") {
	if( $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_3") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "A");
	}
    }
    elsif ($do_full_format eq "D_4") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif ( ($do_full_format eq "D_5") || 
	   ($do_full_format eq "D_6") ) {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "D_7") {
	&gen_uses(TOFILE, $do_RA, "RA");	    
    }
    elsif ($do_full_format eq "D_8") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_FRT, "FRT");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_9") {
	&gen_uses(TOFILE, $do_FRS, "FRS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DS_1") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_RT, "RT");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "DS_2") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DQ_1") {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_RT, "RT");
	if ($do_update) {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    
    elsif( $do_full_format eq "X_1" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_load || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
	if( $do_sets !~ /R0_R31/ ) {
	    &gen_sets(TOFILE, $do_RT, "RT");
	    if( $do_load ) {
		if ( $do_update ) {
		    &gen_mem_sets(TOFILE, $do_RA, "RA");
		}
	    }
	}
    }
    elsif ($do_full_format eq "X_2") {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "X_3") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_load || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	if( $do_store ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_4") {
	if( $do_id eq "STSWI"  || $do_id eq "STSDI" ) {
	    &gen_uses(TOFILE, $do_RS, "RS");
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RS, "RS");
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_5") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "X_6") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_7") {
	&gen_uses(TOFILE, $do_RB, "RA");
	&gen_uses(TOFILE, $do_RA, "RB");
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_8") {
	&gen_uses(TOFILE, $do_FRB, "FRA");
	&gen_uses(TOFILE, $do_FRA, "FRB");
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_9") {
	if ($do_BFA eq "0") {
	    #* None *#
	}
	else {
	    &gen_uses(TOFILE, $do_BFA, "BFA");
	}
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_10") {
	#* None *#
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_11") {
	&gen_uses(TOFILE, $do_RB, "RA");
    }
    elsif( $do_full_format eq "X_12" ) {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_FRT, "FRT");
	if ($do_load) {
	    if ($do_update) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_13") {
	&gen_uses(TOFILE, $do_FRB, "FRB");
	&gen_sets(TOFILE, $do_FRT, "FRT");
    }
    elsif ($do_full_format eq "X_14") {
	&gen_uses(TOFILE, $do_FRS, "FRS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
	if ($do_store ) {
	    if ( $do_update) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_15") {
	&gen_sets(TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "X_16") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_17") {
	#* No uses *#
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "X_18") {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_19") {
	&gen_uses(TOFILE, $do_VS, "VS");
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_store || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_load ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
	&gen_sets(TOFILE, $do_VT, "VT");
	if( $do_load ) {
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }

    elsif ($do_full_format eq "XL_1") {
	&gen_uses(TOFILE, $do_BA, "BA");
	&gen_uses(TOFILE, $do_BB, "BB");
	&gen_uses(TOFILE, $do_BT, "BT");
	&gen_sets(TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "XL_2") {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x14) != 0x14) {\n  ");
	&gen_uses(TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
	if( $do_id eq "BCCTR" || $do_id eq "BCCTRL" ) {
	    printf(TOFILE "      is_brctr = 1;\n");
	    printf(TOFILE "      is_brcrg = !OPC_DEC_BO_bit0(iword);\n");
	}
	elsif( $do_id eq "BCLR" || $do_id eq "BCLRL" ) {
	    printf(TOFILE "      is_brlink = 1;\n");
	    printf(TOFILE "      is_brcrg = !OPC_DEC_BO_bit0(iword);\n");
	}
	if( $do_LK eq "1" ) {
	    printf(TOFILE "      is_brlk = 1;\n");
	}
    }
    elsif ($do_full_format eq "XL_3") {
	&gen_uses(TOFILE, $do_BFA, "BFA");
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "XL_4") {
	#* None *#
    }

    elsif ( ($do_full_format eq "XFX_1") || 
	   ($do_full_format eq "XFX_2") ) {
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif (($do_full_format eq "XFX_3") ||
	   ($do_full_format eq "XFX_4") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ( $do_full_format eq "XFX_5" ) {
	#* None -- note, need special encoding (uses) or not? *#
    }

    elsif ($do_full_format eq "XFL_1") {
	&gen_uses(TOFILE, $do_FRB, "FRB");
    }

    elsif ($do_full_format eq "XS_1") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_sets(TOFILE, $do_RA, "RA");
    }

    elsif ( ($do_full_format eq "XO_1") || ($do_full_format eq "XO_2") ) {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RT, "RT");
    }

    elsif( $do_full_format eq "A_1" ) {
	&gen_uses(TOFILE, $do_FRA, "FRA");
	&gen_uses(TOFILE, $do_FRB, "FRB");
	&gen_uses(TOFILE, $do_FRC, "FRC");
	&gen_sets(TOFILE, $do_FRT, "FRT");
    }

    elsif( $do_full_format eq "M_1" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "M_2" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_sets(TOFILE, $do_RA, "RA");
    }

    elsif( ($do_full_format eq "MD_1") || ($do_full_format eq "MD_2") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    
    elsif( ($do_full_format eq "MDS_1") || ($do_full_format eq "MDS_2") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_3" ) {
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_3n" ) {
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_4" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_4n" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_5" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_5n" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_6" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif( $do_full_format eq "MDS_6n" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	#* None *#
    }

    elsif( $do_full_format eq "VA_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_uses(TOFILE, $do_VC, "VC");
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VA_2" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_2" ) {
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_3" ) {
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VXR_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_sets(TOFILE, $do_VT, "VT");
    }

    else {
	print(STDERR "Unknown format ", $do_format, " : ", $do_full_format, " in process_dep\n");
	exit(-1);
    }

    if( $do_load ) {
	printf(TOFILE "      is_load = 1;\n");
	printf(TOFILE "      dlength = %d;\n", $do_dlength);
    }
    if( $do_store ) {
	printf(TOFILE "      is_store = 1;\n");
	printf(TOFILE "      dlength = %d;\n", $do_dlength);
    }
    if( $do_load || $do_store || $do_cache ) {
	printf(TOFILE "      is_memop = 1;\n");
    }

    #* Check for added "special" uses *#
    if( $do_uses ne "" ) {
	@others = split(":", $do_uses);
	for $idx ( @others ) {
	    $reg = $GR_reg{$idx};
	    if( $idx eq "quad" ) {
		printf(TOFILE "        n = (OPC_DEC_RS(iword)+1)%32;\n");
		printf(TOFILE "        uses[nuses++] = OPC_FPR(n);\n");
	    }
	    elsif( $idx eq "RS_NB" ) {
		printf(TOFILE "      n = OPC_DEC_NB(iword)?(OPC_DEC_NB(iword)+3)>>2:8;\n");
		printf(TOFILE "      for( i = OPC_DEC_RS(iword)+1; i < OPC_DEC_RS(iword)+n; i++ ) {\n");
		printf(TOFILE "        unsigned reg = i%32;\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(reg);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      for( i = 0; i < 32; i++ ) {\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RS_R31" ) {
		printf(TOFILE "      for( i = OPC_DEC_RS(iword)+1; i < 32; i++ ) {\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "SPRenc" ) {
		printf(TOFILE "      spr = OPC_DEC_SPR(iword);\n");
		printf(TOFILE "      if( spr == 1 ) {\n");
		printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"SO"});
		printf(TOFILE "        nuses += %s;\n", $GR_incr{"SO"});
		printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"CA"});
		printf(TOFILE "        nuses += %s;\n", $GR_incr{"CA"});
		printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"BCNT"});
		printf(TOFILE "        nuses += %s;\n", $GR_incr{"BCNT"});
		printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"FXCC"});
		printf(TOFILE "        nuses += %s;\n", $GR_incr{"FXCC"});
		printf(TOFILE "      }\n");
		printf(TOFILE "	else {\n");
		printf(TOFILE "        spr = opc_tblsprenc[spr];\n");
		printf(TOFILE "        uses[nuses] = spr;\n");
		printf(TOFILE "        nuses += spr != 0;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "XBIenc" ) {
		printf(TOFILE "  /*** NEED TO FIGURE THIS ONE OUT (Time Base?) ***/ \n");
		printf(TOFILE "  /*    tbr = OPC_DEC_TBR(iword);  */\n");
	    }
	    elsif( ($idx eq "FPSCR") ||
		   ($idx eq "FPSCR_FPCC") ||
		   ($idx eq "FPSCR_FRFI") ||
		   ($idx eq "FPSCR_EXCPT") ||
		   ($idx eq "FPSCR_FLM") ||
		   ($idx eq "FPSCR_BFA") ||
		   ($idx eq "FPSCR_BT") ||
		   ($idx eq "FPSCR_BF") ) {
	    }
	    elsif( $reg eq "" ) {
		print(STDERR $do_id, ": unknown use $idx $name\n" );
		exit(-1);
	    }
	    else {
		printf(TOFILE "      uses[nuses] = %s;\n", $reg);
		printf(TOFILE "      nuses += %s;\n", $GR_incr{$idx});
	    }
	}
    }

    if( $do_sets ne "" ) {
	@others = split(":", $do_sets);
	for $idx ( @others ) {
	    $reg = $GR_reg{$idx};
	    if( $idx eq "quad" ) {
		printf(TOFILE "      n = (OPC_DEC_RT(iword)+1)%32;\n");
		printf(TOFILE "      sets[nsets++] = OPC_FPR(n);\n");
	    }
	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword);\n");
		printf(TOFILE "      m = OPC_DEC_RA(iword);\n");
		printf(TOFILE "      m = (m == 0) ? n : m;\n");
		printf(TOFILE "      for( i = 0; i < 32; i++ ) {\n");
		printf(TOFILE "        sets[nsets] = OPC_GPR(i);\n");
		printf(TOFILE "        nsets += ((i != n) && (i != m));\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RT_R31" ) {
		printf(TOFILE "      for( i = OPC_DEC_RT(iword)+1; i < 32; i++ ) {\n");
		printf(TOFILE "        sets[nsets++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RT_NB" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword)?(OPC_DEC_RB(iword)+3)>>2:8;\n");
		printf(TOFILE "      for( i = OPC_DEC_RT(iword)+1; i < OPC_DEC_RT(iword) + n; i++ ) {\n");
		printf(TOFILE "        sets[nsets++] = OPC_GPR((i%32));\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "FXM") {
		printf(TOFILE "      for( i = OPC_DEC_FXM(iword), j = 7; i; i  = i >> 1, j--  ) {\n");
		printf(TOFILE "        sets[nsets] = OPC_CR(j);\n");
		printf(TOFILE "        nsets += i&1;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "SPRenc" ) {
		printf(TOFILE "      spr = OPC_DEC_SPR(iword);\n");
		printf(TOFILE "      if( spr == 1 ) {\n");
		printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"SO"});
		printf(TOFILE "        nsets += %s;\n", $GR_incr{"SO"});
		printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"CA"});
		printf(TOFILE "        nsets += %s;\n", $GR_incr{"CA"});
		printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"BCNT"});
		printf(TOFILE "        nsets += %s;\n", $GR_incr{"BCNT"});
		printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"FXCC"});
		printf(TOFILE "        nsets += %s;\n", $GR_incr{"FXCC"});
		printf(TOFILE "      }\n");
		printf(TOFILE "	else {\n");
		printf(TOFILE "        spr = opc_tblsprenc[spr];\n");
		printf(TOFILE "        sets[nsets] = spr;\n");
		printf(TOFILE "        nsets += spr != 0;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( ($idx eq "FPSCR" ) ||
		   ($idx eq "FPSCR_FPCC") ||
		   ($idx eq "FPSCR_FRFI") ||
		   ($idx eq "FPSCR_EXCPT") ||
		   ($idx eq "FPSCR_FLM") ||
		   ($idx eq "FPSCR_BFA") ||
		   ($idx eq "FPSCR_BT") ||
		   ($idx eq "FPSCR_BF") ) {
	    }
	    elsif( $reg eq "" ) {
		print(STDERR $do_id, ": unknown set $idx $name\n");
		exit(-1);
	    }
	    else {
		printf(TOFILE "      sets[nsets] = %s;\n", $reg);
		printf(TOFILE "      nsets += %s;\n", $GR_incr{$idx});
	    }
	}
    }
    
    if( $do_multiple || $do_multaccess ) {
	printf(TOFILE "      is_multi = 1;\n");
    }
    if( $do_string && $do_multiple ) {
	printf(TOFILE "      is_string = 1;\n");
    }
    
    if( $do_load || $special_memop ) {
	printf(TOFILE "      unit = xdep_prep_ctl.load_unit;\n");
	if( $do_id eq "LWA" || $do_id eq "LWAX" || $do_id eq "LWAU" || $do_id eq "LWAUX" ) {
	    printf(TOFILE "      latency = xdep_prep_ctl.load_latency + xdep_prep_ctl.arithmetic_load_latency;\n");
	    printf(TOFILE "      avail = xdep_prep_ctl.load_avail + xdep_prep_ctl.arithmetic_load_avail;\n");
	}
	elsif( $do_id eq "LHA" || $do_id eq "LHAX" || $do_id eq "LHAU" || $do_id eq "LHAUX" ) {
	    printf(TOFILE "      latency = xdep_prep_ctl.load_latency + xdep_prep_ctl.arithmetic_subword_load_latency;\n");
	    printf(TOFILE "      avail = xdep_prep_ctl.load_avail + xdep_prep_ctl.arithmetic_subword_load_avail;\n");
	}
	elsif( $do_id eq "LHZ" || $do_id eq "LHZX" || $do_id eq "LHZU" || $do_id eq "LHZUX" ||
	      $do_id eq "LBZ" || $do_id eq "LBZX" || $do_id eq "LBZU" || $do_id eq "LBZUX" ) {
	    printf(TOFILE "      latency = xdep_prep_ctl.load_latency + xdep_prep_ctl.subword_load_latency;\n");
	    printf(TOFILE "      avail = xdep_prep_ctl.load_avail + xdep_prep_ctl.subword_load_avail;\n");
	}
	elsif( $do_float ) {
	    printf(TOFILE "      latency = xdep_prep_ctl.load_latency + xdep_prep_ctl.float_load_latency;\n");
	    printf(TOFILE "      avail = xdep_prep_ctl.load_avail + xdep_prep_ctl.float_load_avail;\n");
	}
	else {
	    printf(TOFILE "      latency = xdep_prep_ctl.load_latency;\n");
	    printf(TOFILE "      avail = xdep_prep_ctl.load_avail;\n");
	}
    }
    elsif( $do_store || $do_cache ) {
	printf(TOFILE "      unit = xdep_prep_ctl.store_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.store_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.store_avail;\n");
    }
    elsif( $do_id =~ /FDIV.*/ ) {
	printf(TOFILE "      unit = xdep_prep_ctl.fpu_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.fdiv_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.fdiv_avail;\n");
    }
    elsif( $do_float ) {
	printf(TOFILE "      unit = xdep_prep_ctl.fpu_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.fpu_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.fpu_avail;\n");
    }
    elsif( $do_id =~ /CMP.*/ ) {
	printf(TOFILE "      unit = xdep_prep_ctl.fix_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.cmp_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.cmp_avail;\n");
    }
    elsif( $do_branch || $do_id =~ /^S(V)?C(L)?/ ) {
	printf(TOFILE "      is_branch = 1;\n");
	printf(TOFILE "      unit = xdep_prep_ctl.branch_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.branch_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.branch_avail;\n");
    }
    elsif( $do_format eq "XL_form" ) {
	printf(TOFILE "      unit = xdep_prep_ctl.crl_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.crl_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.crl_avail;\n");
    }
    elsif( $do_idivide  ) {
	printf(TOFILE "      unit = xdep_prep_ctl.idiv_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.idiv_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.idiv_avail;\n");
    }
    elsif( $do_imultiply  ) {
	printf(TOFILE "      unit = xdep_prep_ctl.imul_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.imul_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.imul_avail;\n");
    }
    else {
	printf(TOFILE "      unit = xdep_prep_ctl.fix_unit;\n");
	printf(TOFILE "      latency = xdep_prep_ctl.fix_latency;\n");
	printf(TOFILE "      avail = xdep_prep_ctl.fix_avail;\n");
    }

    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}


