sub InitializeDisInfo {
    undef %G_trans;
    
    $G_trans{"RT"}   = "r%d";
    $G_trans{"RS"}   = "r%d";
    $G_trans{"RA"}   = "r%d";
    $G_trans{"RB"}   = "r%d";
    $G_trans{"FRT"}  = "fp%d";
    $G_trans{"FRS"}  = "fp%d";
    $G_trans{"FRA"}  = "fp%d";
    $G_trans{"FRB"}  = "fp%d";
    $G_trans{"FRC"}  = "fp%d";
    $G_trans{"VT"}   = "v%d";
    $G_trans{"VS"}   = "v%d";
    $G_trans{"VA"}   = "v%d";
    $G_trans{"VB"}   = "v%d";
    $G_trans{"VC"}   = "v%d";
    $G_trans{"BF"}   = "cr%d";
    $G_trans{"BFA"}  = "cr%d";
    $G_trans{"BT"}   = "cb%d"; 
    $G_trans{"BA"}   = "cb%d";
    $G_trans{"BB"}   = "cb%d";
    $G_trans{"SPR"}  = "%s";
    $G_trans{"TBR"}  = "0x%x";
    $G_trans{"FLM"}  = "0x%x";
    $G_trans{"FXM"}  = "0x%x";
    $G_trans{"BO"}   = "0x%x";
    $G_trans{"BI"}   = "cb%d";
    $G_trans{"BD"}   = "0x%x";
    $G_trans{"LI"}   = "0x%x";
    $G_trans{"UI"}   = "%d";
    $G_trans{"UIx"}  = "%d";
    $G_trans{"UIL"}  = "%d";
    $G_trans{"SI"}   = "%d";
    $G_trans{"D"}    = "%d";
    $G_trans{"DS"}   = "%d";
    $G_trans{"DQ"}   = "%d";
    $G_trans{"PT"}   = "%d";
    $G_trans{"SR"}   = "%d";
    $G_trans{"NB"}   = "%d";
    $G_trans{"MB"}   = "%d";
    $G_trans{"ME"}   = "%d";
    $G_trans{"XBI"}  = "0x%x";
    $G_trans{"CBI"}  = "cb%d";
    $G_trans{"SH"}   = "%d";
    $G_trans{"LEV"}  = "0x%x";
    $G_trans{"IS"}   = "%d";
    $G_trans{"IB"}   = "%d";
    $G_trans{"L"}    = "%d";
    $G_trans{"U"}    = "%d";
    $G_trans{"TO"}   = "0x%x";
    $G_trans{"Tval"} = "%d";
    $G_trans{"T"} = "%d";
    $G_trans{"SHB"}   = "%d";
    $G_trans{"STRM"} = "%d";
    $G_trans{"SIMM"} = "%d";
    $G_trans{"UIMM"} = "%u";
}



sub generate_dis {
    local(*TOFILE) = $_[0];
    local($the_isa) = $_[1];
    local($name) = $_[2];
    local($format);
    $format = "";
    
    if( $do_full_format eq "I_1" ) {
	$format = $G_trans{"LI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_LI(iword)");
    }	
    elsif( $do_full_format eq "B_1" ) {
	$format = $G_trans{"BO"} . "," . $G_trans{"BI"} . "," . $G_trans{"BD"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BO(iword), ");
	printf(TOFILE "OPC_DEC_BI(iword), ");
	printf(TOFILE "OPC_DEC_BD(iword) ");
    }
    elsif ($do_full_format eq "SC_1") {
	printf(TOFILE "\"");
    }
    elsif ($do_full_format eq "SC_2") {
	$format = $G_trans{"LEV"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_LEV(iword)");
    }
    
    elsif ($do_full_format eq "D_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_3") {
	$format = $G_trans{"RS"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_4") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"UI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_UI(iword)");
    }
    elsif ($do_full_format eq "D_5") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),");
	printf(TOFILE "OPC_DEC_L(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_6") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"UI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),");
	printf(TOFILE "OPC_DEC_L(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_UI(iword)");
    }
    elsif ($do_full_format eq "D_7") {
	$format = $G_trans{"TO"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_8") {
	$format = $G_trans{"FRT"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRT(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_9") {
	$format = $G_trans{"FRS"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRS(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "DS_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"DS"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_DSb(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "DS_2") {
	$format = $G_trans{"RS"} . "," . $G_trans{"DS"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_DSb(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }

    elsif ($do_full_format eq "DQ_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"DQ"} . "," . $G_trans{"PT"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_DQb(iword),");
	printf(TOFILE "OPC_DEC_PT(iword)");
    }
    
    elsif( $do_full_format eq "X_1" ) {
	if ( ($do_RT eq "0") && ($do_RA eq "0") && ($do_RB eq "0") ) {
	    printf(TOFILE "\"");
	}
	elsif ( ($do_RA eq "0") && ($do_RB eq "0") ) {
	    $format = $G_trans{"RT"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword)");
	}
	elsif ( ($do_RT eq "0") && ($do_RA eq "0") ) {
	    $format = $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RT eq "0") {
	    $format = $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RA eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RB eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword)");
	}
	else {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
    }
    elsif ($do_full_format eq "X_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"NB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif ($do_full_format eq "X_3") {
	if ($do_store) {
	    if ( ($do_RS ne "0") && ($do_RA ne "0") && ($do_RB ne "0") ) {
		$format = $G_trans{"RS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    else { 
		printf("Can a store indexed (%s) have RS = %s, RA = %s and RB = %s?\n", $do_id, $do_RS, $do_RA, $do_RB);
	    }
	}
	else {
	    if ( ($do_RS eq "0") && ($do_RB eq "0") ) { 
		$format = $G_trans{"RA"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword)");
	    }
	    elsif ($do_RA eq "0") { 
		$format = $G_trans{"RS"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    elsif ($do_RB eq "0") { 
		$format = $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RS(iword)");
	    }
	    else {
		$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	}
    }
    elsif ($do_full_format eq "X_4") {
	$format = $G_trans{"RS"} . "," . $G_trans{"RA"} . "," . $G_trans{"NB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif ($do_full_format eq "X_5") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SH(iword)"); 
    }
    elsif ($do_full_format eq "X_6") {
	$format = $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword)");
    }
    elsif ($do_full_format eq "X_7") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_L(iword),"); 
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_8") {
	$format = $G_trans{"BF"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_FRA(iword),");
	printf(TOFILE "OPC_DEC_FRB(iword)");
    }
    elsif ($do_full_format eq "X_9") {
	if( ( $do_BFA eq "0" ) ) {
	  $format = $G_trans{"BF"};
	  printf(TOFILE "%s\", ", $format);
	  printf(TOFILE "OPC_DEC_BF(iword)"); 
	}
	else {
	  $format = $G_trans{"BF"} . "," . $G_trans{"BFA"};
	  printf(TOFILE "%s\", ", $format);
	  printf(TOFILE "OPC_DEC_BF(iword),"); 
	  printf(TOFILE "OPC_DEC_BFA(iword)");
	}
    }
    elsif ($do_full_format eq "X_10") {
	$format = $G_trans{"BF"} . "," . $G_trans{"U"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_U(iword)");
    }
    elsif ($do_full_format eq "X_11") {
	$format = $G_trans{"TO"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif( $do_full_format eq "X_12" ) {
	$format = $G_trans{"FRT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_13") {
	if( ( $do_FRB eq "0" ) ) {
	    $format = $G_trans{"FRT"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword)");
	}
	else {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
    }
    elsif ($do_full_format eq "X_14") {
	$format = $G_trans{"FRS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRS(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_15") {
	$format = $G_trans{"BT"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BT(iword)");
    }
    elsif ($do_full_format eq "X_16") {
	$format = $G_trans{"RS"} . "," . $G_trans{"SR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SR(iword)");
    }
    elsif ($do_full_format eq "X_17") {
	$format = $G_trans{"RT"} . "," . $G_trans{"SR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_SR(iword)");
    }
    elsif ($do_full_format eq "X_18") {
	if( ( $do_RA eq "0" ) && ( $do_RB eq "0" ) ) {
	    $format = $G_trans{"T"} . "," . $G_trans{"STRM"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_Tval(iword),");
	    printf(TOFILE "OPC_DEC_STRM(iword)");
	}
	else {
	    $format = $G_trans{"Tval"} . "," . $G_trans{"STRM"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_Tval(iword),");
	    printf(TOFILE "OPC_DEC_STRM(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
    }
    elsif ($do_full_format eq "X_19") {
	if ($do_store) {
	    if ( ($do_RS ne "0") && ($do_RA ne "0") && ($do_RB ne "0") ) {
		$format = $G_trans{"VS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_VS(iword),");
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    else { 
		printf("Can a store indexed (%s) have RS = %s, RA = %s and RB = %s?\n", $do_id, $do_RS, $do_RA, $do_RB);
	    }
	}
	else { 
	    printf("Can an X_19 instruction (%s) NOT be a store?\n", $do_id);
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "XL_1") {
	$format = $G_trans{"BT"} . "," . $G_trans{"BA"} . "," . $G_trans{"BB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BT(iword),"); 
	printf(TOFILE "OPC_DEC_BA(iword),"); 
	printf(TOFILE "OPC_DEC_BB(iword)");
    }
    elsif ($do_full_format eq "XL_2") {
	$format = $G_trans{"BO"} . "," . $G_trans{"BI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BO(iword),"); 
	printf(TOFILE "OPC_DEC_BI(iword)");
    }
    elsif ($do_full_format eq "XL_3") {
	$format = $G_trans{"BF"} . "," . $G_trans{"BFA"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_BFA(iword)");
    }
    elsif ($do_full_format eq "XL_4") {
    }
    elsif ($do_full_format eq "XFX_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"SPR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),"); 
	printf(TOFILE "opc_spr_tbl[OPC_DEC_SPR(iword)]"); 
    }
    elsif ($do_full_format eq "XFX_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"TBR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),"); 
	printf(TOFILE "OPC_DEC_TBR(iword)"); 
    }
    elsif ($do_full_format eq "XFX_3") {
	$format = $G_trans{"FXM"} . "," . $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FXM(iword),"); 
	printf(TOFILE "OPC_DEC_RS(iword)"); 
    }
    elsif ($do_full_format eq "XFX_4") {
	$format = $G_trans{"SPR"} . "," . $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "opc_spr_tbl[OPC_DEC_SPR(iword)],"); 
	printf(TOFILE "OPC_DEC_RS(iword)"); 
    }
    elsif ($do_full_format eq "XFX_5") {
	printf(TOFILE "\"");      
    }

    elsif ($do_full_format eq "XFL_1") {
	$format = $G_trans{"FLM"} . "," . $G_trans{"FRB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FLM(iword),"); 
	printf(TOFILE "OPC_DEC_FRB(iword)"); 
    }

    elsif ($do_full_format eq "XS_1") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword)"); 
    }

    elsif ($do_full_format eq "XO_1") {
	if( $do_RB eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword)");
	}
	else {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
    }
    elsif ($do_full_format eq "XO_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }

    elsif( $do_full_format eq "A_1" ) {
	if( ( $do_FRA eq "0" ) && ( $do_FRC eq "0" ) ) {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
	elsif( $do_FRB eq "0") {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRC"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRC(iword)");
	}
	elsif( $do_FRC eq "0" ) {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
	else {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRC"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRC(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
    }
    elsif( $do_full_format eq "M_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"MB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MB(iword),");
	printf(TOFILE "OPC_DEC_ME(iword)");
    }
    elsif( $do_full_format eq "M_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"MB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SH(iword),");
	printf(TOFILE "OPC_DEC_MB(iword),");
	printf(TOFILE "OPC_DEC_ME(iword)");
    }

    elsif( $do_full_format eq "MD_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"MB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword),");
	printf(TOFILE "OPC_DEC_MBW(iword)");
    }
    elsif( $do_full_format eq "MD_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword),");
	printf(TOFILE "OPC_DEC_MEW(iword)");
    }

    elsif( $do_full_format eq "MDS_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"MB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MBW(iword)");
    }
    elsif( $do_full_format eq "MDS_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MEW(iword)");
    }
    elsif( $do_full_format eq "MDS_3" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"IB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_3n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"IB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_4" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"RB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_4n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"RB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_5" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"IB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_5n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"IB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_6" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_6n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	$format = $G_trans{"TO"} . "," . $G_trans{"UIL"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_UIL(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    
    elsif( $do_full_format eq "VA_1" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VC"} . "," . $G_trans{"VB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VC(iword),");
	printf(TOFILE "OPC_DEC_VB(iword)");	
    }
    elsif( $do_full_format eq "VA_2" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"} . "," . $G_trans{"SHB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VB(iword),");
	printf(TOFILE "OPC_DEC_SHB(iword)");	
    }

    elsif( $do_full_format eq "VX_1" ) {
	if( ( $do_RA eq "0" ) && ( $do_RB eq "0" ) ) {
	    $format = $G_trans{"VT"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword)");
	}
	elsif ( $do_RA eq "0" ) {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
	elsif ( $do_RA eq "0" ) {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword)");
	}
	else {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
    }
    elsif( $do_full_format eq "VX_2" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"UIMM"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_UIMM(iword)");
    }    
    elsif( $do_full_format eq "VX_3" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"SIMM"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_SIMM(iword)");
    }    

    elsif( $do_full_format eq "VXR_1" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VB(iword)");
    }    

    else {
	print(STDERR "Unknown format ", $do_format, " : ", $do_full_format, " in generate_dis\n");
	exit(-1);
    }

    printf(TOFILE ");\n");
}




sub DoInitialGenerateDis {
    local(*TOFILE) = $_[0];
}

sub DoGenerateDisForThisInstruction {
    local(*TOFILE) = $_[0];
    local($name);
    printf(TOFILE "  case OPC_%s: {\n", $do_id);
    printf(TOFILE  "    switch (the_ISA) {\n");

    printf(TOFILE "      case OPC_UNION_ISA: {\n");
    $name = "";

    if( $do_ppc_name ne "" )    { $name = $do_ppc_name;    }
    elsif( $do_ppc32_name ne "" )  { $name = $do_ppc32_name;  }
    elsif( $do_ppc40x_name ne "" )  { $name = $do_ppc40x_name;  }
    elsif( $do_ppc601_name ne "" ) { $name = $do_ppc601_name; }
    elsif( $do_power_name  ne "" ) { $name = $do_power_name;  }
    elsif( $do_power2_name ne "" ) { $name = $do_power2_name; }
    elsif( $do_amazon_name ne "" ) { $name = $do_amazon_name; }
    
    if ($name ne "") {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_dis( TOFILE, "UNION", $do_ppc_name);    
	printf(TOFILE "        } break;\n");
    }
    else {
	print(STDERR " Instruction ", $do_id, " is not valid in any ISA (process_dis)\n" );
	exit(-1);
    }    
    
    printf(TOFILE "      case OPC_PPC_ISA: {\n");
    if( $do_ppc_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_ppc_name);
	&generate_dis( TOFILE, "PPC", $do_ppc_name);    
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC32_ISA: {\n");
    if( $do_ppc32_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_ppc32_name);
	&generate_dis( TOFILE, "PPC32", $do_ppc32_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC40X_ISA: {\n");
    if( $do_ppc40x_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_dis( TOFILE, "PPC40X", $do_ppc40x_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC601_ISA: {\n");
    if( $do_ppc601_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_ppc601_name);
	&generate_dis( TOFILE, "PPC601", $do_ppc601_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_AMAZON_ISA: {\n");
    if( $do_amazon_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_amazon_name);
	&generate_dis( TOFILE, "AMAZON", $do_amazon_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_POWER_ISA: {\n");
    if( $do_power_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_power_name);
	&generate_dis( TOFILE, "POWER", $do_power_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_POWER2_ISA: {\n");
    if ($do_power2_name ne "") {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $do_power2_name);
	&generate_dis( TOFILE, "POWER2", $do_power2_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      default:\n");
    printf(TOFILE "        fprintf(stderr, \"ERROR: Illegal (unrecognized) ISA type... %%u\", the_ISA);\n");
    printf(TOFILE "        break;\n");
    printf(TOFILE "     }\n");
    printf(TOFILE "     break;\n");
    printf(TOFILE "   }\n");
}


sub DoFinalGenerateDis {
    local(*TOFILE) = $_[0];
}






##################################################################
#
# This is a second disassembly routine, that attempts to create 
#  a disassembly much more like the compiler-generated 
#  disassembly of instructions.
#


sub generate_disassembly {
    local(*TOFILE) = $_[0];
    local($the_isa) = $_[1];
    local($name) = $_[2];
    local($format);
    $format = "";
    
    if( $do_full_format eq "I_1" ) {
	$format = $G_trans{"LI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "4*OPC_DEC_LI(iword)");
    }	
    elsif( $do_full_format eq "B_1" ) {
	$format = $G_trans{"BO"} . "," . $G_trans{"BI"} . "," . $G_trans{"BD"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BO(iword), ");
	printf(TOFILE "OPC_DEC_BI(iword), ");
	printf(TOFILE "4*OPC_DEC_BD(iword) ");
    }
    elsif ($do_full_format eq "SC_1") {
	printf(TOFILE "\"");
    }
    elsif ($do_full_format eq "SC_2") {
	$format = $G_trans{"LEV"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_LEV(iword)");
    }
    
    elsif ($do_full_format eq "D_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_3") {
	$format = $G_trans{"RS"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_4") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"UI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_UI(iword)");
    }
    elsif ($do_full_format eq "D_5") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),");
	printf(TOFILE "OPC_DEC_L(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_6") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"UI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),");
	printf(TOFILE "OPC_DEC_L(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_UI(iword)");
    }
    elsif ($do_full_format eq "D_7") {
	$format = $G_trans{"TO"} . "," . $G_trans{"RA"} . "," . $G_trans{"SI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_SI(iword)");
    }
    elsif ($do_full_format eq "D_8") {
	$format = $G_trans{"FRT"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRT(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "D_9") {
	$format = $G_trans{"FRS"} . "," . $G_trans{"D"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRS(iword),");
	printf(TOFILE "OPC_DEC_D(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "DS_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"DS"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "4*OPC_DEC_DS(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }
    elsif ($do_full_format eq "DS_2") {
	$format = $G_trans{"RS"} . "," . $G_trans{"DS"} . "(" . $G_trans{"RA"} . ")";
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "4*OPC_DEC_DS(iword),");
	printf(TOFILE "OPC_DEC_RA(iword)");
    }

    elsif ($do_full_format eq "DQ_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"DQ"} . "," . $G_trans{"PT"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "16*OPC_DEC_DQ(iword),");
	printf(TOFILE "OPC_DEC_PT(iword)");
    }
    
    elsif( $do_full_format eq "X_1" ) {
	if ( ($do_RT eq "0") && ($do_RA eq "0") && ($do_RB eq "0") ) {
	    printf(TOFILE "\"");
	}
	elsif ( ($do_RA eq "0") && ($do_RB eq "0") ) {
	    $format = $G_trans{"RT"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword)");
	}
	elsif ( ($do_RT eq "0") && ($do_RA eq "0") ) {
	    $format = $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RT eq "0") {
	    $format = $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RA eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
	elsif ($do_RB eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword)");
	}
	else {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
    }
    elsif ($do_full_format eq "X_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"NB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif ($do_full_format eq "X_3") {
	if ($do_store) {
	    if ( ($do_RA ne "0") && ($do_RA ne "0") && ($do_RB ne "0") ) {
		$format = $G_trans{"RS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    else { 
		printf("Can a store indexed (%s) have RS = %s, RA = %s and RB = %s?\n", $do_id, $do_RS, $do_RA, $do_RB);
	    }
	}
	else {
	    if ( ($do_RS eq "0") && ($do_RB eq "0") ) { 
		$format = $G_trans{"RA"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword)");
	    }
	    elsif ($do_RA eq "0") { 
		$format = $G_trans{"RS"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    elsif ($do_RB eq "0") { 
		$format = $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RS(iword)");
	    }
	    else {
		$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RS(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	}
    }
    elsif ($do_full_format eq "X_4") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"NB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif ($do_full_format eq "X_5") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SH(iword)"); 
    }
    elsif ($do_full_format eq "X_6") {
	$format = $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword)");
    }
    elsif ($do_full_format eq "X_7") {
	$format = $G_trans{"BF"} . "," . $G_trans{"L"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_L(iword),"); 
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_8") {
	$format = $G_trans{"BF"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_FRA(iword),");
	printf(TOFILE "OPC_DEC_FRB(iword)");
    }
    elsif ($do_full_format eq "X_9") {
	$format = $G_trans{"BF"} . "," . $G_trans{"BFA"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_BFA(iword)");
    }
    elsif ($do_full_format eq "X_10") {
	$format = $G_trans{"BF"} . "," . $G_trans{"U"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_U(iword)");
    }
    elsif ($do_full_format eq "X_11") {
	$format = $G_trans{"TO"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_NB(iword)");
    }
    elsif( $do_full_format eq "X_12" ) {
	$format = $G_trans{"FRT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_13") {
	$format = $G_trans{"FRT"} . "," . $G_trans{"FRB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRT(iword),");
	printf(TOFILE "OPC_DEC_FRB(iword)");
    }
    elsif ($do_full_format eq "X_14") {
	$format = $G_trans{"FRS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FRS(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "X_15") {
	$format = $G_trans{"BT"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BT(iword)");
    }
    elsif ($do_full_format eq "X_16") {
	$format = $G_trans{"RS"} . "," . $G_trans{"SR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SR(iword)");
    }
    elsif ($do_full_format eq "X_17") {
	$format = $G_trans{"RT"} . "," . $G_trans{"SR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_SR(iword)");
    }
    elsif ($do_full_format eq "X_18") {
	if( ( $do_RA eq "0" ) && ( $do_RB eq "0" ) ) {
	    $format = $G_trans{"T"} . "," . $G_trans{"STRM"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_Tval(iword),");
	    printf(TOFILE "OPC_DEC_STRM(iword)");
	}
	else {
	    $format = $G_trans{"Tval"} . "," . $G_trans{"STRM"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_Tval(iword),");
	    printf(TOFILE "OPC_DEC_STRM(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
    }
    elsif ($do_full_format eq "X_19") {
	if ($do_store) {
	    if ( ($do_RS ne "0") && ($do_RA ne "0") && ($do_RB ne "0") ) {
		$format = $G_trans{"VS"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
		printf(TOFILE "%s\", ", $format);
		printf(TOFILE "OPC_DEC_VS(iword),");
		printf(TOFILE "OPC_DEC_RA(iword),");
		printf(TOFILE "OPC_DEC_RB(iword)");
	    }
	    else { 
		printf("Can a store indexed (%s) have RS = %s, RA = %s and RB = %s?\n", $do_id, $do_RS, $do_RA, $do_RB);
	    }
	}
	else { 
	    printf("Can an X_19 instruction (%s) NOT be a store?\n", $do_id);
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }
    elsif ($do_full_format eq "XL_1") {
	$format = $G_trans{"BT"} . "," . $G_trans{"BA"} . "," . $G_trans{"BB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BT(iword),"); 
	printf(TOFILE "OPC_DEC_BA(iword),"); 
	printf(TOFILE "OPC_DEC_BB(iword)");
    }
    elsif ($do_full_format eq "XL_2") {
	$format = $G_trans{"BO"} . "," . $G_trans{"BI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BO(iword),"); 
	printf(TOFILE "OPC_DEC_BI(iword)");
    }
    elsif ($do_full_format eq "XL_3") {
	$format = $G_trans{"BF"} . "," . $G_trans{"BFA"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_BF(iword),"); 
	printf(TOFILE "OPC_DEC_BFA(iword)");
    }
    elsif ($do_full_format eq "XL_4") {
    }
    elsif ($do_full_format eq "XFX_1") {
	$format = $G_trans{"RT"} . "," . $G_trans{"SPR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),"); 
	printf(TOFILE "opc_spr_tbl[OPC_DEC_SPR(iword)]"); 
    }
    elsif ($do_full_format eq "XFX_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"TBR"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),"); 
	printf(TOFILE "OPC_DEC_TBR(iword)"); 
    }
    elsif ($do_full_format eq "XFX_3") {
	$format = $G_trans{"FXM"} . "," . $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FXM(iword),"); 
	printf(TOFILE "OPC_DEC_RS(iword)"); 
    }
    elsif ($do_full_format eq "XFX_4") {
	$format = $G_trans{"SPR"} . "," . $G_trans{"RS"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "opc_spr_tbl[OPC_DEC_SPR(iword)],"); 
	printf(TOFILE "OPC_DEC_RS(iword)"); 
    }
    elsif ($do_full_format eq "XFX_5") {
	printf(TOFILE "\"");      
    }

    elsif ($do_full_format eq "XFL_1") {
	$format = $G_trans{"FLM"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_FLM(iword),"); 
	printf(TOFILE "OPC_DEC_RB(iword)"); 
    }

    elsif ($do_full_format eq "XS_1") {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword)"); 
    }

    elsif ($do_full_format eq "XO_1") {
	if( $do_RB eq "0") {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword)");
	}
	else {
	    $format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_RT(iword),");
	    printf(TOFILE "OPC_DEC_RA(iword),");
	    printf(TOFILE "OPC_DEC_RB(iword)");
	}
    }
    elsif ($do_full_format eq "XO_2") {
	$format = $G_trans{"RT"} . "," . $G_trans{"RA"} . "," . $G_trans{"RB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RT(iword),");
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RB(iword)");
    }

    elsif( $do_full_format eq "A_1" ) {
	if( ( $do_FRA eq "0" ) && ( $do_FRC eq "0" ) ) {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
	elsif( $do_FRB eq "0") {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRC"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRC(iword)");
	}
	elsif( $do_FRC eq "0" ) {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
	else {
	    $format = $G_trans{"FRT"} . "," . $G_trans{"FRA"} . "," . $G_trans{"FRC"} . "," . $G_trans{"FRB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_FRT(iword),");
	    printf(TOFILE "OPC_DEC_FRA(iword),");
	    printf(TOFILE "OPC_DEC_FRC(iword),");
	    printf(TOFILE "OPC_DEC_FRB(iword)");
	}
    }
    elsif( $do_full_format eq "M_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"MB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MB(iword),");
	printf(TOFILE "OPC_DEC_ME(iword)");
    }
    elsif( $do_full_format eq "M_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"MB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SH(iword),");
	printf(TOFILE "OPC_DEC_MB(iword),");
	printf(TOFILE "OPC_DEC_ME(iword)");
    }

    elsif( $do_full_format eq "MD_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"MB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword),");
	printf(TOFILE "OPC_DEC_MBW(iword)");
    }
    elsif( $do_full_format eq "MD_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"SH"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_SHSH(iword),");
	printf(TOFILE "OPC_DEC_MEW(iword)");
    }

    elsif( $do_full_format eq "MDS_1" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"MB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MBW(iword)");
    }
    elsif( $do_full_format eq "MDS_2" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"ME"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_MEW(iword)");
    }
    elsif( $do_full_format eq "MDS_3" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"IB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_3n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"IB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_4" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"RB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_4n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"IS"} . "," . $G_trans{"RB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_IS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_5" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"IB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_5n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"IB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_IB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    elsif( $do_full_format eq "MDS_6" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    elsif( $do_full_format eq "MDS_6n" ) {
	$format = $G_trans{"RA"} . "," . $G_trans{"RS"} . "," . $G_trans{"RB"} . "," . $G_trans{"CBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_RA(iword),");
	printf(TOFILE "OPC_DEC_RS(iword),");
	printf(TOFILE "OPC_DEC_RB(iword),");
	printf(TOFILE "OPC_DEC_CBI(iword)");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	$format = $G_trans{"TO"} . "," . $G_trans{"UIL"} . "," . $G_trans{"XBI"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_TO(iword),");
	printf(TOFILE "OPC_DEC_UIL(iword),");
	printf(TOFILE "OPC_DEC_XBI(iword)");
    }
    
    elsif( $do_full_format eq "VA_1" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VC"} . "," . $G_trans{"VB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VC(iword),");
	printf(TOFILE "OPC_DEC_VB(iword)");	
    }
    elsif( $do_full_format eq "VA_2" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"} . "," . $G_trans{"SHB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VB(iword),");
	printf(TOFILE "OPC_DEC_SHB(iword)");	
    }

    elsif( $do_full_format eq "VX_1" ) {
	if( ( $do_RA eq "0" ) && ( $do_RB eq "0" ) ) {
	    $format = $G_trans{"VT"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword)");
	}
	elsif ( $do_RA eq "0" ) {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
	elsif ( $do_RA eq "0" ) {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VA"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword)");
	}
	else {
	    $format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_VA(iword),");
	    printf(TOFILE "OPC_DEC_VB(iword)");
	}
    }
    elsif( $do_full_format eq "VX_2" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"UIMM"} . "," . $G_trans{"VA"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_UIMM(iword),");
	printf(TOFILE "OPC_DEC_VB(iword)");
    }    
    elsif( $do_full_format eq "VX_3" ) {
	if ($do_VB eq "0") {
	    $format = $G_trans{"VT"} . "," . $G_trans{"SIMM"};
	    printf(TOFILE "%s\", ", $format);
	    printf(TOFILE "OPC_DEC_VT(iword),");
	    printf(TOFILE "OPC_DEC_SIMM(iword)");
	}
	else {
	    print "Opcode_dis.pl: I don't know instr $do_id with full_format $do_full_format and VB != 0\n";
	}
    }    

    elsif( $do_full_format eq "VXR_1" ) {
	$format = $G_trans{"VT"} . "," . $G_trans{"VA"} . "," . $G_trans{"VB"};
	printf(TOFILE "%s\", ", $format);
	printf(TOFILE "OPC_DEC_VT(iword),");
	printf(TOFILE "OPC_DEC_VA(iword),");
	printf(TOFILE "OPC_DEC_VB(iword)");
    }    

    else {
	print(STDERR "Unknown format ", $do_format, " : ", $do_full_format, " in generate_dis\n");
	exit(-1);
    }

    printf(TOFILE ");\n");
}




sub DoInitialGenerateDisassembly {
    local(*TOFILE) = $_[0];
}

sub DoGenerateDisassemblyForThisInstruction {
    local(*TOFILE) = $_[0];
    local($name);
    printf(TOFILE "  case OPC_%s: {\n", $do_id);
    printf(TOFILE  "    switch (the_ISA) {\n");

    printf(TOFILE "      case OPC_UNION_ISA: {\n");
    $name = "";
    if( $do_ppc_name ne "" )    { $name = $do_ppc_name;    }
    elsif( $do_ppc32_name ne "" )  { $name = $do_ppc32_name;  }
    elsif( $do_ppc40x_name ne "" )  { $name = $do_ppc40x_name;  }
    elsif( $do_ppc601_name ne "" ) { $name = $do_ppc601_name; }
    elsif( $do_power_name ne "" )  { $name = $do_power_name;  }
    elsif( $do_power2_name ne "" ) { $name = $do_power2_name; }
    elsif( $do_amazon_name ne "" ) { $name = $do_amazon_name; }
    
    if ($name ne "") {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "UNION", $do_ppc_name);    
	printf(TOFILE "        } break;\n");
    }
    else {
	print(STDERR " Instruction ", $do_id, " is not valid in any ISA (process_dis)\n" );
	exit(-1);
    }    
    
    printf(TOFILE "      case OPC_PPC_ISA: {\n");
    if( $do_ppc_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "PPC", $do_ppc_name);    
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC32_ISA: {\n");
    if( $do_ppc32_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "PPC32", $do_ppc32_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC40X_ISA: {\n");
    if( $do_ppc40x_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "PPC40X", $do_ppc40x_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_PPC601_ISA: {\n");
    if( $do_ppc601_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "PPC601", $do_ppc601_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_AMAZON_ISA: {\n");
    if( $do_amazon_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "AMAZON", $do_amazon_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_POWER_ISA: {\n");
    if( $do_power_name ne "" ) {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "POWER", $do_power_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      case OPC_POWER2_ISA: {\n");
    if ($do_power2_name ne "") {
	printf(TOFILE "        sprintf( buf, \"%-8s  ", $name);
	&generate_disassembly( TOFILE, "POWER2", $do_power2_name);
    }
    else {
	printf(TOFILE "        sprintf( buf, \"??? ILLEGAL\" );\n");
    }    
    printf(TOFILE "        } break;\n");

    printf(TOFILE "      default:\n");
    printf(TOFILE "        fprintf(stderr, \"ERROR: Illegal (unrecognized) ISA type... %%u\", the_ISA);\n");
    printf(TOFILE "        break;\n");
    printf(TOFILE "     }\n");
    printf(TOFILE "     break;\n");
    printf(TOFILE "   }\n");
}


sub DoFinalGenerateDisassembly {
    local(*TOFILE) = $_[0];
}
