

##############################################################################
#
#  The functions in the "GenerateLibInfo" package
#



############################################################
# The memory operation types file:
#
sub DoInitialExtendedOps{
    local(*TOFILE) = $_[0];
    printf(TOFILE "  -1, \n");
}

sub DoExtendedOpsForThisInstruction {
    local(*TOFILE) = $_[0];

    if( $do_format eq "I_form" ) {
	printf(TOFILE "  -1,    /* %12s */\n", $do_id);
    }
    elsif( $do_format eq "B_form" ) {
	printf(TOFILE "  -1,    /* %12s */\n", $do_id);
    }
    elsif( $do_format eq "SC_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "D_form" ) {
	printf(TOFILE "  -1,    /* %12s */\n", $do_id);
    }
    elsif( $do_format eq "DS_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "DQ_form" ) {
	printf(TOFILE "  -1,    /* %12s */\n", $do_id);
    }
    elsif( $do_format eq "X_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "XL_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "XFX_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "XFL_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "XS_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "XO_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "A_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "M_form" ) {
	printf(TOFILE "  -1,    /* %12s */\n", $do_id);
    }
    elsif( $do_format eq "MD_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "MDS_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "TX_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }

    elsif( $do_format eq "VA_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "VX_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
    elsif( $do_format eq "VXR_form" ) {
	printf(TOFILE "  %d,    /* %12s */\n", $do_extended_op, $do_id);
    }
}

sub DoFinalExtendedOps {
    local (*TOFILE) = $_[0];
}



############################################################
# The memory operation types file:
#
sub DoInitialMemOps{
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_MEMOP_NOT, \n");
}

sub DoMemOpsForThisInstruction {
    local(*TOFILE) = $_[0];
    if( $do_store ) {
	printf(TOFILE "  OPC_MEMOP_STORE, /* OPC_%s */\n", $do_id);
    }
    elsif( $do_load ) {
	printf(TOFILE "  OPC_MEMOP_LOAD,  /* OPC_%s */\n", $do_id);
    }
    elsif( $do_cache ) {
	printf(TOFILE "  OPC_MEMOP_CACHE, /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_MEMOP_NOT,   /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalMemOps {
    local (*TOFILE) = $_[0];
}


############################################################
# The fF32 types (categories) file:
#
sub DoInitialFFCat {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_FF32_ILLEGAL, \n", $do_id);
}

sub DoFFCatForThisInstruction{
    local(*TOFILE) = $_[0];
    if( $do_branch || ( $do_alters_flow &&  ( $do_id eq "SC" || $do_id eq  "SVC" || $do_id eq "SVCL" )) ) {
	printf(TOFILE "  OPC_FF32_BRANCH, /* OPC_%s */\n", $do_id);
    }
    elsif( $do_store || $do_load || $do_cache ) {
	if( $do_multiple ) {
	    printf(TOFILE "  OPC_FF32_MULTI,  /* OPC_%s */\n", $do_id);
	}
	else {
	    printf(TOFILE "  OPC_FF32_MEMOP,  /* OPC_%s */\n", $do_id);
	}
    }
    else {
	printf(TOFILE "  OPC_FF32_OTHER,  /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalFFCat {
    local (*TOFILE) = $_[0];
}


############################################################
# The integer multiplication operations file:
#

sub DoInitialIMult {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  0, \n");
}

sub DoIMultForThisInstruction {
    local(*TOFILE) = $_[0];
    if( $do_imultiply ) {
	printf(TOFILE "  1, /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  0, /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalIMult {
    local (*TOFILE) = $_[0];
}

############################################################
# The integer division operations file:
#
sub DoInitialIDiv {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  0, \n");
}

sub DoIDivForThisInstruction{
    local(*TOFILE) = $_[0];
    if( $do_idivide ) {
	printf(TOFILE "  1, /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  0, /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalIDiv {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction format declarations
#
sub DoInitialFormat {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_ILLEGAL_FORMAT,\n");
}

sub DoFormatForThisInstruction {
    local(*TOFILE) = $_[0];
    local ($mainform, $rest);
    ($mainform, $rest) = split("_", $do_format);
    printf(TOFILE "  OPC_%s_FORMAT, /* OPC_%s */\n", $mainform, $do_id);
}

sub DoFinalFormat {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction full format declarations
#
sub DoInitialFullFormat {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_ILLEGAL_FORMAT,\n");
}

sub DoFullFormatForThisInstruction {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_%s_FORMAT,\n", $do_full_format);
}

sub DoFinalFullFormat {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction "is_floating_point" declarations
#
sub DoInitialFloats {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_IS_NOT_A_FLOAT_OP, \n");
}

sub DoFloatsForThisInstruction {
    local(*TOFILE) = $_[0];
    if ($do_float ne "") {
	printf(TOFILE "  OPC_IS_A_FLOAT_OP,      /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_IS_NOT_A_FLOAT_OP,  /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalFloats {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction "is_vmx" declarations
#
sub DoInitialVMX {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_IS_NOT_A_VMX_OP, \n");
}

sub DoVMXForThisInstruction {
    local(*TOFILE) = $_[0];
    if ($do_VMX ne "") {
	printf(TOFILE "  OPC_IS_A_VMX_OP,      /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_IS_NOT_A_VMX_OP,  /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalVMX {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction data access lengths
#
sub DoInitialDLength {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  0, \n");
}

sub DoDLengthForThisInstruction {
    local(*TOFILE) = $_[0];
    if ($do_dlength ne "") {
	if (($do_dlength eq "1") || ($do_dlength eq "2") ||
	    ($do_dlength eq "4") || ($do_dlength eq "8") ||
	    ($do_dlength eq "16")|| ($do_dlength eq "0") ) {
	    printf(TOFILE "  %2d,   /* OPC_%s */\n", $do_dlength, $do_id);
	}
	else {
	    printf(TOFILE "  OPC_DLENGTH_%s,   /* OPC_%s */\n", $do_dlength, $do_id);
	}	
    }
    else {
	printf(TOFILE "  0,    /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalDLength {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction "does_an_update" declarations
#
sub DoInitialUpdates {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_DOES_NOT_DO_AN_UPDATE, \n");
}

sub DoUpdatesForThisInstruction {
    local(*TOFILE) = $_[0];
    if ($do_update ne "") {
	printf(TOFILE "  OPC_DOES_AN_UPDATE,          /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_DOES_NOT_DO_AN_UPDATE,   /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalUpdates {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction "does_a_record" declarations
#
sub DoInitialRecords {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_DOES_NOT_DO_A_RECORD, \n");
}

sub DoRecordsForThisInstruction {
    local(*TOFILE) = $_[0];
    if ($do_Rc eq "1") {
	printf(TOFILE "  OPC_DOES_A_RECORD,          /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_DOES_NOT_DO_A_RECORD,   /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalRecords {
    local (*TOFILE) = $_[0];
}

############################################################
# The instruction index name declarations
#
#** Declare all the (symbolic) instruction index macros **/
sub DoInitialDecls {
    local(*TOFILE) = $_[0];
    printf(TOFILE "#define %-12s\t%d\n", "OPC_ILLEGAL", $i);
}

sub DoDeclsForThisInstruction {
    local(*TOFILE) = $_[0];
    local ($name);
    $name = "OPC_" . $do_id;
    printf(TOFILE "#define %-12s\t%d\n", $name, $i);
}

sub DoFinalDecls {
    local (*TOFILE) = $_[0];
    printf(TOFILE "\n#define %-12s\t%d\n", "OPC_NUM", ($G_num+1));
}

############################################################
# The instruction type (kind) declarations
#
sub DoInitialIType {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  OPC_ILLEGAL_INSTR,\n");
}

sub DoITypeForThisInstruction {
    local(*TOFILE) = $_[0];
    if( $do_branch ) {
	printf(TOFILE "  OPC_BRANCH_INSTR,      /* OPC_%s */\n", $do_id);
    }
    elsif( $do_alters_flow ) {
	if ( ( $do_id eq "SC") || ( $do_id eq "SVC") || ( $do_id eq "SVCL") ) {
	    printf(TOFILE "  OPC_SYSTEM_CALL_INSTR, /* OPC_%s */\n", $do_id);
	}
	else {
	    printf(TOFILE "  OPC_FLOW_INSTR,        /* OPC_%s */\n", $do_id);
	}
    }
    elsif( $do_store ) {
	if( $do_multaccess ) {
	    printf(TOFILE "  OPC_MULTI_STORE_INSTR, /* OPC_%s */\n", $do_id);
	}
	elsif ( $do_string ) {
	    if ( $do_NB ne "") {
		printf(TOFILE "  OPC_STR_STORE_INSTR,   /* OPC_%s */\n", $do_id);
	    }
	    else {
		printf(TOFILE "  OPC_STR_X_STORE_INSTR, /* OPC_%s */\n", $do_id);
	    }	
	}
	else {
	    printf(TOFILE "  OPC_STORE_INSTR,       /* OPC_%s */\n", $do_id);
	
	}
    }
    elsif( $do_load ) {
	if( $do_multaccess ) {
	    printf(TOFILE "  OPC_MULTI_LOAD_INSTR,  /* OPC_%s */\n", $do_id);
	}
	elsif ( $do_string ) {
	    if ( $do_NB ne "") {
		printf(TOFILE "  OPC_STR_LOAD_INSTR,    /* OPC_%s */\n", $do_id);
	    }
	    else {
		printf(TOFILE "  OPC_STR_X_LOAD_INSTR,  /* OPC_%s */\n", $do_id);
	    }	
	}
	else {
	    printf(TOFILE "  OPC_LOAD_INSTR,        /* OPC_%s */\n", $do_id);
	}
    }
    elsif( $do_cache ) {
	printf(TOFILE "  OPC_CACHE_INSTR,       /* OPC_%s */\n", $do_id);
    }
    else {
	printf(TOFILE "  OPC_OTHER_INSTR,       /* OPC_%s */\n", $do_id);
    }
}

sub DoFinalIType {
    local (*TOFILE) = $_[0];
}




############################################################
#
#  Generate a table of "in_ISA" or "not_in_ISA" fields
#   NOTE: there is also "is_in_ISA_priv which indicates
#    the instruction is implemented, but also priveledeged mode
#
sub DoInitialIsInISA {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  { OPC_IS_NOT_IN_ISA , OPC_IS_NOT_IN_ISA , OPC_IS_NOT_IN_ISA , OPC_IS_NOT_IN_ISA , OPC_IS_NOT_IN_ISA , OPC_IS_NOT_IN_ISA  }, \n");
}

sub DoIsInISAForThisInstruction {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  {");

    if (($do_ppc_name ne "")   || ($do_ppc32_name ne "")  ||
	($do_ppc40x_name ne "") || ($do_ppc601_name ne "") ||
	($do_power_name ne "") || ($do_power2_name ne "") || ($do_amazon_name ne "") ) {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }

    if ($do_ppc_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_ppc32_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_ppc40x_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_ppc601_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_power_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_power2_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA     ,");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV,");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA ,");
    }
    if ($do_amazon_name ne "") {
	if ( ($do_privileged eq "") ) {
	    printf(TOFILE " OPC_IS_IN_ISA      ");
	}
	else {
	    printf(TOFILE " OPC_IS_IN_ISA_PRIV ");
	}
    }
    else {
	printf(TOFILE " OPC_IS_NOT_IN_ISA  ");
    }

    printf(TOFILE "}, \n");
}

sub DoFinalIsInISA {
    local (*TOFILE) = $_[0];
}


############################################################
#
# Generate tables of instruction names
#

sub DoInitialIName {
    local(*TOFILE) = $_[0];
    printf(TOFILE " /* %12s, %12s, %12s, %12s, %12s, %12s, %12s, %12s */\n", "UNION", "PPC", "PPC32", "PPC40X", "PPC601", "AMAZON", "POWER", "POWER2");
    printf(TOFILE " /* %12s, %12s, %12s, %12s, %12s, %12s, %12s, %12s */\n", "---------", "---------", "---------", "---------", "---------", "---------", "---------", "---------");
    printf(TOFILE "  { %12s, %12s, %12s, %12s, %12s, %12s, %12s, %12s },\n", "\"???\"", "\"???\"", "\"???\"", "\"???\"", "\"???\"", "\"???\"", "\"???\"", "\"???\"");
}

sub DoINameForThisInstruction {
    local(*TOFILE) = $_[0];
    local ($name);

    printf(TOFILE "  { ");

    $name = "";
    if( $do_ppc_name ne "" )    { $name = $do_ppc_name;    }
    elsif( $do_ppc32_name ne "" )  { $name = $do_ppc32_name;  }
    elsif( $do_ppc40x_name ne "" )  { $name = $do_ppc40x_name;  }
    elsif( $do_ppc601_name ne "" ) { $name = $do_ppc601_name; }
    elsif( $do_power_name ne "" )  { $name = $do_power_name;  }
    elsif( $do_power2_name ne "" ) { $name = $do_power2_name; }
    elsif( $do_amazon_name ne "" ) { $name = $do_amazon_name; }

    if ($name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$name));
    }
    else {
	printf(STDERR " Instruction %s is not valid in any ISA (process_names)", $do_id );
    }

    if ($do_ppc_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_ppc_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }

    if ($do_ppc32_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_ppc32_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }

    if ($do_ppc40x_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_ppc40x_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }
    if ($do_ppc601_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_ppc601_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }

    if ($do_power_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_power_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }

    if ($do_power2_name ne "") {
	printf(TOFILE "%12s, ", sprintf("\"%s\"",$do_power2_name));
    }
    else {
	printf(TOFILE "%12s, ", "\"ILL\"");
    }

    if ($do_amazon_name ne "") {
	printf(TOFILE "%12s ", sprintf("\"%s\"",$do_amazon_name));
    }
    else {
	printf(TOFILE "%12s ", "\"ILL\"");
    }

    printf(TOFILE "},\n");
}


sub DoFinalIName {
    local (*TOFILE) = $_[0];
}






############################################################
#
# Generate tables of instruction names
#

sub DoInitialLegal {
    local(*TOFILE) = $_[0];
}

sub DoLegalForThisInstruction {
    local(*TOFILE) = $_[0];

    undef %valid;

    printf(TOFILE "  case OPC_%s: {\n", $do_id);

    if ($do_full_format eq "I_1") {
	$valid{"LI"} = "1";
	$valid{"AA"} = "1";
	$valid{"LK"} = "1";
    }
    elsif ($do_full_format eq "B_1") {
	$valid{"BO"} = "1";
	$valid{"BI"} = "1";
	$valid{"BD"} = "1";
	$valid{"AA"} = "1";
	$valid{"LK"} = "1";
    }
    elsif ($do_full_format eq "SC_1") {
	$valid{"LK"} = "1";
	$do_LK = "0";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,6,29) == 0);\n");
    }
    elsif ($do_full_format eq "SC_2") {
	$valid{"LEV"} = "1";
	$valid{"LK"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,6,19) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,27,29) == 0);\n");
    }
    elsif ($do_full_format eq "D_1") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"D"} = "1";
    }
    elsif ($do_full_format eq "D_2") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"SI"} = "1";
    }
    elsif ($do_full_format eq "D_3") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"D"} = "1";
    }
    elsif ($do_full_format eq "D_4") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SI"} = "1";
    }
    elsif ($do_full_format eq "D_5") {
	$valid{"BF"} = "1";
	$valid{"L"} = "1";
	$valid{"RA"} = "1";
	$valid{"SI"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,9) == 0);\n");
    }
    elsif ($do_full_format eq "D_6") {
	$valid{"BF"} = "1";
	$valid{"L"} = "1";
	$valid{"RA"} = "1";
	$valid{"UI"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,9) == 0);\n");
    }
    elsif ($do_full_format eq "D_7") {
	$valid{"TO"} = "1";
	$valid{"RA"} = "1";
	$valid{"SI"} = "1";
    }
    elsif ($do_full_format eq "D_8") {
	$valid{"FRT"} = "1";
	$valid{"RA"} = "1";
	$valid{"D"} = "1";
    }
    elsif ($do_full_format eq "D_9") {
	$valid{"FRS"} = "1";
	$valid{"RA"} = "1";
	$valid{"D"} = "1";
    }
    elsif ($do_full_format eq "DS_1") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"DS"} = "1";
    }
    elsif ($do_full_format eq "DS_2") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"DS"} = "1";
    }
    elsif ($do_full_format eq "DQ_1") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"DQ"} = "1";
	$valid{"PT"} = "1";
    }
    elsif ($do_full_format eq "X_1") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "X_2") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"NB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_3") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "X_4") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"NB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_5") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "X_6") {
	$valid{"RS"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_7") {
	$valid{"BF"} = "1";
	$valid{"L"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,9) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_8") {
	$valid{"BF"} = "1";
	$valid{"FRA"} = "1";
	$valid{"FRB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,10) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_9") {
	$valid{"BF"} = "1";
	$valid{"BFA"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,10) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,14,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_10") {
	$valid{"BF"} = "1";
	$valid{"U"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,15) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,20,20) == 0);\n");
    }
    elsif ($do_full_format eq "X_11") {
	$valid{"TO"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_12") {
	$valid{"FRT"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_13") {
	$valid{"FRT"} = "1";
	$valid{"FRB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,15) == 0);\n");
    }
    elsif ($do_full_format eq "X_14") {
	$valid{"FRS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_15") {
	$valid{"BT"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,20) == 0);\n");
    }
    elsif ($do_full_format eq "X_16") {
	$valid{"RS"} = "1";
	$valid{"SR"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,11) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,16,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_17") {
	$valid{"RT"} = "1";
	$valid{"SR"} = "1";
	$valid{"Rc"} = "1";

	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,11) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,16,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "X_18") {
	$valid{"T"} = "1";
	$valid{"STRM"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";

	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,7,8) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_Rc(iword) == 0);\n");
    }
    elsif ($do_full_format eq "X_19") {
	$valid{"VS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "X_20") {
	$valid{"VT"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "XL_1") {
	$valid{"BT"} = "1";
	$valid{"BA"} = "1";
	$valid{"BB"} = "1";
	$valid{"LK"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XL_2") {
	$valid{"BO"} = "1";
	$valid{"BI"} = "1";
	$valid{"LK"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,16,20) == 0);\n");
    }
    elsif ($do_full_format eq "XL_3") {
	$valid{"BF"} = "1";
	$valid{"BFA"} = "1";
	$valid{"LK"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,9,10) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,14,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XL_4") {
	$valid{"LK"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,6,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFX_1") {
	$valid{"RT"} = "1";
	$valid{"SPR"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFX_2") {
	$valid{"RT"} = "1";
	$valid{"TBR"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFX_3") {
	$valid{"RS"} = "1";
	$valid{"FXM"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,11,11) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,20,20) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFX_4") {
	$valid{"RS"} = "1";
	$valid{"SPR"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFX_5") {
	$valid{"XO2"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,6,10) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,31,31) == 0);\n");
    }
    elsif ($do_full_format eq "XFL_1") {
	$valid{"FLM"} = "1";
	$valid{"FRB"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,6,6) == 0);\n");
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,15,15) == 0);\n");
    }
    elsif ($do_full_format eq "XS_1") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "XO_1") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"OE"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "XO_2") {
	$valid{"RT"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"OE"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,16,16) == 0);\n");
    }
    elsif ($do_full_format eq "A_1") {
	$valid{"FRT"} = "1";
	$valid{"FRA"} = "1";
	$valid{"FRB"} = "1";
	$valid{"FRC"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "M_1") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"MB"} = "1";
	$valid{"ME"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "M_2") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"MB"} = "1";
	$valid{"ME"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "MD_1") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"MB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "MD_2") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"SH"} = "1";
	$valid{"ME"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "MDS_1") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"MB"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "MDS_2") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"ME"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "MDS_3") {
	$valid{"IS"} = "1";
	$valid{"RA"} = "1";
	$valid{"IB"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,25,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_3n") {
	$valid{"IS"} = "1";
	$valid{"RA"} = "1";
	$valid{"IB"} = "1";
	$valid{"CBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,26,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_4") {
	$valid{"IS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,25,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_4n") {
	$valid{"IS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"CBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,26,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_5") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"IB"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,25,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_5n") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"IB"} = "1";
	$valid{"CBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,26,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_6") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,25,26) == 0);\n");
    }
    elsif ($do_full_format eq "MDS_6n") {
	$valid{"RS"} = "1";
	$valid{"RA"} = "1";
	$valid{"RB"} = "1";
	$valid{"CBI"} = "1";
	$valid{"Rc"} = "1";
    }
    elsif ($do_full_format eq "TX_1") {
	$valid{"TO"} = "1";
	$valid{"UI"} = "1";
	$valid{"XBI"} = "1";
	$valid{"Rc"} = "1";
    }

    elsif ($do_full_format eq "VA_1") {
	$valid{"VT"} = "1";
	$valid{"VA"} = "1";
	$valid{"VB"} = "1";
	$valid{"VC"} = "1";
    }
    elsif ($do_full_format eq "VA_2") {
	$valid{"VT"} = "1";
	$valid{"VA"} = "1";
	$valid{"VB"} = "1";
	$valid{"VSH"} = "1";
	printf(TOFILE "      ok = ok && (OPC_DEC_IBM_BITS(iword,20,20) == 0);\n");
    }
    elsif ($do_full_format eq "VX_1") {
	$valid{"VT"} = "1";
	$valid{"VA"} = "1";
	$valid{"VB"} = "1";
    }
    elsif ($do_full_format eq "VX_2") {
	$valid{"VT"} = "1";
	$valid{"VUI"} = "1";
	$valid{"VB"} = "1";
    }
    elsif ($do_full_format eq "VX_3") {
	$valid{"VT"} = "1";
	$valid{"VSI"} = "1";
	$valid{"VB"} = "1";
    }
    elsif ($do_full_format eq "VXR_1") {
	$valid{"VT"} = "1";
	$valid{"VA"} = "1";
	$valid{"VB"} = "1";
	$valid{"Rc"} = "1";
    }
    
    else {
	printf(STDERR "Opcode_lib.pl: instr %s Illegal full_format %s for format %s\n", $do_id, $do_full_format, $do_format);
    }

    if( $do_load && $do_update ) {
	printf(TOFILE "      ok = ok && (OPC_DEC_RA(iword) != 0);\n");
	if( !$do_float ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_RA(iword) != OPC_DEC_RT(iword));\n");
	}
    }
    if( $do_store && $do_update ) {
	printf(TOFILE "      ok = ok && (OPC_DEC_RA(iword) != 0);\n");
    }

    if( $valid{"RT"} ) {
	if( $do_RT ne "GPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_RT(iword) == %s);\n", $do_RT);
	}
    }
    if( $valid{"RS"} ) {
	if( $do_RS ne "GPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_RS(iword) == %s);\n", $do_RS);
	}
    }
    if( $valid{"RA"} ) {
	if( $do_RA ne "GPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_RA(iword) == %s);\n", $do_RA);
	}
    }
    if( $valid{"RB"} ) {
	if( $do_RB ne "GPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_RB(iword) == %s);\n", $do_RB);
	}
    }

    if( $valid{"FRT"} ) {
	if( $do_FRT ne "FPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_FRT(iword) == %s);\n", $do_FRT);
	}
    }
    if( $valid{"FRS"} ) {
	if( $do_FRS ne "FPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_FRS(iword) == %s);\n", $do_FRS);
	}
    }
    if( $valid{"FRA"} ) {
	if( $do_FRA ne "FPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_FRA(iword) == %s);\n", $do_FRA);
	}
    }
    if( $valid{"FRB"} ) {
	if( $do_FRB ne "FPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_FRB(iword) == %s);\n", $do_FRB);
	}
    }
    if( $valid{"FRC"} ) {
	if( $do_FRC ne "FPR" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_FRC(iword) == %s);\n", $do_FRC);
	}
    }

    if( $valid{"BA"} ) {
	if( $do_BA ne "CRB" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BA(iword) == %s);\n", $do_BA);
	}
    }
    if( $valid{"BB"} ) {
	if( $do_BB ne "CRB" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BB(iword) == %s);\n", $do_BB);
	}
    }
    if( $valid{"BT"} ) {
	if( $do_BT ne "CRB" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BT(iword) == %s);\n", $do_BT);
	}
    }
    if( $valid{"BF"} ) {
	if( $do_BF ne "CRF" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BF(iword) == %s);\n", $do_BF);
	}
    }
    if( $valid{"BFA"} ) {
	if( $do_BFA ne "CRF" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BFA(iword) == %s);\n", $do_BFA);
	}
    }
    if( $valid{"BI"} ) {
	if( $do_BI ne "CRB" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_BI(iword) == %s);\n", $do_BI);
	}
    }

    if( $valid{"ME"} ) {
	if( $do_ME ne "" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_ME(iword) == %s);\n", $do_ME);
	}
    }
    if( $valid{"MB"} ) {
	if( $do_MB ne "" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_MB(iword) == %s);\n", $do_MB);
	}
    }

    if( $valid{"Rc"} ) {
	if( $do_Rc eq "0" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_Rc(iword) == 0);\n");
	}
    }
    if( $valid{"LK"} ) {
	if( $do_LK eq "0" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_LK(iword) == 0);\n");
	}
    }
    if( $valid{"L"} ) {
	if( $do_LK eq "0" ) {
	    printf(TOFILE "      ok = ok && (OPC_DEC_L(iword) == 0);\n");
	}
    }

    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}

sub DoFinalLegal {
    local (*TOFILE) = $_[0];
}



######################################################################
#
# The index tables
#

sub DoInitialTableSize {
    local(*TOFILE) = $_[0];
    local($i);
    for( $i = 0; $i < 64; $i++ ) {
	$P_table[$i] = 0;
    }
}

#* In terms of the "internal extended op"     *#
#* the AA, LK, Rc, OE bits are all considered *#
#* as a part of the extended operand          *#

sub DoTableSizeForThisInstruction {
    local(*TOFILE) = $_[0];
    local($cur, $bits);

    if( $do_format eq "I_form" ) {
	$bits = 2;
    }
    elsif( $do_format eq "B_form" ) {
	$bits = 2;
    }
    elsif( $do_format eq "SC_form" ) {
	$bits = 2;
    }
    elsif( $do_format eq "D_form" ) {
	$bits = 0;
    }
    elsif( $do_format eq "DS_form" ) {
	$bits = 2;
    }
    elsif( $do_format eq "DQ_form" ) {
	$bits = 0;
    }
    elsif( $do_format eq "X_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "XL_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "XFX_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "XFL_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "XS_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "XO_form" ) {
	$bits = 11;
    }
    elsif( $do_format eq "A_form" ) {
	$bits = 6;
    }
    elsif( $do_format eq "M_form" ) {
	$bits = 1;
    }
    elsif( $do_format eq "MD_form" ) {
	$bits = 5;
    }
    elsif( $do_format eq "MDS_form" ) {
	$bits = 5;
    }
    elsif( $do_format eq "TX_form" ) {
	$bits = 7;
    }
    elsif( $do_format eq "VA_form") {
	$bits = 6;
    }
    elsif( $do_format eq "VX_form") {
	$bits = 11;
    }
    elsif( $do_format eq "VXR_form") {
	$bits = 11;
    }

    $cur = $P_table[ $do_opcode ];
    if( $cur < $bits ) {
	$cur = $bits;
    }
    $P_table[$do_opcode] = $bits;
}


sub DoFinalTableSize {
    local (*TOFILE) = $_[0];
    local($i);
    for( $i = 0; $i < 63; $i++ ) {
	printf(TOFILE "  %4d,\n", $P_table[$i]);
    }
    printf(TOFILE "  %4d\n", $P_table[63]);
}




sub DoInitialTableSetup {
    local(*TOFILE) = $_[0];
}

sub DoTableSetupForThisInstruction {
    local(*TOFILE) = $_[0];
    local($bits, $extended_op, $name);

    $name = "OPC_" . $do_id;

    if( $do_format eq "I_form" ) {
	$extended_op = $do_AA * 2 + $do_LK;
	$bits = 2;
    }
    elsif( $do_format eq "B_form" ) {
	$extended_op = $do_AA*2 + $do_LK;
	$bits = 2;
    }
    elsif( $do_format eq "SC_form" ) {
	$extended_op = $do_extended_op*2 + $do_LK;
	$bits = 2;
    }
    elsif( $do_format eq "D_form" ) {
	$extended_op = 0;
	$bits = 0;
    }
    elsif( $do_format eq "DS_form" ) {
	$extended_op = $do_extended_op;
	$bits = 2;
    }
    elsif( $do_format eq "DQ_form" ) {
	$extended_op = 0;
	$bits = 0;
    }
    elsif( $do_format eq "X_form" ) {
	$extended_op = $do_extended_op * 2 + $do_Rc;
	$bits = 11;
    }
    elsif( $do_format eq "XL_form" ) {
	$extended_op = $do_extended_op * 2 + $do_LK;
	$bits = 11;
    }
    elsif( $do_format eq "XFX_form" ) {
	$extended_op = $do_extended_op * 2 + $do_Rc;
	$bits = 11;
    }
    elsif( $do_format eq "XFL_form" ) {
	$extended_op = $do_extended_op * 2 + $do_Rc;
	$bits = 11;
    }
    elsif( $do_format eq "XS_form" ) {
	$bits = 11;

	#* Do the case where the right-part of sh == 0 *#
	$extended_op = $do_extended_op * 4 + $do_Rc;
	if( (2 **$bits) <= $extended_op ) {
	    printf(STDERR "%s: minor opcode %d too big for %s bit format\n",$do_id, $extended_op, $bits);
	}
	printf(TOFILE "  { %3d, %3d, %5d, %s },\n", $do_opcode, $bits, $extended_op, $name);

	#* Do the case where the right-part of sh == 1 *#
	$extended_op = $do_extended_op * 4 + 2 + $do_Rc;
    }
    elsif( $do_format eq "XO_form" ) {
	$extended_op = $do_OE * 1024 + $do_extended_op * 2 + $do_Rc;
	$bits = 11;
    }
    elsif( $do_format eq "A_form" ) {
	$extended_op = $do_extended_op*2 +  $do_Rc;
	$bits = 6;
    }
    elsif( $do_format eq "M_form" ) {
	$extended_op =  $do_Rc;
	$bits = 1;
    }
    elsif( $do_format eq "MD_form" ) {
	$bits = 5;
	#* Do the case where the right-part of sh == 0 *#
	$extended_op = $do_extended_op * 4 + $do_Rc;
	if( (2 **$bits) <= $extended_op ) {
	    printf(STDERR "%s: minor opcode %d too big for %s bit format\n",$do_id, $extended_op, $bits);
	}
	printf(TOFILE "  { %3d, %3d, %5d, %s },\n", $do_opcode, $bits, $extended_op, $name);

	#* Do the case where the right-part of sh == 1 *#
	$extended_op = $do_extended_op * 4 + 2 + $do_Rc;
    }
    elsif( $do_format eq "MDS_form" ) {
	$extended_op =  $do_extended_op*2 + $do_Rc;
	$bits = 5;
    }
    elsif( $do_format eq "TX_form" ) {
	$extended_op =  $do_extended_op*2 + $do_Rc;
	$bits = 7;
    }
    elsif( $do_format eq "VA_form" ) {
	$extended_op = $do_extended_op;
	$bits = 6;
    }
    elsif( $do_format eq "VX_form" ) {
	$extended_op = $do_extended_op;
	$bits = 11;
    }
    elsif( $do_format eq "VXR_form" ) {
	$extended_op = $do_Rc*1024 + $do_extended_op;
	$bits = 11;
    }

    if( (2 ** $bits) <= $extended_op ) {
	printf(STDERR "%s: minor opcode %d too big for %s bit format\n",$do_id, $extended_op, $bits);
    }
    printf(TOFILE "  { %3d, %3d, %5d, %s },\n", $do_opcode, $bits, $extended_op, $name);
}


sub DoFinalTableSetup {
    local (*TOFILE) = $_[0];
}
