
sub InitializeUseDefInfo {
    $GR_reg{"CTR_BO2"}  = "OPC_CTR";
    $GR_incr{"CTR_BO2"} = "!OPC_DEC_BO2(iword)";

    $GR_reg{"CTR"}  = "OPC_CTR";
    $GR_incr{"CTR"} = "1";
    $GR_reg{"LR"}   = "OPC_LR";
    $GR_incr{"LR"}  = "1";
    $GR_reg{"MQ"}   = "OPC_MQ";
    $GR_incr{"MQ"}  = "1";

    $GR_reg{"CR0"}  = "OPC_CR(0)";
    $GR_incr{"CR0"} = "1";
    $GR_reg{"CR1"}  = "OPC_CR(1)";
    $GR_incr{"CR1"} = "1";
    $GR_reg{"CR2"}  = "OPC_CR(2)";
    $GR_incr{"CR2"} = "1";
    $GR_reg{"CR3"}  = "OPC_CR(3)";
    $GR_incr{"CR3"} = "1";
    $GR_reg{"CR4"}  = "OPC_CR(4)";
    $GR_incr{"CR4"} = "1";
    $GR_reg{"CR5"}  = "OPC_CR(5)";
    $GR_incr{"CR5"} = "1";
    $GR_reg{"CR6"}  = "OPC_CR(6)";
    $GR_incr{"CR6"} = "1";
    $GR_reg{"CR7"}  = "OPC_CR(7)";
    $GR_incr{"CR7"} = "1";

    $GR_reg{"FPSCR"}  = "OPC_FPSCR";
    $GR_incr{"FPSCR"} = "1";
    $GR_reg{"FPSCR_ENR"}  = "OPC_FPSCR_ENR";
    $GR_incr{"FPSCR_ENR"} = "1";
    $GR_reg{"FPSCR_FPCC"}  = "OPC_FPSCR_FPCC";
    $GR_incr{"FPSCR_FPCC"} = "1";
    $GR_reg{"FPSCR_FRFI"}  = "OPC_FPSCR_FRFI";
    $GR_incr{"FPSCR_FRFI"} = "1";
    $GR_reg{"FPSCR_EXCPT"}  = "OPC_FPSCR_EXCPT";
    $GR_incr{"FPSCR_EXCPT"} = "1";

    $GR_reg{"FPSCR_BFA"}  = "FPSCR_BFA";
    $GR_incr{"FPSCR_BFA"} = "1";
    $GR_reg{"FPSCR_BF"}  = "FPSCR_BF";
    $GR_incr{"FPSCR_BF"} = "1";
    $GR_reg{"FPSCR_BT"}  = "FPSCR_BT";
    $GR_incr{"FPSCR_BT"} = "1";
    $GR_reg{"FPSCR_FLM"}  = "FPSCR_FLM";
    $GR_incr{"FPSCR_FLM"} = "1";

    $GR_reg{"SRs"}  = "OPC_SR0_15";
    $GR_incr{"SRs"} = "1";

    $GR_reg{"MSR"}  = "OPC_MSR";
    $GR_incr{"MSR"} = "1";

    $GR_reg{"SRR0"}  = "OPC_SRR0";
    $GR_incr{"SRR0"} = "1";
    $GR_reg{"SRR1"}  = "OPC_SRR1";
    $GR_incr{"SRR1"} = "1";
    $GR_reg{"SRR2"}  = "OPC_SRR2";
    $GR_incr{"SRR2"} = "1";
    $GR_reg{"SRR3"}  = "OPC_SRR3";
    $GR_incr{"SRR3"} = "1";

    $GR_reg{"RT"}  = "OPC_GPR(OPC_DEC_RT(iword))";
    $GR_incr{"RT"} = "1";
    $GR_reg{"RS"}  = "OPC_GPR(OPC_DEC_RS(iword))";
    $GR_incr{"RS"} = "1";
    $GR_reg{"RA"}  = "OPC_GPR(OPC_DEC_RA(iword))";
    $GR_incr{"RA"} = "1";
    $GR_reg{"RB"}  = "OPC_GPR(OPC_DEC_RB(iword))";
    $GR_incr{"RB"} = "1";

    $GR_reg{"TB"}   = "OPC_TB";
    $GR_incr{"TB"}  = "1";
    $GR_reg{"TBU"}  = "OPC_TBU";
    $GR_incr{"TBU"} = "1";

    # The XER fields
    $GR_reg{"DC"}    = "OPC_XER_DC";
    $GR_incr{"DC"}   = "1";
    $GR_reg{"SO"}    = "OPC_XER_SO";
    $GR_incr{"SO"}   = "1";
    $GR_reg{"OV"}    = "OPC_XER_OV";
    $GR_incr{"OV"}   = "1";
    $GR_reg{"CA"}    = "OPC_XER_CA";
    $GR_incr{"CA"}   = "1";
    $GR_reg{"OC"}    = "OPC_XER_OC";
    $GR_incr{"OC"}   = "1";
    $GR_reg{"FXCC"}  = "OPC_XER_FXCC";
    $GR_incr{"FXCC"} = "1";
    $GR_reg{"TGCC"}  = "OPC_XER_TGCC";
    $GR_incr{"TGCC"} = "1";
    $GR_reg{"DS"}    = "OPC_XER_DS";
    $GR_incr{"DS"}   = "1";
    $GR_reg{"BCMP"}  = "OPC_XER_BCMP";
    $GR_incr{"BCMP"} = "1";
    $GR_reg{"BCNT"}  = "OPC_XER_BCNT";
    $GR_incr{"BCNT"} = "1";

    ########################################
    #* The vector defines *#
    $GR_vec{"CTR_BO2"} = "spr |= (!OPC_DEC_BO2(iword))<<OPC_CTR";
    $GR_vec{"CTR"} = "spr |= 1<<OPC_CTR";
    $GR_vec{"LR"}  = "spr |= 1<<OPC_LR";
    $GR_vec{"MQ"}  = "spr |= 1<<OPC_MQ";
    
    $GR_vec{"CR0"} = "cr |= 1<<0";
    $GR_vec{"CR1"} = "cr |= 1<<1";
    $GR_vec{"CR2"} = "cr |= 1<<2";
    $GR_vec{"CR3"} = "cr |= 1<<3";
    $GR_vec{"CR4"} = "cr |= 1<<4";
    $GR_vec{"CR5"} = "cr |= 1<<5";
    $GR_vec{"CR6"} = "cr |= 1<<6";
    $GR_vec{"CR7"} = "cr |= 1<<7";

    $GR_vec{"FPSCR"}       = "spr |= 1<<OPC_FPSCR";
    $GR_vec{"FPSCR_ENR"}   = "xer |= 1<<OPC_FPSCR_ENR_OFFSET;   spr |= 1<<OPC_FPSCR";
    $GR_vec{"FPSCR_FPCC"}  = "xer |= 1<<OPC_FPSCR_FPCC_OFFSET;  spr |= 1<<OPC_FPSCR";
    $GR_vec{"FPSCR_FRFI"}  = "xer |= 1<<OPC_FPSCR_FRFI_OFFSET;  spr |= 1<<OPC_FPSCR";
    $GR_vec{"FPSCR_EXCPT"} = "xer |= 1<<OPC_FPSCR_EXCPT_OFFSET; spr |= 1<<OPC_FPSCR";

    $GR_vec{"SRs"}   = "spr |= 1<<OPC_SR0_15";
    $GR_vec{"MSR"}   = "spr |= 1<<OPC_MSR";
    $GR_vec{"SRR0"}  = "spr |= 1<<OPC_SRR0";
    $GR_vec{"SRR1"}  = "spr |= 1<<OPC_SRR1";
    $GR_vec{"SRR2"}  = "spr |= 1<<OPC_SRR2";
    $GR_vec{"SRR3"}  = "spr |= 1<<OPC_SRR3";

    $GR_vec{"RA"}   = "gpr |= 1<<OPC_DEC_RA(iword)";
    $GR_vec{"RB"}   = "gpr |= 1<<OPC_DEC_RB(iword)";
    $GR_vec{"RS"}   = "gpr |= 1<<OPC_DEC_RS(iword)";
    $GR_vec{"RT"}   = "gpr |= 1<<OPC_DEC_RT(iword)";

    # The XER fields
    $GR_vec{"DC"}    = "xer |= 1<<OPC_XER_DC_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"SO"}    = "xer |= 1<<OPC_XER_SO_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"OV"}    = "xer |= 1<<OPC_XER_OV_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"CA"}    = "xer |= 1<<OPC_XER_CA_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"OC"}    = "xer |= 1<<OPC_XER_OC_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"FXCC"}  = "xer |= 1<<OPC_XER_FXCC_OFFSET; spr |= 1<<OPC_XER";
    $GR_vec{"TGCC"}  = "xer |= 1<<OPC_XER_TGCC_OFFSET; spr |= 1<<OPC_XER";
    $GR_vec{"DS"}    = "xer |= 1<<OPC_XER_DS_OFFSET;   spr |= 1<<OPC_XER";
    $GR_vec{"BCNT"}  = "xer |= 1<<OPC_XER_BCNT_OFFSET; spr |= 1<<OPC_XER";
    $GR_vec{"BCMP"}  = "xer |= 1<<OPC_XER_BCMP_OFFSET; spr |= 1<<OPC_XER";
}


#************************************************************************#
#*  The uses routines, which put out the list of registers used by the  *#
#*    instruction, based on the instruction full_format type.           *#
#************************************************************************#

sub DoInitialGenerateInstrUses {
    local(*TOFILE) = $_[0];
}


sub DoGenerateInstrUsesForThisInstruction {
    local (*TOFILE) = $_[0];
    local (@others);
    local ($idx, $reg);

    printf(TOFILE "  case OPC_%s: {\n", $do_id);

    if( $do_full_format eq "I_1" ) {
	#* None *#
    }	

    elsif( $do_full_format eq "B_1" ) {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x10) != 0x10) {\n  ");
	printf(TOFILE "        /* Do not use the cond reg if this is branch always */\n");
	printf(TOFILE "        /*  or branch based only on the counter value.      */\n");
	&gen_uses(TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
    }

    elsif ($do_full_format eq "SC_1") {
	#* None *#
    }
    elsif ($do_full_format eq "SC_2") {
	#* None *#
    }

    elsif ($do_full_format eq "D_1") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_2") {
	if( $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_3") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_4") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif (($do_full_format eq "D_5") || 
	   ($do_full_format eq "D_6") ||
	   ($do_full_format eq "D_7") ) {
	&gen_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_8") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_9") {
	&gen_uses(TOFILE, $do_FRS, "FRS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }

    elsif ($do_full_format eq "DS_1") {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "DS_2") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
    }

    elsif ($do_full_format eq "DQ_1") {
	&gen_uses(TOFILE, $do_RA, "RA");
    }
    
    elsif( $do_full_format eq "X_1" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_load || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_uses(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_2") {
	&gen_uses(TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "X_3") {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_store || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    #* RA is the destination in X_3 form if not a store *#
	}
    }
    elsif ($do_full_format eq "X_4") {
	&gen_uses(TOFILE, $do_RS, "RS");
	if( $do_store ) {
	    &gen_mem_uses(TOFILE, $do_RS, "RA");
	}
    }
    elsif ($do_full_format eq "X_5") {
	&gen_uses(TOFILE, $do_RS, "RS");
	if ($do_store) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_6") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_7") {
	&gen_uses(TOFILE, $do_RB, "RA");
	&gen_uses(TOFILE, $do_RA, "RB");
    }
    elsif ($do_full_format eq "X_8") {
	&gen_uses(TOFILE, $do_FRB, "FRA");
	&gen_uses(TOFILE, $do_FRA, "FRB");
    }
    elsif ($do_full_format eq "X_9") {
	if ($do_BFA eq "0") {
	    #* None *#
	}
	else {
	    &gen_uses(TOFILE, $do_BFA, "BFA");
	}
    }
    elsif ($do_full_format eq "X_10") {
	#* None *#
    }
    elsif ($do_full_format eq "X_11") {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "X_12" ) {
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_13") {
	&gen_uses(TOFILE, $do_FRB, "FRB");
    }
    elsif ($do_full_format eq "X_14") {
	&gen_uses(TOFILE, $do_FRS, "FRS");
	&gen_mem_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_15") {
	#* None *#
    }
    elsif ($do_full_format eq "X_16") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_17") {
	printf(TOFILE "      spr = OPC_DEC_SR(iword);\n");
	printf(TOFILE "      switch (spr) {\n");
	printf(TOFILE "        case  0: uses[nuses++] = OPC_SR0 ; break;\n");
	printf(TOFILE "        case  1: uses[nuses++] = OPC_SR1 ; break;\n");
	printf(TOFILE "        case  2: uses[nuses++] = OPC_SR2 ; break;\n");
	printf(TOFILE "        case  3: uses[nuses++] = OPC_SR3 ; break;\n");
	printf(TOFILE "        case  4: uses[nuses++] = OPC_SR4 ; break;\n");
	printf(TOFILE "        case  5: uses[nuses++] = OPC_SR5 ; break;\n");
	printf(TOFILE "        case  6: uses[nuses++] = OPC_SR6 ; break;\n");
	printf(TOFILE "        case  7: uses[nuses++] = OPC_SR7 ; break;\n");
	printf(TOFILE "        case  8: uses[nuses++] = OPC_SR8 ; break;\n");
	printf(TOFILE "        case  9: uses[nuses++] = OPC_SR9 ; break;\n");
	printf(TOFILE "        case 10: uses[nuses++] = OPC_SR10; break;\n");
	printf(TOFILE "        case 11: uses[nuses++] = OPC_SR11; break;\n");
	printf(TOFILE "        case 12: uses[nuses++] = OPC_SR12; break;\n");
	printf(TOFILE "        case 13: uses[nuses++] = OPC_SR13; break;\n");
	printf(TOFILE "        case 14: uses[nuses++] = OPC_SR14; break;\n");
	printf(TOFILE "        case 15: uses[nuses++] = OPC_SR15; break;\n");
	printf(TOFILE "      }\n");
    }
    elsif ($do_full_format eq "X_18") {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_19") {
	&gen_uses(TOFILE, $do_VS, "VS");
	&gen_uses(TOFILE, $do_RB, "RB");
	if( $do_store || $do_cache || $do_RAas0 ) {
	    &gen_mem_uses(TOFILE, $do_RA, "RA");
	}
	else {
	    #* RA is the destination in X_3 form if not a store *#
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }

    elsif ($do_full_format eq "XL_1") {
	&gen_uses(TOFILE, $do_BA, "BA");
	&gen_uses(TOFILE, $do_BB, "BB");
	&gen_uses(TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "XL_2") {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x14) != 0x14) {\n  ");
	&gen_uses(TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
    }
    elsif ($do_full_format eq "XL_3") {
	&gen_uses(TOFILE, $do_BFA, "BFA");
    }
    elsif ($do_full_format eq "XL_4") {
	#* None *#
    }

    elsif ($do_full_format eq "XFX_1") {
	if( $do_id == "MFSPR" ) {
	    printf(TOFILE "      spr = OPC_DEC_SPR(iword);\n");
	    printf(TOFILE "      if( spr == 1 ) {\n");
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"DC"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"DC"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"SO"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"SO"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"OV"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"OV"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"CA"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"CA"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"OC"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"OC"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"FXCC"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"FXCC"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"TGCC"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"TGCC"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"DS"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"DS"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"BCMP"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"BCMP"});
	    printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"BCNT"});
	    printf(TOFILE "        nuses += %s;\n", $GR_incr{"BCNT"});
	    printf(TOFILE "      }\n");
	    printf(TOFILE "	else {\n");
	    printf(TOFILE "        spr = opc_tblsprenc[spr];\n");
	    printf(TOFILE "        uses[nuses] = spr;\n");
	    printf(TOFILE "        nuses += spr != 0;\n");
	    printf(TOFILE "      }\n");
	}
	else {
	}
    }
    elsif ($do_full_format eq "XFX_2") {
	printf(TOFILE "      spr = OPC_DEC_TBR(iword);\n");
	printf(TOFILE "      if( spr == 268 ) {\n");
	printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"TB"});
	printf(TOFILE "        nuses += %s;\n", $GR_incr{"TB"});
	printf(TOFILE "      }\n");
	printf(TOFILE "      else {\n");
	printf(TOFILE "        uses[nuses] = %s;\n", $GR_reg{"TBU"});
	printf(TOFILE "        nuses += %s;\n", $GR_incr{"TBU"});
	printf(TOFILE "      }\n");
    }
    elsif (($do_full_format eq "XFX_3") || 
	   ($do_full_format eq "XFX_4") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif ( $do_full_format eq "XFX_5" ) {
	#* None -- note, need special encoding (uses) or not? *#
    }

    elsif ($do_full_format eq "XFL_1") {
	&gen_uses(TOFILE, $do_FRB, "FRB");
    }

    elsif ($do_full_format eq "XS_1") {
	&gen_uses(TOFILE, $do_RS, "RS");
    }

    elsif ( ($do_full_format eq "XO_1") || ($do_full_format eq "XO_2") ) {
	&gen_uses(TOFILE, $do_RA, "RA");
	&gen_uses(TOFILE, $do_RB, "RB");
    }

    elsif( $do_full_format eq "A_1" ) {
	&gen_uses(TOFILE, $do_FRA, "FRA");
	&gen_uses(TOFILE, $do_FRB, "FRB");
	&gen_uses(TOFILE, $do_FRC, "FRC");	
    }

    elsif( $do_full_format eq "M_1" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "M_2" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }

    elsif( ($do_full_format eq "MD_1") || ($do_full_format eq "MD_2") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    
    elsif( ($do_full_format eq "MDS_1") || ($do_full_format eq "MDS_2") ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_3" ) {
	#* None *#
    }
    elsif( $do_full_format eq "MDS_3n" ) {
	#* None *#
    }
    elsif( $do_full_format eq "MDS_4" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_4n" ) {
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_5" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif( $do_full_format eq "MDS_5n" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
    }
    elsif( $do_full_format eq "MDS_6" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_6n" ) {
	&gen_uses(TOFILE, $do_RS, "RS");
	&gen_uses(TOFILE, $do_RB, "RB");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	#* None *#
    }

    elsif( $do_full_format eq "VA_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
	&gen_uses(TOFILE, $do_VC, "VC");
    }
    elsif( $do_full_format eq "VA_2" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_2" ) {
	&gen_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_3" ) {
	&gen_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VXR_1" ) {
	&gen_uses(TOFILE, $do_VA, "VA");
	&gen_uses(TOFILE, $do_VB, "VB");
    }

    else {
	printf(STDERR "Opcode_usedef.pl: Unknown format %s : %s in generate_instr_uses\n", $do_format, $do_full_format);
    }

    #printf(TOFILE "\n");
    
    #* Check for added "special" uses *#
    if( $do_uses ne "" ) {
	@others = split(":", $do_uses);

	foreach $idx (@others) {
	    $reg = $GR_reg{$idx};
	    if( $idx eq "quad" ) {
		printf(TOFILE "        n = (OPC_DEC_FRS(iword)+1)%32;\n");
		printf(TOFILE "        uses[nuses++] = OPC_FPR(n);\n");
	    }
	    elsif( $idx eq "RS_NB" ) {
		printf(TOFILE "      n = OPC_DEC_NB(iword)?(OPC_DEC_NB(iword)+3)>>2:8;\n");
		printf(TOFILE "      for( i = OPC_DEC_RS(iword)+1; i < OPC_DEC_RS(iword)+n; i++ ) {\n");
		printf(TOFILE "        unsigned reg = i%32;\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(reg);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      for( i = 0; i < 32; i++ ) {\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RS_R31" ) {
		printf(TOFILE "      for( i = OPC_DEC_RS(iword)+1; i < 32; i++ ) {\n");
		printf(TOFILE "        uses[nuses++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "SPRenc" ) {
		printf("ERROR: Bad uses value \"SPRenv\"\n");
		exit (-1);
	    }
	    elsif( $idx eq "XBIenc" ) {
		printf(TOFILE "      xbi = OPC_DEC_XBI(iword);\n");
		printf(TOFILE "      xbi = opc_tblxbienc[xbi];\n");
		printf(TOFILE "      uses[nuses] = xbi;\n");
		printf(TOFILE "      nuses += 1;\n");
	    }

	    elsif( $reg eq "FPSCR_BFA" ) {
		printf(TOFILE "      bfa = OPC_DEC_BFA(iword);\n");
		printf(TOFILE "      if ((bfa < 4) || (bfa == 5)) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 3) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 4) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa > 4) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BF" ) {
		printf(TOFILE "      bf = OPC_DEC_BF(iword);\n");
		printf(TOFILE "      if ((bf < 4) || (bf == 5)) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 3) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 4) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf > 4) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BT" ) {
		printf(TOFILE "      bt = OPC_DEC_BT(iword);\n");
		printf(TOFILE "      if ((bt < 13) || ((bt > 20) && ( bt < 24))) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 16) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 20) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      flm = OPC_DEC_FLM(iword);\n");
		printf(TOFILE "      if (flm & 0xf4) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x10) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x08) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x03) { \n");
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "        uses[nuses++] = OPC_FPSCR_ENR;\n");
	    }
	    elsif( $reg eq "" ) {
		printf(STDERR "Opcode_usedef.pl :: %s : unknown use %s\n",$do_id, $idx );
	    }
	    else {
		printf(TOFILE "      uses[nuses] = %s;\n", $reg);
		printf(TOFILE "      nuses += %s;\n", $GR_incr{$idx});
	    }
	}
    }
    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}


sub DoFinalGenerateInstrUses {
    local (*TOFILE) = $_[0];
}


sub gen_uses {
    local(*TOFILE) = $_[0];
    local($reg, $name);
    local($theuse);

    $reg = $_[1];
    $name = $_[2];
    
    if( ($reg eq "FPR") || ($reg eq "GPR") || ($reg eq "CRF") || ($reg eq "VECR") ) {
	$theuse = "OPC_" . $reg . "(OPC_DEC_" . $name . "(iword))";
    }
    elsif( $reg eq "CRB" ) {
	$theuse = "OPC_CR(OPC_DEC_" . $name . "(iword) >> 2)";
    }
    elsif( ($reg eq "0") || ($reg eq "1") ) {
	return;
    }
    else {
	printf(STDERR "Opcode_usedef.pl :: %s: gen_use: unknown reg type: %s with name %s\n", $do_id, $reg, $name );
    }
    printf(TOFILE "      uses[nuses++] = %s;\n", $theuse);
}

sub gen_mem_uses {
    local(*TOFILE) = $_[0];
    local($reg, $name);
    local($theuse);

    $reg = $_[1];
    $name = $_[2];
    if( ($reg ne "GPR") && ($reg ne "0") ) {
	printf(STDERR "%s: gen_mem_use: register should be GPR, is %s\n", $do_id, $reg );
    }
    if ($reg ne "0") {
	printf(TOFILE "      uses[nuses] = OPC_GPR(OPC_DEC_%s(iword));\n", $name);
	printf(TOFILE "      nuses += OPC_DEC_%s(iword) != 0;\n", $name);
    }
}









#************************************************************************#
#*  The sets routines (identical structure as the uses routines         *#
#*    but they output the registers defined (set) by the instruction.   *#
#************************************************************************#

sub DoInitialGenerateInstrSets {
    local(*TOFILE) = $_[0];
}

sub DoGenerateInstrSetsForThisInstruction {
    local(*TOFILE) = $_[0];
    local (@others);
    local ($idx, $reg);

    printf(TOFILE "  case OPC_%s: {\n", $do_id);

    if( $do_full_format eq "I_1" ) {
	#* None *#
    }	

    elsif( $do_full_format eq "B_1" ) {
	#* None *#
    }

    elsif ($do_full_format eq "SC_1") {
	#* None *#
    }
    elsif ($do_full_format eq "SC_2") {
	#* None *#
    }

    elsif ($do_full_format eq "D_1") {
	if( $do_load ) {
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_2") {
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_3") {
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_4") {
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    elsif ( ($do_full_format eq "D_5") || 
	   ($do_full_format eq "D_6") ) { 
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "D_7") {
	#* None *#
    }
    elsif ($do_full_format eq "D_8") {
	&gen_sets(TOFILE, $do_FRT, "FRT");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_9") {
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DS_1") {
	&gen_sets(TOFILE, $do_RT, "RT");
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "DS_2") {
	if( $do_update ) {
	    &gen_mem_sets(TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DQ_1") {
	&gen_sets(TOFILE, $do_RT, "RT");
	if ($do_update) {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    
    elsif( $do_full_format eq "X_1" ) {
	&gen_sets(TOFILE, $do_RT, "RT");
	if( $do_load ) {
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_2") {
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "X_3") {
	if( $do_store ) {
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_4") {
	if( !$do_store ) {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_5") {
	if (!$do_store) {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_6") {
	#* None *#
    }
    elsif ( ($do_full_format eq "X_7") || 
	   ($do_full_format eq "X_8") ||
	   ($do_full_format eq "X_9") ||
	   ($do_full_format eq "X_10") ) {
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_11") {
	#* None *#
    }
    elsif( $do_full_format eq "X_12" ) {
	&gen_sets(TOFILE, $do_FRT, "FRT");
	if ($do_load) {
	    if ($do_update) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_13") {
	&gen_sets(TOFILE, $do_FRT, "FRT");
    }
    elsif ($do_full_format eq "X_14") {
	if ($do_store) {
	    if ($do_update) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_15") {
	if ($do_float) {
	    #* None (fpscr is implicit in "float") *#
	}
	else {
	    &gen_sets(TOFILE, $do_BT, "BT");
	}
    }
    elsif ($do_full_format eq "X_16") {
	printf(TOFILE "      spr = OPC_DEC_SR(iword);\n");
	printf(TOFILE "      switch (spr) {\n");
	printf(TOFILE "        case  0: sets[nsets++] = OPC_SR0 ; break;\n");
	printf(TOFILE "        case  1: sets[nsets++] = OPC_SR1 ; break;\n");
	printf(TOFILE "        case  2: sets[nsets++] = OPC_SR2 ; break;\n");
	printf(TOFILE "        case  3: sets[nsets++] = OPC_SR3 ; break;\n");
	printf(TOFILE "        case  4: sets[nsets++] = OPC_SR4 ; break;\n");
	printf(TOFILE "        case  5: sets[nsets++] = OPC_SR5 ; break;\n");
	printf(TOFILE "        case  6: sets[nsets++] = OPC_SR6 ; break;\n");
	printf(TOFILE "        case  7: sets[nsets++] = OPC_SR7 ; break;\n");
	printf(TOFILE "        case  8: sets[nsets++] = OPC_SR8 ; break;\n");
	printf(TOFILE "        case  9: sets[nsets++] = OPC_SR9 ; break;\n");
	printf(TOFILE "        case 10: sets[nsets++] = OPC_SR10; break;\n");
	printf(TOFILE "        case 11: sets[nsets++] = OPC_SR11; break;\n");
	printf(TOFILE "        case 12: sets[nsets++] = OPC_SR12; break;\n");
	printf(TOFILE "        case 13: sets[nsets++] = OPC_SR13; break;\n");
	printf(TOFILE "        case 14: sets[nsets++] = OPC_SR14; break;\n");
	printf(TOFILE "        case 15: sets[nsets++] = OPC_SR15; break;\n");
	printf(TOFILE "      }\n");
    }
    elsif ($do_full_format eq "X_17") {
	&gen_sets(TOFILE, $do_RT, "RT");
	#* None -- Actually, an SR *# 
    }
    elsif ($do_full_format eq "X_18") {
	# None -- access to some stream
    }
    elsif ($do_full_format eq "X_19") {
	if( $do_store ) {
	    if ( $do_update ) {
		&gen_mem_sets(TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_sets(TOFILE, $do_RA, "RA");
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }

    elsif ($do_full_format eq "XL_1") {
	&gen_sets(TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "XL_2") {
	#* None *#
    }
    elsif ($do_full_format eq "XL_3") {
	&gen_sets(TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "XL_4") {
	#* None *#
    }

    elsif (($do_full_format eq "XFX_1") || 
	   ($do_full_format eq "XFX_2") ) {
	&gen_sets(TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "XFX_3") {
    }
    elsif ($do_full_format eq "XFX_4") {
	if( $do_id == "MTSPR" ) {
	    printf(TOFILE "      spr = OPC_DEC_SPR(iword);\n");
	    printf(TOFILE "      if( spr == 1 ) {\n");
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"DC"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"DC"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"SO"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"SO"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"OV"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"OV"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"CA"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"CA"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"OC"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"OC"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"FXCC"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"FXCC"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"TGCC"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"TGCC"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"DS"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"DS"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"BCMP"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"BCMP"});
	    printf(TOFILE "        sets[nsets] = %s;\n", $GR_reg{"BCNT"});
	    printf(TOFILE "        nsets += %s;\n", $GR_incr{"BCNT"});
	    printf(TOFILE "      }\n");
	    printf(TOFILE "	else {\n");
	    printf(TOFILE "        spr = opc_tblsprenc[spr];\n");
	    printf(TOFILE "        sets[nsets] = spr;\n");
	    printf(TOFILE "        nsets += spr != 0;\n");
	    printf(TOFILE "      }\n");
	}
	else {
	}
    }
    elsif ( $do_full_format eq "XFX_5" ) {
	#* None -- actually part of XER? (or uses?) *#
    }

    elsif ($do_full_format eq "XFL_1") {
	#* None -- actually the FPSCR *# 
    }

    elsif ($do_full_format eq "XS_1") {
	&gen_sets(TOFILE, $do_RA, "RA");
    }

    elsif (($do_full_format eq "XO_1") || 
	   ($do_full_format eq "XO_2") ) {
	&gen_sets(TOFILE, $do_RT, "RT");
    }

    elsif( $do_full_format eq "A_1" ) {
	&gen_sets(TOFILE, $do_FRT, "FRT");
    }

    elsif( ($do_full_format eq "M_1") ||
	  ($do_full_format eq "M_2") ) {
	&gen_sets(TOFILE, $do_RA, "RA");
    }

    elsif( ($do_full_format eq "MD_1") || 
	  ($do_full_format eq "MD_2") ) {
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    
    elsif( ($do_full_format eq "MDS_1") || 
	  ($do_full_format eq "MDS_2") || 
	  ($do_full_format eq "MDS_3") || 
	  ($do_full_format eq "MDS_4") || 
	  ($do_full_format eq "MDS_5") || 
	  ($do_full_format eq "MDS_6") ||
	  ($do_full_format eq "MDS_3n") || 
	  ($do_full_format eq "MDS_4n") || 
	  ($do_full_format eq "MDS_5n") || 
	  ($do_full_format eq "MDS_6n") ) {
	&gen_sets(TOFILE, $do_RA, "RA");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	#* None *#
    }

    elsif( $do_full_format eq "VA_1" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VA_2" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_1" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_2" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_3" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VXR_1" ) {
	&gen_sets(TOFILE, $do_VT, "VT");
    }

    else {
	printf(STDERR  "Opcode_usedef.pl: Unknown format %s : %s in generate_instr_sets\n", $do_format, $do_full_format);
    }

    #printf(TOFILE "\n");

    if( $do_sets ne "" ) {
	@others = split(":", $do_sets);
	foreach $idx (@others) {
	    $reg = $GR_reg{$idx};
	    if( $idx eq "quad" ) {
		printf(TOFILE "      n = (OPC_DEC_FRT(iword)+1)%32;\n");
		printf(TOFILE "      sets[nsets++] = OPC_FPR(n);\n");
	    }
	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword);\n");
		printf(TOFILE "      m = OPC_DEC_RA(iword);\n");
		printf(TOFILE "      m = m==0?n:m;\n");
		printf(TOFILE "      for( i = 0; i < 32; i++ ) {\n");
		printf(TOFILE "        sets[nsets] = OPC_GPR(i);\n");
		printf(TOFILE "        nsets += (i != n && i != m);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RT_R31" ) {
		printf(TOFILE "      for( i = OPC_DEC_RT(iword)+1; i < 32; i++ ) {\n");
		printf(TOFILE "        sets[nsets++] = OPC_GPR(i);\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "RT_NB" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword)?(OPC_DEC_RB(iword)+3)>>2:8;\n");
		printf(TOFILE "      for( i = OPC_DEC_RT(iword)+1; i < OPC_DEC_RT(iword) + n; i++ ) {\n");
		printf(TOFILE "        sets[nsets++] = OPC_GPR((i%32));\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "FXM") {
		printf(TOFILE "      for( i = OPC_DEC_FXM(iword), j = 7; i; i  = i >> 1, j--  ) {\n");
		printf(TOFILE "        sets[nsets] = OPC_CR(j);\n");
		printf(TOFILE "        nsets += i&1;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $idx eq "SPRenc" ) {
		printf("ERROR: Bad sets value \"SPRenv\"\n");
		exit (-1);
	    }
	    elsif( $idx eq "XBIenc" ) {
		printf(TOFILE "      xbi = OPC_DEC_XBI(iword);\n");
		printf(TOFILE "      xbi = opc_tblxbienc[xbi];\n");
		printf(TOFILE "      sets[nsets] = xbi;\n");
		printf(TOFILE "      nsets += 1;\n");
	    }

	    elsif( $reg eq "FPSCR_BFA" ) {
		printf(TOFILE "      bfa = OPC_DEC_BFA(iword);\n");
		printf(TOFILE "      if ((bfa < 4) || (bfa == 5)) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 3) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 4) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa > 4) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BF" ) {
		printf(TOFILE "      bf = OPC_DEC_BF(iword);\n");
		printf(TOFILE "      if ((bf < 4) || (bf == 5)) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 3) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BT" ) {
		printf(TOFILE "      bt = OPC_DEC_BT(iword);\n");
		printf(TOFILE "      if ((bt < 13) || ((bt > 20) && ( bt < 24))) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 16) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 20) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      flm = OPC_DEC_FLM(iword);\n");
		printf(TOFILE "      if (flm & 0xf4) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_EXCPT;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x10) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FRFI;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x08) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_FPCC;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x03) { \n");
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_ENR;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "        sets[nsets++] = OPC_FPSCR_ENR;\n");
	    }

	    elsif( $reg eq "" ) {
		printf(STDERR "Opcode_usedef.pl :: %s: unknown set %s\n",$do_id, $idx);
	    }
	    else {
		printf(TOFILE "      sets[nsets] = %s;\n", $reg);
		printf(TOFILE "      nsets += %s;\n", $GR_incr{$idx});
	    }
	}
    }

    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}

sub DoFinalGenerateInstrSets {
    local (*TOFILE) = $_[0];
}




sub gen_sets {
    local(*TOFILE) = $_[0];
    local($reg, $name);
    local($theset);

    $reg = $_[1];
    $name = $_[2];

    if( ($reg eq "FPR") || ($reg eq "GPR") || ($reg eq "CRF") || ($reg eq "VECR") ) {
	$theset = "OPC_" . $reg . "(OPC_DEC_" . $name . "(iword))"; 
    }
    elsif( $reg eq "CRB" ) {
	$theset = "OPC_CR(OPC_DEC_" . $name . "(iword) >> 2)";
    }
    elsif( ($reg eq "0") || ($reg eq "1") ) {
	return;
    }
    else {
	printf(STDERR "Opcode_usedef.pl :: %s: gen_sets: unknown reg type: reg = %s  name = %s\n", $do_id, $reg, $name);
    }
    printf(TOFILE "      sets[nsets++] = %s;\n", $theset);
}

sub gen_mem_sets {
    local(*TOFILE) = $_[0];
    local($reg, $name);
    local($theuse);

    $reg = $_[1];
    $name = $_[2];
    
    if( $reg ne "GPR" ) {
	printf(STDERR "%s: gen_mem_sets: reg should be GPR, is %s\n", $do_id, $reg );
    }
    printf(TOFILE "      sets[nsets] = OPC_GPR(OPC_DEC_%s(iword));\n", $name);
    printf(TOFILE "      nsets += OPC_DEC_%s(iword) != 0;\n", $name);
}




#************************************************************************#
#*  These are the process_uses and process_sets routines, which are     *#
#*    really just wrappers for the generate_instr_* routines.           *#
#************************************************************************#

sub DoInitialGenerateInstrVecUses {
    local(*TOFILE) = $_[0];
}

sub DoGenerateInstrVecUsesForThisInstruction {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  case OPC_%s: {\n", $do_id);
    &generate_instr_vec_uses( TOFILE );
    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}

sub DoFinalGenerateInstrVecUses {
    local (*TOFILE) = $_[0];
}



sub DoInitialGenerateInstrVecSets {
    local(*TOFILE) = $_[0];
}

sub DoGenerateInstrVecSetsForThisInstruction {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  case OPC_%s: {\n", $do_id);
    &generate_instr_vec_sets( TOFILE );
    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}

sub DoFinalGenerateInstrVecSets {
    local (*TOFILE) = $_[0];
}



sub DoInitialGenerateInstrVecUseSets {
    local(*TOFILE) = $_[0];
}

sub DoGenerateInstrVecUseSetsForThisInstruction {
    local(*TOFILE) = $_[0];
    printf(TOFILE "  case OPC_%s: {\n", $do_id);
    &generate_instr_vec_uses( TOFILE );
    printf(TOFILE "      uvec[0] = gpr;\n");
    printf(TOFILE "      uvec[1] = fpr;\n");
    printf(TOFILE "      uvec[2] = cr;\n");
    printf(TOFILE "      uvec[3] = spr;\n");
    printf(TOFILE "      uvec[4] = xer;\n");
    
    printf(TOFILE "      gpr = 0;\n");
    printf(TOFILE "      fpr = 0;\n");
    printf(TOFILE "      cr  = 0;\n");
    printf(TOFILE "      spr = 0;\n");
    printf(TOFILE "      xer = 0;\n");

    &generate_instr_vec_sets( TOFILE );
    printf(TOFILE "      break;\n");
    printf(TOFILE "    }\n");
}

sub DoFinalGenerateInstrVecUseSets {
    local (*TOFILE) = $_[0];
}

#************************************************************************#
#*  The use vector routines (identical structure as the uses routines   *#
#*    but they output use-vector manipulations)                         *#
#************************************************************************#

sub gen_vec_uses {
    local(*TOFILE) = $_[0];
    local($reg, $name);
    
    $reg = $_[1];
    $name = $_[2];

    if( $reg eq "FPR" ) {
	printf(TOFILE "      fpr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "GPR" ) {
	printf(TOFILE "      gpr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "CRF" ) {
	printf(TOFILE "      cr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "VECR" ) {
	# Nothing for now -- don't track vector registers
    }
    elsif( $reg eq "CRB" ) {
	printf(TOFILE "      cr |= 1<<(OPC_DEC_%s(iword)>>2);\n", $name);
    }
    elsif( ($reg eq "0") || ($reg eq "1") ) {
	return;
    }
    else {
	printf(STDERR "Opcode_usedef.pl :: %s: gen_vec_uses: unknown $reg type: %s\n", $do_id, $reg);
    }
}

sub gen_vec_mem_uses {
    local(*TOFILE) = $_[0];
    
    local($reg, $name);
    $reg = $_[1];
    $name = $_[2];
    
    if( ($reg ne "GPR") && ($reg ne "0") ) {
	printf(STDERR  "%s: gen_vec_mem_uses: $reg should be GPR, is %s\n", $do_id, $reg );
    }
    if ($reg ne "0") {
	printf(TOFILE "      gpr |= (1<<OPC_DEC_%s(iword))&~(1);\n", $name);
    }
}

sub generate_instr_vec_uses {
    local(*TOFILE) = $_[0];
    local ($reg, $idx, @others);

    if( $do_full_format eq "I_1" ) {
	#* None *#
    }	

    elsif( $do_full_format eq "B_1" ) {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x10) != 0x10) {\n  ");
	printf(TOFILE "        /* Do not use the cond reg if this is branch always */\n");
	printf(TOFILE "        /*  or branch based only on the counter value.      */\n");
	&gen_vec_uses( TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
    }

    elsif ($do_full_format eq "SC_1") {
	#* None *#
    }
    elsif ($do_full_format eq "SC_2") {
	#* None *#
    }

    elsif ($do_full_format eq "D_1") {
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_2") {
	if( $do_RAas0 ) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_vec_uses( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_3") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_4") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif (($do_full_format eq "D_5") || 
	   ($do_full_format eq "D_6") || 
	   ($do_full_format eq "D_7") ) {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_8") {
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "D_9") {
	&gen_vec_uses( TOFILE, $do_FRS, "FRS");
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }

    elsif ($do_full_format eq "DS_1") {
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "DS_2") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
    }

    elsif ($do_full_format eq "DQ_1") {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
    }
    
    elsif( $do_full_format eq "X_1" ) {
	&gen_vec_uses( TOFILE, $do_RB, "RB");
	if( $do_load || $do_cache || $do_RAas0 ) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
	else {
	    &gen_vec_uses( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_2") {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
    }
    elsif ($do_full_format eq "X_3") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
	if( $do_store || $do_cache || $do_RAas0 ) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
	else {
	    #* RA is the destination in X_3 form if not a store *#
	}
    }
    elsif ($do_full_format eq "X_4") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	if ($do_store) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_5") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	if ($do_store) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_6") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_7") {
	&gen_vec_uses( TOFILE, $do_RB, "RA");
	&gen_vec_uses( TOFILE, $do_RA, "RB");
    }
    elsif ($do_full_format eq "X_8") {
	&gen_vec_uses( TOFILE, $do_FRB, "FRA");
	&gen_vec_uses( TOFILE, $do_FRA, "FRB");
    }
    elsif ($do_full_format eq "X_9") {
	if ($do_BFA eq "0") {
	    #* None *#
	}
	else {
	    &gen_vec_uses( TOFILE, $do_BFA, "BFA");
	}
    }
    elsif ($do_full_format eq "X_10") {
	#* None *#
    }
    elsif ($do_full_format eq "X_11") {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "X_12" ) {
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_13") {
	&gen_vec_uses( TOFILE, $do_FRB, "FRB");
    }
    elsif ($do_full_format eq "X_14") {
	&gen_vec_uses( TOFILE, $do_FRS, "FRS");
	&gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_15") {
	#* None *#
    }
    elsif ($do_full_format eq "X_16") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif ($do_full_format eq "X_17") {
	#* None *#
    }
    elsif ($do_full_format eq "X_18") {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif ($do_full_format eq "X_19") {
	&gen_vec_uses( TOFILE, $do_VS, "VS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
	if( $do_store || $do_cache || $do_RAas0 ) {
	    &gen_vec_mem_uses( TOFILE, $do_RA, "RA");
	}
	else {
	    #* RA is the destination in X_3 form if not a store *#
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	&gen_vec_uses(TOFILE, $do_RA, "RA");
	&gen_vec_uses(TOFILE, $do_RB, "RB");
    }

    elsif ($do_full_format eq "XL_1") {
	&gen_vec_uses( TOFILE, $do_BA, "BA");
	&gen_vec_uses( TOFILE, $do_BB, "BB");
	&gen_vec_uses( TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "XL_2") {
	printf(TOFILE "      if ((OPC_DEC_BO(iword) & 0x14) != 0x14) {\n  ");
	&gen_vec_uses( TOFILE, $do_BI, "BI");
	printf(TOFILE "      }\n");    
    }
    elsif ($do_full_format eq "XL_3") {
	&gen_vec_uses( TOFILE, $do_BFA, "BFA");
    }
    elsif ($do_full_format eq "XL_4") {
	#* None *#
    }

    elsif ($do_full_format eq "XFX_1") { 
	printf(TOFILE "      m = OPC_DEC_SPR(iword);\n");
	printf(TOFILE "      if( m == 1 ) {\n");
	printf(TOFILE "        spr |= OPC_XER_DEF_USE_MASK;\n");
	printf(TOFILE "        xer |= OPC_XER_FIELDS_MASK;\n");
	printf(TOFILE "      }\n");
	printf(TOFILE "      else {\n");
	printf(TOFILE "        spr |= opc_tblvecsprenc[m];\n");
	printf(TOFILE "      }\n");
    }
    elsif ($do_full_format eq "XFX_2") { 
	printf(TOFILE "      m = OPC_DEC_TBR(iword);\n");
	printf(TOFILE "      if( m == 268 ) {\n");
	printf(TOFILE "        spr |= OPC_TB;\n");
	printf(TOFILE "      }\n");
	printf(TOFILE "      else {\n");
	printf(TOFILE "        spr |= OPC_TBU;\n");
	printf(TOFILE "      }\n");
    }
    elsif (($do_full_format eq "XFX_3") ||
	   ($do_full_format eq "XFX_4") ) { 
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif ( $do_full_format eq "XFX_5" ) {
	#* None -- note, need special encoding (uses) or not? *#
    }

    elsif ($do_full_format eq "XFL_1") {
	&gen_vec_uses( TOFILE, $do_FRB, "FRB");
    }

    elsif ($do_full_format eq "XS_1") {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }

    elsif ( ($do_full_format eq "XO_1") || ($do_full_format eq "XO_2") ) {
	&gen_vec_uses( TOFILE, $do_RA, "RA");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }

    elsif( $do_full_format eq "A_1" ) {
	&gen_vec_uses( TOFILE, $do_FRA, "FRA");
	&gen_vec_uses( TOFILE, $do_FRB, "FRB");
	&gen_vec_uses( TOFILE, $do_FRC, "FRC");
    }

    elsif( $do_full_format eq "M_1" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "M_2" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }

    elsif( ($do_full_format eq "MD_1") || ($do_full_format eq "MD_2") ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    
    elsif( ($do_full_format eq "MDS_1") || ($do_full_format eq "MDS_2") ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_3" ) {
	#* None *#
    }
    elsif( $do_full_format eq "MDS_3n" ) {
	#* None *#
    }
    elsif( $do_full_format eq "MDS_4" ) {
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_4n" ) {
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_5" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif( $do_full_format eq "MDS_5n" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
    }
    elsif( $do_full_format eq "MDS_6" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    elsif( $do_full_format eq "MDS_6n" ) {
	&gen_vec_uses( TOFILE, $do_RS, "RS");
	&gen_vec_uses( TOFILE, $do_RB, "RB");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	#* None *#
    }

    elsif( $do_full_format eq "VA_1" ) {
	&gen_vec_uses(TOFILE, $do_VA, "VA");
	&gen_vec_uses(TOFILE, $do_VB, "VB");
	&gen_vec_uses(TOFILE, $do_VC, "VC");
    }
    elsif( $do_full_format eq "VA_2" ) {
	&gen_vec_uses(TOFILE, $do_VA, "VA");
	&gen_vec_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_1" ) {
	&gen_vec_uses(TOFILE, $do_VA, "VA");
	&gen_vec_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_2" ) {
	&gen_vec_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VX_3" ) {
	&gen_vec_uses(TOFILE, $do_VB, "VB");
    }
    elsif( $do_full_format eq "VXR_1" ) {
	&gen_vec_uses(TOFILE, $do_VA, "VA");
	&gen_vec_uses(TOFILE, $do_VB, "VB");
    }

    else {
	printf(STDERR  "Opcode_usedef.pl: Unknown format %s : %s in generate_instr_vec_uses\n", $do_format, $do_full_format);
    }

    #printf(TOFILE "\n");

    #* Check for added "special" uses *#
    if( $do_uses ne "" ) {
	@others = split(":", $do_uses);
	foreach $idx (@others) {
	    $reg = $GR_reg{$idx};

	    if( $idx eq "quad" ) {
		printf(TOFILE "        n = (OPC_DEC_RS(iword)+1)%32;\n");
		printf(TOFILE "        fpr |= 1<<n;\n");
	    }
	    elsif( $idx eq "RS_NB" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword)?\n");
		printf(TOFILE "         (1<<((OPC_DEC_RB(iword)+3)>>2))-1:\n");
		printf(TOFILE "         (1<<8)-1;\n");
		printf(TOFILE "      m = OPC_DEC_RS(iword);\n");
		printf(TOFILE "      gpr |= (n<<m) | (n>>(32-m));\n");
	    }

	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      gpr = ~0;\n");
	    }

	    elsif( $idx eq "RS_R31" ) {
		printf(TOFILE "      gpr |= ~0<<OPC_DEC_RS(iword);\n");
	    }

	    elsif( $idx eq "SPRenc" ) {
		printf("ERROR: Bad uses value \"SPRenv\"\n");
		exit(-1);
	    }
	    elsif( $idx eq "XBIenc" ) {
		printf(TOFILE "      m = OPC_DEC_XBI(iword);\n");
		printf(TOFILE "      spr |= OPC_XER_DEF_USE_MASK;\n");
		printf(TOFILE "      xer |= opc_tblvecxbienc[m];\n");
	    }

	    elsif( $reg eq "FPSCR_BFA" ) {
		printf(TOFILE "      bfa = OPC_DEC_BFA(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bfa < 4) || (bfa == 5)) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 3) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa > 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BF" ) {
		printf(TOFILE "      bf = OPC_DEC_BF(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bf < 4) || (bf == 5)) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 3) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf > 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BT" ) {
		printf(TOFILE "      bt = OPC_DEC_BT(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bt < 13) || ((bt > 20) && ( bt < 24))) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 16) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 20) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      flm = OPC_DEC_FLM(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if (flm & 0xf4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x10) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x08) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x03) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
	    }

	    elsif( $reg eq "" ) {
		printf(STDERR "Opcode_usedef.pl :: %s: unknown use %s\n",$do_id, $idx );
	    }

	    else {
		printf(TOFILE "      %s;\n", $GR_vec{$idx});
	    }
	}
    }
}


#************************************************************************#
#*  The set vector routines (identical structure as the sets routines   *#
#*    but they output use-vector manipulations)                         *#
#************************************************************************#

sub gen_vec_sets {
    local(*TOFILE) = $_[0];
    local($reg, $name);

    $reg = $_[1];
    $name = $_[2];

    if( $reg eq "FPR" ) {
	printf(TOFILE "      fpr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "GPR" ) {
	printf(TOFILE "      gpr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "CRF" ) {
	printf(TOFILE "      cr |= 1<<OPC_DEC_%s(iword);\n", $name);
    }
    elsif( $reg eq "VECR" ) {
	# Nothing for now -- don't track vector registers
    }
    elsif( $reg eq "CRB" ) {
	printf(TOFILE "      cr |= 1<<(OPC_DEC_%s(iword)>>2);\n", $name);
    }
    elsif( ($reg eq "0") || ($reg eq "1") ) {
	return;
    }
    else {
	printf(STDERR "Opcode_usedef.pl :: %s: gen_vec_sets: unknown reg type: %s",$do_id, $reg);
    }
}

sub gen_vec_mem_sets {
    local(*TOFILE) = $_[0];
    local( $reg, $name);
    $reg  = $_[1];
    $name = $_[2];
    
    if( $reg ne "GPR" ) {
	printf(STDERR "%s: gen_vec_mem_sets: reg should be GPR, is %s\n",$do_id, $reg );
    }
    printf(TOFILE "      gpr |= (1<<OPC_DEC_%s(iword))&~(1);\n", $name);
}

sub generate_instr_vec_sets {
    local(*TOFILE) = $_[0];
    local ($reg, $idx, @others);

    if( $do_full_format eq "I_1" ) {
	#* None *#
    }	

    elsif( $do_full_format eq "B_1" ) {
	#* None *#
    }

    elsif ($do_full_format eq "SC_1") {
	#* None *#
    }
    elsif ($do_full_format eq "SC_2") {
	#* None *#
    }

    elsif ($do_full_format eq "D_1") {
	if( $do_load ) {
	    if ( $do_update ) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_2") {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "D_3") {
	if( $do_update ) {
	    &gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_4") {
	&gen_vec_sets( TOFILE, $do_RA, "RA");
    }
    elsif ( ($do_full_format eq "D_5") || 
	   ($do_full_format eq "D_6") ) { 
	&gen_vec_sets( TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "D_7") {
	#* None *#
    }
    elsif ($do_full_format eq "D_8") {
	&gen_vec_sets( TOFILE, $do_FRT, "FRT");
	if( $do_update ) {
	    &gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "D_9") {
	if( $do_update ) {
	    &gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DS_1") {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
	if( $do_update ) {
	    &gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "DS_2") {
	if( $do_update ) {
	    &gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	}
    }

    elsif ($do_full_format eq "DQ_1") {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
	if ($do_update) {
	    &gen_vec_sets( TOFILE, $do_RA, "RA");
	}
    }
    
    elsif( $do_full_format eq "X_1" ) {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
	if( $do_load ) {
	    if ( $do_update ) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_2") {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "X_3") {
	if( $do_store ) {
	    if ( $do_update ) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_vec_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_4") {
	if (!$do_store) {
	    &gen_vec_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_5") {
	if (!$do_store) {
	    &gen_vec_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif ($do_full_format eq "X_6") {
	#* None *#
    }
    elsif ( ($do_full_format eq "X_7") || 
	   ($do_full_format eq "X_8") ||
	   ($do_full_format eq "X_9") ||
	   ($do_full_format eq "X_10") ) {
	&gen_vec_sets( TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "X_11") {
	#* None *#
    }
    elsif( $do_full_format eq "X_12" ) {
	&gen_vec_sets( TOFILE, $do_FRT, "FRT");
	if ($do_load) {
	    if ($do_update) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_13") {
	&gen_vec_sets( TOFILE, $do_FRT, "FRT");
    }
    elsif ($do_full_format eq "X_14") {
	if ($do_store) {
	    if ($do_update) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
    }
    elsif ($do_full_format eq "X_15") {
	if ($do_float) {
	    #* None (fpscr is implicit in "float") *#
	}
	else {
	    &gen_vec_sets( TOFILE, $do_BT, "BT");
	}
    }
    elsif ($do_full_format eq "X_16") {
	#* None -- Actually, an SR *# 
    }
    elsif ($do_full_format eq "X_17") {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "X_18") {
	# None -- access to some stream
    }
    elsif ($do_full_format eq "X_19") {
	if( $do_store ) {
	    if ( $do_update ) {
		&gen_vec_mem_sets( TOFILE, $do_RA, "RA");
	    }
	}
	else {
	    &gen_vec_sets( TOFILE, $do_RA, "RA");
	}
    }
    elsif( $do_full_format eq "X_20" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }

    elsif ($do_full_format eq "XL_1") {
	&gen_vec_sets( TOFILE, $do_BT, "BT");
    }
    elsif ($do_full_format eq "XL_2") {
	#* None *#
    }
    elsif ($do_full_format eq "XL_3") {
	&gen_vec_sets( TOFILE, $do_BF, "BF");
    }
    elsif ($do_full_format eq "XL_4") {
	#* None *#
    }
    
    elsif (($do_full_format eq "XFX_1") || 
	   ($do_full_format eq "XFX_2") ) {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }
    elsif ($do_full_format eq "XFX_3") {
    }
    elsif ($do_full_format eq "XFX_4") {
	printf(TOFILE "      m = OPC_DEC_SPR(iword);\n");
	printf(TOFILE "      if( m == 1 ) {\n");
	printf(TOFILE "        spr |= OPC_XER_DEF_USE_MASK;\n");
	printf(TOFILE "        xer |= OPC_XER_FIELDS_MASK;\n");
	printf(TOFILE "      }\n");
	printf(TOFILE "      else {\n");
	printf(TOFILE "        spr |= opc_tblvecsprenc[m];\n");
	printf(TOFILE "      }\n");
    }
    elsif ( $do_full_format eq "XFX_5" ) {
	#* None -- actually part of XER? (or uses?) *#
    }

    elsif ($do_full_format eq "XFL_1") {
	#* None -- actually the FPSCR *# 
    }

    elsif ($do_full_format eq "XS_1") {
	&gen_vec_sets( TOFILE, $do_RA, "RA");
    }

    elsif ( ($do_full_format eq "XO_1") || 
	   ($do_full_format eq "XO_2") ) {
	&gen_vec_sets( TOFILE, $do_RT, "RT");
    }

    elsif( $do_full_format eq "A_1" ) {
	&gen_vec_sets( TOFILE, $do_FRT, "FRT");
    }

    elsif( ($do_full_format eq "M_1") ||
	  ($do_full_format eq "M_2") ) {
	&gen_vec_sets( TOFILE, $do_RA, "RA");
    }

    elsif( ($do_full_format eq "MD_1") || 
	  ($do_full_format eq "MD_2") ) {
	&gen_vec_sets( TOFILE, $do_RA, "RA");
    }
    
    elsif( ($do_full_format eq "MDS_1") || 
	  ($do_full_format eq "MDS_2") || 
	  ($do_full_format eq "MDS_3") || 
	  ($do_full_format eq "MDS_4") || 
	  ($do_full_format eq "MDS_5") || 
	  ($do_full_format eq "MDS_6") ||
	  ($do_full_format eq "MDS_3n") || 
	  ($do_full_format eq "MDS_4n") || 
	  ($do_full_format eq "MDS_5n") || 
	  ($do_full_format eq "MDS_6n") ) {
	&gen_vec_sets( TOFILE, $do_RA, "RA");
    }
    
    elsif( $do_full_format eq "TX_1" ) {
	#* None *#
    }

    elsif( $do_full_format eq "VA_1" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VA_2" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_1" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_2" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VX_3" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }
    elsif( $do_full_format eq "VXR_1" ) {
	&gen_vec_sets(TOFILE, $do_VT, "VT");
    }

    else {
	printf(STDERR  "Opcode_usedef.pl: Unknown format %s : %s in generate_instr_vec_sets\n", $do_format, $do_full_format);
    }

    #printf(TOFILE "\n");

    if( $do_sets ne "" ) {
	@others = split(":", $do_sets);
	foreach $idx (@others) {
	    $reg = $GR_reg{$idx};
	    if( $idx eq "quad" ) {
		printf(TOFILE "      n = (OPC_DEC_RT(iword)+1)%32;\n");
		printf(TOFILE "      fpr |= 1<<n;\n");
	    }
	    elsif( $idx eq "R0_R31" ) {
		printf(TOFILE "      gpr = ~(1<<OPC_DEC_RB(iword));\n");
	    }
	    elsif( $idx eq "RT_R31" ) {
		printf(TOFILE "      gpr = (~0)<<OPC_DEC_RT(iword);\n");
	    }
	    elsif( $idx eq "RT_NB" ) {
		printf(TOFILE "      n = OPC_DEC_RB(iword)?\n");
		printf(TOFILE "         (1<<((OPC_DEC_RB(iword)+3)>>2))-1:\n");
		printf(TOFILE "         (1<<8)-1;\n");
		printf(TOFILE "      m = OPC_DEC_RT(iword);\n");
		printf(TOFILE "      gpr |= n<<m;\n");

	    }
	    elsif( $idx eq "FXM") {
		printf(TOFILE "	cr |= crm_swap[OPC_DEC_FXM(iword)];\n");
	    }
	    elsif( $idx eq "SPRenc" ) {
		printf("ERROR: Bad sets value \"SPRenv\"\n");
		exit (-1);
	    }
	    elsif( $idx eq "XBIenc" ) {
		printf(TOFILE "      m = OPC_DEC_XBI(iword);\n");
		printf(TOFILE "      spr |= OPC_XER_DEF_USE_MASK;\n");
		printf(TOFILE "      xer |= opc_tblvecxbienc[m];\n");
	    }

	    elsif( $reg eq "FPSCR_BFA" ) {
		printf(TOFILE "      bfa = OPC_DEC_BFA(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bfa < 4) || (bfa == 5)) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 3) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa == 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bfa > 4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BF" ) {
		printf(TOFILE "      bf = OPC_DEC_BF(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bf < 4) || (bf == 5)) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (bf == 3) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_BT" ) {
		printf(TOFILE "      bt = OPC_DEC_BT(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if ((bt < 13) || ((bt > 20) && ( bt < 24))) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 16) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else if (bt < 20) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      else {\n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }		
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      flm = OPC_DEC_FLM(iword);\n");
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      if (flm & 0xf4) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_EXCPT_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x10) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FRFI_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x08) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_FPCC_OFFSET;\n");
		printf(TOFILE "      }\n");
		printf(TOFILE "      if (flm & 0x03) { \n");
		printf(TOFILE "        xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
		printf(TOFILE "      }\n");
	    }
	    elsif( $reg eq "FPSCR_FLM" ) {
		printf(TOFILE "      spr |= OPC_FPSCR_DEF_USE_MASK;\n");
		printf(TOFILE "      xer |= 1<<OPC_FPSCR_ENR_OFFSET;\n");
	    }

	    elsif( $reg eq "" ) {
		printf(STDERR "Opcode_usedef.pl :: %s: unknown set %s\n",$do_id, $idx);
	    }
	    else {
		printf(TOFILE "      %s;\n", $GR_vec{$idx});
	    }
	}
    }
}

