#ifndef H_opc_instr_info
#define H_opc_instr_info

#include "opc_instr_info_defns.h"

extern __thread unsigned short opc_itypes_tbl[];
extern __thread unsigned char opc_iformats_tbl[];
extern __thread unsigned char opc_is_float_tbl[];
extern __thread unsigned char opc_is_vmx_tbl[];
extern __thread unsigned char opc_does_update_tbl[];
extern __thread unsigned char opc_does_record_tbl[];
/*
  extern unsigned char opc_is_user_PPC_tbl[];
  extern unsigned char opc_is_user_POWER_tbl[];
  */

extern __thread char opc_tbl_is_in_ISA[OPC_NUM+1][OPC_NUM_ISAs];

unsigned opc_itype(opc_idx idx);
unsigned opc_iword_itype(unsigned iword);
#define opc_itype(idx)	(opc_itypes_tbl[idx])
#define opc_iword_itype(iword)	(opc_itypes_tbl[opc_index(iword)])

unsigned opc_iformat(opc_idx idx);
unsigned opc_iword_iformat(unsigned iword);
#define opc_iformat(idx)           (opc_iformats_tbl[idx])
#define opc_iword_iformat(iword)   (opc_iformats_tbl[opc_index(iword)])

unsigned opc_is_float(opc_idx idx);
unsigned opc_iword_is_float(unsigned iword);
#define opc_is_float(idx)	(opc_is_float_tbl[idx])
#define opc_iword_is_float(iword)	(opc_is_float_tbl[opc_index(iword)])

unsigned opc_is_vmx(opc_idx idx);
unsigned opc_iword_is_vmx(unsigned iword);
#define opc_is_vmx(idx)	(opc_is_vmx_tbl[idx])
#define opc_iword_is_vmx(iword)	(opc_is_vmx_tbl[opc_index(iword)])

unsigned opc_does_update(opc_idx idx);
unsigned opc_iword_does_update(unsigned iword);
#define opc_does_update(idx)	(opc_does_update_tbl[idx])
#define opc_iword_does_update(iword)	(opc_does_update_tbl[opc_index(iword)])

unsigned opc_does_record(opc_idx idx);
unsigned opc_iword_does_record(unsigned iword);
#define opc_does_record(idx)	(opc_does_record_tbl[idx])
#define opc_iword_does_record(iword)	(opc_does_record_tbl[opc_index(iword)])

int opc_is_in_ISA(int theISA, opc_idx index);
int opc_is_in_ISA_typed(int theISA, opc_idx index);
#define opc_is_in_ISA(_ISA,_idx)       (opc_tbl_is_in_ISA[_idx][_ISA] != 0)
#define opc_is_in_ISA_typed(_ISA,_idx) (opc_tbl_is_in_ISA[_idx][_ISA])

#define opc_is_user_PPC_instr(_idx)	    (opc_is_in_ISA_typed(OPC_PPC_ISA,_idx) == OPC_IS_IN_ISA)
#define opc_iword_is_user_PPC_instr(_iwd)  (opc_is_in_ISA_typed(OPC_PPC_ISA,opc_index(_iwd)) == OPC_IS_IN_ISA)

#define opc_is_user_POWER_instr(_idx)	    (opc_is_in_ISA_typed(OPC_POWER_ISA,_idx) == OPC_IS_IN_ISA)
#define opc_iword_is_user_POWER_instr(_iwd)  (opc_is_in_ISA_typed(OPC_POWER_ISA,opc_index(_iwd)) == OPC_IS_IN_ISA)

#endif

#ifndef H_opc_iformats
#define H_opc_iformats




#endif
