
#include "ansi_assert.h"
#include "ansi_stdio.h"
#include "ansi_string.h"
#include "ansi_stdlib.h"
#include "opc.h"

int
main(
	int	argc,
	char *	argv[]
	)
{
  int		i;
  int		j;
  unsigned	val;
  unsigned	index;
  unsigned	index2;
  // char *	name; // unused?
  char 		buf[512];
  opc_reg	uses[256];
  int		nuses;
  opc_reg	sets[256];
  int		nsets;
  int            pos = 1;

  #if 0
  printf("strcmp(argv[1], \"-am\") = %d\n", strcmp(argv[1], "-am"));
  #endif

  if (!strcmp(argv[1], "-am")) {
    opc_ISA_init(OPC_AMAZON_ISA);
    pos++;
  }
  else {
    opc_init();
  }

  for( i = pos; i < argc; i++ ) {
    val = strtoul(argv[i], 0, 0);
    index = opc_index(val);
    index2 = (opc_index)(val);
    assert( index == index2 );
    opc_dis(val, buf);
    printf("%08x: %s\n", val, buf);
    printf("\tff32cat = %d opc_index = %d\n",  opc_ff32_cat(index), index);

    #if 1 
    nuses = opc_uses(val, uses);
    printf("#uses = %d\n", nuses);
    for( j = 0; j < nuses; j++ ) {
      printf("\t%d: %s\n", uses[j], opc_reg_names(uses[j]));
    }

    nsets = opc_sets(val, sets);
    printf("#sets = %d\n", nsets);
    for( j = 0; j < nsets; j++ ) {
      printf("\t%d: %s\n", sets[j], opc_reg_names(sets[j]));
    }
    #endif

    #if 0
    printf("XBI = %d\n", OPC_DEC_XBI(val));
    #endif

    #if 1
    {
      unsigned	major = val >> 26;
      unsigned	mask  = opc_tblidx_mask[major];
      unsigned	init  = opc_tblidx_init[major];
      unsigned	minor = val & mask;
      // unsigned	index = init+minor; // unused? and name conflict with other 'index'
      printf("major = %d\nmask  = 0x%08x\nminor = %d\n", major, mask, minor);
    }
    #endif

    #if 1
    if (OPC_IS_A_MEMORY_ACCESS_OP(opc_itype(index))) {
      int len = opc_iword_dlength(val);
      printf("the    dlength = %d\n", len);
      printf("(macro dlength = %d\n", opc_dlength(index));
    }
    #endif

    printf("\n");
  }
  return EXIT_SUCCESS; // jdonald
}
