/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... analyze_branch.h
  FUNCTION ........ Forward declarations of the end-of-basic-block
      analysis routines.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... analyze_branch.c do_translation.c
  MACROS-USED...... None
  INCLUDES......... <see below>

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef ANALYZE_BRANCH_H
#define ANALYZE_BRANCH_H

#include "globtypes.h"

extern unsigned * analyze_branch(unsigned branch_iword,
				 unsigned * prog_address, 
				 unsigned * base_reg, 
				 unsigned dtrbf_ptr, 
				 unsigned dyntr_posn
				 );

extern unsigned * bb_fallthrough(unsigned * prog_address, 
				 unsigned * base_reg
				 );

extern unsigned * find_relative_branch_target(unsigned   branch_iword,
					      unsigned * prog_address,
					      unsigned * target_addr,
					      unsigned * fallthru_addr
					      );

unsigned * insert_embedded_branch_code(unsigned   branch_iword,
				       unsigned   branch_number,
				       branch_list_type * the_branches_list,
				       unsigned   base_reg,
				       unsigned   scratch_reg,
				       unsigned   dtrbf_ptr,
				       unsigned   br_num_reg,
				       unsigned   br_target_reg,
				       unsigned   br_fallthru_reg
				       );

unsigned * insert_embedded_branch_cleanup_code(unsigned   num_branches,
					       branch_list_type * the_branches_list,
					       unsigned  *last_user_instr_addr,
					       unsigned  *base_reg_ptr,
					       unsigned   scratch_reg,
					       unsigned   dtrbf_ptr,
					       unsigned   br_num_reg,
					       unsigned   br_target_reg,
					       unsigned   br_fallthru_reg
					       );

#endif

