/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... aria_per_instr_interface.h
  FUNCTION ........ Declares the per-instruction interface table 
     type, and the accessor macros, plus an extern declaration
     of the table itself.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... <aria interface code>
  MACROS-USED...... None
  INCLUDES......... None

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... May, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/
#ifndef ARIA_PER_INSTR_INTERFACE_H
#define ARIA_PER_INSTR_INTERFACE_H

#include "globdefs.h"
#include "aria_interface.h"

#define PER_INSTR_INTEGER_VALUE_ACTION   1
#define PER_INSTR_FUNCTION_CALL_ACTION   2

typedef struct aria_per_instr_interf_struct {
  short                    action_timing;
  short                    action_flag_type;
  aria_user_function_type  before_function_pointer;
  aria_user_function_type  after_function_pointer;
} aria_per_instr_entry_type;

#define per_instruction_action_time(x)         (global_per_instruction_actions[(x)].action_timing)
#define per_instruction_action_type(x)         (global_per_instruction_actions[(x)].action_flag_type)
#define per_instruction_before_function_ptr(x) (global_per_instruction_actions[(x)].before_function_pointer)
#define per_instruction_after_function_ptr(x)  (global_per_instruction_actions[(x)].after_function_pointer)

#endif
