/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... dump_description.h
  FUNCTION ........ Declarations of the macros that are used in 
      invoking the DUMP_DESCRIPTION routines to print out the 
      translated code.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... canned_multiple_code.c, canned_string_code.c,
      do_svc_translation.c, do_translation.c, save_user_state.c
  MACROS-USED...... None
  INCLUDES......... <see below>

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef DUMP_DESCRIPTION_H
#define DUMP_DESCRIPTION_H

#define DUMP_DESCRIPTION(a,b)               dump_one_instruction_description((a),(b),NULL,0)
#define ALWAYS_DUMP_DESCRIPTION(a,b)        dump_one_instruction_description((a),(b),NULL,3)
#define DUMP_XLATE_DESCRIPTION(a,b,c)       dump_one_instruction_description((a),(b),(c),1)
#define DUMP_FAKE_DESCRIPTION(a,b)          dump_one_instruction_description((a),(b),NULL,2)
#define DUMP_SIMULATION_DESCRIPTION(a,b,c)  dump_one_instruction_description((a),(b),(c),4)

void dump_one_instruction_description(unsigned * first_addr, unsigned * last_addr,  
				      unsigned * user_addr, int flag);

#endif
