/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... globtypes.h
  FUNCTION ........ Defines some globally-defined types that will 
     be useful to a number of different routines.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... aria_interface.c, aria_main.c, canned_multiple_code.c
      canned_string_code.c, do_svc_translation.c, do_translation.c
      interface_globals.h

  MACROS-USED...... None
  INCLUDES......... None

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef GLOBTYPES_H
#define GLOBTYPES_H

/********************************************************************/
/** These defines are used to define elements used in Aria, e.g.   **/
/**  the number of bits in an address, etc.                        **/
/********************************************************************/
#if DO_64_BIT_COMPILE
  typedef unsigned long long  BASE_TYPE;
#else
  typedef unsigned  BASE_TYPE;
#endif


/** Loaded program function definitions **/

typedef int (*func_ptr)();

typedef struct aria_func_desc aria_func_desc;
struct aria_func_desc {
  unsigned *	pc;
  BASE_TYPE	toc;
  unsigned	other;
};

/** and Access Macros **/

#define deref_func_desc(f)	(f)
#define pc_func_desc(f)		(deref_func_desc(f)->pc)
#define toc_func_desc(f)	(deref_func_desc(f)->toc)
#define other_func_desc(f)	(deref_func_desc(f)->other)



/* The information about the use and definition of instructions */
typedef struct use_def_data_struct {
  unsigned use_vectors[4];
  unsigned def_vectors[4];
  unsigned touch_vectors[4];
} use_def_data_type;


/* The information about the use and definition of instructions */
typedef struct instruction_xlate_type_struct {
  BASE_TYPE iaddr;
  unsigned  iword;
  unsigned  index;
  unsigned  ikind;
  BASE_TYPE daddr;
  unsigned  dlen;
  unsigned  dynamic_code_end_posn;
  unsigned  speculation_code_end_posn;
} instruction_xlate_type;

/* A type that holds branch information from the user code */
typedef struct br_list_type_struct {
  BASE_TYPE  address;
  short      num_instr;
  short      to_a_stwcx;
  unsigned   rel_target;
  BASE_TYPE  fall_thru;
  unsigned * skip_posn;
} branch_list_type;

#define MAX_NUMBER_OF_BRANCHES_IN_BRANCH_LIST  100


#endif
