/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... interface_globals.h
  FUNCTION ........ External declatations of global variables 
     shared JUST between the aria_main and the are_interface
     routines.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... aria_interface.c 
  MACROS-USED...... None
  INCLUDES......... <see below>

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef INTERFACE_GLOBALS_H
#define INTERFACE_GLOBALS_H

#include "globtypes.h"

extern unsigned  * prog_start;
extern unsigned  * xlate_mem_start;
extern unsigned    user_program_start_address;

extern aria_func_desc * prog_desc;
extern func_ptr    prog_ptr;

extern int     user_argc;
extern char ** user_argv;
extern char  * user_envp;

extern unsigned long long global_user_line_index;
extern unsigned long long global_xlated_line_index;

extern unsigned long long global_user_instructions;
extern unsigned long long global_xlated_instructions;

extern proc_state_type * curr_process_state_space_ptr;
extern proc_state_type * last_process_state_space_position;

extern unsigned global_do_show_system_xlation;
extern unsigned global_do_show_system_pre_run_proc_state;
extern unsigned global_do_show_system_proc_state;

extern unsigned do_interactive_aria_system_run;

extern unsigned long long show_run_update_after;
extern unsigned long long show_run_update_every;

extern unsigned long long capture_window_size;
extern unsigned long long skip_window_size;
extern int      do_uniform_sampling_in_aria;
extern unsigned curr_window_count;

#ifdef FULL_DEVELOPMENT_DEBUG_CODE
extern unsigned long long global_do_verify_hash_after;
extern unsigned long long global_do_verify_hash_every;
#endif

extern unsigned * user_stack_address_value;

/** Global microtrace buffers used to represent an SVC/SC code and return **/
#define dummy_3600_microtrace_buffer_size  2

extern unsigned dummy_3600_microtrace_buffer[10];

#endif

