/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... io_msgs.h
  FUNCTION ........ Forward declarations of io routines.  These 
     io routines provide guards on their execution.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... None
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... aria_interface.c, aria_main.c, dump_description.c,
      proc_state.c, warn_proc_state.c

  MACROS-USED...... None
  INCLUDES......... <see below>

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef IO_MSGS_H
#define IO_MSGS_H

#include <stdarg.h>

void warn(char * fmt, ...);

void warn_exec(char * fmt, ...);

void warn_trace(char * fmt, ...);

void warn_xlate(char * fmt, ...);

void warn_hash(char * fmt, ...);

void warn_bb_regs(char * fmt, ...);

void warn_proc_state(char * fmt, ...);

void warn_trace_buffer(char * fmt, ...);

void warn_warnings(char * fmt, ...);

#endif
