/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... proc_state_accessors.h
  FUNCTION ........ Provides the user with access to the 
      user-relevant parts of the process saved state space.

  NOTES............
  ASSUMPTIONS... None
  GLOBAL-VARS... None
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... 
  CALLED-ROUTINES.. 
  CALLED-BY........ None
  INCLUDED-BY...... User code, proc_state.h
  MACROS-USED...... None
  INCLUDES......... None

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

#ifndef PROC_STATE_ACCESSORS_H
#define PROC_STATE_ACCESSORS_H

/**************************************/
/* The user-relevant accessor macros. */
/**************************************/

/* Processor register values */
#define proc_state_LR(x)               ((x)->_aria_link_reg)
#define proc_state_CTR(x)              ((x)->_aria_count_reg)
#define proc_state_CR(x)               ((x)->_aria_condition_reg)
#define proc_state_CRF(x,y)            (((x)->_aria_condition_reg)>>(31-(y<<2)) & (0x0f))
#define proc_state_CRB(x,y)            (((x)->_aria_condition_reg)>>(31-(y)) & (0x1))
#define proc_state_XER(x)              ((x)->_aria_XER_reg)
#define proc_state_GPR(x,y)            ((x)->_aria_GPRS[(y)])
#define proc_state_FPSCR(x)            ((x)->_aria_fpscr)
#define proc_state_FPR(x,y)            ((x)->_aria_FPRS[y])
#define proc_state_MQ(x)               ((x)->_aria_MQ_reg)

/* The next execution address */
#define proc_state_TARGET(x)           ((x)->_aria_next_target)

/* The time spent in the last system call execution */
#define proc_state_sc_identifier(x)      ((x)->_last_sc_id_number)
#define proc_state_sc_exec_time_secs(x)  ((x)->_last_sc_execution_time_high)
#define proc_state_sc_exec_time_ns(x)    ((x)->_last_sc_execution_time_low)


/* The raw starting and ending address of the loaded user program */
#define raw_address_of_program_start(x) ((x)->_raw_address_of_program_start)
#define raw_address_of_program_end(x)   ((x)->_raw_address_of_program_end)

#endif
