/*                                                                     
** COMPONENT_NAME: MET / Aria
**                                                                      
** Licensed Materials - Property of IBM                                  
**                                                                     
** IBM Confidential (IBM Confidential-Restricted when combined          
**                   with aggregated modules for this product)          
**                                                                     
**                                                                     
** OCO Source Materials                                                
**                                                                     
**                                                                     
** GA-0100 (C) Copyright IBM Corp. 1997                                 
**                                                                     
** US Government Users Restricted RIghts - Use, duplication or         
** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.   
**                                                                     
** The source code for this program is not published or otherwise      
** divested of its trade secrets, irrespective of what has been        
** deposited within the U.S. Copyright Office.                         
**                                                                     
*/


 
/*******************************************************************
  PROGRAM NAME..... None
  FUNCTION ........ Inlined (#included) code to align translation 
                     space on a user-specified boundary.
  
  NOTES............
  ASSUMPTIONS... Two variables are assumed to be defined globally :
    next_xlate_address : holds the next available xlation address
         (this is what must be aligned to the user-specified boundary)
    the_xlated_code_alignment : a value (in terms of bytes) on which 
         the start of xlated code (for user or speculation code) 
	 addresses must be aligned 
  RESTRICTIONS.. None
  DEVIATIONS.... None
  PROGRAM TYPE..... C
  RETURN CODES..... 0= Successful
  CALLED-ROUTINES.. None
  CALLED-BY........ None
  INCLUDED-BY...... do_translation.c, do_svc_translation.c, canned_code.c
  MACROS-USED...... None
  INCLUDES......... None

  AUTHOR........... John-David Wellman, IBM Yorktown
  CREATION DATE.... April, 1997
  MODIFIED......... Who       Date      What
  
  ********************************************************************/

  {
    unsigned next_xl_start = (unsigned) next_xlate_address;
    unsigned curr_offset_in_align = next_xl_start & (the_xlated_code_alignment-1);
    if (curr_offset_in_align != 0) {
      unsigned adder = the_xlated_code_alignment - curr_offset_in_align;
      next_xl_start = next_xl_start + adder;
      next_xlate_address = (unsigned *)next_xl_start;
    }
  }
