#! /usr/bin/perl
#
# prep_xlc: A tool to remove C++ style comments that IBM's xlc
# compiler can't handle. This was made originally to try for
# proper compilation of PTCMP, but can probably also come in handy
# building things like the MediaBench suite.
#
# This does not guard for errors that can result from comments
# within comments, or constructs such as *//*.
#
# Also, this script does not succeed in getting PTCMP to build
# with xlc. There are several other remaining problems that are
# just not worth our time to deal with. Use gcc.
#
# /jdonald

	print "This will irreversibly modify all source files in the current folder and its subdirectories.\n";
	print "Are you sure you want to do this? (yes/no) ";
	$yesno = <STDIN>;
	chomp($yesno);

	if (!($yesno eq "yes" || $yesno eq "y" || $yesno eq "Y" || $yesno eq "YES")) {
		exit 0;
	}
	
	# $find_cmd = "find . -name '\*\\\.[chC]'";
	# $find_cmd = "find . -name '\*\\\.macros'";
    # $find_cmd = "find . | egrep '\\.c\$|\\.h\$|\\.C\$|\\.macros\$'";
    #    : find . | egrep '\.c$|\.h$|\.C$|\.macros$'

	$find_cmd = 'find .';
   
	@srcfiles = `$find_cmd`;
	
	foreach $fname (@srcfiles) {
		if ($fname =~ m/.c$/ || $fname =~ m/.h$/ || $fname =~ m/.C$/ || $fname =~/.macros$/) {
			@sed_result = `sed -e 's/\\\/\\\/.*\$//g' $fname`;
			$f = open(FILE, ">$fname");
			if (!$f) {
				print "prep_xlc: unable to open $fname for writing\n";
				exit -1;
			}
			print FILE @sed_result;
			close(FILE);
			print "processed file: $fname\n";
		}
	}
	exit 0;
