#ifndef H_aria_reader
#define H_aria_reader

#include "insn_info.h"
#include "aria_interface.h"

typedef struct aria_reader aria_reader;

struct aria_reader {
  unsigned		first_pc;
  unsigned		min_pc;
  unsigned		max_pc;
  unsigned		is_done;

  unsigned 		samp_total;
  unsigned		samp_skip;
  unsigned		samp_read;

  unsigned short	taken_left;
  unsigned short	taken_start;
  unsigned		taken_last_pc;
  unsigned *		taken_itrace;
  proc_state_type	taken_state;

  unsigned short	nottaken_left;
  unsigned short	nottaken_start;
  unsigned		nottaken_last_pc;
  unsigned *		nottaken_itrace;
  proc_state_type	nottaken_state;

};

#define aria_reader_deref(reader)	\
	(reader)

#define aria_reader_first_pc(reader)	\
	(aria_reader_deref(reader)->first_pc)


#define aria_reader_min_pc(reader)	\
	(aria_reader_deref(reader)->min_pc)

#define aria_reader_max_pc(reader)	\
	(aria_reader_deref(reader)->max_pc)

#define aria_reader_is_done(reader)	\
	(aria_reader_deref(reader)->is_done)

#define aria_reader_sample_total(reader)	\
	(aria_reader_deref(reader)->samp_total)

#define aria_reader_sample_skip(reader)	\
	(aria_reader_deref(reader)->samp_skip)

#define aria_reader_sample_read(reader)	\
	(aria_reader_deref(reader)->samp_read)

#define aria_reader_taken_last_pc(reader)	\
	(aria_reader_deref(reader)->taken_last_pc)

#define aria_reader_taken_left(reader)	\
	(aria_reader_deref(reader)->taken_left)

#define aria_reader_taken_start(reader)	\
	(aria_reader_deref(reader)->taken_start)

#define aria_reader_taken_itrace(reader)	\
	(aria_reader_deref(reader)->taken_itrace)

#define aria_reader_taken_dtrace(reader)	\
	(aria_reader_deref(reader)->taken_dtrace)

#define aria_reader_taken_state(reader)	\
	(&(aria_reader_deref(reader)->taken_state))

#define aria_reader_nottaken_last_pc(reader)	\
	(aria_reader_deref(reader)->nottaken_last_pc)

#define aria_reader_nottaken_left(reader)	\
	(aria_reader_deref(reader)->nottaken_left)

#define aria_reader_nottaken_start(reader)	\
	(aria_reader_deref(reader)->nottaken_start)

#define aria_reader_nottaken_itrace(reader)	\
	(aria_reader_deref(reader)->nottaken_itrace)

#define aria_reader_nottaken_dtrace(reader)	\
	(aria_reader_deref(reader)->nottaken_dtrace)

#define aria_reader_nottaken_state(reader)	\
	(&(aria_reader_deref(reader)->nottaken_state))


void aria_reader_setup(
	aria_reader *	reader,
	unsigned	min_pc,
	unsigned	max_pc,
	unsigned *	init_pc
	);

void aria_sample_setup(
	aria_reader *	reader,
	unsigned	insns_skip,
	unsigned	insns_read
	);

int aria_get_taken(
	aria_reader *	reader,
	unsigned *	pc,
	int		max_info,
	xinsn_info	info[]
	);

int aria_get_not_taken(
	aria_reader *	reader,
	unsigned *	pc,
	int		max_info,
	xinsn_info	info[]
	);

void aria_swap_to_not_taken(
	aria_reader *	reader,
	unsigned	pc
	);

#endif
