#ifndef H_dep_prep_info
#define H_dep_prep_info

#if( defined(max) ) 
#undef max
#endif
#define max(x,y)	((x)>(y)?(x):(y))

#if( !defined(IFETCH_MAX) )
#define IFETCH_MAX	4
#endif

#if( !defined(IFETCHE_ALIGN) )
#define IFETCH_ALIGN	4
#endif

#if( !defined(ICACHE_ALIGN ) )
#define ICACHE_ALIGN	32
#endif

#define IFETCH_ALIGN_MASK	(IFETCH_ALIGN-1)
#define ICACHE_MASK	(ICACHE_ALIGN-1)

#if( !defined( BRANCH_LATENCY ) )
#define BRANCH_LATENCY	1
#endif

#if( !defined( CRL_LATENCY ) )
#define CRL_LATENCY	1
#endif

#if( !defined( FPU_LATENCY ) )
#define FPU_LATENCY	3
#endif

#if( !defined( LOAD_LATENCY ) )
#define LOAD_LATENCY	3
#endif

#if( !defined( SUBWORD_LOAD_LATENCY ) )
#define SUBWORD_LOAD_LATENCY	0
#endif

#if( !defined( ARITHMETIC_LOAD_LATENCY ) )
#define ARITHMETIC_LOAD_LATENCY	0
#endif

#if( !defined( FLOAT_LOAD_LATENCY ) )
#define FLOAT_LOAD_LATENCY	0
#endif

#if( !defined( STORE_LATENCY ) )
#define STORE_LATENCY	3
#endif

#if( !defined( FIX_LATENCY ) )
#define FIX_LATENCY	1
#endif

#if( !defined( IMUL_LATENCY ))
#define IMUL_LATENCY	5
#endif

#if( !defined( IDIV_LATENCY ) )
#define IDIV_LATENCY	8
#endif

#if( !defined( FDIV_LATENCY ) )
#define FDIV_LATENCY	21
#endif

#if( !defined( CMP_LATENCY ) )
#define CMP_LATENCY	FIX_LATENCY
#endif


#if( !defined( BRANCH_AVAIL ) )
#define BRANCH_AVAIL	BRANCH_LATENCY
#endif

#if( !defined( CRL_AVAIL ) )
#define CRL_AVAIL	CRL_LATENCY
#endif

#if( !defined( FPU_AVAIL ) )
#define FPU_AVAIL	FPU_LATENCY
#endif

#if( !defined( LOAD_AVAIL ) )
#define LOAD_AVAIL	LOAD_LATENCY
#endif

#if( !defined( SUBWORD_LOAD_AVAIL ) )
#define SUBWORD_LOAD_AVAIL	SUBWORD_LOAD_LATENCY
#endif

#if( !defined( ARITHMETIC_LOAD_AVAIL ) )
#define ARITHMETIC_LOAD_AVAIL	ARITHMETIC_LOAD_LATENCY
#endif

#if( !defined( FLOAT_LOAD_AVAIL ) )
#define FLOAT_LOAD_AVAIL	FLOAT_LOAD_LATENCY
#endif

#if( !defined( STORE_AVAIL ) )
#define STORE_AVAIL	STORE_LATENCY
#endif

#if( !defined( FIX_AVAIL ) )
#define FIX_AVAIL	FIX_LATENCY
#endif

#if( !defined( IMUL_AVAIL ) )
#define IMUL_AVAIL	IMUL_LATENCY
#endif

#if( !defined( IDIV_AVAIL ) )
#define IDIV_AVAIL	IDIV_LATENCY
#endif

#if( !defined( FDIV_AVAIL ) )
#define FDIV_AVAIL	FDIV_LATENCY
#endif

#if( !defined( CMP_AVAIL ) )
#define CMP_AVAIL	CMP_LATENCY
#endif


#if( !defined( BRANCH_UNIT ) )
#define BRANCH_UNIT	3
#endif

#if( !defined( FPU_UNIT ) )
#define FPU_UNIT	1
#endif

#if( !defined( LOAD_UNIT ) )
#define LOAD_UNIT	2
#endif

#if( !defined( STORE_UNIT ) )
#define STORE_UNIT	2
#endif

#if( !defined( FIX_UNIT ) )
#define FIX_UNIT	0
#endif

#if( !defined( IMUL_UNIT ) )
#define IMUL_UNIT	FIX_UNIT
#endif

#if( !defined( IDIV_UNIT ) )
#define IDIV_UNIT	FIX_UNIT
#endif

#if( !defined( USE_GP ) )
#define USE_GP		1
#endif

#if( !defined( SPLIT_ALL ) )
#define SPLIT_ALL	1
#endif

#if( !defined( SPLIT_FXLDAU ) )
#define SPLIT_FXLDAU	1
#endif

#if( !defined( SPLIT_FXLDA ) )
#define SPLIT_FXLDA	1
#endif

#if( !defined( SPLIT_FXLDU ) )
#define SPLIT_FXLDU	1
#endif

#if( !defined( SPLIT_FPLDU ) )
#define SPLIT_FPLDU	1
#endif

#if( !defined( SPLIT_FXSTUX ) )
#define SPLIT_FXSTUX	1
#endif

#if( !defined( SPLIT_FXSTU ) )
#define SPLIT_FXSTU	1
#endif

#if( !defined( SPLIT_FPSTU ) )
#define SPLIT_FPSTU	1
#endif

#if( !defined( SPLIT_STU3 )  )
#define SPLIT_STU3	1
#endif

#if( !defined( SPLIT_FXST ) )
#define SPLIT_FXST	1
#endif

#if( !defined( SPLIT_FPST ) )
#define SPLIT_FPST	1
#endif

#if( !defined( SPLIT_MULT ) )
#define SPLIT_MULT	1
#endif

#if( !defined( SPLIT_CRL ) )
#define SPLIT_CRL	1
#endif

#if( !defined( SPLIT_SPR ) )
#define SPLIT_SPR	1
#endif

#if( !defined( SPLIT_STRING ) )
#define SPLIT_STRING	1
#endif

#if( !defined( SPLIT_SHOW ) )
#define SPLIT_SHOW	0
#endif

#if( !defined( PRED_DO ) )
#define PRED_DO		0
#endif

#if( !defined( PRED_DIST ) )
#define PRED_DIST	1
#endif

#if( !defined( PRED_MODE ) )
#define PRED_MODE	1
#endif

#if( !defined( PRED_SHOW ) )
#define PRED_SHOW	0
#endif

#if( !defined( WIDE_ARCH_REG ) )
#define WIDE_ARCH_REG	0
#endif

#if( !defined( LG2ARCH_MAX ) )
#define LG2ARCH_MAX	5
#endif

#if( WIDE_ARCH_REG )
typedef unsigned short xarch;
#else
typedef unsigned char xarch;
#endif

struct xdep_prep_ctl {
  unsigned	fetch_max;
  unsigned	fetch_align;
  unsigned	fetch_align_mask;
  unsigned	cache_align;
  unsigned	cache_mask;

  unsigned char	branch_latency;
  unsigned char	crl_latency;
  unsigned char	fpu_latency;
  unsigned char	load_latency;
  unsigned char	subword_load_latency;
  unsigned char	arithmetic_load_latency;
  unsigned char	arithmetic_subword_load_latency;
  unsigned char	float_load_latency;
  unsigned char	store_latency;
  unsigned char	fix_latency;
  unsigned char	imul_latency;
  unsigned char	idiv_latency;
  unsigned char	fdiv_latency;
  unsigned char	cmp_latency;

  unsigned char	branch_avail;
  unsigned char	crl_avail;
  unsigned char	fpu_avail;
  unsigned char	load_avail;
  unsigned char	subword_load_avail;
  unsigned char	arithmetic_load_avail;
  unsigned char	arithmetic_subword_load_avail;
  unsigned char	float_load_avail;
  unsigned char	store_avail;
  unsigned char	fix_avail;
  unsigned char	imul_avail;
  unsigned char	idiv_avail;
  unsigned char	fdiv_avail;
  unsigned char	cmp_avail;

  unsigned char	branch_unit;
  unsigned char	crl_unit;
  unsigned char	fpu_unit;
  unsigned char	load_unit;
  unsigned char	store_unit;
  unsigned char	fix_unit;
  unsigned char	imul_unit;
  unsigned char	idiv_unit;

  unsigned char	flag_use_gp;

  unsigned char	flag_all_split;
  unsigned char	flag_fxldau_split;
  unsigned char	flag_fxlda_split;
  unsigned char	flag_fxldu_split;
  unsigned char	flag_fpldu_split;
  unsigned char	flag_fxstux_split;
  unsigned char	flag_fxstu_split;
  unsigned char	flag_fpstu_split;
  unsigned char	flag_stu3_split;
  unsigned char	flag_fxst_split;
  unsigned char	flag_fpst_split;
  unsigned char	flag_mult_split;
  unsigned char	flag_crl_split;
  unsigned char	flag_spr_split;
  unsigned char	flag_string_split;
  unsigned char	flag_show_split;

  unsigned char	pred_do;
  unsigned char	flag_show_pred;
  unsigned char pred_mode;
  unsigned pred_dist;

  unsigned char	flag_wide_arch_reg;
  unsigned char	flag_lg2arch_max;
};

extern struct xdep_prep_ctl	xdep_prep_ctl;

typedef struct xdep_prep_info xdep_prep_info;

struct xdep_prep_info {
#if( USING_FF ||USING_IM)
  unsigned iword;
  xdep_prep_info * over;
#endif

  unsigned res_compl;
  unsigned res;

  unsigned prop0;
  unsigned prop1;
  unsigned prop2;

  union {
    xarch		r_regs[4];
    xarch *		r_overflow;
    unsigned		r_offset;
  } u_reg;

  union {
    xdep_prep_info *	x_expands;
    unsigned 		x_offset;
  } u_expand;
};

#define xdep_prep_info_deref(i)		(i)

#if( USING_FF ||USING_IM )
#define xdep_prep_info_iword(i)		(xdep_prep_info_deref(i)->iword)
#define xdep_prep_info_over(i)		(xdep_prep_info_deref(i)->over)
#define set_xdep_prep_info_over(i,j)	(xdep_prep_info_over(i) = (j))
#endif

#define xdep_prep_info_res_compl(i)	(xdep_prep_info_deref(i)->res_compl)
#define xdep_prep_info_res(i)		(xdep_prep_info_deref(i)->res)


#include "xprop.h"

#define xdep_prep_info_prop0(i)		(xdep_prep_info_deref(i)->prop0)

#define xdep_prep_info_fetch(i)		xprop_fetch(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_memop(i)	xprop_is_memop(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_branch(i)	xprop_is_branch(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_pred(i)	(xprop_pred(xdep_prep_info_prop0(i))!=0)
#define xdep_prep_info_pred_dist(i)	(xprop_pred(xdep_prep_info_prop0(i)))
#define xdep_prep_info_is_store(i)	xprop_is_store(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_load(i)	xprop_is_load(xdep_prep_info_prop0(i))
#define xdep_prep_info_dlength(i)	xprop_dlength(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_brlk(i)	xprop_is_brlk(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_brlink(i)	xprop_is_brlink(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_brctr(i)	xprop_is_brctr(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_brcond(i)	xprop_is_brcond(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_brcrg(i)	xprop_is_brcrg(xdep_prep_info_prop0(i))
#define xdep_prep_info_unit(i)		xprop_unit(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_split(i)	xprop_is_split(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_transfer(i)	xprop_is_transfer(xdep_prep_info_prop0(i))
#define xdep_prep_info_latency(i)	xprop_latency(xdep_prep_info_prop0(i))
#define xdep_prep_info_nexpands(i)	xprop_nexpands(xdep_prep_info_prop0(i))
#define xdep_prep_info_is_expand(i)	xprop_is_expand(xdep_prep_info_prop0(i))

#define set_xdep_prep_info_fetch(i,v)		set_xprop_fetch(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_memop(i,v)	set_xprop_is_memop(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_branch(i,v)	set_xprop_is_branch(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_pred_dist(i,v)	set_xprop_pred(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_store(i,v)	set_xprop_is_store(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_load(i,v)		set_xprop_is_load(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_dlength(i,v)		set_xprop_dlength(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_brlk(i,v)		set_xprop_is_brlk(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_brlink(i,v)	set_xprop_is_brlink(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_brctr(i,v)	set_xprop_is_brctr(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_brcond(i,v)	set_xprop_is_brcond(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_brcrg(i,v)	set_xprop_is_brcrg(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_unit(i,v)		set_xprop_unit(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_split(i,v)	set_xprop_is_split(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_is_transfer(i,v)	set_xprop_is_transfer(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_latency(i,v)		set_xprop_latency(xdep_prep_info_prop0(i),v)
#define set_xdep_prep_info_nexpands(i,v)	set_xprop_nexpands(xdep_prep_info_prop0(i),v)

#define reset_xdep_prep_info_fetch(i,v)		reset_xprop_fetch(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_memop(i,v)	reset_xprop_is_memop(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_branch(i,v)	reset_xprop_is_branch(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_pred(i,v)		reset_xprop_pred(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_store(i,v)	reset_xprop_is_store(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_load(i,v)	reset_xprop_is_load(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_dlength(i,v)	reset_xprop_dlength(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_brlk(i,v)	reset_xprop_is_brlk(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_brlink(i,v)	reset_xprop_is_brlink(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_brctr(i,v)	reset_xprop_is_brctr(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_brcond(i,v)	reset_xprop_is_brcond(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_brcrg(i,v)	reset_xprop_is_brcrg(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_unit(i,v)		reset_xprop_unit(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_split(i,v)	reset_xprop_is_split(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_is_transfer(i,v)	reset_xprop_is_transfer(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_latency(i,v)	reset_xprop_latency(xdep_prep_info_prop0(i),v)
#define reset_xdep_prep_info_nexpands(i,v)	reset_xprop_nexpands(xdep_prep_info_prop0(i),v)

#define xdep_prep_info_prop1(i)			(xdep_prep_info_deref(i)->prop1)

#define xdep_prep_info_is_over(i)		xprop_is_over(xdep_prep_info_prop1(i))
#define xdep_prep_info_ins(i)			xprop_ins(xdep_prep_info_prop1(i))
#define xdep_prep_info_outs(i)			xprop_outs(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_string(i)		xprop_is_string(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_sync(i)		xprop_is_sync(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_athead(i)		xprop_is_athead(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_mtsr(i)		xprop_is_mtsr(xdep_prep_info_prop1(i))
#define xdep_prep_info_sr(i)			xprop_sr(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_notaddr(i)		xprop_is_notaddr(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_slot0(i)		xprop_is_slot0(xdep_prep_info_prop1(i))
#define xdep_prep_info_avail(i)			xprop_avail(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_multi(i)		xprop_is_multi(xdep_prep_info_prop1(i))
#define xdep_prep_info_is_slotN(i)		xprop_is_slotN(xdep_prep_info_prop1(i))

#define set_xdep_prep_info_is_over(i,v)		set_xprop_is_over(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_ins(i,v)		set_xprop_ins(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_outs(i,v)		set_xprop_outs(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_string(i,v)	set_xprop_is_string(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_sync(i,v)		set_xprop_is_sync(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_athead(i,v)	set_xprop_is_athead(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_mtsr(i,v)		set_xprop_is_mtsr(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_sr(i,v)		set_xprop_sr(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_notaddr(i,v)	set_xprop_is_notaddr(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_slot0(i,v)	set_xprop_is_slot0(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_avail(i,v)		set_xprop_avail(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_multi(i,v)	set_xprop_is_multi(xdep_prep_info_prop1(i),v)
#define set_xdep_prep_info_is_slotN(i,v)	set_xprop_is_slotN(xdep_prep_info_prop1(i),v)

#define reset_xdep_prep_info_is_over(i,v)	reset_xprop_is_over(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_ins(i,v)		reset_xprop_ins(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_outs(i,v)		reset_xprop_outs(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_string(i,v)	reset_xprop_is_string(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_sync(i,v)	reset_xprop_is_sync(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_athead(i,v)	reset_xprop_is_athead(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_mtsr(i,v)	reset_xprop_is_mtsr(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_sr(i,v)		reset_xprop_sr(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_notaddr(i,v)	reset_xprop_is_notaddr(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_slot0(i,v)	reset_xprop_is_slot0(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_avail(i,v)		reset_xprop_avail(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_multi(i,v)	reset_xprop_is_multi(xdep_prep_info_prop1(i),v)
#define reset_xdep_prep_info_is_slotN(i,v)	reset_xprop_is_slotN(xdep_prep_info_prop1(i),v)

#define xdep_prep_info_prop2(i)			(xdep_prep_info_deref(i)->prop2)

#define xdep_prep_info_is_carry(i)		xprop_is_carry(xdep_prep_info_prop2(i))
#define xdep_prep_info_is_nop(i)		xprop_is_nop(xdep_prep_info_prop2(i))
#define xdep_prep_info_is_notpipe(i)		xprop_is_notpipe(xdep_prep_info_prop2(i))
#define xdep_prep_info_is_nocount(i)		xprop_is_nocount(xdep_prep_info_prop2(i))
#define xdep_prep_info_is_reissue(i)		xprop_is_reissue(xdep_prep_info_prop2(i))

#define set_xdep_prep_info_is_carry(i,v)	set_xprop_is_carry(xdep_prep_info_prop2(i),v)
#define set_xdep_prep_info_is_nop(i,v)		set_xprop_is_nop(xdep_prep_info_prop2(i),v)
#define set_xdep_prep_info_is_notpipe(i,v)	set_xprop_is_notpipe(xdep_prep_info_prop2(i),v)
#define set_xdep_prep_info_is_nocount(i,v)	set_xprop_is_nocount(xdep_prep_info_prop2(i),v)
#define set_xdep_prep_info_is_reissue(i,v)	set_xprop_is_reissue(xdep_prep_info_prop2(i),v)

#define reset_xdep_prep_info_is_carry(i,v)	reset_xprop_is_carry(xdep_prep_info_prop2(i),v)
#define reset_xdep_prep_info_is_nop(i,v)	reset_xprop_is_nop(xdep_prep_info_prop2(i),v)
#define reset_xdep_prep_info_is_notpipe(i,v)	reset_xprop_is_notpipe(xdep_prep_info_prop2(i),v)
#define reset_xdep_prep_info_is_nocount(i,v)	reset_xprop_is_nocount(xdep_prep_info_prop2(i),v)
#define reset_xdep_prep_info_is_reissue(i,v)	reset_xprop_is_reissue(xdep_prep_info_prop2(i),v)

#define xdep_prep_info_regs(i)		(xdep_prep_info_deref(i)->u_reg.r_regs)
#define xdep_prep_info_overflow(i)	(xdep_prep_info_deref(i)->u_reg.r_overflow)
#define xdep_prep_info_over_off(i)	(xdep_prep_info_deref(i)->u_reg.r_offset)

#define xdep_prep_info_expands(i)	(xdep_prep_info_deref(i)->u_expand.x_expands)
#define xdep_prep_info_exp_off(i)	(xdep_prep_info_deref(i)->u_expand.x_offset)

#if( IN_TRANS )
#define xdep_prep_reg_class(r,lg)		(((r)>>LG2ARCH_MAX)&0x3)
#else
#define xdep_prep_reg_class(r,lg)		(((r)>>(lg))&0x3)
#endif

#if( IN_TRANS )
#define xdep_prep_reg_num(r,lg)		((r)&~(~0<<LG2ARCH_MAX))
#else
#define xdep_prep_reg_num(r,lg)		((r)&~(~0<<(lg)))
#endif

#if( USING_FF ||USING_IM )
#include "ffdep_prep_info_table.h"

void read_ffdep_prep(
	FILE *			fp,
	struct xdep_prep_ctl *	prep_ctl,
	unsigned *		p_ifetch_max,
	unsigned *		p_first,
	xdep_prep_info_table *	table,
	unsigned *		p_xsize,
	xdep_prep_info **	p_expand,
	unsigned *		p_osize,
	xarch **		p_overflow);

void write_ffdep_prep(
	FILE *			fp,
	struct xdep_prep_ctl *	prep_ctl,
	unsigned		ifetch_max,
	unsigned		first,
	xdep_prep_info_table *	table,
	unsigned		xsize,
	xdep_prep_info *	expand,
	unsigned		osize,
	xarch *			overflow);

#elif( USING_ROCH )

void read_rochdep_prep(
	FILE *			fp,
	unsigned *		p_size,
	unsigned *		p_xsize,
	xdep_prep_info **	p_info,
	unsigned *		p_osize,
	xarch **		p_overflow);

void write_rochdep_prep(
	FILE *			fp,
	unsigned		size,
	xdep_prep_info *	info,
	unsigned		osize,
	xarch *		overflow,
	unsigned		xsize,
	xdep_prep_info *	expand);
#else

void read_dep_prep(
	FILE *			fp,
	struct xdep_prep_ctl *	prep_ctl,
	unsigned *		p_first,
	unsigned *		p_min,
	unsigned *		p_size,
	unsigned *		p_xsize,
	xdep_prep_info **	p_info,
	unsigned *		p_osize,
	xarch **	p_overflow);

void write_dep_prep(
	FILE *			fp,
	struct xdep_prep_ctl *	prep_ctl,
	unsigned		first,
	unsigned		min,
	unsigned		size,
	xdep_prep_info *	info,
	unsigned		osize,
	xarch *		overflow,
	unsigned		xsize,
	xdep_prep_info *	expand);
#endif

#endif
