#ifndef H_ffdep_prep_info_table_private
#define H_ffdep_prep_info_table_private

#define FFREADER_PREP_INFO_SUBTABLE_BITS	(10)
#define FFREADER_PREP_INFO_SUBTABLE_MASK	(~((~0)<<FFREADER_PREP_INFO_SUBTABLE_BITS))
#define FFREADER_PREP_INFO_SUBTABLE_SIZE	(1<<FFREADER_PREP_INFO_SUBTABLE_BITS)
#define FFREADER_PREP_INFO_TABLE_BITS	(30-FFREADER_PREP_INFO_SUBTABLE_BITS)
#define FFREADER_PREP_INFO_TABLE_SIZE	(1<<FFREADER_PREP_INFO_TABLE_BITS)

#define FFREADER_PREP_INFO_INDEX(x)		(((unsigned)(x))>>2)
#define FFREADER_PREP_INFO_HI(x)		(FFREADER_PREP_INFO_INDEX(x)>>FFREADER_PREP_INFO_SUBTABLE_BITS)
#define FFREADER_PREP_INFO_LO(x)		(FFREADER_PREP_INFO_INDEX(x)&FFREADER_PREP_INFO_SUBTABLE_MASK)

struct xdep_prep_info_table {
  struct subxdep_prep_info_table	*	subtables[FFREADER_PREP_INFO_TABLE_SIZE];
  xdep_prep_info *			array;
  unsigned *			addrs;
  unsigned			size;
};

#define deref_xdep_prep_info_table(p)		(p)
#define	subtables_xdep_prep_info_table(p)	(deref_xdep_prep_info_table(p)->subtables)
#define array_xdep_prep_info_table(p)		(deref_xdep_prep_info_table(p)->array)
#define addrs_xdep_prep_info_table(p)		(deref_xdep_prep_info_table(p)->addrs)
#define size_xdep_prep_info_table(p)		(deref_xdep_prep_info_table(p)->size)
#define	subtable_xdep_prep_info_table(p, i)	\
  (deref_xdep_prep_info_table(p)->subtables[	\
	(assert((unsigned)(i) < FFREADER_PREP_INFO_TABLE_SIZE), (i))])

struct subxdep_prep_info_table {
  xdep_prep_info *		entrys[FFREADER_PREP_INFO_SUBTABLE_SIZE];
};

#define deref_subxdep_prep_info_table(p)		(p)
#define	entrys_subxdep_prep_info_table(p)	(deref_subxdep_prep_info_table(p)->entrys)
#define	entry_subxdep_prep_info_table(p, i)	\
    (deref_subxdep_prep_info_table(p)->entrys[	\
	(assert((unsigned)(i) < FFREADER_PREP_INFO_SUBTABLE_SIZE), (i))])

#define get_xdep_prep_info_table(p,a,w)	\
  ( ( xdep_prep_info_iword(				\
	entry_subxdep_prep_info_table(subtable_xdep_prep_info_table(p, FFREADER_PREP_INFO_HI(a)), FFREADER_PREP_INFO_LO(a))\
      ) == (w))? 			\
    (entry_subxdep_prep_info_table(subtable_xdep_prep_info_table(p, FFREADER_PREP_INFO_HI(a)), FFREADER_PREP_INFO_LO(a))):\
    ( find_xdep_prep_info_table(p, a, w)) )


#endif
