#ifndef H_XPROP
#define H_XPROP

#define XPROP_FETCH_START	0
#define XPROP_FETCH_MASK	0x1f
#define xprop_fetch(i)			\
	(((i)>>XPROP_FETCH_START)&XPROP_FETCH_MASK)
#define set_xprop_fetch(i,v)		\
	((i) |= ((v)&XPROP_FETCH_MASK)<<XPROP_FETCH_START)
#define reset_xprop_fetch(i,v)		\
	((i) =	((i)&~(XPROP_FETCH_MASK<<XPROP_FETCH_START))\
		|(((v)&XPROP_FETCH_MASK)<<XPROP_FETCH_START))

#define XPROP_IS_MEMOP_START	5
#define XPROP_IS_MEMOP_MASK	0x1
#define xprop_is_memop(i)		\
	(((i)>>XPROP_IS_MEMOP_START)&XPROP_IS_MEMOP_MASK)
#define set_xprop_is_memop(i,v)	\
	((i) |= ((v)&XPROP_IS_MEMOP_MASK)<<XPROP_IS_MEMOP_START)
#define reset_xprop_is_memop(i,v)		\
	((i) =	((i)&~(XPROP_IS_MEMOP_MASK<<XPROP_IS_MEMOP_START))\
		|(((v)&XPROP_IS_MEMOP_MASK)<<XPROP_IS_MEMOP_START))

#define XPROP_IS_BRANCH_START	6
#define XPROP_IS_BRANCH_MASK	0x1
#define xprop_is_branch(i)		\
	(((i)>>XPROP_IS_BRANCH_START)&XPROP_IS_BRANCH_MASK)
#define set_xprop_is_branch(i,v)	\
	((i) |= ((v)&XPROP_IS_BRANCH_MASK)<<XPROP_IS_BRANCH_START)
#define reset_xprop_is_branch(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRANCH_MASK<<XPROP_IS_BRANCH_START))\
		|(((v)&XPROP_IS_BRANCH_MASK)<<XPROP_IS_BRANCH_START))

/*** memory overlay: [7..13] ***/
#define XPROP_IS_STORE_START	7
#define XPROP_IS_STORE_MASK	0x1
#define xprop_is_store(i)		\
	(((i)>>XPROP_IS_STORE_START)&XPROP_IS_STORE_MASK)
#define set_xprop_is_store(i,v)	\
	((i) |= ((v)&XPROP_IS_STORE_MASK)<<XPROP_IS_STORE_START)
#define reset_xprop_is_store(i,v)		\
	((i) =	((i)&~(XPROP_IS_STORE_MASK<<XPROP_IS_STORE_START))\
		|(((v)&XPROP_IS_STORE_MASK)<<XPROP_IS_STORE_START))

#define XPROP_IS_LOAD_START	8
#define XPROP_IS_LOAD_MASK	0x1
#define xprop_is_load(i)		\
	(((i)>>XPROP_IS_LOAD_START)&XPROP_IS_LOAD_MASK)
#define set_xprop_is_load(i,v)	\
	((i) |= ((v)&XPROP_IS_LOAD_MASK)<<XPROP_IS_LOAD_START)
#define reset_xprop_is_load(i,v)		\
	((i) =	((i)&~(XPROP_IS_LOAD_MASK<<XPROP_IS_LOAD_START))\
		|(((v)&XPROP_IS_LOAD_MASK)<<XPROP_IS_LOAD_START))

#define XPROP_DLENGTH_START	9
#define XPROP_DLENGTH_MASK	0x1f
#define xprop_dlength(i)		\
	(((i)>>XPROP_DLENGTH_START)&XPROP_DLENGTH_MASK)
#define set_xprop_dlength(i,v)	\
	((i) |= ((v)&XPROP_DLENGTH_MASK)<<XPROP_DLENGTH_START)
#define reset_xprop_dlength(i,v)		\
	((i) =	((i)&~(XPROP_DLENGTH_MASK<<XPROP_DLENGTH_START))\
		|(((v)&XPROP_DLENGTH_MASK)<<XPROP_DLENGTH_START))

/*** branch overlay: [7..11] + 2 for pred ***/
#define XPROP_IS_BRLK_START	7
#define XPROP_IS_BRLK_MASK	0x1
#define xprop_is_brlk(i)		\
	(((i)>>XPROP_IS_BRLK_START)&XPROP_IS_BRLK_MASK)
#define set_xprop_is_brlk(i,v)	\
	((i) |= ((v)&XPROP_IS_BRLK_MASK)<<XPROP_IS_BRLK_START)
#define reset_xprop_is_brlk(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRLK_MASK<<XPROP_IS_BRLK_START))\
		|(((v)&XPROP_IS_BRLK_MASK)<<XPROP_IS_BRLK_START))

#define XPROP_IS_BRLINK_START	8
#define XPROP_IS_BRLINK_MASK	0x1
#define xprop_is_brlink(i)		\
	(((i)>>XPROP_IS_BRLINK_START)&XPROP_IS_BRLINK_MASK)
#define set_xprop_is_brlink(i,v)	\
	((i) |= ((v)&XPROP_IS_BRLINK_MASK)<<XPROP_IS_BRLINK_START)
#define reset_xprop_is_brlink(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRLINK_MASK<<XPROP_IS_BRLINK_START))\
		|(((v)&XPROP_IS_BRLINK_MASK)<<XPROP_IS_BRLINK_START))

#define XPROP_IS_BRCTR_START	9
#define XPROP_IS_BRCTR_MASK	0x1
#define xprop_is_brctr(i)		\
	(((i)>>XPROP_IS_BRCTR_START)&XPROP_IS_BRCTR_MASK)
#define set_xprop_is_brctr(i,v)	\
	((i) |= ((v)&XPROP_IS_BRCTR_MASK)<<XPROP_IS_BRCTR_START)
#define reset_xprop_is_brctr(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRCTR_MASK<<XPROP_IS_BRCTR_START))\
		|(((v)&XPROP_IS_BRCTR_MASK)<<XPROP_IS_BRCTR_START))

#define XPROP_IS_BRCOND_START	10
#define XPROP_IS_BRCOND_MASK	0x1
#define xprop_is_brcond(i)		\
	(((i)>>XPROP_IS_BRCOND_START)&XPROP_IS_BRCOND_MASK)
#define set_xprop_is_brcond(i,v)	\
	((i) |= ((v)&XPROP_IS_BRCOND_MASK)<<XPROP_IS_BRCOND_START)
#define reset_xprop_is_brcond(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRCOND_MASK<<XPROP_IS_BRCOND_START))\
		|(((v)&XPROP_IS_BRCOND_MASK)<<XPROP_IS_BRCOND_START))

#define XPROP_IS_BRCRG_START	11
#define XPROP_IS_BRCRG_MASK	0x1
#define xprop_is_brcrg(i)		\
	(((i)>>XPROP_IS_BRCRG_START)&XPROP_IS_BRCRG_MASK)
#define set_xprop_is_brcrg(i,v)	\
	((i) |= ((v)&XPROP_IS_BRCRG_MASK)<<XPROP_IS_BRCRG_START)
#define reset_xprop_is_brcrg(i,v)		\
	((i) =	((i)&~(XPROP_IS_BRCRG_MASK<<XPROP_IS_BRCRG_START))\
		|(((v)&XPROP_IS_BRCRG_MASK)<<XPROP_IS_BRCRG_START))

#define XPROP_PRED_START	12
#define XPROP_PRED_MASK		0x3
#define xprop_pred(i)		\
	(((i)>>XPROP_PRED_START)&XPROP_PRED_MASK)
#define set_xprop_pred(i,v)	\
	((i) |= ((v)&XPROP_PRED_MASK)<<XPROP_PRED_START)
#define reset_xprop_pred(i,v)		\
	((i) =	((i)&~(XPROP_PRED_MASK<<XPROP_PRED_START))\
		|(((v)&XPROP_PRED_MASK)<<XPROP_PRED_START))


/*** end overlays ***/

#define XPROP_UNIT_START	14
#define XPROP_UNIT_MASK		0x7
#define xprop_unit(i)		\
	(((i)>>XPROP_UNIT_START)&XPROP_UNIT_MASK)
#define set_xprop_unit(i,v)	\
	((i) |= ((v)&XPROP_UNIT_MASK)<<XPROP_UNIT_START)
#define reset_xprop_unit(i,v)		\
	((i) =	((i)&~(XPROP_UNIT_MASK<<XPROP_UNIT_START))\
		|(((v)&XPROP_UNIT_MASK)<<XPROP_UNIT_START))

#define XPROP_IS_SPLIT_START	17
#define XPROP_IS_SPLIT_MASK	0x1
#define xprop_is_split(i)		\
	(((i)>>XPROP_IS_SPLIT_START)&XPROP_IS_SPLIT_MASK)
#define set_xprop_is_split(i,v)	\
	((i) |= ((v)&XPROP_IS_SPLIT_MASK)<<XPROP_IS_SPLIT_START)
#define reset_xprop_is_split(i,v)		\
	((i) =	((i)&~(XPROP_IS_SPLIT_MASK<<XPROP_IS_SPLIT_START))\
		|(((v)&XPROP_IS_SPLIT_MASK)<<XPROP_IS_SPLIT_START))

#define XPROP_IS_TRANSFER_START	18
#define XPROP_IS_TRANSFER_MASK	0x1
#define xprop_is_transfer(i)		\
	(((i)>>XPROP_IS_TRANSFER_START)&XPROP_IS_TRANSFER_MASK)
#define set_xprop_is_transfer(i,v)	\
	((i) |= ((v)&XPROP_IS_TRANSFER_MASK)<<XPROP_IS_TRANSFER_START)
#define reset_xprop_is_transfer(i,v)		\
	((i) =	((i)&~(XPROP_IS_TRANSFER_MASK<<XPROP_IS_TRANSFER_START))\
		|(((v)&XPROP_IS_TRANSFER_MASK)<<XPROP_IS_TRANSFER_START))

#define XPROP_LATENCY_START	19
#define XPROP_LATENCY_MASK	0x3f
#define xprop_latency(i)		\
	(((i)>>XPROP_LATENCY_START)&XPROP_LATENCY_MASK)
#define set_xprop_latency(i,v)	\
	((i) |= ((v)&XPROP_LATENCY_MASK)<<XPROP_LATENCY_START)
#define reset_xprop_latency(i,v)		\
	((i) =	((i)&~(XPROP_LATENCY_MASK<<XPROP_LATENCY_START))\
		|(((v)&XPROP_LATENCY_MASK)<<XPROP_LATENCY_START))

#define XPROP_NEXPANDS_START	25
#define XPROP_NEXPANDS_MASK	0x7f
#define xprop_nexpands(i)		\
	(((i)>>XPROP_NEXPANDS_START)&XPROP_NEXPANDS_MASK)
#define set_xprop_nexpands(i,v)	\
	((i) |= ((v)&XPROP_NEXPANDS_MASK)<<XPROP_NEXPANDS_START)
#define xprop_is_expand(i)		\
	((((i)>>XPROP_NEXPANDS_START)&XPROP_NEXPANDS_MASK)!=0)
#define reset_xprop_nexpands(i,v)		\
	((i) =	((i)&~(XPROP_NEXPANDS_MASK<<XPROP_NEXPANDS_START))\
		|(((v)&XPROP_NEXPANDS_MASK)<<XPROP_NEXPANDS_START))

/**** next word ****/
#define XPROP_IS_OVER_START	0
#define XPROP_IS_OVER_MASK	0x1
#define xprop_is_over(i)		\
	(((i)>>XPROP_IS_OVER_START)&XPROP_IS_OVER_MASK)
#define set_xprop_is_over(i,v)	\
	((i) |= ((v)&XPROP_IS_OVER_MASK)<<XPROP_IS_OVER_START)
#define reset_xprop_is_over(i,v)		\
	((i) =	((i)&~(XPROP_IS_OVER_MASK<<XPROP_IS_OVER_START))\
		|(((v)&XPROP_IS_OVER_MASK)<<XPROP_IS_OVER_START))

#define XPROP_INS_START		1
#define XPROP_INS_MASK		0x3f
#define xprop_ins(i)		\
	(((i)>>XPROP_INS_START)&XPROP_INS_MASK)
#define set_xprop_ins(i,v)	\
	((i) |= ((v)&XPROP_INS_MASK)<<XPROP_INS_START)
#define reset_xprop_ins(i,v)		\
	((i) =	((i)&~(XPROP_INS_MASK<<XPROP_INS_START))\
		|(((v)&XPROP_INS_MASK)<<XPROP_INS_START))

#define XPROP_OUTS_START	7
#define XPROP_OUTS_MASK		0x3f
#define xprop_outs(i)		\
	(((i)>>XPROP_OUTS_START)&XPROP_OUTS_MASK)
#define set_xprop_outs(i,v)	\
	((i) |= ((v)&XPROP_OUTS_MASK)<<XPROP_OUTS_START)
#define reset_xprop_outs(i,v)		\
	((i) =	((i)&~(XPROP_OUTS_MASK<<XPROP_OUTS_START))\
		|(((v)&XPROP_OUTS_MASK)<<XPROP_OUTS_START))

#define XPROP_IS_STRING_START	13
#define XPROP_IS_STRING_MASK	0x1
#define xprop_is_string(i)		\
	(((i)>>XPROP_IS_STRING_START)&XPROP_IS_STRING_MASK)
#define set_xprop_is_string(i,v)	\
	((i) |= ((v)&XPROP_IS_STRING_MASK)<<XPROP_IS_STRING_START)
#define reset_xprop_is_string(i,v)		\
	((i) =	((i)&~(XPROP_IS_STRING_MASK<<XPROP_IS_STRING_START))\
		|(((v)&XPROP_IS_STRING_MASK)<<XPROP_IS_STRING_START))

#define XPROP_IS_SYNC_START	14
#define XPROP_IS_SYNC_MASK	0x1
#define xprop_is_sync(i)		\
	(((i)>>XPROP_IS_SYNC_START)&XPROP_IS_SYNC_MASK)
#define set_xprop_is_sync(i,v)	\
	((i) |= ((v)&XPROP_IS_SYNC_MASK)<<XPROP_IS_SYNC_START)
#define reset_xprop_is_sync(i,v)		\
	((i) =	((i)&~(XPROP_IS_SYNC_MASK<<XPROP_IS_SYNC_START))\
		|(((v)&XPROP_IS_SYNC_MASK)<<XPROP_IS_SYNC_START))

#define XPROP_IS_ATHEAD_START	15
#define XPROP_IS_ATHEAD_MASK	0x1
#define xprop_is_athead(i)		\
	(((i)>>XPROP_IS_ATHEAD_START)&XPROP_IS_ATHEAD_MASK)
#define set_xprop_is_athead(i,v)	\
	((i) |= ((v)&XPROP_IS_ATHEAD_MASK)<<XPROP_IS_ATHEAD_START)
#define reset_xprop_is_athead(i,v)		\
	((i) =	((i)&~(XPROP_IS_ATHEAD_MASK<<XPROP_IS_ATHEAD_START))\
		|(((v)&XPROP_IS_ATHEAD_MASK)<<XPROP_IS_ATHEAD_START))

#define XPROP_IS_MTSR_START	16
#define XPROP_IS_MTSR_MASK	0x1
#define xprop_is_mtsr(i)		\
	(((i)>>XPROP_IS_MTSR_START)&XPROP_IS_MTSR_MASK)
#define set_xprop_is_mtsr(i,v)	\
	((i) |= ((v)&XPROP_IS_MTSR_MASK)<<XPROP_IS_MTSR_START)
#define reset_xprop_is_mtsr(i,v)		\
	((i) =	((i)&~(XPROP_IS_MTSR_MASK<<XPROP_IS_MTSR_START))\
		|(((v)&XPROP_IS_MTSR_MASK)<<XPROP_IS_MTSR_START))


#define XPROP_SR_START	17
#define XPROP_SR_MASK	0xf
#define xprop_sr(i)		\
	(((i)>>XPROP_SR_START)&XPROP_SR_MASK)
#define set_xprop_sr(i,v)	\
	((i) |= ((v)&XPROP_SR_MASK)<<XPROP_SR_START)
#define reset_xprop_sr(i,v)		\
	((i) =	((i)&~(XPROP_SR_MASK<<XPROP_SR_START))\
		|(((v)&XPROP_SR_MASK)<<XPROP_SR_START))

#define XPROP_IS_NOTADDR_START	21
#define XPROP_IS_NOTADDR_MASK	0x1
#define xprop_is_notaddr(i)		\
	(((i)>>XPROP_IS_NOTADDR_START)&XPROP_IS_NOTADDR_MASK)
#define set_xprop_is_notaddr(i,v)	\
	((i) |= ((v)&XPROP_IS_NOTADDR_MASK)<<XPROP_IS_NOTADDR_START)
#define reset_xprop_is_notaddr(i,v)		\
	((i) =	((i)&~(XPROP_IS_NOTADDR_MASK<<XPROP_IS_NOTADDR_START))\
		|(((v)&XPROP_IS_NOTADDR_MASK)<<XPROP_IS_NOTADDR_START))

#define XPROP_IS_SLOT0_START	22
#define XPROP_IS_SLOT0_MASK	0x1
#define xprop_is_slot0(i)		\
	(((i)>>XPROP_IS_SLOT0_START)&XPROP_IS_SLOT0_MASK)
#define set_xprop_is_slot0(i,v)	\
	((i) |= ((v)&XPROP_IS_SLOT0_MASK)<<XPROP_IS_SLOT0_START)
#define reset_xprop_is_slot0(i,v)		\
	((i) =	((i)&~(XPROP_IS_SLOT0_MASK<<XPROP_IS_SLOT0_START))\
		|(((v)&XPROP_IS_SLOT0_MASK)<<XPROP_IS_SLOT0_START))


#define XPROP_AVAIL_START	23
#define XPROP_AVAIL_MASK	0x3f
#define xprop_avail(i)		\
	(((i)>>XPROP_AVAIL_START)&XPROP_AVAIL_MASK)
#define set_xprop_avail(i,v)	\
	((i) |= ((v)&XPROP_AVAIL_MASK)<<XPROP_AVAIL_START)
#define reset_xprop_avail(i,v)		\
	((i) =	((i)&~(XPROP_AVAIL_MASK<<XPROP_AVAIL_START))\
		|(((v)&XPROP_AVAIL_MASK)<<XPROP_AVAIL_START))

#define XPROP_IS_MULTI_START	30
#define XPROP_IS_MULTI_MASK	0x1
#define xprop_is_multi(i)		\
	(((i)>>XPROP_IS_MULTI_START)&XPROP_IS_MULTI_MASK)
#define set_xprop_is_multi(i,v)	\
	((i) |= ((v)&XPROP_IS_MULTI_MASK)<<XPROP_IS_MULTI_START)
#define reset_xprop_is_multi(i,v)		\
	((i) =	((i)&~(XPROP_IS_MULTI_MASK<<XPROP_IS_MULTI_START))\
		|(((v)&XPROP_IS_MULTI_MASK)<<XPROP_IS_MULTI_START))

#define XPROP_IS_SLOTN_START	31
#define XPROP_IS_SLOTN_MASK	0x1
#define xprop_is_slotN(i)		\
	(((i)>>XPROP_IS_SLOTN_START)&XPROP_IS_SLOTN_MASK)
#define set_xprop_is_slotN(i,v)	\
	((i) |= ((v)&XPROP_IS_SLOTN_MASK)<<XPROP_IS_SLOTN_START)
#define reset_xprop_is_slotN(i,v)		\
	((i) =	((i)&~(XPROP_IS_SLOTN_MASK<<XPROP_IS_SLOTN_START))\
		|(((v)&XPROP_IS_SLOTN_MASK)<<XPROP_IS_SLOTN_START))


/**** next word ****/
#define XPROP_IS_CARRY_START	0
#define XPROP_IS_CARRY_MASK	0x1
#define xprop_is_carry(i)		\
	(((i)>>XPROP_IS_CARRY_START)&XPROP_IS_CARRY_MASK)
#define set_xprop_is_carry(i,v)	\
	((i) |= ((v)&XPROP_IS_CARRY_MASK)<<XPROP_IS_CARRY_START)
#define reset_xprop_is_carry(i,v)		\
	((i) =	((i)&~(XPROP_IS_CARRY_MASK<<XPROP_IS_CARRY_START))\
		|(((v)&XPROP_IS_CARRY_MASK)<<XPROP_IS_CARRY_START))

#define XPROP_IS_NOP_START	1
#define XPROP_IS_NOP_MASK	0x1
#define xprop_is_nop(i)		\
	(((i)>>XPROP_IS_NOP_START)&XPROP_IS_NOP_MASK)
#define set_xprop_is_nop(i,v)	\
	((i) |= ((v)&XPROP_IS_NOP_MASK)<<XPROP_IS_NOP_START)
#define reset_xprop_is_nop(i,v)		\
	((i) =	((i)&~(XPROP_IS_NOP_MASK<<XPROP_IS_NOP_START))\
		|(((v)&XPROP_IS_NOP_MASK)<<XPROP_IS_NOP_START))

#define XPROP_IS_NOTPIPE_START	2
#define XPROP_IS_NOTPIPE_MASK	0x1
#define xprop_is_notpipe(i)		\
	(((i)>>XPROP_IS_NOTPIPE_START)&XPROP_IS_NOTPIPE_MASK)
#define set_xprop_is_notpipe(i,v)	\
	((i) |= ((v)&XPROP_IS_NOTPIPE_MASK)<<XPROP_IS_NOTPIPE_START)
#define reset_xprop_is_notpipe(i,v)		\
	((i) =	((i)&~(XPROP_IS_NOTPIPE_MASK<<XPROP_IS_NOTPIPE_START))\
		|(((v)&XPROP_IS_NOTPIPE_MASK)<<XPROP_IS_NOTPIPE_START))

#define XPROP_IS_NOCOUNT_START	3
#define XPROP_IS_NOCOUNT_MASK	0x1
#define xprop_is_nocount(i)		\
	(((i)>>XPROP_IS_NOCOUNT_START)&XPROP_IS_NOCOUNT_MASK)
#define set_xprop_is_nocount(i,v)	\
	((i) |= ((v)&XPROP_IS_NOCOUNT_MASK)<<XPROP_IS_NOCOUNT_START)
#define reset_xprop_is_nocount(i,v)		\
	((i) =	((i)&~(XPROP_IS_NOCOUNT_MASK<<XPROP_IS_NOCOUNT_START))\
		|(((v)&XPROP_IS_NOCOUNT_MASK)<<XPROP_IS_NOCOUNT_START))

#define XPROP_IS_REISSUE_START	4
#define XPROP_IS_REISSUE_MASK	0x1
#define xprop_is_reissue(i)		\
	(((i)>>XPROP_IS_REISSUE_START)&XPROP_IS_REISSUE_MASK)
#define set_xprop_is_reissue(i,v)	\
	((i) |= ((v)&XPROP_IS_REISSUE_MASK)<<XPROP_IS_REISSUE_START)
#define reset_xprop_is_reissue(i,v)		\
	((i) =	((i)&~(XPROP_IS_REISSUE_MASK<<XPROP_IS_REISSUE_START))\
		|(((v)&XPROP_IS_REISSUE_MASK)<<XPROP_IS_REISSUE_START))


#endif
