#ifndef H_fftrace_reader
#define H_fftrace_reader

#include <stdio.h>

#if !defined(SWITCH_ENDIAN)
#define SWITCH_ENDIAN		0
#endif /* !defined(SWITCH_ENDIAN) */

typedef struct trace_ffreader trace_ffreader;

#define TRACE_FFREADER_BUF_SIZE 1024

/*
#define TRACE_FFREADER_BUF_SIZE 32
*/

struct trace_ffreader {
  unsigned		first_pc;
  unsigned		last_pc;
  unsigned		is_done;
  FILE *		fp;
  unsigned		bufptr;
  unsigned		buflen;
#if( USING_FF52_SEGS )
  unsigned		segids[16];
  unsigned		pcseg;
#endif
  unsigned 		buf[TRACE_FFREADER_BUF_SIZE];
};


#define trace_ffreader_deref(reader)	\
	(reader)

#define trace_ffreader_first_pc(reader)	\
	(trace_ffreader_deref(reader)->first_pc)

#define trace_ffreader_fp(reader)	\
	(trace_ffreader_deref(reader)->fp)

#define trace_ffreader_last_pc(reader)	\
	(trace_ffreader_deref(reader)->last_pc)

#define trace_ffreader_is_done(reader)	\
	(trace_ffreader_deref(reader)->is_done)

#define trace_ffreader_buf(reader)	\
	(trace_ffreader_deref(reader)->buf)

#define trace_ffreader_bufptr(reader)	\
	(trace_ffreader_deref(reader)->bufptr)

#define trace_ffreader_buflen(reader)	\
	(trace_ffreader_deref(reader)->buflen)

#if( USING_FF52_SEGS )
#define trace_ffreader_segids(reader)	\
	(trace_ffreader_deref(reader)->segids)

#define trace_ffreader_segid(reader,n)	\
	(trace_ffreader_segids(reader)[n])

#define trace_ffreader_pcseg(reader)	\
	(trace_ffreader_deref(reader)->pcseg)
#endif


void	trace_ffreader_setup(trace_ffreader *, FILE * trace_fp);
int	trace_ffreader_fill(trace_ffreader *, int size, xinsn_info info[]);
#endif
