#include <stdio.h>
#include <stdlib.h>
#include "reader_prep_info.h"

char * xreader_prep_info_kind_name[] = {
  "xreader_prep_info_is_unknown",
  "xreader_prep_info_is_branch",
  "xreader_prep_info_is_brcond",
  "xreader_prep_info_is_brabs",
  "xreader_prep_info_is_brreg",
  "xreader_prep_info_is_memop",
  "xreader_prep_info_is_other"
};

int
write_reader_prep(
	FILE * fp,
	unsigned first_addr,
	unsigned min_addr,
	unsigned size,
	xreader_prep_info * info
	)
{
  size_t ret;
  ret = fwrite( &first_addr, sizeof( unsigned ), 1, fp);
  ret = fwrite( &min_addr, sizeof( unsigned ), 1, fp);
  ret = fwrite( &size, sizeof( unsigned ), 1, fp);
  if( ret != 1 )  {
    return 1;
  }

  ret = fwrite( info, sizeof( xreader_prep_info ), size, fp);
  if( ret != size )  {
    return 2;
  }
  return 0;
}

int
read_reader_prep(	FILE * fp,
		unsigned * pfirst,
		unsigned * pmin,
		unsigned * psize,
		xreader_prep_info ** pinfo
	)
{
  int		ret;
  xreader_prep_info *	info;
  unsigned	size;

  ret = fread( pfirst, sizeof(unsigned), 1, fp);
  ret = fread( pmin, sizeof(unsigned), 1, fp);
  ret = fread( psize, sizeof(unsigned), 1, fp);
  if( ret != 1 ) {
    return 1;
  }

  size = *psize;
  info = malloc( sizeof(xreader_prep_info)*size );
  if( info == 0 ) {
    return 2;
  }

  ret = fread( info, sizeof(xreader_prep_info), size, fp);
  if( ret == 0 ) {
    return 3;
  }

  if( ret != size ) {
    return 4;
  }

  *pinfo = info;
  return 0;
}
