#include <stdlib.h>
#include <stdio.h>
#include "insn_info.h"
#include "trace_reader.h"

int
main(	int argc,
	char * argv[]
	)
{
  xtrace_reader		_reader;
  xtrace_reader *	reader = &_reader;
  FILE *		prep_fp;
  xinsn_info		info[0x1000];
  int			n;
  int			total;

  if( argc != 2 ) {
    fprintf(stderr, "no prep file specified\n");
    return EXIT_FAILURE;
  }

  prep_fp = fopen(argv[1], "rb");

  if( prep_fp == 0 ) {
    fprintf(stderr, "could not open prep file %s\n", argv[1]);
    return EXIT_FAILURE;
  }

  xtrace_reader_setup(reader, prep_fp, stdin);

  total = 0;
  do {
    n = xtrace_reader_fill(reader, 0x1000, info);
    total += n;
    if( ( total % 0x100000 )  == 0) {
      fprintf(stderr, "read %d/%d\n", n, total);
    }
  } while( n != 0 );


  fprintf(stderr, "total = %d\n", total );
}
