#ifndef H_trace_reader
#define H_trace_reader

#include <stdio.h>
#include "reader_prep_info.h"

typedef struct xtrace_reader xtrace_reader;

#define XTRACE_READER_BUF_SIZE 100000

struct xtrace_reader {
  unsigned		first_pc;
  unsigned		min_pc;
  unsigned		max_pc;
  unsigned		last_pc;
  unsigned		size;
  unsigned		is_done;
  xreader_prep_info *	prep;
  xreader_prep_info *	prep_buf;
  FILE *		fp;
  unsigned		bufptr;
  unsigned		buflen;
  unsigned 		buf[XTRACE_READER_BUF_SIZE];
};


#define xtrace_reader_deref(reader)	\
	(reader)

#define xtrace_reader_first_pc(reader)	\
	(xtrace_reader_deref(reader)->first_pc)

#define xtrace_reader_min_pc(reader)	\
	(xtrace_reader_deref(reader)->min_pc)

#define xtrace_reader_size(reader)	\
	(xtrace_reader_deref(reader)->size)

#define xtrace_reader_max_pc(reader)	\
	(xtrace_reader_deref(reader)->max_pc)

#define xtrace_reader_fp(reader)	\
	(xtrace_reader_deref(reader)->fp)

#define xtrace_reader_last_pc(reader)	\
	(xtrace_reader_deref(reader)->last_pc)

#define xtrace_reader_is_done(reader)	\
	(xtrace_reader_deref(reader)->is_done)

#define xtrace_reader_prep(reader)	\
	(xtrace_reader_deref(reader)->prep)

#define xtrace_reader_prep_buf(reader)	\
	(xtrace_reader_deref(reader)->prep_buf)

#define xtrace_reader_buf(reader)	\
	(xtrace_reader_deref(reader)->buf)

#define xtrace_reader_bufptr(reader)	\
	(xtrace_reader_deref(reader)->bufptr)

#define xtrace_reader_buflen(reader)	\
	(xtrace_reader_deref(reader)->buflen)


void	xtrace_reader_setup(xtrace_reader *, FILE * prep_fp, FILE * trace_fp);
int	xtrace_reader_fill(xtrace_reader *, int size, xinsn_info info[]);
#endif
