
/*****************************************************************************
  CONTROLS
*****************************************************************************/

#if( !defined(USING_FF) )
#define	USING_FF			FALSE
#endif

#if( !defined(USING_FF52_SEGS) )
#define	USING_FF52_SEGS			FALSE
#endif

#if( !defined(USING_IM) )
#define	USING_IM			FALSE
#endif

#if( !defined(USING_ARIA) )
#define	USING_ARIA			FALSE
#endif

#if( !defined(USING_SPECULATION) )
#define	USING_SPECULATION		FALSE
#endif

#if( !defined(USE_0x200_FIX) )
#define	USE_0x200_FIX			TRUE
#endif

/* If true continue fetching after encountering a conditional branch that is
 * both actually fall-through and predicted fall-through. If false, treat
 * like all other branches; stop fetching after encountering branch
 */
#if( !defined(IFETCH_MULTIPLE_FALLTHRU) )
#define	IFETCH_MULTIPLE_FALLTHRU	TRUE
#endif

#if( !defined(RENAME_MULTIPLE_BRANCHES) )
#define	RENAME_MULTIPLE_BRANCHES	TRUE
#endif

/* If true, assume perfect branch prediction. Otherwise use predictors
 */
#if( !defined(PERFECT_BRANCH_PREDICTION) )
#define PERFECT_BRANCH_PREDICTION	FALSE
#endif

/* If true, assume perfect branch nfa prediction for branches. Otherwise use nfa
 */
#if( !defined(PERFECT_NFA_PREDICTION) )
#define PERFECT_NFA_PREDICTION		(FALSE || PERFECT_BRANCH_PREDICTION)
#endif

/* If true, assume perfect branch prediction for cond branches. Otherwise use predictors
 */
#if( !defined(PERFECT_COND_BRANCHES) )
#define PERFECT_COND_BRANCHES		(FALSE || PERFECT_BRANCH_PREDICTION)
#endif

/* If true, assume perfect branch prediction for link branches. Otherwise use predictors
 */
#if( !defined(PERFECT_LINK_BRANCHES) )
#define PERFECT_LINK_BRANCHES		(FALSE || PERFECT_BRANCH_PREDICTION)
#endif

/* If true, assume perfect branch prediction for ctr branches. Otherwise use predictors
 */
#if( !defined(PERFECT_CTR_BRANCHES) )
#define PERFECT_CTR_BRANCHES		(FALSE || PERFECT_BRANCH_PREDICTION)
#endif

/* If true, mispredicted branch will be evaluated. If it
 * can be evaluated, the processor recovers immediately.
 */
#if( !defined(EVALUATE_MISPREDICTED_BRANCHES) )
#define EVALUATE_MISPREDICTED_BRANCHES	(TRUE && !PERFECT_BRANCH_PREDICTION)
#endif

/* If true, in rename stage (mispredicted) branch will be evaluated. If it
 * can be evaluated, the processor recovers immediately.
 */
#if( !defined(EVALUATE_MISPREDICTED_RENAME) )
#define EVALUATE_MISPREDICTED_RENAME	(TRUE && EVALUATE_MISPREDICTED_BRANCHES)
#endif

/* If true, in dispatch stage (mispredicted) branch will be evaluated. If it
 * can be evaluated, the processor recovers immediately.
 */
#if( !defined(EVALUATE_MISPREDICTED_DISPATCH) )
#define EVALUATE_MISPREDICTED_DISPATCH	(TRUE && EVALUATE_MISPREDICTED_BRANCHES)
#endif

/* If true, will recover from mispredict as soon as mispredicted branch
 * is evaluated
 */
#if( !defined(RECOVER_AT_EVALUATION) )
#define RECOVER_AT_EVALUATION		(TRUE && !PERFECT_BRANCH_PREDICTION)
#endif

/* If true assume all cache's are infinite
 */
#if( !defined( INFINITE_CACHE ) )
#define INFINITE_CACHE			FALSE
#endif

/* If true assume ITLB is infinite
 */
#if( !defined( INFINITE_ITLB ) )
#define INFINITE_ITLB			(FALSE || INFINITE_CACHE)
#endif

/* If true assume I2TLB is infinite
 */
#if( !defined( INFINITE_I2TLB ) )
#define INFINITE_I2TLB			(FALSE || INFINITE_CACHE)
#endif

/* If true, use same 2TLB for both D and I */
#if( !defined( UNIFIED_2TLB ) )
#define UNIFIED_2TLB			TRUE
#endif

/* If true assume L1 Icache is infinite
 */
#if( !defined( INFINITE_ICACHE ) )
#define INFINITE_ICACHE			(FALSE || INFINITE_CACHE)
#endif

/* Don't use L15 cache by default
 */
#if( !defined( USE_I15CACHE ) )
#define USE_I15CACHE			(FALSE)
#endif

/* If true assume L115 Icache is infinite
 */
#if( !defined( INFINITE_I15CACHE ) )
#define INFINITE_I15CACHE		(FALSE || INFINITE_CACHE)
#endif

/* If true assume DTLB-1 (ERAT) is infinite
 */
#if( !defined( INFINITE_DTLB ) )
#define INFINITE_DTLB			(FALSE || INFINITE_CACHE)
#endif

/* If true assume DTLB is infinite
 */
#if( !defined( INFINITE_D2TLB ) )
#define INFINITE_D2TLB			(FALSE || INFINITE_CACHE)
#endif

/* If true assume L1 Dcache is infinite
 */
#if( !defined( INFINITE_DCACHE ) )
#define INFINITE_DCACHE			(FALSE || INFINITE_CACHE)
#endif

/* If true assume L2 cache's are infinite
 */
#if( !defined( INFINITE_L2CACHE ) )
#define INFINITE_L2CACHE		(FALSE || INFINITE_CACHE)
#endif

/* If true, the decode and rename stages are assumed to be combined
 */
#if( !defined(NO_DECODE_STAGE) )
#define NO_DECODE_STAGE			FALSE
#endif

#if( !defined(RF_DELAY) )
#define RF_DELAY			1
#endif

#if( !defined(BRANCH_MAX_PRED) )
#define	BRANCH_MAX_PRED			12
#endif

#if( !defined(MULTI_DECODE_STAGE) )
#define	MULTI_DECODE_STAGE		2
#endif

#if( !defined(MISPREDICT_RECOVERY_CYCLES) )
#define	MISPREDICT_RECOVERY_CYCLES	0
#endif

#if( !defined(PERFECT_LOAD_REORDER) )
#define	PERFECT_LOAD_REORDER	FALSE
#endif

#if( !defined(INFLIGHT_MAX) )
#define INFLIGHT_MAX		160
#endif

#if( !defined(IGNORE_SPEC_DMISSES) )
#define IGNORE_SPEC_DMISSES	FALSE
#endif

#if( !defined(EXPAND_INSNS) )
#define EXPAND_INSNS		TRUE
#endif

#if( !defined(EXEC_INORDER ) )
#define EXEC_INORDER		FALSE
#endif

#if( !defined(INORDER_BRANCHES ) )
#define INORDER_BRANCHES	EXEC_INORDER
#endif

#if( !defined(REORDER_ALL_LOADS) )
#define REORDER_ALL_LOADS	TRUE
#endif

#if( !defined(USE_BITS_MEMQ) )
#define USE_BITS_MEMQ		0
#endif

#if( !defined(STOREQ_AT_DISPATCH) )
#define STOREQ_AT_DISPATCH	TRUE
#endif

#if( !defined(REORDERQ_AT_DISPATCH) )
#define REORDERQ_AT_DISPATCH	TRUE
#endif

#if( !defined(USE_IPREFETCH ) )
#define USE_IPREFETCH		TRUE
#endif

#if( !defined(USE_BROKEN_COMBINE ) )
#define USE_BROKEN_COMBINE	TRUE
#endif

#if( !defined(COMBINE_FIX_MEM ) )
#define COMBINE_FIX_MEM		FALSE
#endif

#if( !defined(COMBINE_FIX_NUM ) )
#define COMBINE_FIX_NUM		0
#endif

#if( !defined(COMBINE_MEM_NUM ) )
#define COMBINE_MEM_NUM		0
#endif

#if( !defined(NO_PARTIAL_IFETCH ) )
#define NO_PARTIAL_IFETCH	TRUE
#endif

#if( !defined(WIDE_ARCH_REG ) )
#define WIDE_ARCH_REG		FALSE
#endif

#if( !defined(BP_COND_BIMODAL) )
#define BP_COND_BIMODAL		FALSE
#endif

#if( !defined(BP_COND_GSHARE) )
#define BP_COND_GSHARE		FALSE
#endif

#if( !defined(BP_COND_GP) )
#define BP_COND_GP		TRUE
#endif

#if( !defined(BP_HISTORY_SHIFT) )
#define BP_HISTORY_SHIFT	3
#endif

#if( !defined(BP_HISTORY_USES_ALL) )
#define BP_HISTORY_USES_ALL	TRUE
#endif

#if( !defined(BP_COND_BITS ) )
#define BP_COND_BITS	2
#endif

#if( BP_COND_BIMODAL && BP_COND_GSHARE )
  #error "Specify only one of BP_COND_BIMODAL, BP_COND_GSHARE and BP_COND_GP"
#endif

#if( BP_COND_GSHARE && BP_COND_GP )
  #error "Specify only one of BP_COND_BIMODAL, BP_COND_GSHARE and BP_COND_GP"
#endif

#if( BP_COND_GP && BP_COND_BIMODAL )
  #error "Specify only one of BP_COND_BIMODAL, BP_COND_GSHARE and BP_COND_GP"
#endif

#if( !defined(PREFETCH_NEXT_SEQ) )
#define PREFETCH_NEXT_SEQ	TRUE
#endif

#if( !defined(PREFETCH_USING_NFA) )
#define PREFETCH_USING_NFA	FALSE
#endif

#if( PREFETCH_USING_NFA && PREFETCH_NEXT_SEQ )
  #error "Specify only one of PREFETCH_USING_NFA and PREFETCH_NEXT_SEQ"
#endif

#if( !defined( EXPAND_STRINGS_DYNAMIC ) )
#define EXPAND_STRINGS_DYNAMIC	TRUE
#endif

#if( !defined( EXPAND_STRINGS_PENALTY ) )
#define EXPAND_STRINGS_PENALTY	2
#endif

#if( !defined( DRAIN_ON_SYNC ) )
#define DRAIN_ON_SYNC		TRUE
#endif

#if( !defined( DECODE_MULTI_SPECIAL ) )
#define DECODE_MULTI_SPECIAL	TRUE
#endif

#if( !defined( DECODE_MULTI_PENALTY ) )
#define DECODE_MULTI_PENALTY	2
#endif

#if( !defined( DECODE_ONE_BRANCH ) )
#define DECODE_ONE_BRANCH	FALSE
#endif

#if( !defined( DECODE_EXTRA_BRANCH ) )
#define DECODE_EXTRA_BRANCH	FALSE
#endif

#if( !defined( DECODE_MAX_INSNS ) ) 
#define DECODE_MAX_INSNS	DECODE_MAX
#endif

#if( !defined( DECODE_ALL_CRACK ) ) 
#define DECODE_ALL_CRACK	TRUE
#endif

#if( !defined( DECODE_MODEL_REISSUE ) ) 
#define DECODE_MODEL_REISSUE	TRUE
#endif

#if( !defined( DECODE0_MAX ) ) 
#define DECODE0_MAX		DECODE_MAX
#endif

#if( !defined( DECODE_SLOT0 ) ) 
#define DECODE_SLOT0		TRUE
#endif

#if( !defined( BLOCK_ATHEAD_OPS ) ) 
#define BLOCK_ATHEAD_OPS	TRUE
#endif

#if( !defined( MTSR_PURGE_TLB ) ) 
#define MTSR_PURGE_TLB		TRUE
#endif


#if( !defined( RETIRE_DELAY ) ) 
#define RETIRE_DELAY		1
#endif

#if( !defined( CLUSTER ) )
#define CLUSTER			TRUE
#endif

#if( !defined(CLUSTER) || !CLUSTER )
#define CLUSTERS_MAX		1
#elif( !defined(CLUSTERS_MAX) )
#define CLUSTERS_MAX		2
#endif

#if( !defined( CLUSTER_FPU ) )
#define CLUSTER_FPU		TRUE
#endif

#if( !defined(RETIRE_GROUPS) )
#define RETIRE_GROUPS		TRUE
#endif

#if( !defined(DISPATCH_GROUPS) )
#define DISPATCH_GROUPS		TRUE
#endif

#if( !defined(GROUPS_MAX) )
#define GROUPS_MAX		20
#endif

#if( !defined(GID_MAX) )
#define GID_MAX			32
#endif

#if( GROUPS_MAX > GID_MAX )
#error "GROUPS_MAX must be less than GID_MAX"
#endif

#if( GID_MAX > 32 )
//#error "GID_MAX must be less than or equal to 32; to increase, modify GID in iq.h" /* LYM */
#endif

#if( !defined(NFA_NEXT_SEQ) )
#define NFA_NEXT_SEQ		FALSE
#endif

#if( !defined(USE_BLOCK_NFA) )
#define USE_BLOCK_NFA		FALSE
#endif

#if( !defined(GET_SPEC_STATS) )
#define GET_SPEC_STATS		FALSE
#endif

#if( !defined(USING_LOG_UNIT) )
#define USING_LOG_UNIT		FALSE
#endif

#if( !defined(USING_CMPLX_UNIT) )
#define USING_CMPLX_UNIT	FALSE
#endif

#if( !defined(USE_PREDICATION) )
#define USE_PREDICATION		FALSE
#endif

#if( !defined(USE_PREDICATION_MODE1) )
#define USE_PREDICATION_MODE1	TRUE
#endif

#if( !defined(HANDLE_NOPS) )
#define HANDLE_NOPS		FALSE
#endif

#if( !defined(USE_NONPIPE_FPU_OPS) )
#define USE_NONPIPE_FPU_OPS	FALSE
#endif

#if( !defined(USE_NONPIPE_FIX_OPS) )
#define USE_NONPIPE_FIX_OPS	FALSE
#endif

#if( !defined(USE_STOREQ_NODATA_CIRCULATE ) )
#define USE_STOREQ_NODATA_CIRCULATE 	FALSE
#endif

#if( !defined(STOREQ_SAME_CYCLE_ABORT ) )
#define STOREQ_SAME_CYCLE_ABORT 	FALSE
#endif

#if( !defined(STOREQ_IGNORE_RETIRED ) )
#define STOREQ_IGNORE_RETIRED 	FALSE
#endif

#if( !defined(STOREQ_IGNORE_PARTIAL ) )
#define STOREQ_IGNORE_PARTIAL 	TRUE
#endif

#if( !STOREQ_IGNORE_PARTIAL && !USE_STOREQ_NODATA_CIRCULATE )
#error "if STOREQ_IGNORE_PARTIAL is FALSE, USE_STOREQ_NODATA_CIRCULATE must be TRUE"
#endif

#if( !defined(MEMQ_FLUSHES_IMMEDIATELY) )
#define MEMQ_FLUSHES_IMMEDIATELY	TRUE
#endif

#if( !defined(DMISS_COUNT_LINES) )
#define DMISS_COUNT_LINES		TRUE
#endif

#if( DUMP_DMISS )
  #define DMPMISS(x)	(x)
#else
  #define DMPMISS(x) // jdonald thinks blank is better than (0)
#endif

