#include <stdio.h>
#define NDEBUG 1
#include <assert.h>
#define POLICY "rename"
#define NUM_BARS 3

#define MAXLINE 1024
typedef struct {
  char name[24];
  double weighted_speedup[NUM_BARS];
  double ED2_product[NUM_BARS];
} bench_t;

bench_t benchmarks[64];
unsigned num_benchmarks = 0;

void read_table(char* fname, unsigned index) {
    FILE* f;
    unsigned i;
    char name[24];
    char str[24];
    double ED2_product;
    double IPC;
    unsigned j = 0;
    int count;
    unsigned cycles, instructions;
    unsigned num_threads;
    unsigned thread_instructions[2];
    char buff[MAXLINE];
    double weighted_speedup;
    f = fopen(fname, "r");
    if (f == NULL) {
        fprintf(stderr, "hmm i couldn't open: %s\n", str);
        exit(-1);
    }
    for (i = 0; i < 11; i += 1) {
        fgets(buff, MAXLINE, f);
    }
    while (!feof(f) && fscanf(f, "%s", name) != 0) {
        count = fscanf(f, "%u", &cycles);
        assert(count == 1);
        count = fscanf(f, "%u", &instructions);
        assert(count == 1);
        for (i= 0; i < 2; i += 1) {
            fscanf(f, "%s", str);
        }
        count = fscanf(f, "%lf", &IPC);
        assert(count == 1);
        fscanf(f, "%s", str); /* EPI */
        count = fscanf(f, "%lf", &ED2_product);
        assert(count == 1);
        count = fscanf(f, "%lf", &weighted_speedup);
        assert(count == 1);
        fscanf(f, "%u", &num_threads);
        assert(num_threads == 2); /* for now */
        for (i = 0; i < num_threads; i += 1) {
          fscanf(f, "%u", &thread_instructions[i]);
          }
        fgets(buff, MAXLINE, f);
        printf("%s & ", name);
        printf("%.3f", IPC);
        printf(" & ");
        for (i = 0; i < num_threads; i += 1) {
            printf("%.1f\\%%", (double) thread_instructions[i] / instructions * 100.0);
            if (i != num_threads-1) printf("/");
        }
        printf(" & ");
        printf("%.3f", weighted_speedup);
        printf(" & ");
        printf("%.2e", ED2_product);
        printf(" \\\\\n");
        strcpy(benchmarks[j].name, name);
        benchmarks[j].weighted_speedup[index] = weighted_speedup;
        benchmarks[j].ED2_product[index] = ED2_product;
        j += 1;
        if (j == 10) break; /* hack */
    }
    num_benchmarks = j;
}

void graph_weighted_speedup() {
    unsigned i, j;
    for (i = 0; i < num_benchmarks; i += 1) {
        printf("%s", benchmarks[i].name);
        printf(" ");
        for (j = 0; j < NUM_BARS; j += 1)
            printf("%.3f ", benchmarks[i].weighted_speedup[j]);
        printf("\n");
    }
}

void graph_ED2_product() {
    unsigned i, j;
    for (i = 0; i < num_benchmarks; i += 1) {
        printf("%s ", benchmarks[i].name);
        for (j = 0; j < NUM_BARS; j += 1)
            /* printf("%.2e ", benchmarks[i].ED2_product[j]); */
            printf("%.3f ", benchmarks[i].ED2_product[j] / benchmarks[i].ED2_product[0]);
        printf("\n");
    }
}

int main() {
   read_table(POLICY "throttle/results.txt", 0);
   printf("\n");
   read_table("selective" POLICY "_moderate/results.txt", 1);
   printf("\n");
   read_table("selective" POLICY "_aggressive/results.txt", 2);
   printf("\n");
   graph_weighted_speedup();
   printf("\n");
   graph_ED2_product();
   return 0;
}
