#include <stdio.h>
#include <stdlib.h>
#include <math.h>

FILE * input_fp;
FILE *		the_stderr = stderr;
  int			the_stderr_des;

#define GROUPS_MAX 20
#define DCACHE_PORTS 2
#define CLUSTERS_MAX 2
#define INFLIGHT_MAX 150
#define REORDERQ_LENGTH 31
#define STAT0 1
#define STATS 1
unsigned stats_storeq[STOREQ_SIZE+1];
unsigned stats_reorderq[REORDERQ_LENGTH+1];

#define dumpStats( total_, size_, array_, tag_ )	\
  {						\
    unsigned	tmp_total_;			\
    unsigned	num_;				\
    unsigned	div_;				\
    unsigned	hi_;				\
    unsigned	frac_;				\
    unsigned	n_;				\
    unsigned	j_;				\
    unsigned	scale_;				\
    unsigned	weight_;			\
						\
    scale_ = total_/10000;			\
    for( n_ = (size_); n_ > 0; n_ -- ) {	\
      if( array_[n_] ) {			\
	break;					\
      }						\
    }						\
    tmp_total_ = 0;				\
    weight_ = 0;				\
    fprintf(the_stderr, "@@ %s\n", tag_);		\
    for( j_ = 0; j_ <= n_; j_++ ) {		\
      num_ = array_[j_];			\
      if( total_ < (1<<18) ) {			\
	div_ = (num_*10000)/total_;		\
      }						\
      else {					\
	div_ = num_/scale_;			\
      }						\
      frac_ = div_%100;				\
      hi_ = (div_ - frac_);			\
      hi_ = hi_/100;				\
      fprintf(the_stderr, "@@ \t%2u:%-8u\t%2d.%02d\n", j_, num_, hi_, frac_);\
      tmp_total_ += num_;			\
      weight_ += num_*j_;			\
    }						\
    fprintf(the_stderr, "@@ = %u %u\n", tmp_total_, weight_);	\
    fprintf(the_stderr, "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n" ); \
  }


unsigned cycle; 
 unsigned stats_iprefetch_hits ; 
unsigned stats_iprefetch ; 
 unsigned bp_bclr_total ; 
 unsigned nfa_total ; 
 unsigned nfa_miss ; 
 unsigned nfa_miss_buried ; 
 unsigned branch_total ; 
 unsigned branch_stalls ; 
 unsigned branch_pred_stalls ; 
 unsigned bp_bc_miss ; 
 unsigned bp_bc_total ; 
 unsigned bp_bclr_miss ; 
 unsigned bp_bcctr_miss ; 
 unsigned bp_bcctr_total ; 
 unsigned branch_miss_total;  
 unsigned bp_bc_miss_miss ; 
 unsigned bp_bc_miss_total ; 
 unsigned bp_bclr_miss_miss ; 
 unsigned bp_bclr_miss_total ; 
 unsigned bp_bcctr_miss_miss ; 
 unsigned bp_bcctr_miss_total ; 
 unsigned stats_reissue_flushes ; 
 unsigned stats_reissue_decode ; 
 unsigned stats_recirc ; 
 unsigned stats_groups_dispatched ; 
 unsigned stats_ibuf_stall ; 
 unsigned stats_inflight_stall ; 
 unsigned stats_dmiss_stall ; 
 unsigned stats_dcastout_stall ; 
 unsigned stats_storeq_stall ; 
 unsigned stats_reorderq_stall ; 
 unsigned stats_resv_full_stall ; 
 unsigned stats_rename_stall ; 
 unsigned stats_storeq_total ; 
 unsigned stats_storeq_forward ; 
 unsigned stats_storeq_partials ; 
 unsigned stats_storeq_data_not_ready ; 
 unsigned stats_reorderq_total ; 
unsigned stats_reorderq_conflict ; 
unsigned           stats_groups[GROUPS_MAX + 1];

/***** ifetch *****/
  #if( !defined(IFETCH_MAX) )
  #define IFETCH_MAX				4
  #endif

  #if( !defined(IFETCH_MAX_COND_BRANCH) )
  #define		IFETCH_MAX_COND_BRANCH	1
  #endif

/***** ibuf *****/
  #if( !defined( IBUF_MAX ))
  #define		IBUF_MAX		24
  #endif

  #if( !defined( FCHBLK_MAX) )
  #define		FCHBLK_MAX		0
  #endif

/***** decode *****/
  #if( !defined(DECODE_MAX))
  #define		DECODE_MAX		4
  #endif

/***** rename *****/
  #if( !defined(RENAME_MAX) )
  #define		RENAME_MAX		4
  #endif

/* maximum number of physical registers per class */
  #if( !defined(PHYS_MAX))
    #define		PHYS_MAX		128
  #endif
  #define		LG2PHYS_MAX		lg2(PHYS_MAX)

  #define		CLASS_MAX		4
  #define		ARCH_TOTAL		(CLASS_MAX*ARCH_MAX)
  #define		PHYS_TOTAL		(CLASS_MAX*PHYS_MAX)

/***** free register queue *****/
  #if(!defined(GPR_PHYS) )
  #define		GPR_PHYS		80
  #endif
  #if( !defined(GPR_ARCH) )
  #define		GPR_ARCH		32
  #endif
  #define		GPR_CLASS		0

  #if( !defined(FPR_PHYS) )
  #define		FPR_PHYS		80
  #endif
  #if( !defined(FPR_ARCH) )
  #define		FPR_ARCH		32
  #endif
  #define		FPR_CLASS		1

  #if( !defined(CCR_PHYS))
  #define		CCR_PHYS		32
  #endif
  #if( !defined(CCR_ARCH))
  #define		CCR_ARCH		8
  #endif
  #define		CCR_CLASS		2

  #if( !defined(SPR_PHYS))
  #define		SPR_PHYS		64
  #endif
  #if( !defined(SPR_ARCH))
  #define		SPR_ARCH		32
  #endif
  #define		SPR_CLASS		3

/***** dispatch *****/
  #if( !defined(DISPATCH_MAX))
  #define		DISPATCH_MAX		4
  #endif

/***** miss queues *****/
  #if( !defined(DMISS_MAX))
  #define		DMISS_MAX		7
  #endif

  unsigned		stats_lines_n;
  unsigned		stats_l2_dmiss_n;
  unsigned		stats_l2_lines_n;

  unsigned		dmiss_address;
  unsigned		dmiss_loaded;

  unsigned		dmiss_spec_hdspec;
  unsigned		dmiss_spec_hdaddr;

/***** castout queues *****/
  #if( !defined(DCASTOUT_MAX) )
  #define		DCASTOUT_MAX		DMISS_MAX
  #endif

  #define		DCASTOUT_OVERHEAD	5

/***** reservation stations *****/

  #if( USING_CMPLX_UNIT )
  #define		UNITS_MAX		6
  #elif( USING_LOG_UNIT )
  #define		UNITS_MAX		5
  #else
  #define		UNITS_MAX		4
  #endif

  #if( !defined(FIX_RESV) )
  #define		FIX_RESV		20
  #endif
  #if( !defined(FIX_NUM))
  #define		FIX_NUM			3
  #endif

  #if( USE_NONPIPE_FIX_OPS )
  unsigned		fix_nonpipe_in_progress;
  unsigned		fix_nonpipe_till[FIX_NUM];
  #endif

  #if( USE_NONPIPE_FIX_OPS )
  unsigned		fix1_nonpipe_in_progress;
  unsigned		fix1_nonpipe_till[FIX_NUM];
  #endif

  #if( !defined(FPU_RESV) )
  #define		FPU_RESV		20
  #endif
  #if( !defined(FPU_NUM) )
  #define		FPU_NUM			2
  #endif

  #if( !defined(MEM_RESV))
  #define		MEM_RESV		20
  #endif
  #if( !defined(MEM_NUM))
  #define		MEM_NUM			2
  #endif

  #if( !defined( BR_RESV ) )
  #define		BR_RESV			12
  #endif
  #if( !defined( BR_NUM ) )
  #define		BR_NUM			2
  #endif

#if( USING_LOG_UNIT )
  #if( !defined( LOG_RESV ) )
  #define		LOG_RESV		12
  #endif
  #if( !defined( LOG_NUM ) )
  #define		LOG_NUM			1
  #endif
#else
  #if( !defined( LOG_RESV ) )
  #define		LOG_RESV		0
  #endif
  #if( !defined( LOG_NUM) )
  #define		LOG_NUM			0
  #endif
  #define		log_n			0
#endif

#if( USING_CMPLX_UNIT )
  #if( !defined( CMPLX_RESV ) )
  #define		CMPLX_RESV		16
  #endif
  #if( !defined( CMPLX_NUM ) )
  #define		CMPLX_NUM		1
  #endif
#else
  #define		CMPLX_RESV		0
  #define		CMPLX_NUM		0
  #define		cmplx_n			0
#endif

/***** retirement queue *****/
  #if( !defined( RETIRE_MAX ) )
  #define		RETIRE_MAX		6
  #endif
  #if( !defined( RETIREQ_MAX ) )
  #define		RETIREQ_MAX		128
  #endif
  #if( RETIREQ_MAX + IBUF_MAX > 256 )
  #error		"RETIREQ_MAX + IBUF_MAX should be <= 256"
  #endif

  /**** POWERTIMER STATS ADDED BY DBROOKS */
  unsigned		stats_num_stores = 0;
  unsigned		stats_num_loads = 0;

  unsigned		insns = 0;
  unsigned		insns_total_execd = 0;
  unsigned		insns_total_dispd = 0;
  unsigned		insns_retired = 0;
  unsigned		insns_total_retired = 0;
  unsigned		memop = 0;

  unsigned		bp_exec_total = 0;
  unsigned		bp_exec_pred = 0;
  unsigned		bp_exec_miss = 0;
  unsigned		bp_exec_bc_miss = 0;
  unsigned		bp_exec_bc_total = 0;
  unsigned		bp_exec_bclr_miss = 0;
  unsigned		bp_exec_bclr_total = 0;
  unsigned		bp_exec_bcctr_miss = 0;
  unsigned		bp_exec_bcctr_total = 0;

  unsigned		stats_dinter_conflicts = 0;
  unsigned		stats_dinter_equals = 0;

  unsigned		stats_strings_total = 0;
  unsigned		stats_strings_expands = 0;
  unsigned		stats_strings_stalls = 0;

  unsigned		stats_total_execd = 0;
  unsigned		stats_nexpands = 0;
  unsigned		stats_expands_to = 0;
  unsigned		stats_nops_dispd = 0;
  unsigned		stats_nops_retd = 0;

  unsigned		stats_mtsr = 0;
  unsigned		stats_mtsr_ipurge = 0;
  unsigned		stats_mtsr_dpurge = 0;

  unsigned		stats_dtmiss = 0;
  unsigned		stats_d2tmiss = 0;
  unsigned		stats_dmiss = 0;
  unsigned		stats_store_dmiss = 0;
  unsigned		stats_store_dmiss_taken = 0;
  unsigned		stats_dlines = 0;
  unsigned		stats_d1lines = 0;
  unsigned		stats_store_d1lines = 0;
  unsigned		stats_d2lines = 0;

  unsigned		stats_dtrail = 0;
  unsigned		stats_dmiss0 = 0;
  unsigned		stats_dprobe = 0;
  unsigned		stats_dcast = 0;
  unsigned		stats_dl2miss = 0;

  unsigned		stats_dtmiss_taken = 0;
  unsigned		stats_d2tmiss_taken = 0;
  unsigned		stats_dmiss_taken = 0;
  unsigned		stats_dl2miss_taken = 0;

  unsigned		stats_itmiss = 0;
  unsigned		stats_i2tmiss = 0;
  unsigned		stats_imiss = 0;
  unsigned		stats_imiss0 = 0;
  unsigned		stats_iprobe = 0;
  unsigned		stats_i15miss = 0;
  unsigned		stats_il2miss = 0;
#if( USE_PREDICATION )
  unsigned		stats_pred_branch = 0;
  unsigned		stats_pred_exps = 0;
  unsigned		stats_pred_ops = 0;
  unsigned		stats_pred_taken = 0;
#endif

#if( GET_SPEC_STATS )
  unsigned		stats_spec_ifetch = 0;

  unsigned		stats_spec_expands_to = 0;
  unsigned		stats_spec_nexpands = 0;

  unsigned		stats_spec_dispatch = 0;

  unsigned		stats_spec_fix_execd = 0;
  unsigned		stats_spec_fpu_execd = 0;
  unsigned		stats_spec_mem_execd = 0;
  unsigned		stats_spec_br_execd = 0;

  unsigned		stats_spec_imiss = 0;
  unsigned		stats_spec_dmiss = 0;
  unsigned		stats_spec_dlines = 0;
  unsigned		stats_spec_dflush = 0;
  unsigned		stats_spec_dsatisfy = 0;

  unsigned		stats_spec_extra_hits = 0;
  unsigned		stats_spec_extra_misses = 0;
  unsigned		stats_spec_src_hits = 0;
  unsigned		stats_spec_reexec_hits = 0;
  unsigned		stats_spec_used_once = 0;

  unsigned		stats_spec_extra_ihits = 0;
  unsigned		stats_spec_extra_imisses = 0;
  unsigned		stats_spec_src_ihits = 0;
  unsigned		stats_spec_iused_once = 0;

  unsigned		stats_spec_dflush_histo[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_spec_over_histo[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_spec_dflush_over_histo[ DMISS_MAX + MEM_NUM + 1];
#endif

  #if( EVALUATE_MISPREDICTED_BRANCHES )
  unsigned		stats_eval_mispredict;
  #endif

#if( STATS )
  unsigned 		stats_retired[RETIRE_MAX+1];
  unsigned 		stats_st_retired[DCACHE_PORTS+1];
  unsigned 		stats_st_commit[DCACHE_PORTS+1];

  unsigned		stats_fix_execd[ FIX_NUM + 1];
  unsigned		stats_fpu_execd[ FPU_NUM + 1];
  unsigned		stats_mem_execd[ MEM_NUM + 1];
  unsigned		stats_br_execd[ BR_NUM + 1];
  #if( USING_LOG_UNIT )
  unsigned		stats_log_execd[ LOG_NUM + 1];
  #endif
  #if( USING_CMPLX_UNIT )
  unsigned		stats_cmplx_execd[ CMPLX_NUM + 1];
  #endif

  #if( CLUSTER )
    unsigned		stats_fix1_execd[ FIX_NUM + 1];
    unsigned		stats_fpu1_execd[ FPU_NUM + 1];
    unsigned		stats_mem1_execd[ MEM_NUM + 1];
    unsigned		stats_br1_execd[ BR_NUM + 1];
  #endif
  #if( USING_LOG_UNIT )
    unsigned		stats_log1_execd[ LOG_NUM + 1];
  #endif

  #if( USING_CMPLX_UNIT )
    unsigned		stats_cmplx1_execd[ CMPLX_NUM + 1];
  #endif

  unsigned		stats_execd[(FIX_NUM+FPU_NUM+MEM_NUM+BR_NUM+LOG_NUM+CMPLX_NUM)*CLUSTERS_MAX + 1];

  unsigned		stats_dispatched[ DISPATCH_MAX + 1 ];

  unsigned		stats_fix_dispatched[ DISPATCH_MAX + 1 ];
  unsigned		stats_fpu_dispatched[ DISPATCH_MAX + 1 ];
  unsigned		stats_mem_dispatched[ DISPATCH_MAX + 1 ];
  unsigned		stats_br_dispatched[ DISPATCH_MAX + 1 ];
  #if( USING_LOG_UNIT )
  unsigned		stats_log_dispatched[ DISPATCH_MAX + 1];
  #endif
  #if( USING_CMPLX_UNIT )
  unsigned		stats_cmplx_dispatched[ DISPATCH_MAX + 1];
  #endif

  #if( CLUSTER )
    unsigned		stats_fix1_dispatched[ DISPATCH_MAX + 1 ];
    unsigned		stats_fpu1_dispatched[ DISPATCH_MAX + 1 ];
    unsigned		stats_mem1_dispatched[ DISPATCH_MAX + 1 ];
    unsigned		stats_br1_dispatched[ DISPATCH_MAX + 1 ];
    #if( USING_LOG_UNIT )
    unsigned		stats_log1_dispatched[ DISPATCH_MAX + 1];
    #endif
    #if( USING_CMPLX_UNIT )
    unsigned		stats_cmplx1_dispatched[ DISPATCH_MAX + 1];
    #endif
  #endif

  unsigned		stats_renamed[ IBUF_MAX + 1 ];
  unsigned		stats_fetched[ IFETCH_MAX + 1 ];

  unsigned		stats_ibuf[ IBUF_MAX + 1];
  unsigned		stats_fchblk[ FCHBLK_MAX + 1] = {0};
  unsigned 		stats_retireq[RETIREQ_MAX+1];
  unsigned		stats_fix_resv[ FIX_RESV + 1];
  unsigned		stats_fpu_resv[ FPU_RESV + 1];
  unsigned		stats_mem_resv[ MEM_RESV + 1];
  unsigned		stats_br_resv[ BR_RESV + 1];

  #if( USING_LOG_UNIT )
    unsigned		stats_log_resv[ LOG_RESV + 1];
  #endif
  #if( USING_CMPLX_UNIT )
    unsigned		stats_cmplx_resv[ CMPLX_RESV + 1];
  #endif

  #if( CLUSTER )
    unsigned		stats_fix1_resv[ FIX_RESV + 1];
    unsigned		stats_fpu1_resv[ FPU_RESV + 1];
    unsigned		stats_mem1_resv[ MEM_RESV + 1];
    unsigned		stats_br1_resv[ BR_RESV + 1];
    #if( USING_LOG_UNIT )
      unsigned		stats_log1_resv[ LOG_RESV + 1];
    #endif
    #if( USING_CMPLX_UNIT )
      unsigned		stats_cmplx1_resv[ CMPLX_RESV + 1];
    #endif
  #endif

  unsigned		stats_resv[ (FIX_RESV + FPU_RESV + MEM_RESV + BR_RESV + LOG_RESV + CMPLX_RESV )*CLUSTERS_MAX + 1];

  unsigned		stats_gpr[ GPR_PHYS + 1];
  unsigned		stats_fpr[ FPR_PHYS + 1 ];
  unsigned		stats_spr[ SPR_PHYS + 1 ];
  unsigned		stats_ccr[ CCR_PHYS + 1 ];
  unsigned		stats_dmissq[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_l2dmissq[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_lines[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_l2_lines[ DMISS_MAX + MEM_NUM + 1];
  unsigned		stats_dcastoutq[ DCASTOUT_MAX + MEM_NUM + 1];
  unsigned		stats_inflight[INFLIGHT_MAX + 1];
  unsigned		stats_groups[GROUPS_MAX + 1];

  unsigned		stats_dmiss_stall;
  unsigned		stats_dcastout_stall;
  unsigned		stats_resv_full_stall;
  unsigned		stats_rename_stall;
  unsigned		stats_ibuf_stall;
  unsigned		stats_inflight_stall;
  unsigned		stats_reissue_decode = 0;
  unsigned		stats_reissue_flushes = 0;
  unsigned		stats_recirc = 0;
  unsigned		stats_groups_dispatched = 0;
#endif

#if( STAT0 )
  unsigned		stat0_ifetch_reason = 0;
  unsigned		stat0_ifetch_other = 0;
  unsigned		stat0_ifetch_tlb = 0;
  unsigned		stat0_ifetch_cache = 0;
  unsigned		stat0_ifetch_nfa = 0;
  unsigned		stat0_ifetch_ibuf = 0;
  unsigned		stat0_ifetch_fchblk = 0;
  unsigned		stat0_ifetch_sync = 0;
  unsigned		stat0_ifetch_end = 0;
  unsigned		stat0_ifetch_partial = 0;
  unsigned		stat0_ifetch_mispredict = 0;
  unsigned		stat0_ifetch_inflight = 0;
  unsigned		stat0_ifetch_pred = 0;

  unsigned		stat0_decode_empty = 0;
  unsigned		stat0_decode_stall = 0;
  unsigned		stat0_decode_multi = 0;
  unsigned		stat0_decode_string = 0;

  unsigned		stat0_dispatch_groups = 0;
#endif

#define POWER_MODE 1

#define PRINT_STATS 0

#if ( POWER_MODE )
#include "power_defs.macros"
#endif

int main(int argc,char * argv[]	) {
  /*  the_stderr_des = dup(2);
      the_stderr = fdopen(the_stderr_des, "w"); */

  double no_cg[7];
  double both_cg[7];
  double hold_cg[7];
  double logic_cg[7];

  char *	tmp_arg;
  char * pend;
  int i,j,k;
  double FO4,FO4_SCALE,FO4_FREQ_SCALE, FO4_LATCH_SCALE,FO4_LOGIC_SCALE,FO4_LEAKAGE_SCALE;
  double logic_power,cpam_full_power;

  double latch_scale, latch_over, latch_ratio, latch_fraction,glitch_factor;
  double freq_scale, freq_over;
  double FO4_overhead = 3.0;
  double leakage_factor, latch_area;
  double leakage_over, glitch_over;

  FO4 = latch_over = freq_over = leakage_over = glitch_over = 0.0;
  latch_scale = freq_scale = 1.0;
  latch_fraction = 1.0;
  latch_ratio = 0.0;
  glitch_factor = 0.0;
  leakage_factor = 0.0;
  latch_area = 0.3;

  #include "post_utils_cmdline.macros"

  if(input_fp == NULL) {
    printf("bad command line file argument given\n");
    exit(0);
  }

  if(FO4 == 0.0) {
    printf("fo4 not specified on command line\n");
    exit(0);
  }

  /* linear scaling for frequency */
  FO4_FREQ_SCALE = pow(19.0/FO4,freq_scale);

  /* linear scaling for latch bloat */
  /* pow(a,b,m,c) ==> c = ( a ^ b ) mod m */
  /*  pow(19.0/FO4,latch_scale,1,FO4_LATCH_SCALE)*/
  FO4_LATCH_SCALE = latch_fraction * pow((19.0-FO4_overhead)/(FO4-FO4_overhead),latch_scale);

  FO4_LOGIC_SCALE = (1.0/(1.0 + glitch_factor)) * ( 1 + (glitch_factor * ((FO4-FO4_overhead)/(19.0-FO4_overhead))));

  FO4_LEAKAGE_SCALE = pow((19.0-FO4_overhead)/(FO4-FO4_overhead),latch_scale);

  fprintf(the_stderr,"latch_over == %f\n",latch_over);  
  fprintf(the_stderr,"freq_over == %f\n",freq_over);  
  fprintf(the_stderr,"glitch_over == %f\n",glitch_over);
  fprintf(the_stderr,"leakage_over == %f\n",leakage_over);

  if(latch_over != 0.0) 
    FO4_LATCH_SCALE = latch_over;

  if(glitch_over != 0.0) 
    FO4_LOGIC_SCALE = glitch_over;

  if(leakage_over != 0.0) 
    FO4_LEAKAGE_SCALE = leakage_over;

  if(freq_over != 0.0) 
    FO4_FREQ_SCALE = freq_over;
 
  /*        FO4_FREQ_SCALE = 1.0;   */
  /*        FO4_LATCH_SCALE = 1.0;  */

  fprintf(the_stderr,"FO4_FREQ_SCALE == %f\n",FO4_FREQ_SCALE);
  fprintf(the_stderr,"FO4_LATCH_SCALE == %f\n",FO4_LATCH_SCALE);
  fprintf(the_stderr,"FO4_LOGIC_SCALE == %f\n",FO4_LOGIC_SCALE);
  fprintf(the_stderr,"FO4_LEAKAGE_SCALE == %f\n",FO4_LEAKAGE_SCALE);
  fprintf(the_stderr,"FO4_SCALE == %f\n",FO4_FREQ_SCALE*FO4_LATCH_SCALE*FO4_LOGIC_SCALE);

#if( POWER_MODE )
#include "init.power.macros"
#endif
  

      /* READ STATS FROM BINARY FILE FOR POST PROCESSING */
      fread(&cycle,sizeof(unsigned),1,input_fp);
      fread(&insns,sizeof(unsigned),1,input_fp);
      fread(&memop,sizeof(unsigned),1,input_fp);
      fread(&insns_retired,sizeof(unsigned),1,input_fp);
      fread(&insns_total_retired,sizeof(unsigned),1,input_fp);
      fread(&insns_total_execd,sizeof(unsigned),1,input_fp);
      fread(&insns_total_dispd,sizeof(unsigned),1,input_fp);

      fread(&stats_iprobe,sizeof(unsigned),1,input_fp);
      fread(&stats_imiss,sizeof(unsigned),1,input_fp);
      fread(&stats_iprefetch_hits,sizeof(unsigned),1,input_fp);
      fread(&stats_i15miss,sizeof(unsigned),1,input_fp);
      fread(&stats_il2miss,sizeof(unsigned),1,input_fp);
      fread(&stats_itmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_i2tmiss,sizeof(unsigned),1,input_fp);

      fread(&stats_dprobe,sizeof(unsigned),1,input_fp);
      fread(&stats_dlines,sizeof(unsigned),1,input_fp);
      fread(&stats_d1lines,sizeof(unsigned),1,input_fp);
      fread(&stats_d2lines,sizeof(unsigned),1,input_fp);
      fread(&stats_dmiss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_dmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_dl2miss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_dl2miss,sizeof(unsigned),1,input_fp);
      fread(&stats_dtrail,sizeof(unsigned),1,input_fp);
      fread(&stats_dcast,sizeof(unsigned),1,input_fp);

      fread(&stats_dprobe,sizeof(unsigned),1,input_fp);
      fread(&stats_dlines,sizeof(unsigned),1,input_fp);
      fread(&stats_store_d1lines,sizeof(unsigned),1,input_fp);
      fread(&stats_d2lines,sizeof(unsigned),1,input_fp);
      fread(&stats_store_dmiss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_store_dmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_dl2miss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_dl2miss,sizeof(unsigned),1,input_fp);
      fread(&stats_dtrail,sizeof(unsigned),1,input_fp);
      fread(&stats_dcast,sizeof(unsigned),1,input_fp);

      fread(&stats_dtmiss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_dtmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_d2tmiss_taken,sizeof(unsigned),1,input_fp);
      fread(&stats_d2tmiss,sizeof(unsigned),1,input_fp);

      fread(&stats_dinter_conflicts,sizeof(unsigned),1,input_fp);
      fread(&stats_dinter_equals,sizeof(unsigned),1,input_fp);

    #if( STAT0 )
      fread(&stat0_ifetch_tlb,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_cache,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_nfa,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_mispredict,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_ibuf,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_fchblk,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_sync,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_pred,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_partial,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_inflight,sizeof(unsigned),1,input_fp);
      fread(&stat0_ifetch_end,sizeof(unsigned),1,input_fp);

      fread(&stat0_decode_empty,sizeof(unsigned),1,input_fp);
      fread(&stat0_decode_stall,sizeof(unsigned),1,input_fp);
      fread(&stat0_decode_multi,sizeof(unsigned),1,input_fp);
      fread(&stat0_decode_string,sizeof(unsigned),1,input_fp);

      fread(&stat0_dispatch_groups,sizeof(unsigned),1,input_fp);
    #endif

      fread(&stats_iprefetch_hits,sizeof(unsigned),1,input_fp);
      fread(&stats_iprefetch,sizeof(unsigned),1,input_fp);

      fread(&stats_nexpands,sizeof(unsigned),1,input_fp);
      fread(&stats_expands_to,sizeof(unsigned),1,input_fp);

      fread(&stats_strings_total,sizeof(unsigned),1,input_fp);
      fread(&stats_strings_expands,sizeof(unsigned),1,input_fp);
      fread(&stats_strings_stalls,sizeof(unsigned),1,input_fp);

      fread(&bp_bclr_total,sizeof(unsigned),1,input_fp);
      fread(&nfa_total,sizeof(unsigned),1,input_fp);
      fread(&nfa_miss,sizeof(unsigned),1,input_fp);
      fread(&nfa_miss_buried,sizeof(unsigned),1,input_fp);

    #if( 1 || !PERFECT_BRANCH_PREDICTION )
      fread(&branch_total,sizeof(unsigned),1,input_fp);
      fread(&branch_stalls,sizeof(unsigned),1,input_fp);
      fread(&branch_pred_stalls,sizeof(unsigned),1,input_fp);
      fread(&bp_bc_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bc_total,sizeof(unsigned),1,input_fp);
      fread(&bp_bclr_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bclr_total,sizeof(unsigned),1,input_fp);
      fread(&bp_bcctr_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bcctr_total,sizeof(unsigned),1,input_fp);

      fread(&branch_miss_total,sizeof(unsigned),1,input_fp);
      fread(&branch_stalls,sizeof(unsigned),1,input_fp);
      fread(&bp_bc_miss_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bc_miss_total,sizeof(unsigned),1,input_fp);
      fread(&bp_bclr_miss_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bclr_miss_total,sizeof(unsigned),1,input_fp);
      fread(&bp_bcctr_miss_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_bcctr_miss_total,sizeof(unsigned),1,input_fp);

      fread(&bp_exec_total,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_pred,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bc_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bc_total,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bclr_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bclr_total,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bcctr_miss,sizeof(unsigned),1,input_fp);
      fread(&bp_exec_bcctr_total,sizeof(unsigned),1,input_fp);

      fread(&stats_reissue_flushes,sizeof(unsigned),1,input_fp);
      fread(&stats_reissue_decode,sizeof(unsigned),1,input_fp);
      fread(&stats_recirc,sizeof(unsigned),1,input_fp);
      fread(&stats_groups_dispatched,sizeof(unsigned),1,input_fp);
    #endif


    #if( GET_SPEC_STATS )
      fread(&stats_spec_ifetch,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_nexpands,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_nexpands_to,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_dispatch,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_br_execd,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_fix_execd,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_fpu_execd,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_mem_execd,sizeof(unsigned),1,input_fp);

      fread(&stats_spec_dmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_dmiss,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_dlines,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_dflush,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_dsatisfy,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_extra_hits,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_extra_misses,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_src_hits,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_reexec_hits,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_used_once,sizeof(unsigned),1,input_fp);

      fread(&stats_spec_imiss,sizeof(unsigned),1,input_fp);
      fread(&stats_imiss,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_extra_ihits,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_extra_imisses,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_src_ihits,sizeof(unsigned),1,input_fp);
      fread(&stats_spec_iused_once,sizeof(unsigned),1,input_fp);
    #endif

      fread(&stats_ibuf_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_inflight_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_dmiss_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_dcastout_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_storeq_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_reorderq_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_resv_full_stall,sizeof(unsigned),1,input_fp);
      fread(&stats_rename_stall,sizeof(unsigned),1,input_fp);

      fread(&stats_storeq_total,sizeof(unsigned),1,input_fp);
      fread(&stats_storeq_forward,sizeof(unsigned),1,input_fp);
      fread(&stats_storeq_partials,sizeof(unsigned),1,input_fp);
      fread(&stats_storeq_data_not_ready,sizeof(unsigned),1,input_fp);
    
      fread(&stats_reorderq_total,sizeof(unsigned),1,input_fp);
      fread(&stats_reorderq_conflict,sizeof(unsigned),1,input_fp);

      fread(&stats_mtsr,sizeof(unsigned),1,input_fp);
      fread(&stats_mtsr_ipurge,sizeof(unsigned),1,input_fp);
      fread(&stats_mtsr_dpurge,sizeof(unsigned),1,input_fp);

      fread(&stats_nops_dispd,sizeof(unsigned),1,input_fp);
      fread(&stats_nops_retd,sizeof(unsigned),1,input_fp);


      fread(&stats_num_stores,sizeof(unsigned),1,input_fp);
      fread(&stats_num_loads,sizeof(unsigned),1,input_fp);

      fread(&stats_num_loads,sizeof(unsigned),1,input_fp);

    #if( GET_SPEC_STATS )
      fread(stats_spec_dflush_histo,(DMISS_MAX + MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_spec_over_histo,(DMISS_MAX + MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_spec_dflush_over_histo,(DMISS_MAX + MEM_NUM +1)*sizeof(unsigned),1,input_fp);
    #endif

    #if( STATS )
      fread(stats_ibuf,(IBUF_MAX +1)*sizeof(unsigned),1,input_fp);
      fread(stats_fchblk,(FCHBLK_MAX +1)*sizeof(unsigned),1,input_fp);
      fread(stats_retireq,(RETIREQ_MAX +1)*sizeof(unsigned),1,input_fp);
      fread(stats_fix_resv,(FIX_RESV +1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER )
         fread(stats_fix1_resv,(FIX_RESV +1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_fpu_resv,(FPU_RESV +1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER_FPU )
        fread(stats_fpu1_resv,(FPU_RESV +1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_mem_resv,(MEM_RESV +1)*sizeof(unsigned),1,input_fp);
      #if( CLUSTER )
        fread(stats_mem1_resv,(MEM_RESV +1)*sizeof(unsigned),1,input_fp);
      #endif
      fread(stats_br_resv,(BR_RESV +1)*sizeof(unsigned),1,input_fp);

      #if( USING_LOG_UNIT )
      fread(stats_log_resv,(LOG_RESV +1)*sizeof(unsigned),1,input_fp);
      #endif

      #if( USING_CMPLX_UNIT )
        fread(stats_cmplx_resv,(CMPLX_RESV +1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_resv,((FIX_RESV + FPU_RESV + MEM_RESV + BR_RESV + LOG_RESV + CMPLX_RESV )*CLUSTERS_MAX + 1)*sizeof(unsigned),1,input_fp);

      fread(stats_gpr,(GPR_PHYS +1)*sizeof(unsigned),1,input_fp);
      fread(stats_fpr,(FPR_PHYS +1)*sizeof(unsigned),1,input_fp);
      fread(stats_spr,(SPR_PHYS +1)*sizeof(unsigned),1,input_fp);
      fread(stats_ccr,(CCR_PHYS +1)*sizeof(unsigned),1,input_fp);

      fread(stats_storeq,(STOREQ_SIZE +1)*sizeof(unsigned),1,input_fp);
      fread(stats_reorderq,(REORDERQ_LENGTH +1)*sizeof(unsigned),1,input_fp);
      fread(stats_dmissq,(DMISS_MAX+MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_lines,(DMISS_MAX+MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_l2dmissq,(DMISS_MAX+MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_l2_lines,(DMISS_MAX+MEM_NUM +1)*sizeof(unsigned),1,input_fp);
      fread(stats_dcastoutq,(DCASTOUT_MAX + MEM_NUM+1)*sizeof(unsigned),1,input_fp);

      fread(stats_st_commit,(DCACHE_PORTS + 1)*sizeof(unsigned),1,input_fp);

      fread(stats_retired,(RETIRE_MAX + 1)*sizeof(unsigned),1,input_fp);
      fread(stats_st_retired,(DCACHE_PORTS + 1)*sizeof(unsigned),1,input_fp);

      fread(stats_fix_execd,(FIX_NUM + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER )
        fread(stats_fix1_execd,(FIX_NUM + 1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_fpu_execd,(FPU_NUM + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER_FPU )
        fread(stats_fpu1_execd,(FPU_NUM + 1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_mem_execd,(MEM_NUM + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER )
        fread(stats_mem1_execd,(MEM_NUM + 1)*sizeof(unsigned),1,input_fp);
      #endif

      fread(stats_br_execd,(BR_NUM + 1)*sizeof(unsigned),1,input_fp);

      #if( USING_LOG_UNIT )
      fread(stats_log_execd,(LOG_NUM + 1)*sizeof(unsigned),1,input_fp);
      #endif

      #if( USING_CMPLX_UNIT )
      fread(stats_cmplx_execd,(CMPLX_NUM + 1)*sizeof(unsigned),1,input_fp);
      #endif
      fread(stats_execd,((FIX_NUM+FPU_NUM+MEM_NUM+BR_NUM+LOG_NUM+CMPLX_NUM)*CLUSTERS_MAX+1)*sizeof(unsigned),1,input_fp);

      fread(stats_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      fread(stats_fix_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER )
        fread(stats_fix1_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      #endif
      fread(stats_fpu_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER_FPU )
        fread(stats_fpu1_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      #endif
      fread(stats_mem_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);

      #if( CLUSTER )
        fread(stats_mem1_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      #endif
      fread(stats_br_dispatched,(DISPATCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      fread(stats_renamed,(IBUF_MAX + 1)*sizeof(unsigned),1,input_fp);
      fread(stats_fetched,(IFETCH_MAX + 1)*sizeof(unsigned),1,input_fp);
      fread(stats_inflight,(INFLIGHT_MAX + 1)*sizeof(unsigned),1,input_fp);
    #endif
      fread(stats_groups,(GROUPS_MAX + 1)*sizeof(unsigned),1,input_fp);

#if(PRINT_STATS)
    fprintf(the_stderr, "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n" );
    fprintf(the_stderr, "@@ SUMMARY DATA\n" );
    fprintf(the_stderr, "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n" );
    fprintf(the_stderr, "@@ totals: cycle=%llu insns=%u memops=%u retired=%u totalret=%u totalexecd=%u totaldispd=%u\n",
		cycle, insns, memop, insns_retired,
		insns_total_retired, insns_total_execd, insns_total_dispd );

    fprintf(the_stderr, "@@ icache: probes=%u l1miss=%u prehit=%u l15miss=%u l2miss=%u tlb1=%u tlb2=%u\n",
		stats_iprobe, stats_imiss, stats_iprefetch_hits, stats_i15miss,
		stats_il2miss, stats_itmiss, stats_i2tmiss);

    fprintf(the_stderr, "@@ dcache: probes=%u l1lines_started=%u l1lines_fetched=%u l2lines=%u l1miss_all=%u lmiss_taken=%u l2miss_all=%u l2miss_taken=%u trail=%u cast=%u\n",
		stats_dprobe, stats_dlines, stats_d1lines,
		stats_d2lines,
		stats_dmiss_taken, stats_dmiss,
		stats_dl2miss_taken, stats_dl2miss,
		stats_dtrail, stats_dcast);

    fprintf(the_stderr, "@@ dcache_store: probes=%u l1lines_started=%u l1lines_fetched=%u l2lines=%u l1miss_all=%u lmiss_taken=%u l2miss_all=%u l2miss_taken=%u trail=%u cast=%u\n",
		stats_dprobe, stats_dlines, stats_store_d1lines,
		stats_d2lines,
		stats_store_dmiss_taken, stats_store_dmiss,
		stats_dl2miss_taken, stats_dl2miss,
		stats_dtrail, stats_dcast);

    fprintf(the_stderr, "@@ dtlb: tlb1_all=%u tlb1_taken=%u tlb2_all=%u tlb2_taken=%u\n",
		stats_dtmiss_taken, stats_dtmiss,
		stats_d2tmiss_taken, stats_d2tmiss);

    fprintf(the_stderr, "@@ interleave: conflicts=%u samebank=%u\n",
		stats_dinter_conflicts, stats_dinter_equals);
    #if( STAT0 )
      fprintf(the_stderr, "@@ ifetch0: tlb=%u cache=%u nfa=%u mispredict=%u ibuf=%u fchblk=%u sync=%u max_pred=%u partial=%u inflight=%u end=%u\n",
	stat0_ifetch_tlb,
	stat0_ifetch_cache,
	stat0_ifetch_nfa,
	stat0_ifetch_mispredict,
	stat0_ifetch_ibuf,
	stat0_ifetch_fchblk,
	stat0_ifetch_sync,
	stat0_ifetch_pred,
	stat0_ifetch_partial,
	stat0_ifetch_inflight,
	stat0_ifetch_end);

      fprintf(the_stderr, "@@ decode0: empty=%u stall=%u multi=%u string=%u\n",
	stat0_decode_empty,
	stat0_decode_stall,
	stat0_decode_multi,
	stat0_decode_string);

      fprintf(the_stderr, "@@ dispatch0: groups=%u\n",
	stat0_dispatch_groups);
    #endif

    fprintf(the_stderr, "@@ prefetch: hits=%u total=%u\n", stats_iprefetch_hits, stats_iprefetch);
    fprintf(the_stderr, "@@ expands: insns=%u total=%u\n", stats_nexpands, stats_expands_to);
    fprintf(the_stderr, "@@ strings: insns=%u total=%u stalls=%u\n", stats_strings_total, stats_strings_expands, stats_strings_stalls);
    fprintf(the_stderr, "@@ nfa: link=%u nfa=%u mis=%u mispred=%u\n", bp_bclr_total, nfa_total, nfa_miss, nfa_miss_buried);

    #if( 1 || !PERFECT_BRANCH_PREDICTION )
    fprintf(the_stderr, "@@ branch: total=%u stalls=%u full=%u cond_mis=%u cond_tot=%u link_mis=%u link_tot=%u ctr_mis=%u ctr_tot=%u\n",
	  branch_total, branch_stalls, branch_pred_stalls,
	  bp_bc_miss, bp_bc_total,
	  bp_bclr_miss, bp_bclr_total, bp_bcctr_miss, bp_bcctr_total);
    fprintf(the_stderr, "@@ actual_branch: total=%u stalls=%u full=%u cond_mis=%u cond_tot=%u link_mis=%u link_tot=%u ctr_mis=%u ctr_tot=%u\n",
	  branch_total-branch_miss_total, branch_stalls, branch_pred_stalls,
	  bp_bc_miss-bp_bc_miss_miss, bp_bc_total- bp_bc_miss_total,
	  bp_bclr_miss-bp_bclr_miss_miss, bp_bclr_total - bp_bclr_miss_total,
	  bp_bcctr_miss-bp_bcctr_miss_miss, bp_bcctr_total - bp_bcctr_miss_total);
    fprintf(the_stderr, "@@ exec_branch: total=%u stalls=%u full=%u cond_mis=%u cond_tot=%u link_mis=%u link_tot=%u ctr_mis=%u ctr_tot=%u\n",
	  bp_exec_total, bp_exec_pred, bp_exec_miss,
	  bp_exec_bc_miss, bp_exec_bc_total,
	  bp_exec_bclr_miss, bp_exec_bclr_total,
	  bp_exec_bcctr_miss, bp_exec_bcctr_total);
    #endif

    #if( USE_PREDICATION ) 
    fprintf(the_stderr, "@@ predication: skips=%u taken=%u exps=%u ops=%u\n",
	stats_pred_branch, stats_pred_taken, stats_pred_exps, stats_pred_ops);
    #endif

    #if( PREDICTION_IGNORES_BDCTR )
    fprintf(the_stderr, "@@ bdctr: mispredict=%u total=%u\n",
		stats_bdctr_miss, stats_bdctr);
    #endif

    #if( EVALUATE_MISPREDICTED_BRANCHES )
    fprintf(the_stderr, "@@ prediction: early=%u mispredict=%u total=%u\n",
		stats_eval_mispredict, bp_bc_miss+bp_bclr_miss+bp_bcctr_miss,
		bp_bc_total+bp_bclr_total+bp_bcctr_total );
    #endif

    fprintf(the_stderr, "@@ gp: flushes=%u reissue=%u recirc=%u groups=%u\n",
	stats_reissue_flushes, stats_reissue_decode, stats_recirc, stats_groups_dispatched);

    #if( GET_SPEC_STATS )
      fprintf(the_stderr,
	"@@ spec: fetch_insn=%u fetch=%u expand_insns=%u expand=%u dispatch=%u exec_br=%u exec_fix=%u exec_fpu=%u exec_mem=%u\n",
	stats_spec_ifetch, stats_spec_ifetch - stats_spec_nexpands + stats_spec_expands_to,
	stats_spec_nexpands, stats_spec_expands_to,
	stats_spec_dispatch,
	stats_spec_br_execd, stats_spec_fix_execd, stats_spec_fpu_execd, stats_spec_mem_execd);

      fprintf(the_stderr,
	"@@ specdcache: spec_miss=%u tot_miss%u lines=%u flush=%u satisfy=%u hits=%u miss=%u src=%u rehit=%u once=%u\n",
	stats_spec_dmiss, stats_dmiss,
	stats_spec_dlines, stats_spec_dflush, stats_spec_dsatisfy,
	stats_spec_extra_hits, stats_spec_extra_misses, stats_spec_src_hits,
	stats_spec_reexec_hits, stats_spec_used_once);

      fprintf(the_stderr,
	"@@ specicache: spec_miss=%u tot_miss=%u hits=%u miss=%u src=%u once=%u\n",
	stats_spec_imiss, stats_imiss,
	stats_spec_extra_ihits, stats_spec_extra_imisses, stats_spec_src_ihits, stats_spec_iused_once
	);
    #endif
    
      fprintf(the_stderr, "@@ stalls: ibuf=%u inflight=%u dmissq=%u cast=%u storeq=%u reoderq=%u resv=%u rename=%u\n",
		  stats_ibuf_stall, stats_inflight_stall,
		  stats_dmiss_stall, stats_dcastout_stall,
		  stats_storeq_stall, stats_reorderq_stall,
		  stats_resv_full_stall,
		  stats_rename_stall);
      fprintf(the_stderr, "@@ storeq: total=%u forward=%u partial=%u data_wait=%u\n",
	stats_storeq_total, stats_storeq_forward,
	stats_storeq_partials, stats_storeq_data_not_ready);
      fprintf(the_stderr, "@@ reorderq: total=%u conflicts=%u\n",
	stats_reorderq_total, stats_reorderq_conflict);
      fprintf(the_stderr, "@@ mtsr: total=%u ipurge=%u dpurge=%u\n",
	stats_mtsr, stats_mtsr_ipurge, stats_mtsr_dpurge);
      fprintf(the_stderr, "@@ nops: dispd=%u retd=%u\n",
	stats_nops_dispd, stats_nops_retd );
      /**** POWERTIMER STATS ADDED BY DBROOKS */
      fprintf(the_stderr, "@@ extra powertimer stats: num_stores=%u num_loads=%u\n",stats_num_stores,stats_num_loads);


    fprintf(the_stderr, "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n" );
    fprintf(the_stderr, "@@ HISTOGRAMS DATA\n" );
    fprintf(the_stderr, "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n" );

    #if( GET_SPEC_STATS )
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_spec_dflush_histo, "spec_flush");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_spec_over_histo, "spec_over");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_spec_dflush_over_histo, "spec_flushover");
    #endif

    #if( STATS )
      dumpStats( cycle, IBUF_MAX, stats_ibuf, "ibuf");
      dumpStats( cycle, FCHBLK_MAX, stats_fchblk, "fchblk");
      dumpStats( cycle, RETIREQ_MAX, stats_retireq, "retireq");

      dumpStats( cycle, FIX_RESV, stats_fix_resv, "fix_rsv");
      #if( CLUSTER )
	dumpStats( cycle, FIX_RESV, stats_fix1_resv, "fix1_rsv");
      #endif
      dumpStats( cycle, FPU_RESV, stats_fpu_resv, "fpu_rsv");
      #if( CLUSTER_FPU )
	dumpStats( cycle, FPU_RESV, stats_fpu1_resv, "fpu1_rsv");
      #endif
      dumpStats( cycle, MEM_RESV, stats_mem_resv, "mem_rsv");
      #if( CLUSTER )
	dumpStats( cycle, MEM_RESV, stats_mem1_resv, "mem1_rsv");
      #endif
      dumpStats( cycle, BR_RESV, stats_br_resv, "br_rsv");

      #if( USING_LOG_UNIT )
      dumpStats( cycle, LOG_RESV, stats_log_resv, "log_rsv");
      #endif

      #if( USING_CMPLX_UNIT )
      dumpStats( cycle, CMPLX_RESV, stats_cmplx_resv, "cmplx_rsv");
      #endif

      dumpStats( cycle, (FIX_RESV+FPU_RESV+MEM_RESV+BR_RESV+LOG_RESV+CMPLX_RESV)*CLUSTERS_MAX, stats_resv, "tot_rsv");

      dumpStats( cycle, GPR_PHYS, stats_gpr, "gpr");
      dumpStats( cycle, FPR_PHYS, stats_fpr, "fpr");
      dumpStats( cycle, SPR_PHYS, stats_spr, "spr");
      dumpStats( cycle, CCR_PHYS, stats_ccr, "ccr");

      dumpStats( cycle, STOREQ_LENGTH, stats_storeq, "storeq");
      dumpStats( cycle, REORDERQ_LENGTH, stats_reorderq, "reorderq");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_dmissq, "dmissq");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_lines, "lines");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_l2dmissq, "l2dmissq");
      dumpStats( cycle, DMISS_MAX+MEM_NUM, stats_l2_lines, "l2lines");
      dumpStats( cycle, DCASTOUT_MAX+MEM_NUM-1, stats_dcastoutq, "dcast");

      dumpStats( cycle, DCACHE_PORTS, stats_st_commit, "st_commit");

      dumpStats( cycle, RETIRE_MAX, stats_retired, "retired");
      dumpStats( cycle, DCACHE_PORTS, stats_st_retired, "st_retd");
      dumpStats( cycle, FIX_NUM, stats_fix_execd, "fix_exd");
      #if( CLUSTER )
	dumpStats( cycle, FIX_NUM, stats_fix1_execd, "fix1_exd");
      #endif
      dumpStats( cycle, FPU_NUM, stats_fpu_execd, "fpu_exd");
      #if( CLUSTER_FPU )
	dumpStats( cycle, FPU_NUM, stats_fpu1_execd, "fpu1_exd");
      #endif
      dumpStats( cycle, MEM_NUM, stats_mem_execd, "mem_exd");
      #if( CLUSTER )
	dumpStats( cycle, MEM_NUM, stats_mem1_execd, "mem1_exd");
      #endif
      dumpStats( cycle, BR_NUM, stats_br_execd, "br_exd");

      #if( USING_LOG_UNIT )
      dumpStats( cycle, LOG_NUM, stats_log_execd, "log_exd");
      #endif

      #if( USING_CMPLX_UNIT )
      dumpStats( cycle, CMPLX_NUM, stats_cmplx_execd, "cmplx_exd");
      #endif
      dumpStats( cycle, (FIX_NUM+FPU_NUM+MEM_NUM+BR_NUM+LOG_NUM+CMPLX_NUM)*CLUSTERS_MAX, stats_execd, "tot_exd");

      dumpStats( cycle, DISPATCH_MAX, stats_dispatched, "dispchd");
      dumpStats( cycle, DISPATCH_MAX, stats_fix_dispatched, "fix_dsp");
      #if( CLUSTER )
	dumpStats( cycle, DISPATCH_MAX, stats_fix1_dispatched, "fix1_dsp");
      #endif
      dumpStats( cycle, DISPATCH_MAX, stats_fpu_dispatched, "fpu_dsp");
      #if( CLUSTER_FPU )
	dumpStats( cycle, DISPATCH_MAX, stats_fpu1_dispatched, "fpu1_dsp");
      #endif
      dumpStats( cycle, DISPATCH_MAX, stats_mem_dispatched, "mem_dsp");
      #if( CLUSTER )
	dumpStats( cycle, DISPATCH_MAX, stats_mem1_dispatched, "mem1_dsp");
      #endif
      dumpStats( cycle, DISPATCH_MAX, stats_br_dispatched, "br_dsp");
      dumpStats( cycle, IBUF_MAX, stats_renamed, "renamed");
      dumpStats( cycle, IFETCH_MAX, stats_fetched, "fetched");

      dumpStats( cycle, INFLIGHT_MAX, stats_inflight, "inflight");
    #endif
    dumpStats( cycle, GROUPS_MAX, stats_groups, "groups");
#endif
    {
#if( POWER_MODE )
#include "power.macros"
#endif
    }

    fprintf(the_stderr,"NO CG %4.1lf mW\n",no_cg[6]);
    fprintf(the_stderr,"BOTH CG %4.1lf mW\n",both_cg[6]);
    fprintf(the_stderr,"HOLD CG %4.1lf mW\n",hold_cg[6]);
    fprintf(the_stderr,"LOGIC CG %4.1lf mW\n",logic_cg[6]);

}
