#! /bin/bash
#
# testall_spec2k.sh
#
# This script runs 22 out of the 26 SPEC benchmarks (since these 22 are the ones
# we have fF traces for) simultaneously on an 11-core processor.
#
# Minimum of 100,000,000 instructions on all threads
# ETA: About 5 hours on our dual-core Athlons

if [ ! -e /common/spec2k ]; then
	echo /common/spec2k not found. Remember this script is for use only in the parapet cluster.
else
	./gpffturandot -c 100000000 -groupcutoff -chipconf 2 2 2 2 2 2 2 2 2 2 2 2 2 -t \
		/common/spec2k/ammp.fF.bz2 \
		/common/spec2k/applu.fF.bz2 \
		/common/spec2k/apsi.tt6e.bz2 \
		/common/spec2k/art.fF.bz2 \
		/common/spec2k/bzip2.fF.bz2 \
		/common/spec2k/crafty.fF.bz2 \
		/common/spec2k/eon.fF.bz2 \
		/common/spec2k/equake.tt6e.bz2 \
		/common/spec2k/facerec.fF.bz2 \
		/common/spec2k/fma3d.fF.bz2 \
		/common/spec2k/galgel.fF.bz2 \
		/common/spec2k/gap.fF.bz2 \
		/common/spec2k/gcc.fF.bz2 \
		/common/spec2k/gzip.fF.bz2 \
		/common/spec2k/lucas.fF.bz2 \
		/common/spec2k/mcf.fF.bz2 \
		/common/spec2k/mesa.fF.bz2 \
		/common/spec2k/mgrid.fF.bz2 \
		/common/spec2k/parser.fF.bz2 \
		/common/spec2k/perlbmk.fF.bz2 \
		/common/spec2k/sixtrack.fF.bz2 \
		/common/spec2k/swim.fF.bz2 \
		/common/spec2k/twolf.fF.bz2 \
		/common/spec2k/vortex.tt6e.bz2 \
		/common/spec2k/vpr.fF.bz2 \
		/common/spec2k/wupwise.tt6e.bz2 \
		-stderr test1.out test2.out test3.out test4.out test5.out test6.out test7.out \
			  test8.out test9.out test10.out test11.out test12.out test13.out
fi
